From 7612cc2f87b3d06c7d221200d7c77ae5d7a10215 Mon Sep 17 00:00:00 2001
From: Andrew Price <andrewprice@andrewalexanderprice.com>
Date: Fri, 15 Jul 2011 04:29:35 +0930
Subject: [PATCH 2/8] Stereoscopy release, 3d vision, anagylph, SBS

---
 STEREOSCOPY README                 |  151 +
 include/nvapi.h                    | 8398 ++++++++++++++++++++++++++++++++++++
 modules/video_filter/stereoscopy.c | 2662 ++++++++++++
 modules/video_filter/stereoscopy.h |   52 +
 nvapiwrapper/README                |    7 +
 nvapiwrapper/nvapi.lib             |  Bin 0 -> 81968 bytes
 nvapiwrapper/nvapiwrapper.c        |   41 +
 nvapiwrapper/nvapiwrapper.dll      |  Bin 0 -> 49152 bytes
 8 files changed, 11311 insertions(+), 0 deletions(-)
 create mode 100644 STEREOSCOPY README
 create mode 100644 include/nvapi.h
 create mode 100644 modules/video_filter/stereoscopy.c
 create mode 100644 modules/video_filter/stereoscopy.h
 create mode 100644 nvapiwrapper/README
 create mode 100644 nvapiwrapper/nvapi.lib
 create mode 100644 nvapiwrapper/nvapiwrapper.c
 create mode 100644 nvapiwrapper/nvapiwrapper.dll

diff --git a/STEREOSCOPY README b/STEREOSCOPY README
new file mode 100644
index 0000000..c91c0a5
--- /dev/null
+++ b/STEREOSCOPY README	
@@ -0,0 +1,151 @@
+================================================================================
+Before doing anything, be warned that there is a mixture of GPL and non-GPL
+software in this release, so under no circumstance should you publically
+release a binary version of this software yet. The non-GPL files are:
+vlc/include/nvapi.h
+nvapiwrapper/nvapi.lib
+nvapiwrapper/nvapiwrapper.dll
+nvapiwrapper/nvapiwrapper.c
+================================================================================
+To build follow the standard Win32Compile instructions with a few differences.
+I use 32-bit MSYS/MinGW on x64 Windows 7 Ultimate.
+
+================================================================================
+1. To bootstrap I use the following:
+
+cd vlc
+cp -v /usr/win32/share/aclocal/* m4/
+cp -v /usr/share/aclocal/* m4/
+PATH=/usr/win32/bin:$PATH ./bootstrap
+
+================================================================================
+2. Then to configure:
+
+sh extras/package/win32/configure-msys.sh
+
+================================================================================
+3. To build:
+
+PATH=/usr/win32/bin:$PATH make -j6
+PATH=/usr/win32/bin:$PATH make package-win32 -j6
+
+(The -j6 switch is optional and tells makefile to use 6 threads, it speeds up
+the build time on my 6-core machine.)
+
+'make package-win32' will exit with the following error but that's normal and
+VLC has still been built:
+
+cp: cannot stat `./npapi-vlc/installed/lib/npvlc.dll': No such file or directory
+
+
+================================================================================
+4. Temporarily rename vlc.exe to wow.exe:
+
+cd vlc-1.2.0-git
+mv vlc.exe wow.exe
+
+'wow.exe' can be replaced by a number of windowed-mode 3D Vision executable
+names ('googleearth.exe', etc). This step is required because VLC does not yet
+have a nVidia 3D Vision driver profile, and 'windowed mode' 3D Vision only
+activates for programs with a driver profile. Thankfully, it's just a simple
+file name check.
+
+================================================================================
+5. Copy nvapiwrapper.dll from 'nvapiwrapper' to 'vlc-1.2.0-git':
+
+cp ../nvapiwrapper/nvapiwrapper.dll ./
+
+This is a temporary solution. See nvapiwrapper/README for more details.
+
+================================================================================
+6. To view 3D video you manually enable stereoscopy by running VLC with:
+
+wow --video-filter="stereoscopy" --stereoscopy-left=<left mode>            \
+    --stereoscopy-right=<right mode>
+
+<left mode> and <right mode> represent the method that particular eye is encoded
+with. For example, to watch a Red/Cyan anaglyph video you would use:
+
+wow --video-filter="stereoscopy" --stereoscopy-left=1004                   \
+    --stereoscopy-right=1001
+
+To watch a left/right side-by-side video you would use:
+wow --video-filter="stereoscopy" --stereoscopy-left=2000                   \
+    --stereoscopy-right=2001
+
+The possible values are: (found in modules/video_filter/stereoscopy.h)
+--------------------------------------------------------------------------------
+ 0     STEREOSCOPY_2D
+        If either eye is this value then stereoscopy is disabled and the image
+        is treated as 2D.
+ 1000  STEREOSCOPY_ANAGLYPH_BLUE
+        The eye is encoded into the blue channel of the image and returned as
+        a blue image.
+ 1001  STEREOSCOPY_ANAGLYPH_CYAN
+        The eye is encoded into the blue and green channels of the image and
+        returned as a cyan image.
+ 1002  STEREOSCOPY_ANAGLYPH_GREEN
+        The eye is encoded into the green channel of the image and returned
+        as a green image.
+ 1003  STEREOSCOPY_ANAGLYPH_MAGENTA
+        The eye is encoded into the red and blue channels of the image and
+        returned as a magenta image.
+ 1004  STEREOSCOPY_ANAGLYPH_RED
+        The eye is encoded into the red channel of the image and returned as
+        a red image.
+ 1005  STEREOSCOPY_ANAGLYPH_YELLOW
+        The eye is encoded into the red and green channels of the image and
+        returned as a yellow image.
+
+ 1010  STEREOSCOPY_ANAGLYPH_BLUE_GRAY
+        The eye is encoded into the blue channel and returned as a grayscale
+        image.
+ 1011  STEREOSCOPY_ANAGLYPH_CYAN_GRAY
+        The eye is encoded into the blue and green channels of the image and
+        returned as a grayscale image.
+ 1012  STEREOSCOPY_ANAGLYPH_GREEN_GRAY
+        The eye is encoded into the green channel of the image and returned
+        as a grayscale image.
+ 1013  STEREOSCOPY_ANAGLYPH_MAGENTA_GRAY
+        The eye is encoded into the red and blue channels of the image and
+        returned as a grayscale image.
+ 1014  STEREOSCOPY_ANAGLYPH_RED_GRAY
+        The eye is encoded into the red channel of the image and returned
+        as a grayscale image.
+ 1015  STEREOSCOPY_ANAGLYPH_YELLOW_GRAY
+        The eye is encoded into the red and green channels of the image and
+        returned as a grayscale image.
+
+ 1021  STEREOSCOPY_ANAGLYPH_CYAN_FILL
+        The eye is encoded into the blue and green channels of the image and
+        returned as a full colour image. The missing red channel is filled in
+        with the average of the blue and green channels.
+ 1023  STEREOSCOPY_ANAGLYPH_MAGENTA_FILL
+        The eye is encoded into the red and blue channels of the image and
+        returned as a full colour image. The missing green channel is filled in
+        with the average of the red and blue channels.
+ 1025  STEREOSCOPY_ANAGLYPH_YELLOW_FILL
+        The eye is encoded into the red and green channels of the image and
+        returned as a full colour image. The missing blue channel is filled in
+        with the average of the red and green channels.
+
+ 2000  STEREOSCOPY_SIDEBYSIDE_LEFT
+        The eye is encoded into the left half of the image. Assumes the source
+        is half-SBS but the aspect ratio will need to be halved for full-SBS.
+ 2001  STEREOSCOPY_SIDEBYSIDE_RIGHT
+        The eye is encoded into the right half of the image. Assumes the source
+        is half-SBS but the aspect ratio will need to be halved for full-SBS.
+ 2002  STEREOSCOPY_SIDEBYSIDE_BOTTOM
+        Not yet implemented. Reserved for top/bottom side-by-side.
+ 2003  STEREOSCOPY_SIDEBYSIDE_TOP
+        Not yet implemented. Reserved for top/bottom side-by-side.
+--------------------------------------------------------------------------------
+Please only use the Direct3D vout because the other vout's are not stereoscopic
+aware and will just sequentually show each eye. Also be sure to use the latest
+nVidia drivers. (I have been developing with 275.22.)
+
+The Direct3D vout does not require any configuring. If 3D Vision is detected
+then it will be used. It can be enabled/disabled using the button on the
+3D Vision IR dongle or by using the driver hotkey (CTRL+T by default). If 3D
+Vision is turned off then it does not turn the stereoscopy filter off, so you'll
+just see the left eye.
diff --git a/include/nvapi.h b/include/nvapi.h
new file mode 100644
index 0000000..cf7be7c
--- /dev/null
+++ b/include/nvapi.h
@@ -0,0 +1,8398 @@
+ /***************************************************************************\
+|*                                                                           *|
+|*      Copyright 2005-2010 NVIDIA Corporation.  All rights reserved.        *|
+|*                                                                           *|
+|*   NOTICE TO USER:                                                         *|
+|*                                                                           *|
+|*   This source code is subject to NVIDIA ownership rights under U.S.       *|
+|*   and international Copyright laws.  Users and possessors of this         *|
+|*   source code are hereby granted a nonexclusive, royalty-free             *|
+|*   license to use this code in individual and commercial software.         *|
+|*                                                                           *|
+|*   NVIDIA MAKES NO REPRESENTATION ABOUT THE SUITABILITY OF THIS SOURCE     *|
+|*   CODE FOR ANY PURPOSE. IT IS PROVIDED "AS IS" WITHOUT EXPRESS OR         *|
+|*   IMPLIED WARRANTY OF ANY KIND. NVIDIA DISCLAIMS ALL WARRANTIES WITH      *|
+|*   REGARD TO THIS SOURCE CODE, INCLUDING ALL IMPLIED WARRANTIES OF         *|
+|*   MERCHANTABILITY, NONINFRINGEMENT, AND FITNESS FOR A PARTICULAR          *|
+|*   PURPOSE. IN NO EVENT SHALL NVIDIA BE LIABLE FOR ANY SPECIAL,            *|
+|*   INDIRECT, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, OR ANY DAMAGES          *|
+|*   WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN      *|
+|*   AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING     *|
+|*   OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOURCE      *|
+|*   CODE.                                                                   *|
+|*                                                                           *|
+|*   U.S. Government End Users. This source code is a "commercial item"      *|
+|*   as that term is defined at 48 C.F.R. 2.101 (OCT 1995), consisting       *|
+|*   of "commercial computer  software" and "commercial computer software    *|
+|*   documentation" as such terms are used in 48 C.F.R. 12.212 (SEPT 1995)   *|
+|*   and is provided to the U.S. Government only as a commercial end item.   *|
+|*   Consistent with 48 C.F.R.12.212 and 48 C.F.R. 227.7202-1 through        *|
+|*   227.7202-4 (JUNE 1995), all U.S. Government End Users acquire the       *|
+|*   source code with only those rights set forth herein.                    *|
+|*                                                                           *|
+|*   Any use of this source code in individual and commercial software must  *|
+|*   include, in the user documentation and internal comments to the code,   *|
+|*   the above Disclaimer and U.S. Government End Users Notice.              *|
+|*                                                                           *|
+|*                                                                           *|
+ \***************************************************************************/
+///////////////////////////////////////////////////////////////////////////////
+//
+// Date: Apr 30, 2011
+// File: nvapi.h
+//
+// NvAPI provides an interface to NVIDIA devices. This file contains the
+// interface constants, structure definitions and function prototypes.
+//
+//   Target Profile: developer
+//  Target Platform: windows
+//
+///////////////////////////////////////////////////////////////////////////////
+#ifndef _NVAPI_H
+#define _NVAPI_H
+
+#pragma pack(push,8) // Make sure we have consistent structure packings
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+// ====================================================
+// Universal NvAPI Definitions
+// ====================================================
+#ifndef _WIN32
+#define __cdecl
+#endif
+
+// ====================================================
+// SAL related support
+// ====================================================
+#ifndef __ecount
+    #define __nvapi_undef__ecount
+    #define __ecount(size)
+#endif
+#ifndef __bcount
+    #define __nvapi_undef__bcount
+    #define __bcount(size)
+#endif
+#ifndef __in
+    #define __nvapi_undef__in
+    #define __in
+#endif
+#ifndef __in_ecount
+    #define __nvapi_undef__in_ecount
+    #define __in_ecount(size)
+#endif
+#ifndef __in_bcount
+    #define __nvapi_undef__in_bcount
+    #define __in_bcount(size)
+#endif
+#ifndef __in_z
+    #define __nvapi_undef__in_z
+    #define __in_z
+#endif
+#ifndef __in_ecount_z
+    #define __nvapi_undef__in_ecount_z
+    #define __in_ecount_z(size)
+#endif
+#ifndef __in_bcount_z
+    #define __nvapi_undef__in_bcount_z
+    #define __in_bcount_z(size)
+#endif
+#ifndef __in_nz
+    #define __nvapi_undef__in_nz
+    #define __in_nz
+#endif
+#ifndef __in_ecount_nz
+    #define __nvapi_undef__in_ecount_nz
+    #define __in_ecount_nz(size)
+#endif
+#ifndef __in_bcount_nz
+    #define __nvapi_undef__in_bcount_nz
+    #define __in_bcount_nz(size)
+#endif
+#ifndef __out
+    #define __nvapi_undef__out
+    #define __out
+#endif
+#ifndef __out_ecount
+    #define __nvapi_undef__out_ecount
+    #define __out_ecount(size)
+#endif
+#ifndef __out_bcount
+    #define __nvapi_undef__out_bcount
+    #define __out_bcount(size)
+#endif
+#ifndef __out_ecount_part
+    #define __nvapi_undef__out_ecount_part
+    #define __out_ecount_part(size,length)
+#endif
+#ifndef __out_bcount_part
+    #define __nvapi_undef__out_bcount_part
+    #define __out_bcount_part(size,length)
+#endif
+#ifndef __out_ecount_full
+    #define __nvapi_undef__out_ecount_full
+    #define __out_ecount_full(size)
+#endif
+#ifndef __out_bcount_full
+    #define __nvapi_undef__out_bcount_full
+    #define __out_bcount_full(size)
+#endif
+#ifndef __out_z
+    #define __nvapi_undef__out_z
+    #define __out_z
+#endif
+#ifndef __out_z_opt
+    #define __nvapi_undef__out_z_opt
+    #define __out_z_opt
+#endif
+#ifndef __out_ecount_z
+    #define __nvapi_undef__out_ecount_z
+    #define __out_ecount_z(size)
+#endif
+#ifndef __out_bcount_z
+    #define __nvapi_undef__out_bcount_z
+    #define __out_bcount_z(size)
+#endif
+#ifndef __out_ecount_part_z
+    #define __nvapi_undef__out_ecount_part_z
+    #define __out_ecount_part_z(size,length)
+#endif
+#ifndef __out_bcount_part_z
+    #define __nvapi_undef__out_bcount_part_z
+    #define __out_bcount_part_z(size,length)
+#endif
+#ifndef __out_ecount_full_z
+    #define __nvapi_undef__out_ecount_full_z
+    #define __out_ecount_full_z(size)
+#endif
+#ifndef __out_bcount_full_z
+    #define __nvapi_undef__out_bcount_full_z
+    #define __out_bcount_full_z(size)
+#endif
+#ifndef __out_nz
+    #define __nvapi_undef__out_nz
+    #define __out_nz
+#endif
+#ifndef __out_nz_opt
+    #define __nvapi_undef__out_nz_opt
+    #define __out_nz_opt
+#endif
+#ifndef __out_ecount_nz
+    #define __nvapi_undef__out_ecount_nz
+    #define __out_ecount_nz(size)
+#endif
+#ifndef __out_bcount_nz
+    #define __nvapi_undef__out_bcount_nz
+    #define __out_bcount_nz(size)
+#endif
+#ifndef __inout
+    #define __nvapi_undef__inout
+    #define __inout
+#endif
+#ifndef __inout_ecount
+    #define __nvapi_undef__inout_ecount
+    #define __inout_ecount(size)
+#endif
+#ifndef __inout_bcount
+    #define __nvapi_undef__inout_bcount
+    #define __inout_bcount(size)
+#endif
+#ifndef __inout_ecount_part
+    #define __nvapi_undef__inout_ecount_part
+    #define __inout_ecount_part(size,length)
+#endif
+#ifndef __inout_bcount_part
+    #define __nvapi_undef__inout_bcount_part
+    #define __inout_bcount_part(size,length)
+#endif
+#ifndef __inout_ecount_full
+    #define __nvapi_undef__inout_ecount_full
+    #define __inout_ecount_full(size)
+#endif
+#ifndef __inout_bcount_full
+    #define __nvapi_undef__inout_bcount_full
+    #define __inout_bcount_full(size)
+#endif
+#ifndef __inout_z
+    #define __nvapi_undef__inout_z
+    #define __inout_z
+#endif
+#ifndef __inout_ecount_z
+    #define __nvapi_undef__inout_ecount_z
+    #define __inout_ecount_z(size)
+#endif
+#ifndef __inout_bcount_z
+    #define __nvapi_undef__inout_bcount_z
+    #define __inout_bcount_z(size)
+#endif
+#ifndef __inout_nz
+    #define __nvapi_undef__inout_nz
+    #define __inout_nz
+#endif
+#ifndef __inout_ecount_nz
+    #define __nvapi_undef__inout_ecount_nz
+    #define __inout_ecount_nz(size)
+#endif
+#ifndef __inout_bcount_nz
+    #define __nvapi_undef__inout_bcount_nz
+    #define __inout_bcount_nz(size)
+#endif
+#ifndef __ecount_opt
+    #define __nvapi_undef__ecount_opt
+    #define __ecount_opt(size)
+#endif
+#ifndef __bcount_opt
+    #define __nvapi_undef__bcount_opt
+    #define __bcount_opt(size)
+#endif
+#ifndef __in_opt
+    #define __nvapi_undef__in_opt
+    #define __in_opt
+#endif
+#ifndef __in_ecount_opt
+    #define __nvapi_undef__in_ecount_opt
+    #define __in_ecount_opt(size)
+#endif
+#ifndef __in_bcount_opt
+    #define __nvapi_undef__in_bcount_opt
+    #define __in_bcount_opt(size)
+#endif
+#ifndef __in_z_opt
+    #define __nvapi_undef__in_z_opt
+    #define __in_z_opt
+#endif
+#ifndef __in_ecount_z_opt
+    #define __nvapi_undef__in_ecount_z_opt
+    #define __in_ecount_z_opt(size)
+#endif
+#ifndef __in_bcount_z_opt
+    #define __nvapi_undef__in_bcount_z_opt
+    #define __in_bcount_z_opt(size)
+#endif
+#ifndef __in_nz_opt
+    #define __nvapi_undef__in_nz_opt
+    #define __in_nz_opt
+#endif
+#ifndef __in_ecount_nz_opt
+    #define __nvapi_undef__in_ecount_nz_opt
+    #define __in_ecount_nz_opt(size)
+#endif
+#ifndef __in_bcount_nz_opt
+    #define __nvapi_undef__in_bcount_nz_opt
+    #define __in_bcount_nz_opt(size)
+#endif
+#ifndef __out_opt
+    #define __nvapi_undef__out_opt
+    #define __out_opt
+#endif
+#ifndef __out_ecount_opt
+    #define __nvapi_undef__out_ecount_opt
+    #define __out_ecount_opt(size)
+#endif
+#ifndef __out_bcount_opt
+    #define __nvapi_undef__out_bcount_opt
+    #define __out_bcount_opt(size)
+#endif
+#ifndef __out_ecount_part_opt
+    #define __nvapi_undef__out_ecount_part_opt
+    #define __out_ecount_part_opt(size,length)
+#endif
+#ifndef __out_bcount_part_opt
+    #define __nvapi_undef__out_bcount_part_opt
+    #define __out_bcount_part_opt(size,length)
+#endif
+#ifndef __out_ecount_full_opt
+    #define __nvapi_undef__out_ecount_full_opt
+    #define __out_ecount_full_opt(size)
+#endif
+#ifndef __out_bcount_full_opt
+    #define __nvapi_undef__out_bcount_full_opt
+    #define __out_bcount_full_opt(size)
+#endif
+#ifndef __out_ecount_z_opt
+    #define __nvapi_undef__out_ecount_z_opt
+    #define __out_ecount_z_opt(size)
+#endif
+#ifndef __out_bcount_z_opt
+    #define __nvapi_undef__out_bcount_z_opt
+    #define __out_bcount_z_opt(size)
+#endif
+#ifndef __out_ecount_part_z_opt
+    #define __nvapi_undef__out_ecount_part_z_opt
+    #define __out_ecount_part_z_opt(size,length)
+#endif
+#ifndef __out_bcount_part_z_opt
+    #define __nvapi_undef__out_bcount_part_z_opt
+    #define __out_bcount_part_z_opt(size,length)
+#endif
+#ifndef __out_ecount_full_z_opt
+    #define __nvapi_undef__out_ecount_full_z_opt
+    #define __out_ecount_full_z_opt(size)
+#endif
+#ifndef __out_bcount_full_z_opt
+    #define __nvapi_undef__out_bcount_full_z_opt
+    #define __out_bcount_full_z_opt(size)
+#endif
+#ifndef __out_ecount_nz_opt
+    #define __nvapi_undef__out_ecount_nz_opt
+    #define __out_ecount_nz_opt(size)
+#endif
+#ifndef __out_bcount_nz_opt
+    #define __nvapi_undef__out_bcount_nz_opt
+    #define __out_bcount_nz_opt(size)
+#endif
+#ifndef __inout_opt
+    #define __nvapi_undef__inout_opt
+    #define __inout_opt
+#endif
+#ifndef __inout_ecount_opt
+    #define __nvapi_undef__inout_ecount_opt
+    #define __inout_ecount_opt(size)
+#endif
+#ifndef __inout_bcount_opt
+    #define __nvapi_undef__inout_bcount_opt
+    #define __inout_bcount_opt(size)
+#endif
+#ifndef __inout_ecount_part_opt
+    #define __nvapi_undef__inout_ecount_part_opt
+    #define __inout_ecount_part_opt(size,length)
+#endif
+#ifndef __inout_bcount_part_opt
+    #define __nvapi_undef__inout_bcount_part_opt
+    #define __inout_bcount_part_opt(size,length)
+#endif
+#ifndef __inout_ecount_full_opt
+    #define __nvapi_undef__inout_ecount_full_opt
+    #define __inout_ecount_full_opt(size)
+#endif
+#ifndef __inout_bcount_full_opt
+    #define __nvapi_undef__inout_bcount_full_opt
+    #define __inout_bcount_full_opt(size)
+#endif
+#ifndef __inout_z_opt
+    #define __nvapi_undef__inout_z_opt
+    #define __inout_z_opt
+#endif
+#ifndef __inout_ecount_z_opt
+    #define __nvapi_undef__inout_ecount_z_opt
+    #define __inout_ecount_z_opt(size)
+#endif
+#ifndef __inout_ecount_z_opt
+    #define __nvapi_undef__inout_ecount_z_opt
+    #define __inout_ecount_z_opt(size)
+#endif
+#ifndef __inout_bcount_z_opt
+    #define __nvapi_undef__inout_bcount_z_opt
+    #define __inout_bcount_z_opt(size)
+#endif
+#ifndef __inout_nz_opt
+    #define __nvapi_undef__inout_nz_opt
+    #define __inout_nz_opt
+#endif
+#ifndef __inout_ecount_nz_opt
+    #define __nvapi_undef__inout_ecount_nz_opt
+    #define __inout_ecount_nz_opt(size)
+#endif
+#ifndef __inout_bcount_nz_opt
+    #define __nvapi_undef__inout_bcount_nz_opt
+    #define __inout_bcount_nz_opt(size)
+#endif
+#ifndef __deref_ecount
+    #define __nvapi_undef__deref_ecount
+    #define __deref_ecount(size)
+#endif
+#ifndef __deref_bcount
+    #define __nvapi_undef__deref_bcount
+    #define __deref_bcount(size)
+#endif
+#ifndef __deref_out
+    #define __nvapi_undef__deref_out
+    #define __deref_out
+#endif
+#ifndef __deref_out_ecount
+    #define __nvapi_undef__deref_out_ecount
+    #define __deref_out_ecount(size)
+#endif
+#ifndef __deref_out_bcount
+    #define __nvapi_undef__deref_out_bcount
+    #define __deref_out_bcount(size)
+#endif
+#ifndef __deref_out_ecount_part
+    #define __nvapi_undef__deref_out_ecount_part
+    #define __deref_out_ecount_part(size,length)
+#endif
+#ifndef __deref_out_bcount_part
+    #define __nvapi_undef__deref_out_bcount_part
+    #define __deref_out_bcount_part(size,length)
+#endif
+#ifndef __deref_out_ecount_full
+    #define __nvapi_undef__deref_out_ecount_full
+    #define __deref_out_ecount_full(size)
+#endif
+#ifndef __deref_out_bcount_full
+    #define __nvapi_undef__deref_out_bcount_full
+    #define __deref_out_bcount_full(size)
+#endif
+#ifndef __deref_out_z
+    #define __nvapi_undef__deref_out_z
+    #define __deref_out_z
+#endif
+#ifndef __deref_out_ecount_z
+    #define __nvapi_undef__deref_out_ecount_z
+    #define __deref_out_ecount_z(size)
+#endif
+#ifndef __deref_out_bcount_z
+    #define __nvapi_undef__deref_out_bcount_z
+    #define __deref_out_bcount_z(size)
+#endif
+#ifndef __deref_out_nz
+    #define __nvapi_undef__deref_out_nz
+    #define __deref_out_nz
+#endif
+#ifndef __deref_out_ecount_nz
+    #define __nvapi_undef__deref_out_ecount_nz
+    #define __deref_out_ecount_nz(size)
+#endif
+#ifndef __deref_out_bcount_nz
+    #define __nvapi_undef__deref_out_bcount_nz
+    #define __deref_out_bcount_nz(size)
+#endif
+#ifndef __deref_inout
+    #define __nvapi_undef__deref_inout
+    #define __deref_inout
+#endif
+#ifndef __deref_inout_z
+    #define __nvapi_undef__deref_inout_z
+    #define __deref_inout_z
+#endif
+#ifndef __deref_inout_ecount
+    #define __nvapi_undef__deref_inout_ecount
+    #define __deref_inout_ecount(size)
+#endif
+#ifndef __deref_inout_bcount
+    #define __nvapi_undef__deref_inout_bcount
+    #define __deref_inout_bcount(size)
+#endif
+#ifndef __deref_inout_ecount_part
+    #define __nvapi_undef__deref_inout_ecount_part
+    #define __deref_inout_ecount_part(size,length)
+#endif
+#ifndef __deref_inout_bcount_part
+    #define __nvapi_undef__deref_inout_bcount_part
+    #define __deref_inout_bcount_part(size,length)
+#endif
+#ifndef __deref_inout_ecount_full
+    #define __nvapi_undef__deref_inout_ecount_full
+    #define __deref_inout_ecount_full(size)
+#endif
+#ifndef __deref_inout_bcount_full
+    #define __nvapi_undef__deref_inout_bcount_full
+    #define __deref_inout_bcount_full(size)
+#endif
+#ifndef __deref_inout_z
+    #define __nvapi_undef__deref_inout_z
+    #define __deref_inout_z
+#endif
+#ifndef __deref_inout_ecount_z
+    #define __nvapi_undef__deref_inout_ecount_z
+    #define __deref_inout_ecount_z(size)
+#endif
+#ifndef __deref_inout_bcount_z
+    #define __nvapi_undef__deref_inout_bcount_z
+    #define __deref_inout_bcount_z(size)
+#endif
+#ifndef __deref_inout_nz
+    #define __nvapi_undef__deref_inout_nz
+    #define __deref_inout_nz
+#endif
+#ifndef __deref_inout_ecount_nz
+    #define __nvapi_undef__deref_inout_ecount_nz
+    #define __deref_inout_ecount_nz(size)
+#endif
+#ifndef __deref_inout_bcount_nz
+    #define __nvapi_undef__deref_inout_bcount_nz
+    #define __deref_inout_bcount_nz(size)
+#endif
+#ifndef __deref_ecount_opt
+    #define __nvapi_undef__deref_ecount_opt
+    #define __deref_ecount_opt(size)
+#endif
+#ifndef __deref_bcount_opt
+    #define __nvapi_undef__deref_bcount_opt
+    #define __deref_bcount_opt(size)
+#endif
+#ifndef __deref_out_opt
+    #define __nvapi_undef__deref_out_opt
+    #define __deref_out_opt
+#endif
+#ifndef __deref_out_ecount_opt
+    #define __nvapi_undef__deref_out_ecount_opt
+    #define __deref_out_ecount_opt(size)
+#endif
+#ifndef __deref_out_bcount_opt
+    #define __nvapi_undef__deref_out_bcount_opt
+    #define __deref_out_bcount_opt(size)
+#endif
+#ifndef __deref_out_ecount_part_opt
+    #define __nvapi_undef__deref_out_ecount_part_opt
+    #define __deref_out_ecount_part_opt(size,length)
+#endif
+#ifndef __deref_out_bcount_part_opt
+    #define __nvapi_undef__deref_out_bcount_part_opt
+    #define __deref_out_bcount_part_opt(size,length)
+#endif
+#ifndef __deref_out_ecount_full_opt
+    #define __nvapi_undef__deref_out_ecount_full_opt
+    #define __deref_out_ecount_full_opt(size)
+#endif
+#ifndef __deref_out_bcount_full_opt
+    #define __nvapi_undef__deref_out_bcount_full_opt
+    #define __deref_out_bcount_full_opt(size)
+#endif
+#ifndef __deref_out_z_opt
+    #define __nvapi_undef__deref_out_z_opt
+    #define __deref_out_z_opt
+#endif
+#ifndef __deref_out_ecount_z_opt
+    #define __nvapi_undef__deref_out_ecount_z_opt
+    #define __deref_out_ecount_z_opt(size)
+#endif
+#ifndef __deref_out_bcount_z_opt
+    #define __nvapi_undef__deref_out_bcount_z_opt
+    #define __deref_out_bcount_z_opt(size)
+#endif
+#ifndef __deref_out_nz_opt
+    #define __nvapi_undef__deref_out_nz_opt
+    #define __deref_out_nz_opt
+#endif
+#ifndef __deref_out_ecount_nz_opt
+    #define __nvapi_undef__deref_out_ecount_nz_opt
+    #define __deref_out_ecount_nz_opt(size)
+#endif
+#ifndef __deref_out_bcount_nz_opt
+    #define __nvapi_undef__deref_out_bcount_nz_opt
+    #define __deref_out_bcount_nz_opt(size)
+#endif
+#ifndef __deref_inout_opt
+    #define __nvapi_undef__deref_inout_opt
+    #define __deref_inout_opt
+#endif
+#ifndef __deref_inout_ecount_opt
+    #define __nvapi_undef__deref_inout_ecount_opt
+    #define __deref_inout_ecount_opt(size)
+#endif
+#ifndef __deref_inout_bcount_opt
+    #define __nvapi_undef__deref_inout_bcount_opt
+    #define __deref_inout_bcount_opt(size)
+#endif
+#ifndef __deref_inout_ecount_part_opt
+    #define __nvapi_undef__deref_inout_ecount_part_opt
+    #define __deref_inout_ecount_part_opt(size,length)
+#endif
+#ifndef __deref_inout_bcount_part_opt
+    #define __nvapi_undef__deref_inout_bcount_part_opt
+    #define __deref_inout_bcount_part_opt(size,length)
+#endif
+#ifndef __deref_inout_ecount_full_opt
+    #define __nvapi_undef__deref_inout_ecount_full_opt
+    #define __deref_inout_ecount_full_opt(size)
+#endif
+#ifndef __deref_inout_bcount_full_opt
+    #define __nvapi_undef__deref_inout_bcount_full_opt
+    #define __deref_inout_bcount_full_opt(size)
+#endif
+#ifndef __deref_inout_z_opt
+    #define __nvapi_undef__deref_inout_z_opt
+    #define __deref_inout_z_opt
+#endif
+#ifndef __deref_inout_ecount_z_opt
+    #define __nvapi_undef__deref_inout_ecount_z_opt
+    #define __deref_inout_ecount_z_opt(size)
+#endif
+#ifndef __deref_inout_bcount_z_opt
+    #define __nvapi_undef__deref_inout_bcount_z_opt
+    #define __deref_inout_bcount_z_opt(size)
+#endif
+#ifndef __deref_inout_nz_opt
+    #define __nvapi_undef__deref_inout_nz_opt
+    #define __deref_inout_nz_opt
+#endif
+#ifndef __deref_inout_ecount_nz_opt
+    #define __nvapi_undef__deref_inout_ecount_nz_opt
+    #define __deref_inout_ecount_nz_opt(size)
+#endif
+#ifndef __deref_inout_bcount_nz_opt
+    #define __nvapi_undef__deref_inout_bcount_nz_opt
+    #define __deref_inout_bcount_nz_opt(size)
+#endif
+#ifndef __deref_opt_ecount
+    #define __nvapi_undef__deref_opt_ecount
+    #define __deref_opt_ecount(size)
+#endif
+#ifndef __deref_opt_bcount
+    #define __nvapi_undef__deref_opt_bcount
+    #define __deref_opt_bcount(size)
+#endif
+#ifndef __deref_opt_out
+    #define __nvapi_undef__deref_opt_out
+    #define __deref_opt_out
+#endif
+#ifndef __deref_opt_out_z
+    #define __nvapi_undef__deref_opt_out_z
+    #define __deref_opt_out_z
+#endif
+#ifndef __deref_opt_out_ecount
+    #define __nvapi_undef__deref_opt_out_ecount
+    #define __deref_opt_out_ecount(size)
+#endif
+#ifndef __deref_opt_out_bcount
+    #define __nvapi_undef__deref_opt_out_bcount
+    #define __deref_opt_out_bcount(size)
+#endif
+#ifndef __deref_opt_out_ecount_part
+    #define __nvapi_undef__deref_opt_out_ecount_part
+    #define __deref_opt_out_ecount_part(size,length)
+#endif
+#ifndef __deref_opt_out_bcount_part
+    #define __nvapi_undef__deref_opt_out_bcount_part
+    #define __deref_opt_out_bcount_part(size,length)
+#endif
+#ifndef __deref_opt_out_ecount_full
+    #define __nvapi_undef__deref_opt_out_ecount_full
+    #define __deref_opt_out_ecount_full(size)
+#endif
+#ifndef __deref_opt_out_bcount_full
+    #define __nvapi_undef__deref_opt_out_bcount_full
+    #define __deref_opt_out_bcount_full(size)
+#endif
+#ifndef __deref_opt_inout
+    #define __nvapi_undef__deref_opt_inout
+    #define __deref_opt_inout
+#endif
+#ifndef __deref_opt_inout_ecount
+    #define __nvapi_undef__deref_opt_inout_ecount
+    #define __deref_opt_inout_ecount(size)
+#endif
+#ifndef __deref_opt_inout_bcount
+    #define __nvapi_undef__deref_opt_inout_bcount
+    #define __deref_opt_inout_bcount(size)
+#endif
+#ifndef __deref_opt_inout_ecount_part
+    #define __nvapi_undef__deref_opt_inout_ecount_part
+    #define __deref_opt_inout_ecount_part(size,length)
+#endif
+#ifndef __deref_opt_inout_bcount_part
+    #define __nvapi_undef__deref_opt_inout_bcount_part
+    #define __deref_opt_inout_bcount_part(size,length)
+#endif
+#ifndef __deref_opt_inout_ecount_full
+    #define __nvapi_undef__deref_opt_inout_ecount_full
+    #define __deref_opt_inout_ecount_full(size)
+#endif
+#ifndef __deref_opt_inout_bcount_full
+    #define __nvapi_undef__deref_opt_inout_bcount_full
+    #define __deref_opt_inout_bcount_full(size)
+#endif
+#ifndef __deref_opt_inout_z
+    #define __nvapi_undef__deref_opt_inout_z
+    #define __deref_opt_inout_z
+#endif
+#ifndef __deref_opt_inout_ecount_z
+    #define __nvapi_undef__deref_opt_inout_ecount_z
+    #define __deref_opt_inout_ecount_z(size)
+#endif
+#ifndef __deref_opt_inout_bcount_z
+    #define __nvapi_undef__deref_opt_inout_bcount_z
+    #define __deref_opt_inout_bcount_z(size)
+#endif
+#ifndef __deref_opt_inout_nz
+    #define __nvapi_undef__deref_opt_inout_nz
+    #define __deref_opt_inout_nz
+#endif
+#ifndef __deref_opt_inout_ecount_nz
+    #define __nvapi_undef__deref_opt_inout_ecount_nz
+    #define __deref_opt_inout_ecount_nz(size)
+#endif
+#ifndef __deref_opt_inout_bcount_nz
+    #define __nvapi_undef__deref_opt_inout_bcount_nz
+    #define __deref_opt_inout_bcount_nz(size)
+#endif
+#ifndef __deref_opt_ecount_opt
+    #define __nvapi_undef__deref_opt_ecount_opt
+    #define __deref_opt_ecount_opt(size)
+#endif
+#ifndef __deref_opt_bcount_opt
+    #define __nvapi_undef__deref_opt_bcount_opt
+    #define __deref_opt_bcount_opt(size)
+#endif
+#ifndef __deref_opt_out_opt
+    #define __nvapi_undef__deref_opt_out_opt
+    #define __deref_opt_out_opt
+#endif
+#ifndef __deref_opt_out_ecount_opt
+    #define __nvapi_undef__deref_opt_out_ecount_opt
+    #define __deref_opt_out_ecount_opt(size)
+#endif
+#ifndef __deref_opt_out_bcount_opt
+    #define __nvapi_undef__deref_opt_out_bcount_opt
+    #define __deref_opt_out_bcount_opt(size)
+#endif
+#ifndef __deref_opt_out_ecount_part_opt
+    #define __nvapi_undef__deref_opt_out_ecount_part_opt
+    #define __deref_opt_out_ecount_part_opt(size,length)
+#endif
+#ifndef __deref_opt_out_bcount_part_opt
+    #define __nvapi_undef__deref_opt_out_bcount_part_opt
+    #define __deref_opt_out_bcount_part_opt(size,length)
+#endif
+#ifndef __deref_opt_out_ecount_full_opt
+    #define __nvapi_undef__deref_opt_out_ecount_full_opt
+    #define __deref_opt_out_ecount_full_opt(size)
+#endif
+#ifndef __deref_opt_out_bcount_full_opt
+    #define __nvapi_undef__deref_opt_out_bcount_full_opt
+    #define __deref_opt_out_bcount_full_opt(size)
+#endif
+#ifndef __deref_opt_out_z_opt
+    #define __nvapi_undef__deref_opt_out_z_opt
+    #define __deref_opt_out_z_opt
+#endif
+#ifndef __deref_opt_out_ecount_z_opt
+    #define __nvapi_undef__deref_opt_out_ecount_z_opt
+    #define __deref_opt_out_ecount_z_opt(size)
+#endif
+#ifndef __deref_opt_out_bcount_z_opt
+    #define __nvapi_undef__deref_opt_out_bcount_z_opt
+    #define __deref_opt_out_bcount_z_opt(size)
+#endif
+#ifndef __deref_opt_out_nz_opt
+    #define __nvapi_undef__deref_opt_out_nz_opt
+    #define __deref_opt_out_nz_opt
+#endif
+#ifndef __deref_opt_out_ecount_nz_opt
+    #define __nvapi_undef__deref_opt_out_ecount_nz_opt
+    #define __deref_opt_out_ecount_nz_opt(size)
+#endif
+#ifndef __deref_opt_out_bcount_nz_opt
+    #define __nvapi_undef__deref_opt_out_bcount_nz_opt
+    #define __deref_opt_out_bcount_nz_opt(size)
+#endif
+#ifndef __deref_opt_inout_opt
+    #define __nvapi_undef__deref_opt_inout_opt
+    #define __deref_opt_inout_opt
+#endif
+#ifndef __deref_opt_inout_ecount_opt
+    #define __nvapi_undef__deref_opt_inout_ecount_opt
+    #define __deref_opt_inout_ecount_opt(size)
+#endif
+#ifndef __deref_opt_inout_bcount_opt
+    #define __nvapi_undef__deref_opt_inout_bcount_opt
+    #define __deref_opt_inout_bcount_opt(size)
+#endif
+#ifndef __deref_opt_inout_ecount_part_opt
+    #define __nvapi_undef__deref_opt_inout_ecount_part_opt
+    #define __deref_opt_inout_ecount_part_opt(size,length)
+#endif
+#ifndef __deref_opt_inout_bcount_part_opt
+    #define __nvapi_undef__deref_opt_inout_bcount_part_opt
+    #define __deref_opt_inout_bcount_part_opt(size,length)
+#endif
+#ifndef __deref_opt_inout_ecount_full_opt
+    #define __nvapi_undef__deref_opt_inout_ecount_full_opt
+    #define __deref_opt_inout_ecount_full_opt(size)
+#endif
+#ifndef __deref_opt_inout_bcount_full_opt
+    #define __nvapi_undef__deref_opt_inout_bcount_full_opt
+    #define __deref_opt_inout_bcount_full_opt(size)
+#endif
+#ifndef __deref_opt_inout_z_opt
+    #define __nvapi_undef__deref_opt_inout_z_opt
+    #define __deref_opt_inout_z_opt
+#endif
+#ifndef __deref_opt_inout_ecount_z_opt
+    #define __nvapi_undef__deref_opt_inout_ecount_z_opt
+    #define __deref_opt_inout_ecount_z_opt(size)
+#endif
+#ifndef __deref_opt_inout_bcount_z_opt
+    #define __nvapi_undef__deref_opt_inout_bcount_z_opt
+    #define __deref_opt_inout_bcount_z_opt(size)
+#endif
+#ifndef __deref_opt_inout_nz_opt
+    #define __nvapi_undef__deref_opt_inout_nz_opt
+    #define __deref_opt_inout_nz_opt
+#endif
+#ifndef __deref_opt_inout_ecount_nz_opt
+    #define __nvapi_undef__deref_opt_inout_ecount_nz_opt
+    #define __deref_opt_inout_ecount_nz_opt(size)
+#endif
+#ifndef __deref_opt_inout_bcount_nz_opt
+    #define __nvapi_undef__deref_opt_inout_bcount_nz_opt
+    #define __deref_opt_inout_bcount_nz_opt(size)
+#endif
+
+#define NVAPI_INTERFACE extern NvAPI_Status __cdecl
+
+#if defined(WIN32) || defined(_WIN32)
+#define __nvapi_deprecated_function(NewFunction, FirstRelease) __declspec(deprecated("Do not use this function - it is deprecated in release " #FirstRelease ". Instead, use " #NewFunction "."))
+#define __nvapi_deprecated_datatype(FirstRelease) __declspec(deprecated("Do not use this data type - it is deprecated in release " #FirstRelease "."))
+#else
+#define __nvapi_deprecated_function(NewFunction, FirstRelease)
+#define __nvapi_deprecated_datatype(FirstRelease)
+#endif
+
+/* 64-bit types for compilers that support them, plus some obsolete variants */
+#if defined(__GNUC__) || defined(__arm) || defined(__IAR_SYSTEMS_ICC__) || defined(__ghs__) || defined(_WIN64)
+typedef unsigned long long NvU64; /* 0 to 18446744073709551615          */
+#else
+typedef unsigned __int64   NvU64; /* 0 to 18446744073709551615              */
+#endif
+
+// mac os 32-bit still needs this
+#if (defined(macintosh) || defined(__APPLE__)) && !defined(__LP64__)
+typedef signed long        NvS32; /* -2147483648 to 2147483647               */
+#else
+typedef signed int         NvS32; /* -2147483648 to 2147483647               */
+#endif
+
+// mac os 32-bit still needs this
+#if ( (defined(macintosh) && defined(__LP64__) && (__NVAPI_RESERVED0__)) || \
+      (!defined(macintosh) && defined(__NVAPI_RESERVED0__)) )
+typedef unsigned int       NvU32; /* 0 to 4294967295                         */
+#else
+typedef unsigned long      NvU32; /* 0 to 4294967295                         */
+#endif
+
+typedef signed   short   NvS16;
+typedef unsigned short   NvU16;
+typedef unsigned char    NvU8;
+
+typedef struct _NV_RECT
+{
+    NvU32    left;
+    NvU32    top;
+    NvU32    right;
+    NvU32    bottom;
+} NV_RECT;
+
+#define NV_DECLARE_HANDLE(name) struct name##__ { int unused; }; typedef struct name##__ *name
+
+// NVAPI Handles - These handles are retrieved from various calls and passed in to others in NvAPI
+//                 These are meant to be opaque types.  Do not assume they correspond to indices, HDCs,
+//                 display indexes or anything else.
+//
+//                 Most handles remain valid until a display re-configuration (display mode set) or GPU
+//                 reconfiguration (going into or out of SLI modes) occurs.  If NVAPI_HANDLE_INVALIDATED
+//                 is received by an app, it should discard all handles, and re-enumerate them.
+//
+NV_DECLARE_HANDLE(NvDisplayHandle);                // Display Device driven by NVIDIA GPU(s) (an attached display)
+NV_DECLARE_HANDLE(NvUnAttachedDisplayHandle);      // Unattached Display Device driven by NVIDIA GPU(s)
+NV_DECLARE_HANDLE(NvLogicalGpuHandle);             // One or more physical GPUs acting in concert (SLI)
+NV_DECLARE_HANDLE(NvPhysicalGpuHandle);            // A single physical GPU
+NV_DECLARE_HANDLE(NvEventHandle);                  // A handle to an event registration instance
+NV_DECLARE_HANDLE(NvVisualComputingDeviceHandle);  // A handle to Visual Computing Device
+NV_DECLARE_HANDLE(NvHICHandle);                    // A handle to a Host Interface Card
+NV_DECLARE_HANDLE(NvGSyncDeviceHandle);            // A handle to a GSync device
+NV_DECLARE_HANDLE(NvVioHandle);                    // A handle to a SDI device
+NV_DECLARE_HANDLE(NvTransitionHandle);             // A handle to address a single transition request
+NV_DECLARE_HANDLE(NvAudioHandle);                  // NVIDIA HD Audio Device
+NV_DECLARE_HANDLE(Nv3DVPContextHandle);            // A handle for a 3D Vision Pro (3DVP) context
+NV_DECLARE_HANDLE(Nv3DVPTransceiverHandle);        // A handle for a 3DVP RF transceiver
+NV_DECLARE_HANDLE(Nv3DVPGlassesHandle);            // A handle for a pair of 3DVP RF shutter glasses
+
+typedef void* StereoHandle;
+
+NV_DECLARE_HANDLE(NvSourceHandle);                 // Unique source handle on the system
+NV_DECLARE_HANDLE(NvTargetHandle);                 // Unique target handle on the system
+
+
+#define NVAPI_DEFAULT_HANDLE        0
+#define NV_BIT(x)    (1 << (x))
+
+
+#define NVAPI_GENERIC_STRING_MAX    4096
+#define NVAPI_LONG_STRING_MAX       256
+#define NVAPI_SHORT_STRING_MAX      64
+
+typedef struct
+{
+    NvS32   sX;
+    NvS32   sY;
+    NvS32   sWidth;
+    NvS32   sHeight;
+} NvSBox;
+
+#ifndef NvGUID_Defined
+#define NvGUID_Defined
+typedef struct
+{
+    NvU32 data1;
+    NvU16 data2;
+    NvU16 data3;
+    NvU8  data4[8];
+} NvGUID, NvLUID;
+#endif //#ifndef NvGUID_Defined
+
+#define NVAPI_MAX_PHYSICAL_GPUS             64
+#define NVAPI_PHYSICAL_GPUS                 32
+#define NVAPI_MAX_LOGICAL_GPUS              64
+#define NVAPI_MAX_AVAILABLE_GPU_TOPOLOGIES  256
+#define NVAPI_MAX_AVAILABLE_SLI_GROUPS      256
+#define NVAPI_MAX_GPU_TOPOLOGIES            NVAPI_MAX_PHYSICAL_GPUS
+#define NVAPI_MAX_GPU_PER_TOPOLOGY          8
+#define NVAPI_MAX_DISPLAY_HEADS             2
+#define NVAPI_ADVANCED_DISPLAY_HEADS        4
+#define NVAPI_MAX_DISPLAYS                  NVAPI_PHYSICAL_GPUS * NVAPI_ADVANCED_DISPLAY_HEADS
+#define NVAPI_MAX_ACPI_IDS                  16
+#define NVAPI_MAX_VIEW_MODES                8
+#define NV_MAX_HEADS                        4   // Maximum heads, each with NVAPI_DESKTOP_RES resolution
+#define NVAPI_MAX_HEADS_PER_GPU             32
+
+#define NV_MAX_HEADS        4   // Maximum heads, each with NVAPI_DESKTOP_RES resolution
+#define NV_MAX_VID_STREAMS  4   // Maximum input video streams, each with a NVAPI_VIDEO_SRC_INFO
+#define NV_MAX_VID_PROFILES 4   // Maximum output video profiles supported
+
+#define NVAPI_SYSTEM_MAX_DISPLAYS           NVAPI_MAX_PHYSICAL_GPUS * NV_MAX_HEADS
+
+#define NVAPI_SYSTEM_MAX_HWBCS              128
+#define NVAPI_SYSTEM_HWBC_INVALID_ID        0xffffffff
+#define NVAPI_MAX_AUDIO_DEVICES             16
+
+typedef char NvAPI_String[NVAPI_GENERIC_STRING_MAX];
+typedef char NvAPI_LongString[NVAPI_LONG_STRING_MAX];
+typedef char NvAPI_ShortString[NVAPI_SHORT_STRING_MAX];
+
+// =========================================================================================
+// NvAPI Version Definition
+// Maintain per structure specific version define using the MAKE_NVAPI_VERSION macro.
+// Usage: #define NV_GENLOCK_STATUS_VER  MAKE_NVAPI_VERSION(NV_GENLOCK_STATUS, 1)
+// =========================================================================================
+#define MAKE_NVAPI_VERSION(typeName,ver) (NvU32)(sizeof(typeName) | ((ver)<<16))
+#define GET_NVAPI_VERSION(ver) (NvU32)((ver)>>16)
+#define GET_NVAPI_SIZE(ver) (NvU32)((ver) & 0xffff)
+
+// ====================================================
+// NvAPI Status Values
+//    All NvAPI functions return one of these codes.
+// ====================================================
+
+
+typedef enum _NvAPI_Status
+{
+    NVAPI_OK                                    =  0,      // Success
+    NVAPI_ERROR                                 = -1,      // Generic error
+    NVAPI_LIBRARY_NOT_FOUND                     = -2,      // nvapi.dll can not be loaded
+    NVAPI_NO_IMPLEMENTATION                     = -3,      // not implemented in current driver installation
+    NVAPI_API_NOT_INITIALIZED                   = -4,      // NvAPI_Initialize has not been called (successfully)
+    NVAPI_INVALID_ARGUMENT                      = -5,      // invalid argument
+    NVAPI_NVIDIA_DEVICE_NOT_FOUND               = -6,      // no NVIDIA display driver was found
+    NVAPI_END_ENUMERATION                       = -7,      // no more to enum
+    NVAPI_INVALID_HANDLE                        = -8,      // invalid handle
+    NVAPI_INCOMPATIBLE_STRUCT_VERSION           = -9,      // an argument's structure version is not supported
+    NVAPI_HANDLE_INVALIDATED                    = -10,     // handle is no longer valid (likely due to GPU or display re-configuration)
+    NVAPI_OPENGL_CONTEXT_NOT_CURRENT            = -11,     // no NVIDIA OpenGL context is current (but needs to be)
+    NVAPI_INVALID_POINTER                       = -14,     // An invalid pointer, usually NULL, was passed as a parameter
+    NVAPI_NO_GL_EXPERT                          = -12,     // OpenGL Expert is not supported by the current drivers
+    NVAPI_INSTRUMENTATION_DISABLED              = -13,     // OpenGL Expert is supported, but driver instrumentation is currently disabled
+    NVAPI_NO_GL_NSIGHT                          = -15,     // OpenGL does not support Nsight
+    NVAPI_EXPECTED_LOGICAL_GPU_HANDLE           = -100,    // expected a logical GPU handle for one or more parameters
+    NVAPI_EXPECTED_PHYSICAL_GPU_HANDLE          = -101,    // expected a physical GPU handle for one or more parameters
+    NVAPI_EXPECTED_DISPLAY_HANDLE               = -102,    // expected an NV display handle for one or more parameters
+    NVAPI_INVALID_COMBINATION                   = -103,    // used in some commands to indicate that the combination of parameters is not valid
+    NVAPI_NOT_SUPPORTED                         = -104,    // Requested feature not supported in the selected GPU
+    NVAPI_PORTID_NOT_FOUND                      = -105,    // NO port ID found for I2C transaction
+    NVAPI_EXPECTED_UNATTACHED_DISPLAY_HANDLE    = -106,    // expected an unattached display handle as one of the input param
+    NVAPI_INVALID_PERF_LEVEL                    = -107,    // invalid perf level
+    NVAPI_DEVICE_BUSY                           = -108,    // device is busy, request not fulfilled
+    NVAPI_NV_PERSIST_FILE_NOT_FOUND             = -109,    // NV persist file is not found
+    NVAPI_PERSIST_DATA_NOT_FOUND                = -110,    // NV persist data is not found
+    NVAPI_EXPECTED_TV_DISPLAY                   = -111,    // expected TV output display
+    NVAPI_EXPECTED_TV_DISPLAY_ON_DCONNECTOR     = -112,    // expected TV output on D Connector - HDTV_EIAJ4120.
+    NVAPI_NO_ACTIVE_SLI_TOPOLOGY                = -113,    // SLI is not active on this device
+    NVAPI_SLI_RENDERING_MODE_NOTALLOWED         = -114,    // setup of SLI rendering mode is not possible right now
+    NVAPI_EXPECTED_DIGITAL_FLAT_PANEL           = -115,    // expected digital flat panel
+    NVAPI_ARGUMENT_EXCEED_MAX_SIZE              = -116,    // argument exceeds expected size
+    NVAPI_DEVICE_SWITCHING_NOT_ALLOWED          = -117,    // inhibit ON due to one of the flags in NV_GPU_DISPLAY_CHANGE_INHIBIT or SLI Active
+    NVAPI_TESTING_CLOCKS_NOT_SUPPORTED          = -118,    // testing clocks not supported
+    NVAPI_UNKNOWN_UNDERSCAN_CONFIG              = -119,    // the specified underscan config is from an unknown source (e.g. INF)
+    NVAPI_TIMEOUT_RECONFIGURING_GPU_TOPO        = -120,    // timeout while reconfiguring GPUs
+    NVAPI_DATA_NOT_FOUND                        = -121,    // Requested data was not found
+    NVAPI_EXPECTED_ANALOG_DISPLAY               = -122,    // expected analog display
+    NVAPI_NO_VIDLINK                            = -123,    // No SLI video bridge present
+    NVAPI_REQUIRES_REBOOT                       = -124,    // NVAPI requires reboot for its settings to take effect
+    NVAPI_INVALID_HYBRID_MODE                   = -125,    // the function is not supported with the current hybrid mode.
+    NVAPI_MIXED_TARGET_TYPES                    = -126,    // The target types are not all the same
+    NVAPI_SYSWOW64_NOT_SUPPORTED                = -127,    // the function is not supported from 32-bit on a 64-bit system
+    NVAPI_IMPLICIT_SET_GPU_TOPOLOGY_CHANGE_NOT_ALLOWED = -128,    //there is any implicit GPU topo active. Use NVAPI_SetHybridMode to change topology.
+    NVAPI_REQUEST_USER_TO_CLOSE_NON_MIGRATABLE_APPS = -129,      //Prompt the user to close all non-migratable apps.
+    NVAPI_OUT_OF_MEMORY                         = -130,    // Could not allocate sufficient memory to complete the call
+    NVAPI_WAS_STILL_DRAWING                     = -131,    // The previous operation that is transferring information to or from this surface is incomplete
+    NVAPI_FILE_NOT_FOUND                        = -132,    // The file was not found
+    NVAPI_TOO_MANY_UNIQUE_STATE_OBJECTS         = -133,    // There are too many unique instances of a particular type of state object
+    NVAPI_INVALID_CALL                          = -134,    // The method call is invalid. For example, a method's parameter may not be a valid pointer
+    NVAPI_D3D10_1_LIBRARY_NOT_FOUND             = -135,    // d3d10_1.dll can not be loaded
+    NVAPI_FUNCTION_NOT_FOUND                    = -136,    // Couldn't find the function in loaded dll library
+    NVAPI_INVALID_USER_PRIVILEGE                = -137,    // Current User is not Admin
+    NVAPI_EXPECTED_NON_PRIMARY_DISPLAY_HANDLE   = -138,    // The handle corresponds to GDIPrimary
+    NVAPI_EXPECTED_COMPUTE_GPU_HANDLE           = -139,    // Setting Physx GPU requires that the GPU is compute capable
+    NVAPI_STEREO_NOT_INITIALIZED                = -140,    // Stereo part of NVAPI failed to initialize completely. Check if stereo driver is installed.
+    NVAPI_STEREO_REGISTRY_ACCESS_FAILED         = -141,    // Access to stereo related registry keys or values failed.
+    NVAPI_STEREO_REGISTRY_PROFILE_TYPE_NOT_SUPPORTED = -142, // Given registry profile type is not supported.
+    NVAPI_STEREO_REGISTRY_VALUE_NOT_SUPPORTED   = -143,    // Given registry value is not supported.
+    NVAPI_STEREO_NOT_ENABLED                    = -144,    // Stereo is not enabled and function needed it to execute completely.
+    NVAPI_STEREO_NOT_TURNED_ON                  = -145,    // Stereo is not turned on and function needed it to execute completely.
+    NVAPI_STEREO_INVALID_DEVICE_INTERFACE       = -146,    // Invalid device interface.
+    NVAPI_STEREO_PARAMETER_OUT_OF_RANGE         = -147,    // Separation percentage or JPEG image capture quality out of [0-100] range.
+    NVAPI_STEREO_FRUSTUM_ADJUST_MODE_NOT_SUPPORTED = -148, // Given frustum adjust mode is not supported.
+    NVAPI_TOPO_NOT_POSSIBLE                     = -149,    // The mosaic topo is not possible given the current state of HW
+    NVAPI_MODE_CHANGE_FAILED                    = -150,    // An attempt to do a display resolution mode change has failed
+    NVAPI_D3D11_LIBRARY_NOT_FOUND               = -151,    // d3d11.dll/d3d11_beta.dll cannot be loaded.
+    NVAPI_INVALID_ADDRESS                       = -152,    // Address outside of valid range.
+    NVAPI_STRING_TOO_SMALL                      = -153,    // The pre-allocated string is too small to hold the result.
+    NVAPI_MATCHING_DEVICE_NOT_FOUND             = -154,    // The input does not match any of the available devices.
+    NVAPI_DRIVER_RUNNING                        = -155,    // Driver is running
+    NVAPI_DRIVER_NOTRUNNING                     = -156,    // Driver is not running
+    NVAPI_ERROR_DRIVER_RELOAD_REQUIRED          = -157,    // A driver reload is required to apply these settings
+    NVAPI_SET_NOT_ALLOWED                       = -158,    // Intended Setting is not allowed
+    NVAPI_ADVANCED_DISPLAY_TOPOLOGY_REQUIRED    = -159,    // Information can't be returned due to "advanced display topology"
+    NVAPI_SETTING_NOT_FOUND                     = -160,    // Setting is not found
+    NVAPI_SETTING_SIZE_TOO_LARGE                = -161,    // Setting size is too large
+    NVAPI_TOO_MANY_SETTINGS_IN_PROFILE          = -162,    // There are too many settings for a profile
+    NVAPI_PROFILE_NOT_FOUND                     = -163,    // Profile is not found
+    NVAPI_PROFILE_NAME_IN_USE                   = -164,    // Profile name is duplicated
+    NVAPI_PROFILE_NAME_EMPTY                    = -165,    // Profile name is empty
+    NVAPI_EXECUTABLE_NOT_FOUND                  = -166,    // Application not found in Profile
+    NVAPI_EXECUTABLE_ALREADY_IN_USE             = -167,    // Application already exists in the other profile
+    NVAPI_DATATYPE_MISMATCH                     = -168,    // Data Type mismatch
+    NVAPI_PROFILE_REMOVED                       = -169,    /// The profile passed as parameter has been removed and is no longer valid.
+    NVAPI_UNREGISTERED_RESOURCE                 = -170,    // An unregistered resource was passed as a parameter
+    NVAPI_ID_OUT_OF_RANGE                       = -171,    // The DisplayId corresponds to a display which is not within the normal outputId range
+    NVAPI_DISPLAYCONFIG_VALIDATION_FAILED       = -172,    // Display topology is not valid so we can't do a mode set on this config
+    NVAPI_DPMST_CHANGED                         = -173,    // Display Port Multi-Stream topology has been changed
+    NVAPI_INSUFFICIENT_BUFFER                   = -174,    // Input buffer is insufficient to hold the contents    
+    NVAPI_ACCESS_DENIED                         = -175,    // No access to the caller.
+    NVAPI_MOSAIC_NOT_ACTIVE                     = -176,    // The requested action cannot be performed without Mosaic being enabled
+    NVAPI_SHARE_RESOURCE_RELOCATED              = -177,    // The surface is relocated away from vidmem
+    NVAPI_REQUEST_USER_TO_DISABLE_DWM           = -178,    // The user should disable DWM before calling NvAPI
+    NVAPI_INVALID_CONFIGURATION                 = -180,    // The requested action cannot be performed in the current state
+    NVAPI_STEREO_HANDSHAKE_NOT_DONE             = -181,    // Call failed as stereo handshake not completed.
+} NvAPI_Status;
+
+#define NVAPI_API_NOT_INTIALIZED        NVAPI_API_NOT_INITIALIZED       // Fix typo in error code
+#define NVAPI_INVALID_USER_PRIVILEDGE   NVAPI_INVALID_USER_PRIVILEGE    // Fix typo in error code
+
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_Initialize
+//
+//   DESCRIPTION: Initializes NVAPI library. This must be called before any
+//                other NvAPI_ function.
+//
+//  SUPPORTED OS: Mac OS X, Windows XP and higher
+//
+// RETURN STATUS: NVAPI_ERROR            Something is wrong during the initialization process (generic error)
+//                NVAPI_LIBRARYNOTFOUND  Can not load nvapi.dll
+//                NVAPI_OK                  Initialized
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_Initialize();
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_Unload
+//
+//   DESCRIPTION: Unloads NVAPI library. This must be the last function called.
+//
+//  SUPPORTED OS: Mac OS X, Windows XP and higher
+//
+//  !! This is not thread safe. In a multithreaded environment, calling NvAPI_Unload       !!
+//  !! while another thread is executing another NvAPI_XXX function, results in           !!
+//  !! undefined behaviour and might even cause the application to crash. Developers       !!
+//  !! must make sure that they are not in any other function before calling NvAPI_Unload. !!
+//
+//
+//  Unloading NvAPI library is not supported when the library is in a resource locked state.
+//  Some functions in the NvAPI library initiates an operation or allocates certain resources
+//  and there are corresponding functions available, to complete the operation or free the
+//  allocated resources. All such function pairs are designed to prevent unloading NvAPI library.
+//
+//  For example, if NvAPI_Unload is called after NvAPI_XXX which locks a resource, it fails with
+//  NVAPI_ERROR. Developers need to call the corresponding NvAPI_YYY to unlock the resources,
+//  before calling NvAPI_Unload again.
+//
+//
+// RETURN STATUS: NVAPI_ERROR            One or more resources are locked and hence cannot unload NVAPI library
+//                NVAPI_OK               NVAPI library unloaded
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_Unload();
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_GetErrorMessage
+//
+//   DESCRIPTION: converts an NvAPI error code into a null terminated string
+//
+//  SUPPORTED OS: Mac OS X, Windows XP and higher
+//
+// RETURN STATUS: null terminated string (always, never NULL)
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_GetErrorMessage(NvAPI_Status nr,NvAPI_ShortString szDesc);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_GetInterfaceVersionString
+//
+//   DESCRIPTION: Returns a string describing the version of the NvAPI library.
+//                Contents of the string are human readable.  Do not assume a fixed
+//                format.
+//
+//  SUPPORTED OS: Mac OS X, Windows XP and higher
+//
+// RETURN STATUS: User readable string giving info on NvAPI's version
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_GetInterfaceVersionString(NvAPI_ShortString szDesc);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_GetDisplayDriverVersion
+//
+//   DESCRIPTION: Returns a struct that describes aspects of the display driver
+//                build.
+//
+//  SUPPORTED OS: Mac OS X, Windows XP and higher
+//
+// RETURN STATUS: NVAPI_ERROR or NVAPI_OK
+//
+///////////////////////////////////////////////////////////////////////////////
+typedef struct
+{
+    NvU32              version;             // Structure version
+    NvU32              drvVersion;
+    NvU32              bldChangeListNum;
+    NvAPI_ShortString  szBuildBranchString;
+    NvAPI_ShortString  szAdapterString;
+} NV_DISPLAY_DRIVER_VERSION;
+#define NV_DISPLAY_DRIVER_VERSION_VER  MAKE_NVAPI_VERSION(NV_DISPLAY_DRIVER_VERSION,1)
+NVAPI_INTERFACE NvAPI_GetDisplayDriverVersion(NvDisplayHandle hNvDisplay, NV_DISPLAY_DRIVER_VERSION *pVersion);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_SYS_GetDriverAndBranchVersion
+//
+//   DESCRIPTION: Returns display driver version and driver-branch string.
+//
+//    PARAMETERS: pDriverVersion(OUT)  - contains driver-version after successful return
+//                szBuildBranchString(OUT)  - contains driver-branch string after successful return
+//  SUPPORTED OS: Windows XP and higher
+// RETURN STATUS: NVAPI_INVALID_ARGUMENT: either pDriverVersion is NULL or enum index too big
+//                NVAPI_OK - completed request
+//                NVAPI_API_NOT_INTIALIZED - NVAPI not initialized
+//                NVAPI_ERROR - miscellaneous error occurred
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_SYS_GetDriverAndBranchVersion(NvU32* pDriverVersion, NvAPI_ShortString szBuildBranchString);
+
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_EnumNvidiaDisplayHandle
+//
+//   DESCRIPTION: Returns the handle of the NVIDIA display specified by the enum
+//                index (thisEnum). The client should keep enumerating until it
+//                returns NVAPI_END_ENUMERATION.
+//
+//                Note: Display handles can get invalidated on a modeset, so the calling applications need to
+//                renum the handles after every modeset.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+// RETURN STATUS: NVAPI_INVALID_ARGUMENT: either the handle pointer is NULL or enum index too big
+//                NVAPI_OK: return a valid NvDisplayHandle based on the enum index
+//                NVAPI_NVIDIA_DEVICE_NOT_FOUND: no NVIDIA device found in the system
+//                NVAPI_END_ENUMERATION: no more display device to enumerate.
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_EnumNvidiaDisplayHandle(NvU32 thisEnum, NvDisplayHandle *pNvDispHandle);
+
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_EnumNvidiaUnAttachedDisplayHandle
+//
+//   DESCRIPTION: Returns the handle of the NVIDIA UnAttached display specified by the enum
+//                index (thisEnum). The client should keep enumerating till it
+//                return error.
+//
+//                Note: Display handles can get invalidated on a modeset, so the calling applications need to
+//                renum the handles after every modeset.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+// RETURN STATUS: NVAPI_INVALID_ARGUMENT: either the handle pointer is NULL or enum index too big
+//                NVAPI_OK: return a valid NvDisplayHandle based on the enum index
+//                NVAPI_NVIDIA_DEVICE_NOT_FOUND: no NVIDIA device found in the system
+//                NVAPI_END_ENUMERATION: no more display device to enumerate.
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_EnumNvidiaUnAttachedDisplayHandle(NvU32 thisEnum, NvUnAttachedDisplayHandle *pNvUnAttachedDispHandle);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_EnumPhysicalGPUs
+//
+//   DESCRIPTION: Returns an array of physical GPU handles.
+//
+//                Each handle represents a physical GPU present in the system.
+//                That GPU may be part of a SLI configuration, or not be visible to the OS directly.
+//
+//                At least 1 GPU must be present in the system and running an NV display driver.
+//
+//                The array nvGPUHandle will be filled with physical GPU handle values.  The returned
+//                gpuCount determines how many entries in the array are valid.
+//
+//                Note: In drivers older than 105.00, all physical GPU handles get invalidated on a modeset. So the calling applications
+//                      need to renum the handles after every modeset.
+//                      With drivers 105.00 and up all physical GPU handles are constant.
+//                      Physical GPU handles are constant as long as the GPUs are not physically moved and the SBIOS VGA order is unchanged.
+//
+//  SUPPORTED OS: Mac OS X, Windows XP and higher
+//
+// RETURN STATUS: NVAPI_INVALID_ARGUMENT: nvGPUHandle or pGpuCount is NULL
+//                NVAPI_OK: one or more handles were returned
+//                NVAPI_NVIDIA_DEVICE_NOT_FOUND: no NVIDIA GPU driving a display was found
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_EnumPhysicalGPUs(NvPhysicalGpuHandle nvGPUHandle[NVAPI_MAX_PHYSICAL_GPUS], NvU32 *pGpuCount);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_EnumLogicalGPUs
+//
+//   DESCRIPTION: Returns an array of logical GPU handles.
+//
+//                Each handle represents one or more GPUs acting in concert as a single graphics device.
+//
+//                At least 1 GPU must be present in the system and running an NV display driver.
+//
+//                The array nvGPUHandle will be filled with logical GPU handle values.  The returned
+//                gpuCount determines how many entries in the array are valid.
+//
+//                Note: All logical GPUs handles get invalidated on a GPU topology change, so the calling application is required to
+//                renum the logical GPU handles to get latest physical handle mapping after every GPU topology change activated
+//                by a call to NvAPI_SetGpuTopologies.
+//
+//                To detect if SLI rendering is enabled please use NvAPI_D3D_GetCurrentSLIState
+//
+//  SUPPORTED OS: Mac OS X, Windows XP and higher
+//
+// RETURN STATUS: NVAPI_INVALID_ARGUMENT: nvGPUHandle or pGpuCount is NULL
+//                NVAPI_OK: one or more handles were returned
+//                NVAPI_NVIDIA_DEVICE_NOT_FOUND: no NVIDIA GPU driving a display was found
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_EnumLogicalGPUs(NvLogicalGpuHandle nvGPUHandle[NVAPI_MAX_LOGICAL_GPUS], NvU32 *pGpuCount);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_GetPhysicalGPUsFromDisplay
+//
+//   DESCRIPTION: Returns an array of physical GPU handles associated with the specified display.
+//
+//                At least 1 GPU must be present in the system and running an NV display driver.
+//
+//                The array nvGPUHandle will be filled with physical GPU handle values.  The returned
+//                gpuCount determines how many entries in the array are valid.
+//
+//                If the display corresponds to more than one physical GPU, the first GPU returned
+//                is the one with the attached active output.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+// RETURN STATUS: NVAPI_INVALID_ARGUMENT: hNvDisp is not valid; nvGPUHandle or pGpuCount is NULL
+//                NVAPI_OK: one or more handles were returned
+//                NVAPI_NVIDIA_DEVICE_NOT_FOUND: no NVIDIA GPU driving a display was found
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_GetPhysicalGPUsFromDisplay(NvDisplayHandle hNvDisp, NvPhysicalGpuHandle nvGPUHandle[NVAPI_MAX_PHYSICAL_GPUS], NvU32 *pGpuCount);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_GetPhysicalGPUFromUnAttachedDisplay
+//
+//   DESCRIPTION: Returns a physical source GPU handle associated with the specified unattached display.
+//                The source GPU is a physical render GPU which renders the frame buffer but may or may not drive the scan out.
+//
+//                At least 1 GPU must be present in the system and running an NV display driver.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+// RETURN STATUS: NVAPI_INVALID_ARGUMENT: hNvUnAttachedDisp is not valid or pPhysicalGpu is NULL.
+//                NVAPI_OK: one or more handles were returned
+//                NVAPI_NVIDIA_DEVICE_NOT_FOUND: no NVIDIA GPU driving a display was found
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_GetPhysicalGPUFromUnAttachedDisplay(NvUnAttachedDisplayHandle hNvUnAttachedDisp, NvPhysicalGpuHandle *pPhysicalGpu);
+
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_CreateDisplayFromUnAttachedDisplay
+//
+//   DESCRIPTION: The unattached display handle is converted to a active attached display handle.
+//
+//                At least 1 GPU must be present in the system and running an NV display driver.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+// RETURN STATUS: NVAPI_INVALID_ARGUMENT: hNvUnAttachedDisp is not valid or pNvDisplay is NULL.
+//                NVAPI_OK: one or more handles were returned
+//                NVAPI_NVIDIA_DEVICE_NOT_FOUND: no NVIDIA GPU driving a display was found
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_CreateDisplayFromUnAttachedDisplay(NvUnAttachedDisplayHandle hNvUnAttachedDisp, NvDisplayHandle *pNvDisplay);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_GetLogicalGPUFromDisplay
+//
+//   DESCRIPTION: Returns the logical GPU handle associated with the specified display.
+//
+//                At least 1 GPU must be present in the system and running an NV display driver.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+// RETURN STATUS: NVAPI_INVALID_ARGUMENT: hNvDisp is not valid; pLogicalGPU is NULL
+//                NVAPI_OK: one or more handles were returned
+//                NVAPI_NVIDIA_DEVICE_NOT_FOUND: no NVIDIA GPU driving a display was found
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_GetLogicalGPUFromDisplay(NvDisplayHandle hNvDisp, NvLogicalGpuHandle *pLogicalGPU);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_GetLogicalGPUFromPhysicalGPU
+//
+//   DESCRIPTION: Returns the logical GPU handle associated with specified physical GPU handle.
+//
+//                At least 1 GPU must be present in the system and running an NV display driver.
+//
+//  SUPPORTED OS: Mac OS X, Windows XP and higher
+//
+// RETURN STATUS: NVAPI_INVALID_ARGUMENT: hPhysicalGPU is not valid; pLogicalGPU is NULL
+//                NVAPI_OK: one or more handles were returned
+//                NVAPI_NVIDIA_DEVICE_NOT_FOUND: no NVIDIA GPU driving a display was found
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_GetLogicalGPUFromPhysicalGPU(NvPhysicalGpuHandle hPhysicalGPU, NvLogicalGpuHandle *pLogicalGPU);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_GetPhysicalGPUsFromLogicalGPU
+//
+//   DESCRIPTION: Returns the physical GPU handles associated with the specified logical GPU handle.
+//
+//                At least 1 GPU must be present in the system and running an NV display driver.
+//
+//                The array hPhysicalGPU will be filled with physical GPU handle values.  The returned
+//                gpuCount determines how many entries in the array are valid.
+//
+//  SUPPORTED OS: Mac OS X, Windows XP and higher
+//
+// RETURN STATUS: NVAPI_INVALID_ARGUMENT: hLogicalGPU is not valid; hPhysicalGPU is NULL
+//                NVAPI_OK: one or more handles were returned
+//                NVAPI_NVIDIA_DEVICE_NOT_FOUND: no NVIDIA GPU driving a display was found
+//                NVAPI_EXPECTED_LOGICAL_GPU_HANDLE: hLogicalGPU was not a logical GPU handle
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_GetPhysicalGPUsFromLogicalGPU(NvLogicalGpuHandle hLogicalGPU,NvPhysicalGpuHandle hPhysicalGPU[NVAPI_MAX_PHYSICAL_GPUS], NvU32 *pGpuCount);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_GetAssociatedNvidiaDisplayHandle
+//
+//   DESCRIPTION: Returns the handle of the NVIDIA display that is associated
+//                with the display name given.  Eg: "\\DISPLAY1"
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+// RETURN STATUS: NVAPI_INVALID_ARGUMENT: either argument is NULL
+//                NVAPI_OK: *pNvDispHandle is now valid
+//                NVAPI_NVIDIA_DEVICE_NOT_FOUND: no NVIDIA device maps to that display name
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_GetAssociatedNvidiaDisplayHandle(const char *szDisplayName, NvDisplayHandle *pNvDispHandle);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_DISP_GetAssociatedUnAttachedNvidiaDisplayHandle
+//
+//   DESCRIPTION: Returns the handle of an unattached NVIDIA display that is
+//                associated with the display name given.  Eg: "\\DISPLAY1"
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+// RETURN STATUS: NVAPI_INVALID_ARGUMENT: either argument is NULL
+//                NVAPI_OK: *pNvUnAttachedDispHandle is now valid
+//                NVAPI_NVIDIA_DEVICE_NOT_FOUND: no NVIDIA device maps to that display name
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_DISP_GetAssociatedUnAttachedNvidiaDisplayHandle(const char *szDisplayName, NvUnAttachedDisplayHandle *pNvUnAttachedDispHandle);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_GetAssociatedNvidiaDisplayName
+//
+//   DESCRIPTION: Returns the display name given.  Eg: "\\DISPLAY1" using the NVIDIA display handle
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+// RETURN STATUS: NVAPI_INVALID_ARGUMENT: either argument is NULL
+//                NVAPI_OK: *pNvDispHandle is now valid
+//                NVAPI_NVIDIA_DEVICE_NOT_FOUND: no NVIDIA device maps to that display name
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_GetAssociatedNvidiaDisplayName(NvDisplayHandle NvDispHandle, NvAPI_ShortString szDisplayName);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_GetUnAttachedAssociatedDisplayName
+//
+//   DESCRIPTION: Returns the display name given.  Eg: "\\DISPLAY1" using the NVIDIA unattached display handle
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+// RETURN STATUS: NVAPI_INVALID_ARGUMENT: either argument is NULL
+//                NVAPI_OK: *pNvDispHandle is now valid
+//                NVAPI_NVIDIA_DEVICE_NOT_FOUND: no NVIDIA device maps to that display name
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_GetUnAttachedAssociatedDisplayName(NvUnAttachedDisplayHandle hNvUnAttachedDisp, NvAPI_ShortString szDisplayName);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_EnableHWCursor
+//
+//   DESCRIPTION: Enable hardware cursor support
+//
+//  SUPPORTED OS: Windows XP
+//
+// RETURN STATUS: NVAPI_ERROR or NVAPI_OK
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_EnableHWCursor(NvDisplayHandle hNvDisplay);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_DisableHWCursor
+//
+//   DESCRIPTION: Disable hardware cursor support
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+// RETURN STATUS: NVAPI_ERROR or NVAPI_OK
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_DisableHWCursor(NvDisplayHandle hNvDisplay);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_GetVBlankCounter
+//
+//   DESCRIPTION: get vblank counter
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+// RETURN STATUS: NVAPI_ERROR or NVAPI_OK
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_GetVBlankCounter(NvDisplayHandle hNvDisplay, NvU32 *pCounter);
+
+///////////////////////////////////////////////////////////////////////////////
+// FUNCTION NAME: NvAPI_SetRefreshRateOverride
+//   DESCRIPTION: Override the refresh rate on the given  display/outputsMask.
+//                The new refresh rate can be applied right away in this API call or deferred to happen with the
+//                next OS modeset. The override is only good for one modeset (doesn't matter it's deferred or immediate).
+//
+//  SUPPORTED OS: Windows XP
+//
+//
+//         INPUT: hNvDisplay - the NVIDIA display handle. It can be NVAPI_DEFAULT_HANDLE or a handle
+//                             enumerated from NvAPI_EnumNVidiaDisplayHandle().
+//
+//                outputsMask - a set of bits that identify all target outputs which are associated with the NVIDIA
+//                              display handle to apply the refresh rate override. Note when SLI is enabled,  the
+//                              outputsMask only applies to the GPU that is driving the display output.
+//
+//                refreshRate - the override value. "0.0" means cancel the override.
+//
+//
+//                bSetDeferred - "0": apply the refresh rate override immediately in this API call.
+//                               "1":  apply refresh rate at the next OS modeset.
+//
+// RETURN STATUS: NVAPI_INVALID_ARGUMENT: hNvDisplay or outputsMask is invalid
+//                NVAPI_OK: the refresh rate override is correct set
+//                NVAPI_ERROR: the operation failed
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_SetRefreshRateOverride(NvDisplayHandle hNvDisplay, NvU32 outputsMask, float refreshRate, NvU32 bSetDeferred);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_GetAssociatedDisplayOutputId
+//
+//   DESCRIPTION: Gets the active outputId associated with the display handle.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+//    PARAMETERS: hNvDisplay(IN) - NVIDIA Display selection. It can be NVAPI_DEFAULT_HANDLE or a handle enumerated from NvAPI_EnumNVidiaDisplayHandle().
+//                outputId(OUT)  - The active display output id associated with the selected display handle hNvDisplay.
+//                                 The outputid will have only one bit set. In case of clone or span this  will indicate the display
+//                                 outputId of the primary display that the GPU is driving.
+// RETURN STATUS: NVAPI_OK: call successful.
+//                NVAPI_NVIDIA_DEVICE_NOT_FOUND: no NVIDIA GPU driving a display was found.
+//                NVAPI_EXPECTED_DISPLAY_HANDLE: hNvDisplay is not a valid display handle.
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_GetAssociatedDisplayOutputId(NvDisplayHandle hNvDisplay, NvU32 *pOutputId);
+
+
+///////////////////////////////////////////////////////////////////////////////
+// FUNCTION NAME:   NvAPI_GetDisplayPortInfo
+//
+// DESCRIPTION:     This API returns the current DP related into on the specified device(monitor)
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+// PARAMETERS:      hNvDisplay(IN) - NVIDIA Display selection. It can be NVAPI_DEFAULT_HANDLE or a handle enumerated from NvAPI_EnumNVidiaDisplayHandle().
+//                  outputId(IN)   - The display output id. If it's "0" then the default outputId from NvAPI_GetAssociatedDisplayOutputId() will be used.
+//                  pInfo(OUT)     - The display port info
+//
+// RETURN STATUS:
+//                  NVAPI_OK - completed request
+//                  NVAPI_ERROR - miscellaneous error occurred
+//                  NVAPI_INVALID_ARGUMENT: Invalid input parameter.
+//
+///////////////////////////////////////////////////////////////////////////////
+typedef enum
+{
+    NV_DP_1_62GBPS            = 6,
+    NV_DP_2_70GBPS            = 0xA,
+} NV_DP_LINK_RATE;
+
+typedef enum
+{
+    NV_DP_1_LANE              = 1,
+    NV_DP_2_LANE              = 2,
+    NV_DP_4_LANE              = 4,
+} NV_DP_LANE_COUNT;
+
+typedef enum
+{
+    NV_DP_COLOR_FORMAT_RGB     = 0,
+    NV_DP_COLOR_FORMAT_YCbCr422,
+    NV_DP_COLOR_FORMAT_YCbCr444,
+} NV_DP_COLOR_FORMAT;
+
+typedef enum
+{
+    NV_DP_COLORIMETRY_RGB = 0,
+    NV_DP_COLORIMETRY_YCbCr_ITU601,
+    NV_DP_COLORIMETRY_YCbCr_ITU709,
+} NV_DP_COLORIMETRY;
+
+typedef enum
+{
+    NV_DP_DYNAMIC_RANGE_VESA  = 0,
+    NV_DP_DYNAMIC_RANGE_CEA,
+} NV_DP_DYNAMIC_RANGE;
+
+typedef enum
+{
+    NV_DP_BPC_DEFAULT         = 0,
+    NV_DP_BPC_6,
+    NV_DP_BPC_8,
+    NV_DP_BPC_10,
+    NV_DP_BPC_12,
+    NV_DP_BPC_16,
+} NV_DP_BPC;
+
+typedef struct
+{
+    NvU32               version;                     // structure version
+    NvU32               dpcd_ver;                    // the DPCD version of the monitor
+    NV_DP_LINK_RATE     maxLinkRate;                 // the max supported link rate
+    NV_DP_LANE_COUNT    maxLaneCount;                // the max supported lane count
+    NV_DP_LINK_RATE     curLinkRate;                 // the current link rate
+    NV_DP_LANE_COUNT    curLaneCount;                // the current lane count
+    NV_DP_COLOR_FORMAT  colorFormat;                 // the current color format
+    NV_DP_DYNAMIC_RANGE dynamicRange;                // the dynamic range
+    NV_DP_COLORIMETRY   colorimetry;                 // ignored in RGB space
+    NV_DP_BPC           bpc;                         // the current bit-per-component;
+    NvU32               isDp                   : 1;  // if the monitor is driven by display port
+    NvU32               isInternalDp           : 1;  // if the monitor is driven by NV Dp transmitter
+    NvU32               isColorCtrlSupported   : 1;  // if the color format change is supported
+    NvU32               is6BPCSupported        : 1;  // if 6 bpc is supported
+    NvU32               is8BPCSupported        : 1;  // if 8 bpc is supported
+    NvU32               is10BPCSupported       : 1;  // if 10 bpc is supported
+    NvU32               is12BPCSupported       : 1;  // if 12 bpc is supported
+    NvU32               is16BPCSupported       : 1;  // if 16 bpc is supported
+    NvU32               isYCrCb422Supported    : 1;  // if YCrCb422 is supported
+    NvU32               isYCrCb444Supported    : 1;  // if YCrCb444 is supported
+ } NV_DISPLAY_PORT_INFO;
+
+#define NV_DISPLAY_PORT_INFO_VER   MAKE_NVAPI_VERSION(NV_DISPLAY_PORT_INFO,1)
+
+NVAPI_INTERFACE NvAPI_GetDisplayPortInfo(NvDisplayHandle hNvDisplay, NvU32 outputId, NV_DISPLAY_PORT_INFO *pInfo);
+
+///////////////////////////////////////////////////////////////////////////////
+// FUNCTION NAME:   NvAPI_SetDisplayPort
+//
+// DESCRIPTION:     This API is used to setup DP related configurations.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+// PARAMETERS:      hNvDisplay(IN) - NVIDIA display handle. It can be NVAPI_DEFAULT_HANDLE or a handle enumerated from NvAPI_EnumNVidiaDisplayHandle().
+//                  outputId(IN)   - This display output ID, when it's "0" it means the default outputId generated from the return of NvAPI_GetAssociatedDisplayOutputId().
+//                  pCfg(IN)       - The display port config structure. If pCfg is NULL, it means to use the driver's default value to setup.
+//
+// RETURN STATUS:
+//                  NVAPI_OK - completed request
+//                  NVAPI_ERROR - miscellaneous error occurred
+//                  NVAPI_INVALID_ARGUMENT: Invalid input parameter.
+///////////////////////////////////////////////////////////////////////////////
+typedef struct
+{
+    NvU32               version;                     // structure version - 2 is latest
+    NV_DP_LINK_RATE     linkRate;                    // the link rate
+    NV_DP_LANE_COUNT    laneCount;                   // the lane count
+    NV_DP_COLOR_FORMAT  colorFormat;                 // the color format to set
+    NV_DP_DYNAMIC_RANGE dynamicRange;                // the dynamic range
+    NV_DP_COLORIMETRY   colorimetry;                 // ignored in RGB space
+    NV_DP_BPC           bpc;                         // the current bit-per-component;
+    NvU32               isHPD               : 1;     // if CPL is making this call due to HPD
+    NvU32               isSetDeferred       : 1;     // requires an OS modeset to finalize the setup if set
+    NvU32               isChromaLpfOff      : 1;     // force the chroma low_pass_filter to be off
+    NvU32               isDitherOff         : 1;     // force to turn off dither
+    NvU32               testLinkTrain       : 1;     // if testing mode, skip validation
+    NvU32               testColorChange     : 1;     // if testing mode, skip validation
+} NV_DISPLAY_PORT_CONFIG;
+
+#define NV_DISPLAY_PORT_CONFIG_VER   MAKE_NVAPI_VERSION(NV_DISPLAY_PORT_CONFIG,2)
+#define NV_DISPLAY_PORT_CONFIG_VER_1 MAKE_NVAPI_VERSION(NV_DISPLAY_PORT_CONFIG,1)
+#define NV_DISPLAY_PORT_CONFIG_VER_2 MAKE_NVAPI_VERSION(NV_DISPLAY_PORT_CONFIG,2)
+
+NVAPI_INTERFACE NvAPI_SetDisplayPort(NvDisplayHandle hNvDisplay, NvU32 outputId, NV_DISPLAY_PORT_CONFIG *pCfg);
+
+///////////////////////////////////////////////////////////////////////////////
+// FUNCTION NAME:   NvAPI_GetHDMISupportInfo
+//
+// DESCRIPTION:     This API returns the current infoframe data on the specified device(monitor)
+//
+//  SUPPORTED OS: Windows Vista and higher
+//
+// PARAMETERS:      hNvDisplay(IN) - NVIDIA Display selection. It can be NVAPI_DEFAULT_HANDLE or a handle enumerated from NvAPI_EnumNVidiaDisplayHandle().
+//                  outputId(IN)   - The display output id. If it's "0" then the default outputId from NvAPI_GetAssociatedDisplayOutputId() will be used.
+//                  pInfo(OUT)     - The monitor and GPU's HDMI support info
+//
+// RETURN STATUS:
+//                  NVAPI_OK - completed request
+//                  NVAPI_ERROR - miscellaneous error occurred
+//                  NVAPI_INVALID_ARGUMENT: Invalid input parameter.
+//
+///////////////////////////////////////////////////////////////////////////////
+typedef struct
+{
+    NvU32      version;                     // structure version
+    NvU32      isGpuHDMICapable       : 1;  // if the GPU can handle HDMI
+    NvU32      isMonUnderscanCapable  : 1;  // if the monitor supports underscan
+    NvU32      isMonBasicAudioCapable : 1;  // if the monitor supports basic audio
+    NvU32      isMonYCbCr444Capable   : 1;  // if YCbCr 4:4:4 is supported
+    NvU32      isMonYCbCr422Capable   : 1;  // if YCbCr 4:2:2 is supported
+    NvU32      isMonxvYCC601Capable   : 1;  // if xvYCC 601 is supported
+    NvU32      isMonxvYCC709Capable   : 1;  // if xvYCC 709 is supported
+    NvU32      isMonHDMI              : 1;  // if the monitor is HDMI (with IEEE's HDMI registry ID)
+    NvU32      EDID861ExtRev;               // the revision number of the EDID 861 extension
+ } NV_HDMI_SUPPORT_INFO;
+
+#define NV_HDMI_SUPPORT_INFO_VER  MAKE_NVAPI_VERSION(NV_HDMI_SUPPORT_INFO,1)
+
+NVAPI_INTERFACE NvAPI_GetHDMISupportInfo(NvDisplayHandle hNvDisplay, NvU32 outputId, NV_HDMI_SUPPORT_INFO *pInfo);
+
+
+///////////////////////////////////////////////////////////////////////////////
+// FUNCTION NAME:   NvAPI_Disp_InfoFrameControl
+//
+// DESCRIPTION:     Controls the InfoFrame values
+//
+//  SUPPORTED OS: Windows Vista and higher
+//
+// PARAMETERS:      displayId(IN)           - Monitor Identifier
+//                  pInfoframeData(IN/OUT)  - Contains data corresponding to InfoFrame
+//
+// RETURN STATUS:
+//                  NVAPI_OK - completed request
+//                  NVAPI_ERROR - miscellaneous error occurred
+//                  NVAPI_INVALID_ARGUMENT: Invalid input parameter.
+//
+///////////////////////////////////////////////////////////////////////////////
+
+typedef enum
+{
+    NV_INFOFRAME_CMD_GET_DEFAULT = 0,     // returns the fields in the infoframe with values set by manufacturer:nvidia/oem
+    NV_INFOFRAME_CMD_RESET,               // sets the fields in the infoframe to auto, and infoframe to default infoframe for use in a set
+    NV_INFOFRAME_CMD_GET,                 // get the current infoframe state
+    NV_INFOFRAME_CMD_SET,                 // set the current infoframe state (flushed to the monitor), the values are one time and does not persist
+    NV_INFOFRAME_CMD_GET_OVERRIDE,        // get the override infoframe state, non-override fields will be set to value = AUTO, overridden fields will have the current override values
+    NV_INFOFRAME_CMD_SET_OVERRIDE,        // set the override infoframe state, non-override fields will be set to value = AUTO, other values indicate override; persist across modeset/reboot
+    NV_INFOFRAME_CMD_GET_PROPERTY,        // get properties associated with infoframe (each of the infoframe type will have properties)
+    NV_INFOFRAME_CMD_SET_PROPERTY,        // set properties associated with infoframe
+} NV_INFOFRAME_CMD;
+
+
+typedef enum
+{
+    NV_INFOFRAME_PROPERTY_MODE_AUTO           = 0, // driver determines whether to send infoframes
+    NV_INFOFRAME_PROPERTY_MODE_ENABLE,             // driver always sends infoframe
+    NV_INFOFRAME_PROPERTY_MODE_DISABLE,            // driver always don't send infoframe
+    NV_INFOFRAME_PROPERTY_MODE_ALLOW_OVERRIDE,     // driver only sends infoframe when client request thru infoframe escape call
+} NV_INFOFRAME_PROPERTY_MODE;
+
+// returns whether the current monitor is in blacklist or force this monitor to be in blacklist
+typedef enum
+{
+    NV_INFOFRAME_PROPERTY_BLACKLIST_FALSE = 0,
+    NV_INFOFRAME_PROPERTY_BLACKLIST_TRUE,
+} NV_INFOFRAME_PROPERTY_BLACKLIST;
+
+typedef struct
+{
+    NvU32 mode      :  4;
+    NvU32 blackList :  2;
+    NvU32 reserved  : 10;
+    NvU32 version   :  8;
+    NvU32 length    :  8;
+} NV_INFOFRAME_PROPERTY;
+
+// byte1 related
+typedef enum
+{
+    NV_INFOFRAME_FIELD_VALUE_AVI_SCANINFO_NODATA    = 0,
+    NV_INFOFRAME_FIELD_VALUE_AVI_SCANINFO_OVERSCAN,
+    NV_INFOFRAME_FIELD_VALUE_AVI_SCANINFO_UNDERSCAN,
+    NV_INFOFRAME_FIELD_VALUE_AVI_SCANINFO_FUTURE,
+    NV_INFOFRAME_FIELD_VALUE_AVI_SCANINFO_AUTO      = 7
+} NV_INFOFRAME_FIELD_VALUE_AVI_SCANINFO;
+
+
+typedef enum
+{
+    NV_INFOFRAME_FIELD_VALUE_AVI_BARDATA_NOT_PRESENT         = 0,
+    NV_INFOFRAME_FIELD_VALUE_AVI_BARDATA_VERTICAL_PRESENT,
+    NV_INFOFRAME_FIELD_VALUE_AVI_BARDATA_HORIZONTAL_PRESENT,
+    NV_INFOFRAME_FIELD_VALUE_AVI_BARDATA_BOTH_PRESENT,
+    NV_INFOFRAME_FIELD_VALUE_AVI_BARDATA_AUTO                = 7
+} NV_INFOFRAME_FIELD_VALUE_AVI_BARDATA;
+
+typedef enum
+{
+    NV_INFOFRAME_FIELD_VALUE_AVI_AFI_ABSENT   = 0,
+    NV_INFOFRAME_FIELD_VALUE_AVI_AFI_PRESENT,
+    NV_INFOFRAME_FIELD_VALUE_AVI_AFI_AUTO     = 3
+} NV_INFOFRAME_FIELD_VALUE_AVI_ACTIVEFORMATINFO;
+
+typedef enum
+{
+    NV_INFOFRAME_FIELD_VALUE_AVI_COLORFORMAT_RGB      = 0,
+    NV_INFOFRAME_FIELD_VALUE_AVI_COLORFORMAT_YCbCr422,
+    NV_INFOFRAME_FIELD_VALUE_AVI_COLORFORMAT_YCbCr444,
+    NV_INFOFRAME_FIELD_VALUE_AVI_COLORFORMAT_FUTURE,
+    NV_INFOFRAME_FIELD_VALUE_AVI_COLORFORMAT_AUTO     = 7
+} NV_INFOFRAME_FIELD_VALUE_AVI_COLORFORMAT;
+
+typedef enum
+{
+    NV_INFOFRAME_FIELD_VALUE_AVI_F17_FALSE = 0,
+    NV_INFOFRAME_FIELD_VALUE_AVI_F17_TRUE,
+    NV_INFOFRAME_FIELD_VALUE_AVI_F17_AUTO = 3
+} NV_INFOFRAME_FIELD_VALUE_AVI_F17;
+
+// byte2 related
+typedef enum
+{
+    NV_INFOFRAME_FIELD_VALUE_AVI_ASPECTRATIOACTIVEPORTION_NO_AFD           = 0,
+    NV_INFOFRAME_FIELD_VALUE_AVI_ASPECTRATIOACTIVEPORTION_RESERVE01,
+    NV_INFOFRAME_FIELD_VALUE_AVI_ASPECTRATIOACTIVEPORTION_RESERVE02,
+    NV_INFOFRAME_FIELD_VALUE_AVI_ASPECTRATIOACTIVEPORTION_RESERVE03,
+    NV_INFOFRAME_FIELD_VALUE_AVI_ASPECTRATIOACTIVEPORTION_LETTERBOX_GT16x9,
+    NV_INFOFRAME_FIELD_VALUE_AVI_ASPECTRATIOACTIVEPORTION_RESERVE05,
+    NV_INFOFRAME_FIELD_VALUE_AVI_ASPECTRATIOACTIVEPORTION_RESERVE06,
+    NV_INFOFRAME_FIELD_VALUE_AVI_ASPECTRATIOACTIVEPORTION_RESERVE07,
+    NV_INFOFRAME_FIELD_VALUE_AVI_ASPECTRATIOACTIVEPORTION_EQUAL_CODEDFRAME = 8,
+    NV_INFOFRAME_FIELD_VALUE_AVI_ASPECTRATIOACTIVEPORTION_CENTER_4x3,
+    NV_INFOFRAME_FIELD_VALUE_AVI_ASPECTRATIOACTIVEPORTION_CENTER_16x9,
+    NV_INFOFRAME_FIELD_VALUE_AVI_ASPECTRATIOACTIVEPORTION_CENTER_14x9,
+    NV_INFOFRAME_FIELD_VALUE_AVI_ASPECTRATIOACTIVEPORTION_RESERVE12,
+    NV_INFOFRAME_FIELD_VALUE_AVI_ASPECTRATIOACTIVEPORTION_4x3_ON_14x9,
+    NV_INFOFRAME_FIELD_VALUE_AVI_ASPECTRATIOACTIVEPORTION_16x9_ON_14x9,
+    NV_INFOFRAME_FIELD_VALUE_AVI_ASPECTRATIOACTIVEPORTION_16x9_ON_4x3,
+    NV_INFOFRAME_FIELD_VALUE_AVI_ASPECTRATIOACTIVEPORTION_AUTO             = 31,
+} NV_INFOFRAME_FIELD_VALUE_AVI_ASPECTRATIOACTIVEPORTION;
+
+typedef enum
+{
+    NV_INFOFRAME_FIELD_VALUE_AVI_ASPECTRATIOCODEDFRAME_NO_DATA = 0,
+    NV_INFOFRAME_FIELD_VALUE_AVI_ASPECTRATIOCODEDFRAME_4x3,
+    NV_INFOFRAME_FIELD_VALUE_AVI_ASPECTRATIOCODEDFRAME_16x9,
+    NV_INFOFRAME_FIELD_VALUE_AVI_ASPECTRATIOCODEDFRAME_FUTURE,
+    NV_INFOFRAME_FIELD_VALUE_AVI_ASPECTRATIOCODEDFRAME_AUTO    = 7
+} NV_INFOFRAME_FIELD_VALUE_AVI_ASPECTRATIOCODEDFRAME;
+
+typedef enum
+{
+    NV_INFOFRAME_FIELD_VALUE_AVI_COLORIMETRY_NO_DATA                   = 0,
+    NV_INFOFRAME_FIELD_VALUE_AVI_COLORIMETRY_SMPTE_170M,
+    NV_INFOFRAME_FIELD_VALUE_AVI_COLORIMETRY_ITUR_BT709,
+    NV_INFOFRAME_FIELD_VALUE_AVI_COLORIMETRY_USE_EXTENDED_COLORIMETRY,
+    NV_INFOFRAME_FIELD_VALUE_AVI_COLORIMETRY_AUTO                      = 7
+} NV_INFOFRAME_FIELD_VALUE_AVI_COLORIMETRY;
+
+// byte 3 related
+typedef enum
+{
+    NV_INFOFRAME_FIELD_VALUE_AVI_NONUNIFORMPICTURESCALING_NO_DATA    = 0,
+    NV_INFOFRAME_FIELD_VALUE_AVI_NONUNIFORMPICTURESCALING_HORIZONTAL,
+    NV_INFOFRAME_FIELD_VALUE_AVI_NONUNIFORMPICTURESCALING_VERTICAL,
+    NV_INFOFRAME_FIELD_VALUE_AVI_NONUNIFORMPICTURESCALING_BOTH,
+    NV_INFOFRAME_FIELD_VALUE_AVI_NONUNIFORMPICTURESCALING_AUTO       = 7
+} NV_INFOFRAME_FIELD_VALUE_AVI_NONUNIFORMPICTURESCALING;
+
+typedef enum
+{
+    NV_INFOFRAME_FIELD_VALUE_AVI_RGBQUANTIZATION_DEFAULT       = 0,
+    NV_INFOFRAME_FIELD_VALUE_AVI_RGBQUANTIZATION_LIMITED_RANGE,
+    NV_INFOFRAME_FIELD_VALUE_AVI_RGBQUANTIZATION_FULL_RANGE,
+    NV_INFOFRAME_FIELD_VALUE_AVI_RGBQUANTIZATION_RESERVED,
+    NV_INFOFRAME_FIELD_VALUE_AVI_RGBQUANTIZATION_AUTO          = 7
+} NV_INFOFRAME_FIELD_VALUE_AVI_RGBQUANTIZATION;
+
+typedef enum
+{
+    NV_INFOFRAME_FIELD_VALUE_AVI_EXTENDEDCOLORIMETRY_XVYCC601     = 0,
+    NV_INFOFRAME_FIELD_VALUE_AVI_EXTENDEDCOLORIMETRY_XVYCC709,
+    NV_INFOFRAME_FIELD_VALUE_AVI_EXTENDEDCOLORIMETRY_SYCC601,
+    NV_INFOFRAME_FIELD_VALUE_AVI_EXTENDEDCOLORIMETRY_ADOBEYCC601,
+    NV_INFOFRAME_FIELD_VALUE_AVI_EXTENDEDCOLORIMETRY_ADOBERGB,
+    NV_INFOFRAME_FIELD_VALUE_AVI_EXTENDEDCOLORIMETRY_RESERVED05,
+    NV_INFOFRAME_FIELD_VALUE_AVI_EXTENDEDCOLORIMETRY_RESERVED06,
+    NV_INFOFRAME_FIELD_VALUE_AVI_EXTENDEDCOLORIMETRY_RESERVED07,
+    NV_INFOFRAME_FIELD_VALUE_AVI_EXTENDEDCOLORIMETRY_AUTO         = 15
+} NV_INFOFRAME_FIELD_VALUE_AVI_EXTENDEDCOLORIMETRY;
+
+typedef enum
+{
+    NV_INFOFRAME_FIELD_VALUE_AVI_ITC_VIDEO_CONTENT = 0,
+    NV_INFOFRAME_FIELD_VALUE_AVI_ITC_ITCONTENT,
+    NV_INFOFRAME_FIELD_VALUE_AVI_ITC_AUTO          = 3
+} NV_INFOFRAME_FIELD_VALUE_AVI_ITC;
+
+// byte 4 related
+typedef enum
+{
+    NV_INFOFRAME_FIELD_VALUE_AVI_PIXELREPETITION_NONE = 0,
+    NV_INFOFRAME_FIELD_VALUE_AVI_PIXELREPETITION_X02,
+    NV_INFOFRAME_FIELD_VALUE_AVI_PIXELREPETITION_X03,
+    NV_INFOFRAME_FIELD_VALUE_AVI_PIXELREPETITION_X04,
+    NV_INFOFRAME_FIELD_VALUE_AVI_PIXELREPETITION_X05,
+    NV_INFOFRAME_FIELD_VALUE_AVI_PIXELREPETITION_X06,
+    NV_INFOFRAME_FIELD_VALUE_AVI_PIXELREPETITION_X07,
+    NV_INFOFRAME_FIELD_VALUE_AVI_PIXELREPETITION_X08,
+    NV_INFOFRAME_FIELD_VALUE_AVI_PIXELREPETITION_X09,
+    NV_INFOFRAME_FIELD_VALUE_AVI_PIXELREPETITION_X10,
+    NV_INFOFRAME_FIELD_VALUE_AVI_PIXELREPETITION_RESERVED10,
+    NV_INFOFRAME_FIELD_VALUE_AVI_PIXELREPETITION_RESERVED11,
+    NV_INFOFRAME_FIELD_VALUE_AVI_PIXELREPETITION_RESERVED12,
+    NV_INFOFRAME_FIELD_VALUE_AVI_PIXELREPETITION_RESERVED13,
+    NV_INFOFRAME_FIELD_VALUE_AVI_PIXELREPETITION_RESERVED14,
+    NV_INFOFRAME_FIELD_VALUE_AVI_PIXELREPETITION_RESERVED15,
+    NV_INFOFRAME_FIELD_VALUE_AVI_PIXELREPETITION_AUTO         = 31
+} NV_INFOFRAME_FIELD_VALUE_AVI_PIXELREPETITION;
+
+typedef enum
+{
+    NV_INFOFRAME_FIELD_VALUE_AVI_CONTENTTYPE_GRAPHICS = 0,
+    NV_INFOFRAME_FIELD_VALUE_AVI_CONTENTTYPE_PHOTO,
+    NV_INFOFRAME_FIELD_VALUE_AVI_CONTENTTYPE_CINEMA,
+    NV_INFOFRAME_FIELD_VALUE_AVI_CONTENTTYPE_GAME,
+    NV_INFOFRAME_FIELD_VALUE_AVI_CONTENTTYPE_AUTO     = 7
+} NV_INFOFRAME_FIELD_VALUE_AVI_CONTENTTYPE;
+
+typedef enum
+{
+    NV_INFOFRAME_FIELD_VALUE_AVI_YCCQUANTIZATION_LIMITED_RANGE = 0,
+    NV_INFOFRAME_FIELD_VALUE_AVI_YCCQUANTIZATION_FULL_RANGE,
+    NV_INFOFRAME_FIELD_VALUE_AVI_YCCQUANTIZATION_RESERVED02,
+    NV_INFOFRAME_FIELD_VALUE_AVI_YCCQUANTIZATION_RESERVED03,
+    NV_INFOFRAME_FIELD_VALUE_AVI_YCCQUANTIZATION_AUTO          = 7
+} NV_INFOFRAME_FIELD_VALUE_AVI_YCCQUANTIZATION;
+
+
+// Adding an Auto bit to each field
+typedef struct
+{
+    NvU32 vic                     : 8;
+    NvU32 pixelRepeat             : 5;
+    NvU32 colorSpace              : 3;
+    NvU32 colorimetry             : 3;
+    NvU32 extendedColorimetry     : 4;
+    NvU32 rgbQuantizationRange    : 3;
+    NvU32 yccQuantizationRange    : 3;
+    NvU32 itContent               : 2;
+    NvU32 contentTypes            : 3;
+    NvU32 scanInfo                : 3;
+    NvU32 activeFormatInfoPresent : 2;
+    NvU32 activeFormatAspectRatio : 5;
+    NvU32 picAspectRatio          : 3;
+    NvU32 nonuniformScaling       : 3;
+    NvU32 barInfo                 : 3;
+    NvU32 top_bar                 : 17;
+    NvU32 bottom_bar              : 17;
+    NvU32 left_bar                : 17;
+    NvU32 right_bar               : 17;
+    NvU32 Future17                : 2;
+    NvU32 Future47                : 2;
+} NV_INFOFRAME_VIDEO;
+
+// byte 1 related
+typedef enum
+{
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CHANNELCOUNT_IN_HEADER = 0,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CHANNELCOUNT_2,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CHANNELCOUNT_3,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CHANNELCOUNT_4,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CHANNELCOUNT_5,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CHANNELCOUNT_6,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CHANNELCOUNT_7,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CHANNELCOUNT_8,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CHANNELCOUNT_AUTO      = 15
+} NV_INFOFRAME_FIELD_VALUE_AUDIO_CHANNELCOUNT;
+
+typedef enum
+{
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CODINGTYPE_IN_HEADER                  = 0,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CODINGTYPE_PCM,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CODINGTYPE_AC3,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CODINGTYPE_MPEG1,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CODINGTYPE_MP3,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CODINGTYPE_MPEG2,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CODINGTYPE_AACLC,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CODINGTYPE_DTS,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CODINGTYPE_ATRAC,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CODINGTYPE_DSD,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CODINGTYPE_EAC3,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CODINGTYPE_DTSHD,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CODINGTYPE_MLP,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CODINGTYPE_DST,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CODINGTYPE_WMAPRO,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CODINGTYPE_USE_CODING_EXTENSION_TYPE,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CODINGTYPE_AUTO                      = 31
+} NV_INFOFRAME_FIELD_VALUE_AUDIO_CODINGTYPE;
+
+// byte 2 related
+typedef enum
+{
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_SAMPLESIZE_IN_HEADER = 0,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_SAMPLESIZE_16BITS,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_SAMPLESIZE_20BITS,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_SAMPLESIZE_24BITS,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_SAMPLESIZE_AUTO      = 7
+} NV_INFOFRAME_FIELD_VALUE_AUDIO_SAMPLESIZE;
+
+typedef enum
+{
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_SAMPLEFREQUENCY_IN_HEADER = 0,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_SAMPLEFREQUENCY_32000HZ,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_SAMPLEFREQUENCY_44100HZ,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_SAMPLEFREQUENCY_48000HZ,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_SAMPLEFREQUENCY_88200KHZ,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_SAMPLEFREQUENCY_96000KHZ,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_SAMPLEFREQUENCY_176400KHZ,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_SAMPLEFREQUENCY_192000KHZ,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_SAMPLEFREQUENCY_AUTO      = 15
+} NV_INFOFRAME_FIELD_VALUE_AUDIO_SAMPLEFREQUENCY;
+
+// byte 3 related
+typedef enum
+{
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CODINGEXTENSIONTYPE_USE_CODING_TYPE = 0,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CODINGEXTENSIONTYPE_HEAAC,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CODINGEXTENSIONTYPE_HEAACV2,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CODINGEXTENSIONTYPE_MPEGSURROUND,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CODINGEXTENSIONTYPE_RESERVE04,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CODINGEXTENSIONTYPE_RESERVE05,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CODINGEXTENSIONTYPE_RESERVE06,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CODINGEXTENSIONTYPE_RESERVE07,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CODINGEXTENSIONTYPE_RESERVE08,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CODINGEXTENSIONTYPE_RESERVE09,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CODINGEXTENSIONTYPE_RESERVE10,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CODINGEXTENSIONTYPE_RESERVE11,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CODINGEXTENSIONTYPE_RESERVE12,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CODINGEXTENSIONTYPE_RESERVE13,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CODINGEXTENSIONTYPE_RESERVE14,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CODINGEXTENSIONTYPE_RESERVE15,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CODINGEXTENSIONTYPE_RESERVE16,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CODINGEXTENSIONTYPE_RESERVE17,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CODINGEXTENSIONTYPE_RESERVE18,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CODINGEXTENSIONTYPE_RESERVE19,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CODINGEXTENSIONTYPE_RESERVE20,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CODINGEXTENSIONTYPE_RESERVE21,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CODINGEXTENSIONTYPE_RESERVE22,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CODINGEXTENSIONTYPE_RESERVE23,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CODINGEXTENSIONTYPE_RESERVE24,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CODINGEXTENSIONTYPE_RESERVE25,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CODINGEXTENSIONTYPE_RESERVE26,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CODINGEXTENSIONTYPE_RESERVE27,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CODINGEXTENSIONTYPE_RESERVE28,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CODINGEXTENSIONTYPE_RESERVE29,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CODINGEXTENSIONTYPE_RESERVE30,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CODINGEXTENSIONTYPE_RESERVE31,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CODINGEXTENSIONTYPE_AUTO           = 63
+} NV_INFOFRAME_FIELD_VALUE_AUDIO_CODINGEXTENSIONTYPE;
+
+// byte 4 related
+typedef enum
+{
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CHANNELALLOCATION_X_X_X_X_X_X_FR_FL           =0,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CHANNELALLOCATION_X_X_X_X_X_LFE_FR_FL,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CHANNELALLOCATION_X_X_X_X_FC_X_FR_FL,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CHANNELALLOCATION_X_X_X_X_FC_LFE_FR_FL,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CHANNELALLOCATION_X_X_X_RC_X_X_FR_FL,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CHANNELALLOCATION_X_X_X_RC_X_LFE_FR_FL,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CHANNELALLOCATION_X_X_X_RC_FC_X_FR_FL,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CHANNELALLOCATION_X_X_X_RC_FC_LFE_FR_FL,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CHANNELALLOCATION_X_X_RR_RL_X_X_FR_FL,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CHANNELALLOCATION_X_X_RR_RL_X_LFE_FR_FL,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CHANNELALLOCATION_X_X_RR_RL_FC_X_FR_FL,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CHANNELALLOCATION_X_X_RR_RL_FC_LFE_FR_FL,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CHANNELALLOCATION_X_RC_RR_RL_X_X_FR_FL,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CHANNELALLOCATION_X_RC_RR_RL_X_LFE_FR_FL,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CHANNELALLOCATION_X_RC_RR_RL_FC_X_FR_FL,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CHANNELALLOCATION_X_RC_RR_RL_FC_LFE_FR_FL,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CHANNELALLOCATION_RRC_RLC_RR_RL_X_X_FR_FL,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CHANNELALLOCATION_RRC_RLC_RR_RL_X_LFE_FR_FL,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CHANNELALLOCATION_RRC_RLC_RR_RL_FC_X_FR_FL,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CHANNELALLOCATION_RRC_RLC_RR_RL_FC_LFE_FR_FL,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CHANNELALLOCATION_FRC_FLC_X_X_X_X_FR_FL,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CHANNELALLOCATION_FRC_FLC_X_X_X_LFE_FR_FL,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CHANNELALLOCATION_FRC_FLC_X_X_FC_X_FR_FL,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CHANNELALLOCATION_FRC_FLC_X_X_FC_LFE_FR_FL,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CHANNELALLOCATION_FRC_FLC_X_RC_X_X_FR_FL,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CHANNELALLOCATION_FRC_FLC_X_RC_X_LFE_FR_FL,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CHANNELALLOCATION_FRC_FLC_X_RC_FC_X_FR_FL,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CHANNELALLOCATION_FRC_FLC_X_RC_FC_LFE_FR_FL,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CHANNELALLOCATION_FRC_FLC_RR_RL_X_X_FR_FL,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CHANNELALLOCATION_FRC_FLC_RR_RL_X_LFE_FR_FL,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CHANNELALLOCATION_FRC_FLC_RR_RL_FC_X_FR_FL,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CHANNELALLOCATION_FRC_FLC_RR_RL_FC_LFE_FR_FL,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CHANNELALLOCATION_X_FCH_RR_RL_FC_X_FR_FL,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CHANNELALLOCATION_X_FCH_RR_RL_FC_LFE_FR_FL,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CHANNELALLOCATION_TC_X_RR_RL_FC_X_FR_FL,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CHANNELALLOCATION_TC_X_RR_RL_FC_LFE_FR_FL,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CHANNELALLOCATION_FRH_FLH_RR_RL_X_X_FR_FL,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CHANNELALLOCATION_FRH_FLH_RR_RL_X_LFE_FR_FL,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CHANNELALLOCATION_FRW_FLW_RR_RL_X_X_FR_FL,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CHANNELALLOCATION_FRW_FLW_RR_RL_X_LFE_FR_FL,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CHANNELALLOCATION_TC_RC_RR_RL_FC_X_FR_FL,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CHANNELALLOCATION_TC_RC_RR_RL_FC_LFE_FR_FL,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CHANNELALLOCATION_FCH_RC_RR_RL_FC_X_FR_FL,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CHANNELALLOCATION_FCH_RC_RR_RL_FC_LFE_FR_FL,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CHANNELALLOCATION_TC_FCH_RR_RL_FC_X_FR_FL,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CHANNELALLOCATION_TC_FCH_RR_RL_FC_LFE_FR_FL,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CHANNELALLOCATION_FRH_FLH_RR_RL_FC_X_FR_FL,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CHANNELALLOCATION_FRH_FLH_RR_RL_FC_LFE_FR_FL,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CHANNELALLOCATION_FRW_FLW_RR_RL_FC_X_FR_FL,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CHANNELALLOCATION_FRW_FLW_RR_RL_FC_LFE_FR_FL  = 0X31,
+    // all other values should default to auto
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_CHANNELALLOCATION_AUTO                        = 0x1FF
+} NV_INFOFRAME_FIELD_VALUE_AUDIO_CHANNELALLOCATION;
+
+// byte 5 related
+typedef enum
+{
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_LFEPLAYBACKLEVEL_NO_DATA    = 0,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_LFEPLAYBACKLEVEL_0DB,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_LFEPLAYBACKLEVEL_PLUS10DB,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_LFEPLAYBACKLEVEL_RESERVED03,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_LFEPLAYBACKLEVEL_AUTO       = 7
+} NV_INFOFRAME_FIELD_VALUE_AUDIO_LFEPLAYBACKLEVEL;
+
+typedef enum
+{
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_LEVELSHIFTVALUES_0DB  = 0,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_LEVELSHIFTVALUES_1DB,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_LEVELSHIFTVALUES_2DB,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_LEVELSHIFTVALUES_3DB,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_LEVELSHIFTVALUES_4DB,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_LEVELSHIFTVALUES_5DB,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_LEVELSHIFTVALUES_6DB,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_LEVELSHIFTVALUES_7DB,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_LEVELSHIFTVALUES_8DB,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_LEVELSHIFTVALUES_9DB,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_LEVELSHIFTVALUES_10DB,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_LEVELSHIFTVALUES_11DB,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_LEVELSHIFTVALUES_12DB,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_LEVELSHIFTVALUES_13DB,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_LEVELSHIFTVALUES_14DB,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_LEVELSHIFTVALUES_15DB,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_LEVELSHIFTVALUES_AUTO = 31
+} NV_INFOFRAME_FIELD_VALUE_AUDIO_LEVELSHIFTVALUES;
+
+typedef enum
+{
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_DOWNMIX_PERMITTED  = 0,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_DOWNMIX_PROHIBITED,
+    NV_INFOFRAME_FIELD_VALUE_AUDIO_DOWNMIX_AUTO       = 3
+} NV_INFOFRAME_FIELD_VALUE_AUDIO_DOWNMIX;
+
+typedef struct
+{
+    NvU32 codingType          : 5;
+    NvU32 codingExtensionType : 6;
+    NvU32 sampleSize          : 3;
+    NvU32 sampleRate          : 4;
+    NvU32 channelCount        : 4;
+    NvU32 speakerPlacement    : 9;
+    NvU32 downmixInhibit      : 2;
+    NvU32 lfePlaybackLevel    : 3;
+    NvU32 levelShift          : 5;
+    NvU32 Future12            : 2;
+    NvU32 Future2x            : 4;
+    NvU32 Future3x            : 4;
+    NvU32 Future52            : 2;
+    NvU32 Future6             : 9;
+    NvU32 Future7             : 9;
+    NvU32 Future8             : 9;
+    NvU32 Future9             : 9;
+    NvU32 Future10            : 9;
+} NV_INFOFRAME_AUDIO;
+
+typedef struct
+{
+    NvU32 version; // version of this structure
+    NvU16 size;    // size of this structure
+    NvU8  cmd;     // The actions to perform from NV_INFOFRAME_CMD
+    NvU8  type;    // type of infoframe
+
+    union
+    {
+        NV_INFOFRAME_PROPERTY     property;  // This is NVIDIA specific and corresponds to the property cmds and associated infoframe
+        NV_INFOFRAME_AUDIO        audio;
+        NV_INFOFRAME_VIDEO        video;
+    } infoframe;
+} NV_INFOFRAME_DATA;
+
+#define NV_INFOFRAME_DATA_VER   MAKE_NVAPI_VERSION(NV_INFOFRAME_DATA,1)
+
+NVAPI_INTERFACE NvAPI_Disp_InfoFrameControl(NvU32 displayId, NV_INFOFRAME_DATA *pInfoframeData);
+
+
+///////////////////////////////////////////////////////////////////////////////
+// FUNCTION NAME:   NvAPI_Disp_ColorControl
+//
+// DESCRIPTION:     Controls the Color values
+//
+//  SUPPORTED OS: Windows Vista and higher
+//
+// PARAMETERS:      displayId(IN)           - Monitor Identifier
+//                  pColorData(IN/OUT)      - Contains data corresponding to color information
+//
+// RETURN STATUS:
+//                  NVAPI_OK - completed request
+//                  NVAPI_ERROR - miscellaneous error occurred
+//                  NVAPI_INVALID_ARGUMENT: Invalid input parameter.
+//
+///////////////////////////////////////////////////////////////////////////////
+
+typedef enum
+{
+    NV_COLOR_CMD_GET                 = 1,
+    NV_COLOR_CMD_SET,
+    NV_COLOR_CMD_IS_SUPPORTED_COLOR,
+    NV_COLOR_CMD_GET_DEFAULT
+} NV_COLOR_CMD;
+
+// See Table 14 of CEA-861E.  Not all this is supported by GPU.
+typedef enum
+{
+    NV_COLOR_FORMAT_RGB             = 0,
+    NV_COLOR_FORMAT_YUV422,
+    NV_COLOR_FORMAT_YUV444,
+    NV_COLOR_FORMAT_DEFAULT         = 0xFE,
+    NV_COLOR_FORMAT_AUTO            = 0xFF
+} NV_COLOR_FORMAT;
+
+typedef enum
+{
+    NV_COLOR_COLORIMETRY_RGB             = 0,
+    NV_COLOR_COLORIMETRY_YCC601,
+    NV_COLOR_COLORIMETRY_YCC709,
+    NV_COLOR_COLORIMETRY_XVYCC601,
+    NV_COLOR_COLORIMETRY_XVYCC709,
+    NV_COLOR_COLORIMETRY_SYCC601,
+    NV_COLOR_COLORIMETRY_ADOBEYCC601,
+    NV_COLOR_COLORIMETRY_ADOBERGB,
+    NV_COLOR_COLORIMETRY_DEFAULT         = 0xFE,
+    NV_COLOR_COLORIMETRY_AUTO            = 0xFF
+} NV_COLOR_COLORIMETRY;
+
+typedef struct
+{
+    NvU32 version; // version of this structure
+    NvU16 size;    // size of this structure
+    NvU8  cmd;
+    struct
+    {
+        NvU8  colorFormat;
+        NvU8  colorimetry;
+    } data;
+} NV_COLOR_DATA;
+
+NVAPI_INTERFACE NvAPI_Disp_ColorControl(NvU32 displayId, NV_COLOR_DATA *pColorData);
+#define NV_COLOR_DATA_VER   MAKE_NVAPI_VERSION(NV_COLOR_DATA,1)
+
+
+//-----------------------------------------------------------------------------
+// DirectX APIs
+//-----------------------------------------------------------------------------
+typedef struct
+{
+    NvU32 version;                    // Structure version
+    NvU32 maxNumAFRGroups;            // [OUT] The maximum possible value of numAFRGroups
+    NvU32 numAFRGroups;               // [OUT] The number of AFR groups enabled in the system
+    NvU32 currentAFRIndex;            // [OUT] The AFR group index for the frame currently being rendered
+    NvU32 nextFrameAFRIndex;          // [OUT] What the AFR group index will be for the next frame (i.e. after calling Present)
+    NvU32 previousFrameAFRIndex;      // [OUT] The AFR group index that was used for the previous frame (~0 if more than one frame has not been rendered yet)
+    NvU32 bIsCurAFRGroupNew;          // [OUT] boolean: Is this frame the first time running on the current AFR group
+} NV_GET_CURRENT_SLI_STATE;
+#define NV_GET_CURRENT_SLI_STATE_VER  MAKE_NVAPI_VERSION(NV_GET_CURRENT_SLI_STATE,1)
+
+
+#if defined(_D3D9_H_) || defined(__d3d10_h__) || defined(__d3d11_h__)
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME:   NvAPI_D3D_GetCurrentSLIState
+//
+// DESCRIPTION:     Returns the current SLI state for this device.  The struct
+//                  contains the number of AFR groups, the current AFR group index
+//                  and what the AFR group index will be for the next frame.
+//                  pDevice can be either a IDirect3DDevice9 or ID3D10Device ptr.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+// RETURN STATUS:
+//                  NVAPI_OK - completed request
+//                  NVAPI_ERROR - error occurred
+//
+///////////////////////////////////////////////////////////////////////////////
+
+NVAPI_INTERFACE NvAPI_D3D_GetCurrentSLIState(IUnknown *pDevice, NV_GET_CURRENT_SLI_STATE *pSliState);
+
+#endif //if defined(_D3D9_H_) || defined(__d3d10_h__) || defined(__d3d11_h__)
+
+#if defined(_D3D9_H_)
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME:   NvAPI_D3D9_RegisterResource
+//
+// DESCRIPTION:     To bind a resource (surface/texture) so that it can be retrieved
+//                  internally by nvapi.
+//
+//  SUPPORTED OS: Windows XP and higher
+// INPUT:           pResource   (IN)    surface/texture
+//
+// RETURN STATUS:
+//                  NVAPI_OK - completed request
+//                  NVAPI_ERROR - error occurred
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_D3D9_RegisterResource(IDirect3DResource9* pResource);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME:   NvAPI_D3D9_UnregisterResource
+//
+// DESCRIPTION:     To unbind a resource (surface/texture) after usage.
+//
+//  SUPPORTED OS: Windows XP and higher
+// INPUT:           pResource   (IN)    surface/texture
+//
+// RETURN STATUS:
+//                  NVAPI_OK - completed request
+//                  NVAPI_ERROR - error occurred
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_D3D9_UnregisterResource(IDirect3DResource9* pResource);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_D3D9_AliasSurfaceAsTexture
+//
+//   DESCRIPTION: Create a texture that is an alias of a surface registered with NvAPI.  The
+//                new texture can be bound with IDirect3DDevice9::SetTexture().  Note that the texture must
+//                be unbound before drawing to the surface again.
+//                Unless the USE_SUPER flag is passed, MSAA surfaces will be resolved before
+//                being used as a texture.  MSAA depth buffers are resolved with a point filter,
+//                and non-depth MSAA surfaces are resolved with a linear filter.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+//         INPUT:  pDev      (IN)   The D3D device that owns the objects
+//                 pSurface  (IN)   Pointer to a surface that has been registered with NvAPI
+//                                  to provide a texture alias to
+//                 ppTexture (OUT)  Fill with the texture created
+//                 dwFlag    (IN)   NVAPI_ALIAS_SURFACE_FLAG to describe how to handle the texture
+//
+// RETURN STATUS:
+//                  NVAPI_OK - completed request
+//                  NVAPI_INVALID_POINTER - A null pointer was passed as an argument
+//                  NVAPI_INVALID_ARGUMENT - One of the arguments was invalid, probably dwFlag.
+//                  NVAPI_UNREGISTERED_RESOURCE - pSurface has not been registered with NvAPI
+//                  NVAPI_ERROR - error occurred
+//
+///////////////////////////////////////////////////////////////////////////////
+typedef enum {
+    NVAPI_ALIAS_SURFACE_FLAG_NONE                     = 0x00000000,
+    NVAPI_ALIAS_SURFACE_FLAG_USE_SUPER                = 0x00000001,  // Use the surface's msaa buffer directly as a texture, rather than resolving. (This is much slower, but potentially has higher quality.)
+    NVAPI_ALIAS_SURFACE_FLAG_MASK                     = 0x00000001
+} NVAPI_ALIAS_SURFACE_FLAG;
+
+NVAPI_INTERFACE NvAPI_D3D9_AliasSurfaceAsTexture(IDirect3DDevice9* pDev,
+                                                 IDirect3DSurface9* pSurface,
+                                                 IDirect3DTexture9 **ppTexture,
+                                                 DWORD dwFlag);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME:   NvAPI_D3D9_StretchRectEx
+//
+// DESCRIPTION:     Copy the contents of the source resource to the destination
+//                  resource.  This function can convert
+//                  between a wider range of surfaces than
+//                  IDirect3DDevice9::StretchRect.  For example, it can copy
+//                  from a depth/stencil surface to a texture.
+//                  Note that the source and destination resources *must* be registered
+//                  with NvAPI before being used with NvAPI_D3D9_StretchRectEx.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+// INPUT:           pDevice        (IN)     The D3D device that owns the objects.
+//                  pSourceResource(IN)     Pointer to the source resource.
+//                  pSrcRect       (IN)     Defines the rectangle on the source to copy from.  If null, copy from the entire resource.
+//                  pDestResource  (IN)     Pointer to the destination resource.
+//                  pDstRect       (IN)     Defines the rectangle on the destination to copy to.  If null, copy to the entire resource.
+//                  Filter         (IN)     Choose a filtering method: D3DTEXF_NONE, D3DTEXF_POINT, D3DTEXF_LINEAR.
+//
+// RETURN STATUS:
+//                  NVAPI_OK - completed request
+//                  NVAPI_INVALID_POINTER - An invalid pointer was passed as an argument (probably NULL)
+//                  NVAPI_INVALID_ARGUMENT - One of the arguments was invalid
+//                  NVAPI_UNREGISTERED_RESOURCE - a resource was passed in without being registered
+//                  NVAPI_ERROR - error occurred
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_D3D9_StretchRectEx(IDirect3DDevice9 * pDevice,
+                                         IDirect3DResource9 * pSourceResource,
+                                         CONST RECT * pSourceRect,
+                                         IDirect3DResource9 * pDestResource,
+                                         CONST RECT * pDestRect,
+                                         D3DTEXTUREFILTERTYPE Filter);
+
+
+#endif //if defined(_D3D9_H_)
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_GPU_GetGpuCoreCount
+//
+//   DESCRIPTION: Retrieves the total number of Cores defined for a GPU
+//                Returns 0 on architectures that don't define GPU Core's
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+// RETURN STATUS: NVAPI_INVALID_ARGUMENT: pCount is NULL
+//                NVAPI_OK: *pCount is set
+//                NVAPI_NVIDIA_DEVICE_NOT_FOUND: no NVIDIA GPU driving a display was found
+//                NVAPI_EXPECTED_PHYSICAL_GPU_HANDLE: hPhysicalGpu was not a physical GPU handle
+//                NVAPI_NOT_SUPPORTED: API call is not supported on current architecture
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_GPU_GetGpuCoreCount(NvPhysicalGpuHandle hPhysicalGpu,NvU32 *pCount);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_GPU_GetAllOutputs
+//
+//   DESCRIPTION: Returns set of all GPU-output identifiers as a bitmask.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+// RETURN STATUS: NVAPI_INVALID_ARGUMENT: hPhysicalGpu or pOutputsMask is NULL
+//                NVAPI_OK: *pOutputsMask contains a set of GPU-output identifiers
+//                NVAPI_NVIDIA_DEVICE_NOT_FOUND: no NVIDIA GPU driving a display was found
+//                NVAPI_EXPECTED_PHYSICAL_GPU_HANDLE: hPhysicalGpu was not a physical GPU handle
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_GPU_GetAllOutputs(NvPhysicalGpuHandle hPhysicalGpu,NvU32 *pOutputsMask);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_GPU_GetConnectedOutputs
+//
+//   DESCRIPTION: Same as NvAPI_GPU_GetAllOutputs but returns only the set of GPU-output
+//                identifiers that are connected to display devices.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+// RETURN STATUS: NVAPI_INVALID_ARGUMENT: hPhysicalGpu or pOutputsMask is NULL
+//                NVAPI_OK: *pOutputsMask contains a set of GPU-output identifiers
+//                NVAPI_NVIDIA_DEVICE_NOT_FOUND: no NVIDIA GPU driving a display was found
+//                NVAPI_EXPECTED_PHYSICAL_GPU_HANDLE: hPhysicalGpu was not a physical GPU handle
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_GPU_GetConnectedOutputs(NvPhysicalGpuHandle hPhysicalGpu, NvU32 *pOutputsMask);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_GPU_GetConnectedSLIOutputs
+//
+//   DESCRIPTION: Same as NvAPI_GPU_GetConnectedOutputs but returns only the set of GPU-output
+//                identifiers that can be selected in an SLI configuration.
+//                NOTE: This function matches NvAPI_GPU_GetConnectedOutputs
+//                 - On systems which are not SLI capable.
+//                 - If the queried GPU is not part of a active SLI group.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+// RETURN STATUS: NVAPI_INVALID_ARGUMENT: hPhysicalGpu or pOutputsMask is NULL
+//                NVAPI_OK: *pOutputsMask contains a set of GPU-output identifiers
+//                NVAPI_NVIDIA_DEVICE_NOT_FOUND: no NVIDIA GPU driving a display was found
+//                NVAPI_EXPECTED_PHYSICAL_GPU_HANDLE: hPhysicalGpu was not a physical GPU handle
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_GPU_GetConnectedSLIOutputs(NvPhysicalGpuHandle hPhysicalGpu, NvU32 *pOutputsMask);
+
+
+
+typedef enum
+{
+    NV_MONITOR_CONN_TYPE_UNINITIALIZED = 0,
+    NV_MONITOR_CONN_TYPE_VGA,
+    NV_MONITOR_CONN_TYPE_COMPONENT,
+    NV_MONITOR_CONN_TYPE_SVIDEO,
+    NV_MONITOR_CONN_TYPE_HDMI,
+    NV_MONITOR_CONN_TYPE_DVI,
+    NV_MONITOR_CONN_TYPE_LVDS,
+    NV_MONITOR_CONN_TYPE_DP,
+    NV_MONITOR_CONN_TYPE_COMPOSITE,
+    NV_MONITOR_CONN_TYPE_UNKNOWN =  -1
+} NV_MONITOR_CONN_TYPE;
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_GPU_GetConnectedOutputsWithLidState
+//
+//   DESCRIPTION: Similar to NvAPI_GPU_GetConnectedOutputs this API returns the connected display identifiers that are connected
+//                as a output mask but unlike NvAPI_GPU_GetConnectedOutputs this API "always" reflects the Lid State in the output mask.
+//                Thus if you expect the LID close state to be available in the connection mask use this API.
+//                If LID is closed then this API will remove the LID panel from the connected display identifiers.
+//                If LID is open then this API will reflect the LID panel in the connected display identifiers.
+//                Note:This API should be used on laptop systems and on systems where LID state is required in the connection output mask.
+//                     On desktop systems the returned identifiers will match NvAPI_GPU_GetConnectedOutputs.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+// RETURN STATUS: NVAPI_INVALID_ARGUMENT: hPhysicalGpu or pOutputsMask is NULL
+//                NVAPI_OK: *pOutputsMask contains a set of GPU-output identifiers
+//                NVAPI_NVIDIA_DEVICE_NOT_FOUND: no NVIDIA GPU driving a display was found
+//                NVAPI_EXPECTED_PHYSICAL_GPU_HANDLE: hPhysicalGpu was not a physical GPU handle
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_GPU_GetConnectedOutputsWithLidState(NvPhysicalGpuHandle hPhysicalGpu, NvU32 *pOutputsMask);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_GPU_GetConnectedSLIOutputsWithLidState
+//
+//   DESCRIPTION: Same as NvAPI_GPU_GetConnectedOutputsWithLidState but returns only the set of GPU-output
+//                identifiers that can be selected in an SLI configuration. With SLI disabled
+//                this function matches NvAPI_GPU_GetConnectedOutputsWithLidState
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+// RETURN STATUS: NVAPI_INVALID_ARGUMENT: hPhysicalGpu or pOutputsMask is NULL
+//                NVAPI_OK: *pOutputsMask contains a set of GPU-output identifiers
+//                NVAPI_NVIDIA_DEVICE_NOT_FOUND: no NVIDIA GPU driving a display was found
+//                NVAPI_EXPECTED_PHYSICAL_GPU_HANDLE: hPhysicalGpu was not a physical GPU handle
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_GPU_GetConnectedSLIOutputsWithLidState(NvPhysicalGpuHandle hPhysicalGpu, NvU32 *pOutputsMask);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_GPU_GetSystemType
+//
+//   DESCRIPTION: Returns information to identify if the GPU type is for a laptop system or a desktop system.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+// RETURN STATUS: NVAPI_INVALID_ARGUMENT: hPhysicalGpu or pOutputsMask is NULL
+//                NVAPI_OK: *pSystemType contains the GPU system type
+//                NVAPI_NVIDIA_DEVICE_NOT_FOUND: no NVIDIA GPU driving a display was found
+//                NVAPI_EXPECTED_PHYSICAL_GPU_HANDLE: hPhysicalGpu was not a physical GPU handle
+//
+///////////////////////////////////////////////////////////////////////////////
+typedef enum
+{
+    NV_SYSTEM_TYPE_UNKNOWN = 0,
+    NV_SYSTEM_TYPE_LAPTOP  = 1,
+    NV_SYSTEM_TYPE_DESKTOP = 2,
+
+} NV_SYSTEM_TYPE;
+
+NVAPI_INTERFACE NvAPI_GPU_GetSystemType(NvPhysicalGpuHandle hPhysicalGpu, NV_SYSTEM_TYPE *pSystemType);
+
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_GPU_GetActiveOutputs
+//
+//   DESCRIPTION: Same as NvAPI_GPU_GetAllOutputs but returns only the set of GPU-output
+//                identifiers that are actively driving display devices.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+// RETURN STATUS: NVAPI_INVALID_ARGUMENT: hPhysicalGpu or pOutputsMask is NULL
+//                NVAPI_OK: *pOutputsMask contains a set of GPU-output identifiers
+//                NVAPI_NVIDIA_DEVICE_NOT_FOUND: no NVIDIA GPU driving a display was found
+//                NVAPI_EXPECTED_PHYSICAL_GPU_HANDLE: hPhysicalGpu was not a physical GPU handle
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_GPU_GetActiveOutputs(NvPhysicalGpuHandle hPhysicalGpu, NvU32 *pOutputsMask);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_GPU_GetEDID
+//
+//   DESCRIPTION: Returns the EDID data for the specified GPU handle and connection bit mask.
+//                displayOutputId should have exactly 1 bit set to indicate a single display.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+// RETURN STATUS: NVAPI_INVALID_ARGUMENT: pEDID is NULL; displayOutputId has 0 or > 1 bits set.
+//                NVAPI_OK: *pEDID contains valid data.
+//                NVAPI_NVIDIA_DEVICE_NOT_FOUND: no NVIDIA GPU driving a display was found.
+//                NVAPI_EXPECTED_PHYSICAL_GPU_HANDLE: hPhysicalGpu was not a physical GPU handle.
+//                NVAPI_DATA_NOT_FOUND: requested display does not contain an EDID
+//
+///////////////////////////////////////////////////////////////////////////////
+#define NV_EDID_V1_DATA_SIZE   256
+#define NV_EDID_DATA_SIZE      NV_EDID_V1_DATA_SIZE
+
+typedef struct
+{
+    NvU32   version;        //structure version
+    NvU8    EDID_Data[NV_EDID_DATA_SIZE];
+} NV_EDID_V1;
+
+typedef struct
+{
+    NvU32   version;        //structure version
+    NvU8    EDID_Data[NV_EDID_DATA_SIZE];
+    NvU32   sizeofEDID;
+} NV_EDID_V2;
+
+typedef struct
+{
+    NvU32   version;        //structure version
+    NvU8    EDID_Data[NV_EDID_DATA_SIZE];
+    NvU32   sizeofEDID;
+    NvU32   edidId;     // edidId is an ID which always returned in a monotonically increasing counter.
+                       // Across a split-edid read we need to verify that all calls returned the same edidId.
+                       // This counter is incremented if we get the updated EDID.
+    NvU32   offset;    // which 256byte page of the EDID we want to read. Start at 0.
+                       // If the read succeeds with edidSize > NV_EDID_DATA_SIZE
+                       // call back again with offset+256 until we have read the entire buffer
+} NV_EDID_V3;
+
+typedef NV_EDID_V3    NV_EDID;
+
+#define NV_EDID_VER1    MAKE_NVAPI_VERSION(NV_EDID_V1,1)
+#define NV_EDID_VER2    MAKE_NVAPI_VERSION(NV_EDID_V2,2)
+#define NV_EDID_VER3    MAKE_NVAPI_VERSION(NV_EDID_V3,3)
+#define NV_EDID_VER     NV_EDID_VER3
+
+NVAPI_INTERFACE NvAPI_GPU_GetEDID(NvPhysicalGpuHandle hPhysicalGpu, NvU32 displayOutputId, NV_EDID *pEDID);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_GPU_SetEDID
+//
+//   DESCRIPTION: Sets the EDID data for the specified GPU handle and connection bit mask.
+//                displayOutputId should have exactly 1 bit set to indicate a single display.
+//                Note:The EDID will be cached across boot session and will be enumerated to the OS in this call.
+//                     To remove the EDID set the sizeofEDID to zero.
+//                     OS and NVAPI connection status APIs will reflect the newly set or removed EDID dynamically.
+//
+//                This feature shall NOT be supported on the following boards:
+//                1. GeForce
+//                2. Quadro VX 
+//                3. Tesla  
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+// RETURN STATUS: NVAPI_INVALID_ARGUMENT: pEDID is NULL; displayOutputId has 0 or > 1 bits set
+//                NVAPI_OK: *pEDID data was applied to the requested displayOutputId.
+//                NVAPI_NVIDIA_DEVICE_NOT_FOUND: no NVIDIA GPU driving a display was found.
+//                NVAPI_EXPECTED_PHYSICAL_GPU_HANDLE: hPhysicalGpu was not a physical GPU handle.
+//                NVAPI_NOT_SUPPORTED: for the above mentioned GPUs
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_GPU_SetEDID(NvPhysicalGpuHandle hPhysicalGpu, NvU32 displayOutputId, NV_EDID *pEDID);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_GPU_GetOutputType
+//
+//   DESCRIPTION: Give a physical GPU handle and a single outputId (exactly 1 bit set), this API
+//                returns the output type.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+// RETURN STATUS: NVAPI_INVALID_ARGUMENT: hPhysicalGpu, outputId or pOutputsMask is NULL; or outputId has > 1 bit set
+//                NVAPI_OK: *pOutputType contains a NvGpuOutputType value
+//                NVAPI_NVIDIA_DEVICE_NOT_FOUND: no NVIDIA GPU driving a display was found
+//                NVAPI_EXPECTED_PHYSICAL_GPU_HANDLE: hPhysicalGpu was not a physical GPU handle
+//
+///////////////////////////////////////////////////////////////////////////////
+typedef enum _NV_GPU_OUTPUT_TYPE
+{
+    NVAPI_GPU_OUTPUT_UNKNOWN  = 0,
+    NVAPI_GPU_OUTPUT_CRT      = 1,     // CRT display device
+    NVAPI_GPU_OUTPUT_DFP      = 2,     // Digital Flat Panel display device
+    NVAPI_GPU_OUTPUT_TV       = 3,     // TV display device
+} NV_GPU_OUTPUT_TYPE;
+
+NVAPI_INTERFACE NvAPI_GPU_GetOutputType(NvPhysicalGpuHandle hPhysicalGpu, NvU32 outputId, NV_GPU_OUTPUT_TYPE *pOutputType);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_GPU_ValidateOutputCombination
+//
+//   DESCRIPTION: This call is used to determine if a set of GPU outputs can be active
+//                simultaneously.  While a GPU may have <n> outputs, they can not typically
+//                all be active at the same time due to internal resource sharing.
+//
+//                Given a physical GPU handle and a mask of candidate outputs, this call
+//                will return NVAPI_OK if all of the specified outputs can be driven
+//                simultaneously.  It will return NVAPI_INVALID_COMBINATION if they cannot.
+//
+//                Use NvAPI_GPU_GetAllOutputs() to determine which outputs are candidates.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+// RETURN STATUS: NVAPI_OK: combination of outputs in outputsMask are valid (can be active simultaneously)
+//                NVAPI_INVALID_COMBINATION: combination of outputs in outputsMask are NOT valid
+//                NVAPI_INVALID_ARGUMENT: hPhysicalGpu or outputsMask does not have at least 2 bits set
+//                NVAPI_EXPECTED_PHYSICAL_GPU_HANDLE: hPhysicalGpu was not a physical GPU handle
+//                NVAPI_NVIDIA_DEVICE_NOT_FOUND: no NVIDIA GPU driving a display was found
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_GPU_ValidateOutputCombination(NvPhysicalGpuHandle hPhysicalGpu, NvU32 outputsMask);
+
+typedef enum _NV_GPU_CONNECTOR_TYPE
+{
+    NVAPI_GPU_CONNECTOR_VGA_15_PIN                      = 0x00000000,
+    NVAPI_GPU_CONNECTOR_TV_COMPOSITE                    = 0x00000010,
+    NVAPI_GPU_CONNECTOR_TV_SVIDEO                       = 0x00000011,
+    NVAPI_GPU_CONNECTOR_TV_HDTV_COMPONENT               = 0x00000013,
+    NVAPI_GPU_CONNECTOR_TV_SCART                        = 0x00000014,
+    NVAPI_GPU_CONNECTOR_TV_COMPOSITE_SCART_ON_EIAJ4120  = 0x00000016,
+    NVAPI_GPU_CONNECTOR_TV_HDTV_EIAJ4120                = 0x00000017,
+    NVAPI_GPU_CONNECTOR_PC_POD_HDTV_YPRPB               = 0x00000018,
+    NVAPI_GPU_CONNECTOR_PC_POD_SVIDEO                   = 0x00000019,
+    NVAPI_GPU_CONNECTOR_PC_POD_COMPOSITE                = 0x0000001A,
+    NVAPI_GPU_CONNECTOR_DVI_I_TV_SVIDEO                 = 0x00000020,
+    NVAPI_GPU_CONNECTOR_DVI_I_TV_COMPOSITE              = 0x00000021,
+    NVAPI_GPU_CONNECTOR_DVI_I                           = 0x00000030,
+    NVAPI_GPU_CONNECTOR_DVI_D                           = 0x00000031,
+    NVAPI_GPU_CONNECTOR_ADC                             = 0x00000032,
+    NVAPI_GPU_CONNECTOR_LFH_DVI_I_1                     = 0x00000038,
+    NVAPI_GPU_CONNECTOR_LFH_DVI_I_2                     = 0x00000039,
+    NVAPI_GPU_CONNECTOR_SPWG                            = 0x00000040,
+    NVAPI_GPU_CONNECTOR_OEM                             = 0x00000041,
+    NVAPI_GPU_CONNECTOR_DISPLAYPORT_EXTERNAL            = 0x00000046,
+    NVAPI_GPU_CONNECTOR_DISPLAYPORT_INTERNAL            = 0x00000047,
+    NVAPI_GPU_CONNECTOR_DISPLAYPORT_MINI_EXT            = 0x00000048,
+    NVAPI_GPU_CONNECTOR_HDMI_A                          = 0x00000061,
+    NVAPI_GPU_CONNECTOR_HDMI_C_MINI                     = 0x00000063,
+    NVAPI_GPU_CONNECTOR_LFH_DISPLAYPORT_1               = 0x00000064,
+    NVAPI_GPU_CONNECTOR_LFH_DISPLAYPORT_2               = 0x00000065,
+    NVAPI_GPU_CONNECTOR_UNKNOWN                         = 0xFFFFFFFF,
+} NV_GPU_CONNECTOR_TYPE;
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_GPU_GetFullName
+//
+//   DESCRIPTION: Retrieves the full GPU name as an ascii string.  Eg: "Quadro FX 1400"
+//
+//  SUPPORTED OS: Mac OS X, Windows XP and higher
+//
+// RETURN STATUS: NVAPI_ERROR or NVAPI_OK
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_GPU_GetFullName(NvPhysicalGpuHandle hPhysicalGpu, NvAPI_ShortString szName);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_GPU_GetPCIIdentifiers
+//
+//   DESCRIPTION: Returns the PCI identifiers associated with this GPU.
+//                  DeviceId - the internal PCI device identifier for the GPU.
+//                  SubSystemId - the internal PCI subsystem identifier for the GPU.
+//                  RevisionId - the internal PCI device-specific revision identifier for the GPU.
+//                  ExtDeviceId - the external PCI device identifier for the GPU.
+//
+//  SUPPORTED OS: Mac OS X, Windows XP and higher
+//
+// RETURN STATUS: NVAPI_INVALID_ARGUMENT: hPhysicalGpu or an argument is NULL
+//                NVAPI_OK: arguments are populated with PCI identifiers
+//                NVAPI_NVIDIA_DEVICE_NOT_FOUND: no NVIDIA GPU driving a display was found
+//                NVAPI_EXPECTED_PHYSICAL_GPU_HANDLE: hPhysicalGpu was not a physical GPU handle
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_GPU_GetPCIIdentifiers(NvPhysicalGpuHandle hPhysicalGpu,NvU32 *pDeviceId,NvU32 *pSubSystemId,NvU32 *pRevisionId,NvU32 *pExtDeviceId);
+
+typedef enum _NV_GPU_TYPE
+{
+    NV_SYSTEM_TYPE_GPU_UNKNOWN     = 0,
+    NV_SYSTEM_TYPE_IGPU            = 1, //integrated
+    NV_SYSTEM_TYPE_DGPU            = 2, //discrete
+} NV_GPU_TYPE;
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_GPU_GetGPUType
+//
+// DESCRIPTION: Returns information to identify the GPU type
+//
+//  SUPPORTED OS: Mac OS X, Windows XP and higher
+//
+// RETURN STATUS: NVAPI_INVALID_ARGUMENT: hPhysicalGpu
+// NVAPI_OK: *pGpuType contains the GPU type
+// NVAPI_NVIDIA_DEVICE_NOT_FOUND: no NVIDIA GPU driving a display was found
+// NVAPI_EXPECTED_PHYSICAL_GPU_HANDLE: hPhysicalGpu was not a physical GPU handle
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_GPU_GetGPUType(NvPhysicalGpuHandle hPhysicalGpu, NV_GPU_TYPE *pGpuType);
+
+typedef enum _NV_GPU_BUS_TYPE
+{
+    NVAPI_GPU_BUS_TYPE_UNDEFINED    = 0,
+    NVAPI_GPU_BUS_TYPE_PCI          = 1,
+    NVAPI_GPU_BUS_TYPE_AGP          = 2,
+    NVAPI_GPU_BUS_TYPE_PCI_EXPRESS  = 3,
+    NVAPI_GPU_BUS_TYPE_FPCI         = 4,
+} NV_GPU_BUS_TYPE;
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_GPU_GetBusType
+//
+//   DESCRIPTION: Returns the type of bus associated with this GPU.
+//
+//  SUPPORTED OS: Mac OS X, Windows XP and higher
+//
+// RETURN STATUS: NVAPI_INVALID_ARGUMENT: hPhysicalGpu or pBusType is NULL
+//                NVAPI_OK: *pBusType contains bus identifier
+//                NVAPI_NVIDIA_DEVICE_NOT_FOUND: no NVIDIA GPU driving a display was found
+//                NVAPI_EXPECTED_PHYSICAL_GPU_HANDLE: hPhysicalGpu was not a physical GPU handle
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_GPU_GetBusType(NvPhysicalGpuHandle hPhysicalGpu,NV_GPU_BUS_TYPE *pBusType);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_GPU_GetBusId
+//
+//   DESCRIPTION: Returns the ID of bus associated with this GPU.
+//
+//  SUPPORTED OS: Mac OS X, Windows XP and higher
+//
+// RETURN STATUS: NVAPI_INVALID_ARGUMENT: hPhysicalGpu or pBusId is NULL
+//                NVAPI_OK: *pBusId contains bus id
+//                NVAPI_NVIDIA_DEVICE_NOT_FOUND: no NVIDIA GPU driving a display was found
+//                NVAPI_EXPECTED_PHYSICAL_GPU_HANDLE: hPhysicalGpu was not a physical GPU handle
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_GPU_GetBusId(NvPhysicalGpuHandle hPhysicalGpu, NvU32 *pBusId);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_GPU_GetBusSlotId
+//
+//   DESCRIPTION: Returns the ID of bus-slot associated with this GPU.
+//
+//  SUPPORTED OS: Mac OS X, Windows XP and higher
+//
+// RETURN STATUS: NVAPI_INVALID_ARGUMENT: hPhysicalGpu or pBusSlotId is NULL
+//                NVAPI_OK: *pBusSlotId contains bus-slot id
+//                NVAPI_NVIDIA_DEVICE_NOT_FOUND: no NVIDIA GPU driving a display was found
+//                NVAPI_EXPECTED_PHYSICAL_GPU_HANDLE: hPhysicalGpu was not a physical GPU handle
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_GPU_GetBusSlotId(NvPhysicalGpuHandle hPhysicalGpu, NvU32 *pBusSlotId);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_GPU_GetIRQ
+//
+//   DESCRIPTION: Returns the interrupt number associated with this GPU.
+//
+//  SUPPORTED OS: Mac OS X, Windows XP and higher
+//
+// RETURN STATUS: NVAPI_INVALID_ARGUMENT: hPhysicalGpu or pIRQ is NULL
+//                NVAPI_OK: *pIRQ contains interrupt number
+//                NVAPI_NVIDIA_DEVICE_NOT_FOUND: no NVIDIA GPU driving a display was found
+//                NVAPI_EXPECTED_PHYSICAL_GPU_HANDLE: hPhysicalGpu was not a physical GPU handle
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_GPU_GetIRQ(NvPhysicalGpuHandle hPhysicalGpu,NvU32 *pIRQ);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_GPU_GetVbiosRevision
+//
+//   DESCRIPTION: Returns the revision of the video bios associated with this GPU.
+//
+//  SUPPORTED OS: Mac OS X, Windows XP and higher
+//
+// RETURN STATUS: NVAPI_INVALID_ARGUMENT: hPhysicalGpu or pBiosRevision is NULL
+//                NVAPI_OK: *pBiosRevision contains revision number
+//                NVAPI_NVIDIA_DEVICE_NOT_FOUND: no NVIDIA GPU driving a display was found
+//                NVAPI_EXPECTED_PHYSICAL_GPU_HANDLE: hPhysicalGpu was not a physical GPU handle
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_GPU_GetVbiosRevision(NvPhysicalGpuHandle hPhysicalGpu,NvU32 *pBiosRevision);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_GPU_GetVbiosOEMRevision
+//
+//   DESCRIPTION: Returns the OEM revision of the video bios associated with this GPU.
+//
+//  SUPPORTED OS: Mac OS X, Windows XP and higher
+//
+// RETURN STATUS: NVAPI_INVALID_ARGUMENT: hPhysicalGpu or pBiosRevision is NULL
+//                NVAPI_OK: *pBiosRevision contains revision number
+//                NVAPI_NVIDIA_DEVICE_NOT_FOUND: no NVIDIA GPU driving a display was found
+//                NVAPI_EXPECTED_PHYSICAL_GPU_HANDLE: hPhysicalGpu was not a physical GPU handle
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_GPU_GetVbiosOEMRevision(NvPhysicalGpuHandle hPhysicalGpu,NvU32 *pBiosRevision);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_GPU_GetVbiosVersionString
+//
+//   DESCRIPTION: Returns the full bios version string in the form of xx.xx.xx.xx.yy where
+//                the xx numbers come from NvAPI_GPU_GetVbiosRevision and yy comes from
+//                NvAPI_GPU_GetVbiosOEMRevision.
+//
+//  SUPPORTED OS: Mac OS X, Windows XP and higher
+//
+// RETURN STATUS: NVAPI_INVALID_ARGUMENT: hPhysicalGpu is NULL
+//                NVAPI_OK: szBiosRevision contains version string
+//                NVAPI_NVIDIA_DEVICE_NOT_FOUND: no NVIDIA GPU driving a display was found
+//                NVAPI_EXPECTED_PHYSICAL_GPU_HANDLE: hPhysicalGpu was not a physical GPU handle
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_GPU_GetVbiosVersionString(NvPhysicalGpuHandle hPhysicalGpu,NvAPI_ShortString szBiosRevision);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_GPU_GetAGPAperture
+//
+//   DESCRIPTION: Returns AGP aperture in megabytes
+//
+//  SUPPORTED OS: Mac OS X, Windows XP and higher
+//
+// RETURN STATUS: NVAPI_INVALID_ARGUMENT: pSize is NULL
+//                NVAPI_OK: call successful
+//                NVAPI_NVIDIA_DEVICE_NOT_FOUND: no NVIDIA GPU driving a display was found
+//                NVAPI_EXPECTED_PHYSICAL_GPU_HANDLE: hPhysicalGpu was not a physical GPU handle
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_GPU_GetAGPAperture(NvPhysicalGpuHandle hPhysicalGpu,NvU32 *pSize);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_GPU_GetCurrentAGPRate
+//
+//   DESCRIPTION: Returns the current AGP Rate (1 = 1x, 2=2x etc, 0 = AGP not present)
+//
+//  SUPPORTED OS: Mac OS X, Windows XP and higher
+//
+// RETURN STATUS: NVAPI_INVALID_ARGUMENT: pRate is NULL
+//                NVAPI_OK: call successful
+//                NVAPI_NVIDIA_DEVICE_NOT_FOUND: no NVIDIA GPU driving a display was found
+//                NVAPI_EXPECTED_PHYSICAL_GPU_HANDLE: hPhysicalGpu was not a physical GPU handle
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_GPU_GetCurrentAGPRate(NvPhysicalGpuHandle hPhysicalGpu,NvU32 *pRate);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_GPU_GetCurrentPCIEDownstreamWidth
+//
+//   DESCRIPTION: Returns the number of PCIE lanes being used for the PCIE interface
+//                downstream from the GPU.
+//
+//                On systems that do not support PCIE, the maxspeed for the root link
+//                will be zero.
+//
+//  SUPPORTED OS: Mac OS X, Windows XP and higher
+//
+// RETURN STATUS: NVAPI_INVALID_ARGUMENT: pWidth is NULL
+//                NVAPI_OK: call successful
+//                NVAPI_NVIDIA_DEVICE_NOT_FOUND: no NVIDIA GPU driving a display was found
+//                NVAPI_EXPECTED_PHYSICAL_GPU_HANDLE: hPhysicalGpu was not a physical GPU handle
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_GPU_GetCurrentPCIEDownstreamWidth(NvPhysicalGpuHandle hPhysicalGpu,NvU32 *pWidth);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_GPU_GetPhysicalFrameBufferSize
+//
+//   DESCRIPTION: Returns the physical size of framebuffer in Kb.  This does NOT include any
+//                system RAM that may be dedicated for use by the GPU.
+//
+//  SUPPORTED OS: Mac OS X, Windows XP and higher
+//
+// RETURN STATUS: NVAPI_INVALID_ARGUMENT: pSize is NULL
+//                NVAPI_OK: call successful
+//                NVAPI_NVIDIA_DEVICE_NOT_FOUND: no NVIDIA GPU driving a display was found
+//                NVAPI_EXPECTED_PHYSICAL_GPU_HANDLE: hPhysicalGpu was not a physical GPU handle
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_GPU_GetPhysicalFrameBufferSize(NvPhysicalGpuHandle hPhysicalGpu,NvU32 *pSize);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_GPU_GetVirtualFrameBufferSize
+//
+//   DESCRIPTION: Returns the virtual size of framebuffer in Kb.  This includes the physical RAM plus any
+//                system RAM that has been dedicated for use by the GPU.
+//
+//  SUPPORTED OS: Mac OS X, Windows XP and higher
+//
+// RETURN STATUS: NVAPI_INVALID_ARGUMENT: pSize is NULL
+//                NVAPI_OK: call successful
+//                NVAPI_NVIDIA_DEVICE_NOT_FOUND: no NVIDIA GPU driving a display was found
+//                NVAPI_EXPECTED_PHYSICAL_GPU_HANDLE: hPhysicalGpu was not a physical GPU handle
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_GPU_GetVirtualFrameBufferSize(NvPhysicalGpuHandle hPhysicalGpu,NvU32 *pSize);
+
+
+typedef struct _NV_BOARD_INFO
+{
+    NvU32 version;                   // structure version
+    NvU8 BoardNum[16];               // Board Serial Number
+
+}NV_BOARD_INFO_V1;
+
+typedef NV_BOARD_INFO_V1    NV_BOARD_INFO;
+#define NV_BOARD_INFO_VER1  MAKE_NVAPI_VERSION(NV_BOARD_INFO_V1,1)
+#define NV_BOARD_INFO_VER   NV_BOARD_INFO_VER1
+
+//  SUPPORTED OS: Windows XP and higher
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_GPU_GetBoardInfo
+//
+//   DESCRIPTION: This API Retrieves the Board information (a unique GPU Board Serial Number) stored in the InfoROM.
+//
+// PARAMETERS:      hPhysicalGpu(IN)          - Physical GPU Handle.
+//                  NV_BOARD_INFO(IN/OUT)     - Board Information.
+//
+// RETURN STATUS:
+//                  NVAPI_OK - completed request
+//                  NVAPI_ERROR - miscellaneous error occurred
+//                  NVAPI_EXPECTED_PHYSICAL_GPU_HANDLE - handle passed is not a physical GPU handle
+//                  NVAPI_API_NOT_INTIALIZED - NVAPI not initialized
+//                  NVAPI_INVALID_POINTER - pBoardInfo is NULL
+//                  NVAPI_INCOMPATIBLE_STRUCT_VERSION - the version of the INFO struct is not supported
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_GPU_GetBoardInfo(NvPhysicalGpuHandle hPhysicalGpu, NV_BOARD_INFO *pBoardInfo);
+
+#define NVAPI_MAX_GPU_UTILIZATIONS 8
+
+typedef struct
+{
+    NvU32       version;        // Structure version
+    NvU32       flags;          // Reserved for future use
+    struct
+    {
+        NvU32   bIsPresent:1;   // Set if this utilization domain is present on this GPU
+        NvU32   percentage;     // Percentage of time where the domain is considered busy in the last 1 second interval
+    } utilization[NVAPI_MAX_GPU_UTILIZATIONS];
+} NV_GPU_DYNAMIC_PSTATES_INFO_EX;
+#define NV_GPU_DYNAMIC_PSTATES_INFO_EX_VER MAKE_NVAPI_VERSION(NV_GPU_DYNAMIC_PSTATES_INFO_EX,1)
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_GPU_GetDynamicPstatesInfoEx
+//
+// DESCRIPTION:   This retrieves the NV_GPU_DYNAMIC_PSTATES_INFO_EX structure for the specified physical GPU.
+//                    flags is reserved for future use
+//                    For each utilization domain:
+//                        bIsPresent is set for each domain that is present on the GPU
+//                        percentage is the percentage of time where the domain is considered busy in the last 1 second interval
+//
+//                Each domain's info is indexed in the array.  For example:
+//                    pDynamicPstatesInfo->utilization[NVAPI_GPU_UTILIZATION_DOMAIN_GPU] holds the info for the GPU domain
+//                There are currently 3 domains, for which GPU utilization and dynamic P-State thresholds can be retrieved
+//                    graphic engine (GPU), frame buffer (FB), and video engine (VID).
+//
+//  SUPPORTED OS: Mac OS X, Windows XP and higher
+//
+// RETURN STATUS:
+//    NVAPI_OK - completed request
+//    NVAPI_ERROR - miscellaneous error occurred
+//    NVAPI_INVALID_ARGUMENT - pDynamicPstatesInfo is NULL
+//    NVAPI_HANDLE_INVALIDATED - handle passed has been invalidated (see user guide)
+//    NVAPI_EXPECTED_PHYSICAL_GPU_HANDLE - handle passed is not a physical GPU handle
+//    NVAPI_INCOMPATIBLE_STRUCT_VERSION - the version of the INFO struct is not supported
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_GPU_GetDynamicPstatesInfoEx(NvPhysicalGpuHandle hPhysicalGpu, NV_GPU_DYNAMIC_PSTATES_INFO_EX *pDynamicPstatesInfoEx);
+
+///////////////////////////////////////////////////////////////////////////////////
+//  Thermal API
+//  Provides ability to get temperature levels from the various thermal sensors associated with the GPU
+
+#define NVAPI_MAX_THERMAL_SENSORS_PER_GPU 3
+
+typedef enum
+{
+    NVAPI_THERMAL_TARGET_NONE          = 0,
+    NVAPI_THERMAL_TARGET_GPU           = 1,     //GPU core temperature requires NvPhysicalGpuHandle
+    NVAPI_THERMAL_TARGET_MEMORY        = 2,     //GPU memory temperature requires NvPhysicalGpuHandle
+    NVAPI_THERMAL_TARGET_POWER_SUPPLY  = 4,     //GPU power supply temperature requires NvPhysicalGpuHandle
+    NVAPI_THERMAL_TARGET_BOARD         = 8,     //GPU board ambient temperature requires NvPhysicalGpuHandle
+    NVAPI_THERMAL_TARGET_VCD_BOARD     = 9,     //Visual Computing Device Board temperature requires NvVisualComputingDeviceHandle
+    NVAPI_THERMAL_TARGET_VCD_INLET     = 10,    //Visual Computing Device Inlet temperature requires NvVisualComputingDeviceHandle
+    NVAPI_THERMAL_TARGET_VCD_OUTLET    = 11,    //Visual Computing Device Outlet temperature requires NvVisualComputingDeviceHandle
+    NVAPI_THERMAL_TARGET_ALL           = 15,
+    NVAPI_THERMAL_TARGET_UNKNOWN       = -1,
+} NV_THERMAL_TARGET;
+
+typedef enum
+{
+    NVAPI_THERMAL_CONTROLLER_NONE = 0,
+    NVAPI_THERMAL_CONTROLLER_GPU_INTERNAL,
+    NVAPI_THERMAL_CONTROLLER_ADM1032,
+    NVAPI_THERMAL_CONTROLLER_MAX6649,
+    NVAPI_THERMAL_CONTROLLER_MAX1617,
+    NVAPI_THERMAL_CONTROLLER_LM99,
+    NVAPI_THERMAL_CONTROLLER_LM89,
+    NVAPI_THERMAL_CONTROLLER_LM64,
+    NVAPI_THERMAL_CONTROLLER_ADT7473,
+    NVAPI_THERMAL_CONTROLLER_SBMAX6649,
+    NVAPI_THERMAL_CONTROLLER_VBIOSEVT,
+    NVAPI_THERMAL_CONTROLLER_OS,
+    NVAPI_THERMAL_CONTROLLER_UNKNOWN = -1,
+} NV_THERMAL_CONTROLLER;
+
+typedef struct
+{
+    NvU32   version;                //structure version
+    NvU32   count;                  //number of associated thermal sensors
+    struct
+    {
+        NV_THERMAL_CONTROLLER       controller;         //internal, ADM1032, MAX6649...
+        NvU32                       defaultMinTemp;     //the min default temperature value of the thermal sensor in degrees centigrade
+        NvU32                       defaultMaxTemp;    //the max default temperature value of the thermal sensor in degrees centigrade
+        NvU32                       currentTemp;       //the current temperature value of the thermal sensor in degrees centigrade
+        NV_THERMAL_TARGET           target;             //thermal senor targeted @ GPU, memory, chipset, powersupply, Visual Computing Device...
+    } sensor[NVAPI_MAX_THERMAL_SENSORS_PER_GPU];
+
+} NV_GPU_THERMAL_SETTINGS_V1;
+
+typedef struct
+{
+    NvU32   version;                //structure version
+    NvU32   count;                  //number of associated thermal sensors
+    struct
+    {
+        NV_THERMAL_CONTROLLER       controller;         //internal, ADM1032, MAX6649...
+        NvS32                       defaultMinTemp;     //the min default temperature value of the thermal sensor in degrees centigrade
+        NvS32                       defaultMaxTemp;     //the max default temperature value of the thermal sensor in degrees centigrade
+        NvS32                       currentTemp;        //the current temperature value of the thermal sensor in degrees centigrade
+        NV_THERMAL_TARGET           target;             //thermal senor targeted @ GPU, memory, chipset, powersupply, Visual Computing Device...
+    } sensor[NVAPI_MAX_THERMAL_SENSORS_PER_GPU];
+
+} NV_GPU_THERMAL_SETTINGS_V2;
+
+typedef NV_GPU_THERMAL_SETTINGS_V2  NV_GPU_THERMAL_SETTINGS;
+
+#define NV_GPU_THERMAL_SETTINGS_VER_1   MAKE_NVAPI_VERSION(NV_GPU_THERMAL_SETTINGS_V1,1)
+#define NV_GPU_THERMAL_SETTINGS_VER_2   MAKE_NVAPI_VERSION(NV_GPU_THERMAL_SETTINGS_V2,2)
+#define NV_GPU_THERMAL_SETTINGS_VER     NV_GPU_THERMAL_SETTINGS_VER_2
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME:   NvAPI_GPU_GetThermalSettings
+//
+// DESCRIPTION:     Retrieves the thermal information of all thermal sensors or specific thermal sensor associated with the selected GPU.
+//                  Thermal sensors are indexed 0 to NVAPI_MAX_THERMAL_SENSORS_PER_GPU-1.
+//                  To retrieve specific thermal sensor info set the sensorIndex to the required thermal sensor index.
+//                  To retrieve info for all sensors set sensorIndex to NVAPI_THERMAL_TARGET_ALL.
+//
+//  SUPPORTED OS: Mac OS X, Windows XP and higher
+//
+// PARAMETERS :     hPhysicalGPU(IN) - GPU selection.
+//                  sensorIndex(IN)  - Explicit thermal sensor index selection.
+//                  pThermalSettings(OUT) - Array of thermal settings.
+//
+// RETURN STATUS:
+//    NVAPI_OK - completed request
+//    NVAPI_ERROR - miscellaneous error occurred
+//    NVAPI_INVALID_ARGUMENT - pThermalInfo is NULL
+//    NVAPI_HANDLE_INVALIDATED - handle passed has been invalidated (see user guide)
+//    NVAPI_EXPECTED_PHYSICAL_GPU_HANDLE - handle passed is not a physical GPU handle
+//    NVAPI_INCOMPATIBLE_STRUCT_VERSION - the version of the INFO struct is not supported
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_GPU_GetThermalSettings(NvPhysicalGpuHandle hPhysicalGpu, NvU32 sensorIndex, NV_GPU_THERMAL_SETTINGS *pThermalSettings);
+
+////////////////////////////////////////////////////////////////////////////////
+//NvAPI_TVOutput Information
+
+typedef enum _NV_DISPLAY_TV_FORMAT
+{
+    NV_DISPLAY_TV_FORMAT_NONE         = 0,
+    NV_DISPLAY_TV_FORMAT_SD_NTSCM     = 0x00000001,
+    NV_DISPLAY_TV_FORMAT_SD_NTSCJ     = 0x00000002,
+    NV_DISPLAY_TV_FORMAT_SD_PALM      = 0x00000004,
+    NV_DISPLAY_TV_FORMAT_SD_PALBDGH   = 0x00000008,
+    NV_DISPLAY_TV_FORMAT_SD_PALN      = 0x00000010,
+    NV_DISPLAY_TV_FORMAT_SD_PALNC     = 0x00000020,
+    NV_DISPLAY_TV_FORMAT_SD_576i      = 0x00000100,
+    NV_DISPLAY_TV_FORMAT_SD_480i      = 0x00000200,
+    NV_DISPLAY_TV_FORMAT_ED_480p      = 0x00000400,
+    NV_DISPLAY_TV_FORMAT_ED_576p      = 0x00000800,
+    NV_DISPLAY_TV_FORMAT_HD_720p      = 0x00001000,
+    NV_DISPLAY_TV_FORMAT_HD_1080i     = 0x00002000,
+    NV_DISPLAY_TV_FORMAT_HD_1080p     = 0x00004000,
+    NV_DISPLAY_TV_FORMAT_HD_720p50    = 0x00008000,
+    NV_DISPLAY_TV_FORMAT_HD_1080p24   = 0x00010000,
+    NV_DISPLAY_TV_FORMAT_HD_1080i50   = 0x00020000,
+    NV_DISPLAY_TV_FORMAT_HD_1080p50   = 0x00040000,
+
+    NV_DISPLAY_TV_FORMAT_SD_OTHER     = 0x01000000,
+    NV_DISPLAY_TV_FORMAT_ED_OTHER     = 0x02000000,
+    NV_DISPLAY_TV_FORMAT_HD_OTHER     = 0x04000000,
+
+    NV_DISPLAY_TV_FORMAT_ANY          = 0x80000000,
+
+} NV_DISPLAY_TV_FORMAT;
+
+///////////////////////////////////////////////////////////////////////////////////
+//  I2C API
+//  Provides ability to read or write data using I2C protocol.
+//  These APIs allow I2C access only to DDC monitors.
+
+#define NVAPI_MAX_SIZEOF_I2C_DATA_BUFFER 4096
+#define NVAPI_MAX_SIZEOF_I2C_REG_ADDRESS 4
+#define NVAPI_DISPLAY_DEVICE_MASK_MAX 24
+
+typedef struct
+{
+    NvU32                   version;            // The structure version.
+    NvU32                   displayMask;        // The Display Mask of the concerned display.
+    NvU8                    bIsDDCPort;         // This flag indicates either the DDC port (TRUE) or the communication port
+                                                // (FALSE) of the concerned display.
+    NvU8                    i2cDevAddress;      // The address of the I2C slave.  The address should be shifted left by one.  For
+                                                // example, the I2C address 0x50, often used for reading EDIDs, would be stored
+                                                // here as 0xA0.  This matches the position within the byte sent by the master, as
+                                                // the last bit is reserved to specify the read or write direction.
+    NvU8*                   pbI2cRegAddress;    // The I2C target register address.  May be NULL, which indicates no register
+                                                // address should be sent.
+    NvU32                   regAddrSize;        // The size in bytes of target register address.  If pbI2cRegAddress is NULL, this
+                                                // field must be 0.
+    NvU8*                   pbData;             // The buffer of data which is to be read or written (depending on the command).
+    NvU32                   cbSize;             // The size of the data buffer, pbData, to be read or written.
+    NvU32                   i2cSpeed;           // The maximum target speed of the transaction in Kpbs.  For example, a value of
+                                                // 10 would be interpreted to mean that the driver should attempt to drive the I2C
+                                                // bus at 10 Kpbs, if possible given other speed limitations. 
+} NV_I2C_INFO;
+
+#define NV_I2C_INFO_VER  MAKE_NVAPI_VERSION(NV_I2C_INFO,1)
+/***********************************************************************************/
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME:  NvAPI_I2CRead
+//
+// DESCRIPTION:    Read data buffer from I2C port
+//
+//                 The I2C request must be for a DDC port: pI2cInfo->bIsDDCPort = 1.
+//
+//                 A data buffer size larger than 16 bytes may be rejected if a register address is specified.  In such a case,
+//                 NVAPI_ARGUMENT_EXCEED_MAX_SIZE would be returned.
+//
+//                 If a register address is specified (i.e. regAddrSize is positive), then the transaction will be performed in
+//                 the combined format described in the I2C specification.  The register address will be written, followed by
+//                 reading into the data buffer.
+//
+//  SUPPORTED OS: Mac OS X, Windows XP and higher
+//
+// PARAMETERS:     hPhysicalGPU(IN) - GPU selection.
+//                 NV_I2C_INFO *pI2cInfo - The I2C data input structure.
+//
+// RETURN STATUS:
+//    NVAPI_OK - completed request
+//    NVAPI_ERROR - miscellaneous error occurred
+//    NVAPI_HANDLE_INVALIDATED - handle passed has been invalidated (see user guide)
+//    NVAPI_EXPECTED_PHYSICAL_GPU_HANDLE - handle passed is not a physical GPU handle
+//    NVAPI_INCOMPATIBLE_STRUCT_VERSION - structure version is not supported
+//    NVAPI_INVALID_ARGUMENT - argument does not meet specified requirements
+//    NVAPI_ARGUMENT_EXCEED_MAX_SIZE - an argument exceeds the maximum 
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_I2CRead(NvPhysicalGpuHandle hPhysicalGpu, NV_I2C_INFO *pI2cInfo);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME:  NvAPI_I2CWrite
+//
+// DESCRIPTION:    Writes data buffer to I2C port
+//
+//                 The I2C request must be for a DDC port: pI2cInfo->bIsDDCPort = 1.
+//
+//                 A data buffer size larger than 16 bytes may be rejected if a register address is specified.  In such a case,
+//                 NVAPI_ARGUMENT_EXCEED_MAX_SIZE would be returned.
+//
+//                 If a register address is specified (i.e. regAddrSize is positive), then the register address will be written
+//                 and the data buffer will immediately follow without a restart.
+//
+//  SUPPORTED OS: Mac OS X, Windows XP and higher
+//
+// PARAMETERS:     hPhysicalGPU(IN) - GPU selection.
+//                 NV_I2C_INFO *pI2cInfo -The I2C data input structure.
+//
+// RETURN STATUS:
+//    NVAPI_OK - completed request
+//    NVAPI_ERROR - miscellaneous error occurred
+//    NVAPI_HANDLE_INVALIDATED - handle passed has been invalidated (see user guide)
+//    NVAPI_EXPECTED_PHYSICAL_GPU_HANDLE - handle passed is not a physical GPU handle
+//    NVAPI_INCOMPATIBLE_STRUCT_VERSION - structure version is not supported
+//    NVAPI_INVALID_ARGUMENT - argument does not meet specified requirements
+//    NVAPI_ARGUMENT_EXCEED_MAX_SIZE - an argument exceeds the maximum 
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_I2CWrite(NvPhysicalGpuHandle hPhysicalGpu, NV_I2C_INFO *pI2cInfo);
+
+
+typedef struct
+{
+    NvU32               version;            //structure version
+    NvU32               vendorId;           //Chipset vendor identification
+    NvU32               deviceId;           //Chipset device identification
+    NvAPI_ShortString   szVendorName;       //Chipset vendor Name
+    NvAPI_ShortString   szChipsetName;      //Chipset device Name
+    NvU32               flags;              //Chipset info flags - obsolete
+    NvU32               subSysVendorId;     //Chipset subsystem vendor identification
+    NvU32               subSysDeviceId;     //Chipset subsystem device identification 
+    NvAPI_ShortString   szSubSysVendorName; //subsystem vendor Name
+    NvU32               HBvendorId;         //Host bridge vendor identification
+    NvU32               HBdeviceId;         //Host bridge device identification
+    NvU32               HBsubSysVendorId;   //Host bridge  subsystem vendor identification
+    NvU32               HBsubSysDeviceId;   //Host bridge  subsystem device identification
+
+} NV_CHIPSET_INFO_v4;
+
+typedef struct
+{
+    NvU32               version;            //structure version
+    NvU32               vendorId;           //vendorId
+    NvU32               deviceId;           //deviceId
+    NvAPI_ShortString   szVendorName;       //vendor Name
+    NvAPI_ShortString   szChipsetName;      //device Name
+    NvU32               flags;              //Chipset info flags - obsolete
+    NvU32               subSysVendorId;     //subsystem vendorId
+    NvU32               subSysDeviceId;     //subsystem deviceId
+    NvAPI_ShortString   szSubSysVendorName; //subsystem vendor Name
+} NV_CHIPSET_INFO_v3;
+
+typedef enum
+{
+    NV_CHIPSET_INFO_HYBRID          = 0x00000001,
+} NV_CHIPSET_INFO_FLAGS;
+
+typedef struct
+{
+    NvU32               version;        //structure version
+    NvU32               vendorId;       //vendorId
+    NvU32               deviceId;       //deviceId
+    NvAPI_ShortString   szVendorName;   //vendor Name
+    NvAPI_ShortString   szChipsetName;  //device Name
+    NvU32               flags;          //Chipset info flags
+} NV_CHIPSET_INFO_v2;
+
+typedef struct
+{
+    NvU32               version;        //structure version
+    NvU32               vendorId;       //vendorId
+    NvU32               deviceId;       //deviceId
+    NvAPI_ShortString   szVendorName;   //vendor Name
+    NvAPI_ShortString   szChipsetName;  //device Name
+} NV_CHIPSET_INFO_v1;
+
+#define NV_CHIPSET_INFO_VER_1  MAKE_NVAPI_VERSION(NV_CHIPSET_INFO_v1,1)
+#define NV_CHIPSET_INFO_VER_2   MAKE_NVAPI_VERSION(NV_CHIPSET_INFO_v2,2)
+#define NV_CHIPSET_INFO_VER_3   MAKE_NVAPI_VERSION(NV_CHIPSET_INFO_v3,3)
+#define NV_CHIPSET_INFO_VER_4   MAKE_NVAPI_VERSION(NV_CHIPSET_INFO_v4,4)
+
+#define NV_CHIPSET_INFO         NV_CHIPSET_INFO_v4
+#define NV_CHIPSET_INFO_VER     NV_CHIPSET_INFO_VER_4
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_SYS_GetChipSetInfo
+//
+//   DESCRIPTION: Returns information about the System's ChipSet
+//
+//  SUPPORTED OS: Mac OS X, Windows XP and higher
+//
+// RETURN STATUS: NVAPI_INVALID_ARGUMENT: pChipSetInfo is NULL
+//                NVAPI_OK: *pChipSetInfo is now set
+//                NVAPI_INCOMPATIBLE_STRUCT_VERSION - NV_CHIPSET_INFO version not compatible with driver
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_SYS_GetChipSetInfo(NV_CHIPSET_INFO *pChipSetInfo);
+
+typedef struct
+{
+    NvU32 version;    // Structure version, constructed from macro below
+    NvU32 currentLidState;
+    NvU32 currentDockState;
+    NvU32 currentLidPolicy;
+    NvU32 currentDockPolicy;
+    NvU32 forcedLidMechanismPresent;
+    NvU32 forcedDockMechanismPresent;
+}NV_LID_DOCK_PARAMS;
+
+#define NV_LID_DOCK_PARAMS_VER  MAKE_NVAPI_VERSION(NV_LID_DOCK_PARAMS,1)
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_GetLidDockInfo
+//
+// DESCRIPTION: Returns current lid and dock information.
+//
+//  SUPPORTED OS: Mac OS X, Windows XP and higher
+//
+// RETURN STATUS: NVAPI_OK: now *pLidAndDock contains the returned lid and dock information.
+//                NVAPI_ERROR:If any way call is not success.
+//                NVAPI_NOT_SUPPORTED:If any way call is not success.
+//                NVAPI_HANDLE_INVALIDATED:If nvapi escape result handle is invalid.
+//                NVAPI_API_NOT_INTIALIZED:If NVAPI is not initialized.
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_SYS_GetLidAndDockInfo(NV_LID_DOCK_PARAMS *pLidAndDock);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_OGL_ExpertModeSet[Get]
+//
+//   DESCRIPTION: Configure OpenGL Expert Mode, an API usage feedback and
+//                advice reporting mechanism. The effects of this call are
+//                applied only to the current context, and are reset to the
+//                defaults when the context is destroyed.
+//
+//                Note: This feature is valid at runtime only when GLExpert
+//                      functionality has been built into the OpenGL driver
+//                      installed on the system. All Windows Vista OpenGL
+//                      drivers provided by NVIDIA have this instrumentation
+//                      included by default. Windows XP, however, requires a
+//                      special display driver available with the NVIDIA
+//                      PerfSDK found at developer.nvidia.com.
+//
+//                Note: These functions are valid only for the current OpenGL
+//                      context. Calling these functions prior to creating a
+//                      context and calling MakeCurrent with it will result
+//                      in errors and undefined behavior.
+//
+//    PARAMETERS: expertDetailMask  Mask made up of NVAPI_OGLEXPERT_DETAIL bits,
+//                                  this parameter specifies the detail level in
+//                                  the feedback stream.
+//
+//                expertReportMask  Mask made up of NVAPI_OGLEXPERT_REPORT bits,
+//                                  this parameter specifies the areas of
+//                                  functional interest.
+//
+//                expertOutputMask  Mask made up of NVAPI_OGLEXPERT_OUTPUT bits,
+//                                  this parameter specifies the feedback output
+//                                  location.
+//
+//                expertCallback    Used in conjunction with OUTPUT_TO_CALLBACK,
+//                                  this is a simple callback function the user
+//                                  may use to obtain the feedback stream. The
+//                                  function will be called once per fully
+//                                  qualified feedback stream entry.
+//
+// RETURN STATUS: NVAPI_API_NOT_INTIALIZED         : NVAPI not initialized
+//                NVAPI_NVIDIA_DEVICE_NOT_FOUND    : no NVIDIA GPU found
+//                NVAPI_OPENGL_CONTEXT_NOT_CURRENT : no NVIDIA OpenGL context
+//                                                   which supports GLExpert
+//                                                   has been made current
+//                NVAPI_ERROR : OpenGL driver failed to load properly
+//                NVAPI_OK    : success
+//
+///////////////////////////////////////////////////////////////////////////////
+#define NVAPI_OGLEXPERT_DETAIL_NONE                 0x00000000
+#define NVAPI_OGLEXPERT_DETAIL_ERROR                0x00000001
+#define NVAPI_OGLEXPERT_DETAIL_SWFALLBACK           0x00000002
+#define NVAPI_OGLEXPERT_DETAIL_BASIC_INFO           0x00000004
+#define NVAPI_OGLEXPERT_DETAIL_DETAILED_INFO        0x00000008
+#define NVAPI_OGLEXPERT_DETAIL_PERFORMANCE_WARNING  0x00000010
+#define NVAPI_OGLEXPERT_DETAIL_QUALITY_WARNING      0x00000020
+#define NVAPI_OGLEXPERT_DETAIL_USAGE_WARNING        0x00000040
+#define NVAPI_OGLEXPERT_DETAIL_ALL                  0xFFFFFFFF
+
+#define NVAPI_OGLEXPERT_REPORT_NONE                 0x00000000
+#define NVAPI_OGLEXPERT_REPORT_ERROR                0x00000001
+#define NVAPI_OGLEXPERT_REPORT_SWFALLBACK           0x00000002
+#define NVAPI_OGLEXPERT_REPORT_PIPELINE_VERTEX      0x00000004
+#define NVAPI_OGLEXPERT_REPORT_PIPELINE_GEOMETRY    0x00000008
+#define NVAPI_OGLEXPERT_REPORT_PIPELINE_XFB         0x00000010
+#define NVAPI_OGLEXPERT_REPORT_PIPELINE_RASTER      0x00000020
+#define NVAPI_OGLEXPERT_REPORT_PIPELINE_FRAGMENT    0x00000040
+#define NVAPI_OGLEXPERT_REPORT_PIPELINE_ROP         0x00000080
+#define NVAPI_OGLEXPERT_REPORT_PIPELINE_FRAMEBUFFER 0x00000100
+#define NVAPI_OGLEXPERT_REPORT_PIPELINE_PIXEL       0x00000200
+#define NVAPI_OGLEXPERT_REPORT_PIPELINE_TEXTURE     0x00000400
+#define NVAPI_OGLEXPERT_REPORT_OBJECT_BUFFEROBJECT  0x00000800
+#define NVAPI_OGLEXPERT_REPORT_OBJECT_TEXTURE       0x00001000
+#define NVAPI_OGLEXPERT_REPORT_OBJECT_PROGRAM       0x00002000
+#define NVAPI_OGLEXPERT_REPORT_OBJECT_FBO           0x00004000
+#define NVAPI_OGLEXPERT_REPORT_FEATURE_SLI          0x00008000
+#define NVAPI_OGLEXPERT_REPORT_ALL                  0xFFFFFFFF
+
+#define NVAPI_OGLEXPERT_OUTPUT_TO_NONE              0x00000000
+#define NVAPI_OGLEXPERT_OUTPUT_TO_CONSOLE           0x00000001
+#define NVAPI_OGLEXPERT_OUTPUT_TO_DEBUGGER          0x00000004
+#define NVAPI_OGLEXPERT_OUTPUT_TO_CALLBACK          0x00000008
+#define NVAPI_OGLEXPERT_OUTPUT_TO_ALL               0xFFFFFFFF
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION TYPE: NVAPI_OGLEXPERT_CALLBACK
+//
+//   DESCRIPTION: Used in conjunction with OUTPUT_TO_CALLBACK, this is a simple
+//                callback function the user may use to obtain the feedback
+//                stream. The function will be called once per fully qualified
+//                feedback stream entry.
+//
+//    PARAMETERS: categoryId   Contains the bit from the NVAPI_OGLEXPERT_REPORT
+//                             mask that corresponds to the current message
+//                messageId    Unique Id for the current message
+//                detailLevel  Contains the bit from the NVAPI_OGLEXPERT_DETAIL
+//                             mask that corresponds to the current message
+//                objectId     Unique Id of the object that corresponds to the
+//                             current message
+//                messageStr   Text string from the current message
+//
+///////////////////////////////////////////////////////////////////////////////
+typedef void (* NVAPI_OGLEXPERT_CALLBACK) (unsigned int categoryId, unsigned int messageId, unsigned int detailLevel, int objectId, const char *messageStr);
+
+//  SUPPORTED OS: Windows XP and higher
+NVAPI_INTERFACE NvAPI_OGL_ExpertModeSet(NvU32 expertDetailLevel,
+                                        NvU32 expertReportMask,
+                                        NvU32 expertOutputMask,
+                     NVAPI_OGLEXPERT_CALLBACK expertCallback);
+
+
+//  SUPPORTED OS: Windows XP and higher
+NVAPI_INTERFACE NvAPI_OGL_ExpertModeGet(NvU32 *pExpertDetailLevel,
+                                        NvU32 *pExpertReportMask,
+                                        NvU32 *pExpertOutputMask,
+                     NVAPI_OGLEXPERT_CALLBACK *pExpertCallback);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_OGL_ExpertModeDefaultsSet[Get]
+//
+//   DESCRIPTION: Configure OpenGL Expert Mode global defaults. These settings
+//                apply to any OpenGL application which starts up after these
+//                values are applied (i.e. these settings *do not* apply to
+//                currently running applications).
+//
+//    PARAMETERS: expertDetailLevel Value which specifies the detail level in
+//                                  the feedback stream. This is a mask made up
+//                                  of NVAPI_OGLEXPERT_LEVEL bits.
+//
+//                expertReportMask  Mask made up of NVAPI_OGLEXPERT_REPORT bits,
+//                                  this parameter specifies the areas of
+//                                  functional interest.
+//
+//                expertOutputMask  Mask made up of NVAPI_OGLEXPERT_OUTPUT bits,
+//                                  this parameter specifies the feedback output
+//                                  location. Note that using OUTPUT_TO_CALLBACK
+//                                  here is meaningless and has no effect, but
+//                                  using it will not cause an error.
+//
+// RETURN STATUS: NVAPI_ERROR or NVAPI_OK
+//
+///////////////////////////////////////////////////////////////////////////////
+
+//  SUPPORTED OS: Windows XP and higher
+NVAPI_INTERFACE NvAPI_OGL_ExpertModeDefaultsSet(NvU32 expertDetailLevel,
+                                                NvU32 expertReportMask,
+                                                NvU32 expertOutputMask);
+
+//  SUPPORTED OS: Windows XP and higher
+NVAPI_INTERFACE NvAPI_OGL_ExpertModeDefaultsGet(NvU32 *pExpertDetailLevel,
+                                                NvU32 *pExpertReportMask,
+                                                NvU32 *pExpertOutputMask);
+
+#define NVAPI_MAX_VIEW_TARGET  2
+#define NVAPI_ADVANCED_MAX_VIEW_TARGET 4
+
+#ifndef _NV_TARGET_VIEW_MODE_
+#define _NV_TARGET_VIEW_MODE_
+typedef enum _NV_TARGET_VIEW_MODE
+{
+    NV_VIEW_MODE_STANDARD  = 0,
+    NV_VIEW_MODE_CLONE     = 1,
+    NV_VIEW_MODE_HSPAN     = 2,
+    NV_VIEW_MODE_VSPAN     = 3,
+    NV_VIEW_MODE_DUALVIEW  = 4,
+    NV_VIEW_MODE_MULTIVIEW = 5,
+} NV_TARGET_VIEW_MODE;
+#endif
+
+// Following definitions are used in NvAPI_SetViewEx.
+// Scaling modes
+typedef enum _NV_SCALING
+{
+    NV_SCALING_DEFAULT          = 0,        // No change
+    
+    // New Scaling Declarations
+    NV_SCALING_GPU_SCALING_TO_CLOSEST                   = 1,  // Balanced  - Full Screen
+    NV_SCALING_GPU_SCALING_TO_NATIVE                    = 2,  // Force GPU - Full Screen
+    NV_SCALING_GPU_SCANOUT_TO_NATIVE                    = 3,  // Force GPU - Centered\No Scaling
+    NV_SCALING_GPU_SCALING_TO_ASPECT_SCANOUT_TO_NATIVE  = 5,  // Force GPU - Aspect Ratio
+    NV_SCALING_GPU_SCALING_TO_ASPECT_SCANOUT_TO_CLOSEST = 6,  // Balanced  - Aspect Ratio
+    NV_SCALING_GPU_SCANOUT_TO_CLOSEST                   = 7,  // Balanced  - Centered\No Scaling
+    
+    // Legacy Declarations
+    NV_SCALING_MONITOR_SCALING                          = NV_SCALING_GPU_SCALING_TO_CLOSEST,
+    NV_SCALING_ADAPTER_SCALING                          = NV_SCALING_GPU_SCALING_TO_NATIVE,
+    NV_SCALING_CENTERED                                 = NV_SCALING_GPU_SCANOUT_TO_NATIVE,
+    NV_SCALING_ASPECT_SCALING                           = NV_SCALING_GPU_SCALING_TO_ASPECT_SCANOUT_TO_NATIVE,
+    
+    NV_SCALING_CUSTOMIZED       = 255       // For future use
+} NV_SCALING;
+
+// Rotate modes
+typedef enum _NV_ROTATE
+{
+    NV_ROTATE_0           = 0,
+    NV_ROTATE_90          = 1,
+    NV_ROTATE_180         = 2,
+    NV_ROTATE_270         = 3,
+    NV_ROTATE_IGNORED     = 4,
+} NV_ROTATE;
+
+// Color formats
+#define NVFORMAT_MAKEFOURCC(ch0, ch1, ch2, ch3)                              \
+                         ((NvU32)(NvU8)(ch0) | ((NvU32)(NvU8)(ch1) << 8) |   \
+                     ((NvU32)(NvU8)(ch2) << 16) | ((NvU32)(NvU8)(ch3) << 24 ))
+
+typedef enum _NV_FORMAT
+{
+    NV_FORMAT_UNKNOWN           =  0,       // unknown. Driver will choose one as following value.
+    NV_FORMAT_P8                = 41,       // for 8bpp mode
+    NV_FORMAT_R5G6B5            = 23,       // for 16bpp mode
+    NV_FORMAT_A8R8G8B8          = 21,       // for 32bpp mode
+    NV_FORMAT_A16B16G16R16F     = 113,      // for 64bpp(floating point) mode.
+
+} NV_FORMAT;
+
+// TV standard
+
+
+///////////////////////////////////////////////////////////////////////////////
+// FUNCTION NAME:   NvAPI_DISP_GetMonitorCapabilities
+//
+// DESCRIPTION:     This API returns the Monitor capabilities
+//
+//  SUPPORTED OS: Windows Vista and higher
+//
+// PARAMETERS:      displayId(IN)                - Monitor Identifier
+//                  pMonitorCapabilities(IN/OUT) - The monitor support info
+//
+// RETURN STATUS:
+//                  NVAPI_OK - completed request
+//                  NVAPI_ERROR - miscellaneous error occurred
+//                  NVAPI_INVALID_ARGUMENT: Invalid input parameter.
+//
+///////////////////////////////////////////////////////////////////////////////
+
+typedef enum
+{
+    // hdmi related caps
+    NV_MONITOR_CAPS_TYPE_HDMI_VSDB = 0x1000,
+    NV_MONITOR_CAPS_TYPE_HDMI_VCDB = 0x1001,
+
+} NV_MONITOR_CAPS_TYPE;
+
+typedef struct _NV_MONITOR_CAPS_VCDB
+{
+    NvU8    quantizationRangeYcc         : 1;
+    NvU8    quantizationRangeRgb         : 1;
+    NvU8    scanInfoPreferredVideoFormat : 2;
+    NvU8    scanInfoITVideoFormats       : 2;
+    NvU8    scanInfoCEVideoFormats       : 2;
+} NV_MONITOR_CAPS_VCDB;
+
+typedef struct _NV_MONITOR_CAPS_VSDB
+{
+    // byte 1
+    NvU8    sourcePhysicalAddressB         : 4;
+    NvU8    sourcePhysicalAddressA         : 4;
+    // byte 2
+    NvU8    sourcePhysicalAddressD         : 4;
+    NvU8    sourcePhysicalAddressC         : 4;
+    // byte 3
+    NvU8    supportDualDviOperation        : 1;
+    NvU8    reserved6                      : 2;
+    NvU8    supportDeepColorYCbCr444       : 1;
+    NvU8    supportDeepColor30bits         : 1;
+    NvU8    supportDeepColor36bits         : 1;
+    NvU8    supportDeepColor48bits         : 1;
+    NvU8    supportAI                      : 1;
+    // byte 4
+    NvU8    maxTmdsClock;
+    // byte 5
+    NvU8    cnc0SupportGraphicsTextContent : 1;
+    NvU8    cnc1SupportPhotoContent        : 1;
+    NvU8    cnc2SupportCinemaContent       : 1;
+    NvU8    cnc3SupportGameContent         : 1;
+    NvU8    reserved8                      : 1;
+    NvU8    hasVicEntries                  : 1;
+    NvU8    hasInterlacedLatencyField      : 1;
+    NvU8    hasLatencyField                : 1;
+    // byte 6
+    NvU8    videoLatency;
+    // byte 7
+    NvU8    audioLatency;
+    // byte 8
+    NvU8    interlacedVideoLatency;
+    // byte 9
+    NvU8    interlacedAudioLatency;
+    // byte 10
+    NvU8    reserved13                     : 7;
+    NvU8    has3dEntries                   : 1;
+    // byte 11
+    NvU8    hdmi3dLength                   : 5;
+    NvU8    hdmiVicLength                  : 3;
+    // Remaining bytes
+    NvU8    hdmi_vic[7];  // Keeping maximum length for 3 bits
+    NvU8    hdmi_3d[31];  // Keeping maximum length for 5 bits
+} NV_MONITOR_CAPS_VSDB;
+
+typedef struct _NV_MONITOR_CAPABILITIES
+{
+    NvU32    version;
+    NvU16    size;
+    NvU32    infoType;
+    NvU32    connectorType;        // out: vga, tv, dvi, hdmi, dp
+    NvU8     bIsValidInfo : 1;     // boolean : Returns invalid if requested info is not present such as VCDB not present
+    union {
+        NV_MONITOR_CAPS_VSDB  vsdb;
+        NV_MONITOR_CAPS_VCDB  vcdb;
+    } data;
+} NV_MONITOR_CAPABILITIES;
+
+#define NV_MONITOR_CAPABILITIES_VER   MAKE_NVAPI_VERSION(NV_MONITOR_CAPABILITIES,1)
+
+//  SUPPORTED OS: Windows Vista and higher
+NVAPI_INTERFACE NvAPI_DISP_GetMonitorCapabilities(NvU32 displayId, NV_MONITOR_CAPABILITIES *pMonitorCapabilities);
+
+
+///////////////////////////////////////////////////////////////////////////////
+// FUNCTION NAME:   NvAPI_SetView
+//
+// DESCRIPTION:     This API lets caller to modify target display arrangement for selected source display handle in any of the nview modes.
+//                  It also allows to modify or extend the source display in dualview mode.
+//                  Note: Maps the selected source to the associated target Ids.
+//                  Note: Display PATH with this API is limited to single GPU. DUALVIEW across GPUs cannot be enabled with this API.
+//
+//  SUPPORTED OS: Windows Vista and higher
+//
+// PARAMETERS:      hNvDisplay(IN) - NVIDIA Display selection. NVAPI_DEFAULT_HANDLE not allowed, it has to be a handle enumerated with NvAPI_EnumNVidiaDisplayHandle().
+//                  pTargetInfo(IN) - Pointer to array of NV_VIEW_TARGET_INFO, specifying device properties in this view.
+//                                    The first device entry in the array is the physical primary.
+//                                    The device entry with the lowest source id is the desktop primary.
+//                  targetCount(IN) - Count of target devices specified in pTargetInfo.
+//                  targetView(IN) - Target view selected from NV_TARGET_VIEW_MODE.
+//
+// RETURN STATUS:
+//                  NVAPI_OK - completed request
+//                  NVAPI_ERROR - miscellaneous error occurred
+//                  NVAPI_INVALID_ARGUMENT: Invalid input parameter.
+//
+///////////////////////////////////////////////////////////////////////////////
+
+typedef struct
+{
+    NvU32 version;     // (IN) structure version
+    NvU32 count;       // (IN) target count
+    struct
+    {
+        NvU32 deviceMask;   // (IN/OUT) device mask
+        NvU32 sourceId;     // (IN/OUT) Values will be based on the number of heads exposed per GPU(0, 1?).
+        NvU32 bPrimary:1;   // (OUT) Indicates if this is the GPU's primary view target. This is not the desktop GDI primary.
+                            // NvAPI_SetView automatically selects the first target in NV_VIEW_TARGET_INFO index 0 as the GPU's primary view.
+        NvU32 bInterlaced:1;// (IN/OUT) Indicates if the timing being used on this monitor is interlaced
+        NvU32 bGDIPrimary:1;// (IN/OUT) Indicates if this is the desktop GDI primary.
+        NvU32 bForceModeSet:1;// (IN) Used only on Win7 and higher during a call to NvAPI_SetView. Turns off optimization & forces OS to set supplied mode.
+    } target[NVAPI_MAX_VIEW_TARGET];
+} NV_VIEW_TARGET_INFO;
+
+#define NV_VIEW_TARGET_INFO_VER  MAKE_NVAPI_VERSION(NV_VIEW_TARGET_INFO,2)
+
+NVAPI_INTERFACE NvAPI_SetView(NvDisplayHandle hNvDisplay, NV_VIEW_TARGET_INFO *pTargetInfo, NV_TARGET_VIEW_MODE targetView);
+
+///////////////////////////////////////////////////////////////////////////////
+// FUNCTION NAME:   NvAPI_GetView
+//
+// DESCRIPTION:     This API lets caller retrieve the target display arrangement for selected source display handle.
+//                  Note: Display PATH with this API is limited to single GPU. DUALVIEW across GPUs will be returned as STANDARD VIEW.
+//                        Please use NvAPI_SYS_GetDisplayTopologies to query views across GPUs.
+//  SUPPORTED OS: Windows Vista and higher
+//
+// PARAMETERS:      hNvDisplay(IN) - NVIDIA Display selection. NVAPI_DEFAULT_HANDLE not allowed, it has to be a handle enumerated with NvAPI_EnumNVidiaDisplayHandle().
+//                  pTargetInfo(OUT) - User allocated storage to retrieve an array of  NV_VIEW_TARGET_INFO. Can be NULL to retrieve the targetCount.
+//                  targetMaskCount(IN/OUT) - Count of target device mask specified in pTargetMask.
+//                  targetView(OUT) - Target view selected from NV_TARGET_VIEW_MODE.
+//
+// RETURN STATUS:
+//                  NVAPI_OK - completed request
+//                  NVAPI_ERROR - miscellaneous error occurred
+//                  NVAPI_INVALID_ARGUMENT: Invalid input parameter.
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_GetView(NvDisplayHandle hNvDisplay, NV_VIEW_TARGET_INFO *pTargets, NvU32 *pTargetMaskCount, NV_TARGET_VIEW_MODE *pTargetView);
+
+///////////////////////////////////////////////////////////////////////////////
+// FUNCTION NAME:   NvAPI_SetViewEx
+//
+// DESCRIPTION:     This API lets caller to modify the display arrangement for selected source display handle in any of the nview modes.
+//                  It also allows to modify or extend the source display in dualview mode.
+//                  Note: Maps the selected source to the associated target Ids.
+//                  Note: Display PATH with this API is limited to single GPU. DUALVIEW across GPUs cannot be enabled with this API.
+//
+//  SUPPORTED OS: Windows Vista and higher
+//
+// PARAMETERS:      hNvDisplay(IN) - NVIDIA Display selection. NVAPI_DEFAULT_HANDLE not allowed, it has to be a handle enumerated with NvAPI_EnumNVidiaDisplayHandle().
+//                  pPathInfo(IN)  - Pointer to array of NV_VIEW_PATH_INFO, specifying device properties in this view.
+//                                    The first device entry in the array is the physical primary.
+//                                    The device entry with the lowest source id is the desktop primary.
+//                  pathCount(IN)  - Count of paths specified in pPathInfo.
+//                  displayView(IN)- Display view selected from NV_TARGET_VIEW_MODE.
+//
+// RETURN STATUS:
+//                  NVAPI_OK - completed request
+//                  NVAPI_ERROR - miscellaneous error occurred
+//                  NVAPI_INVALID_ARGUMENT: Invalid input parameter.
+//
+///////////////////////////////////////////////////////////////////////////////
+
+#define NVAPI_MAX_DISPLAY_PATH  NVAPI_MAX_VIEW_TARGET
+
+#define NVAPI_ADVANCED_MAX_DISPLAY_PATH  NVAPI_ADVANCED_MAX_VIEW_TARGET
+
+typedef struct
+{
+    NvU32                   deviceMask;     // (IN) device mask
+    NvU32                   sourceId;       // (IN) Values will be based on the number of heads exposed per GPU(0, 1?)
+    NvU32                   bPrimary:1;     // (IN/OUT) Indicates if this is the GPU's primary view target. This is not the desktop GDI primary.
+                                            // NvAPI_SetViewEx automatically selects the first target in NV_DISPLAY_PATH_INFO index 0 as the GPU's primary view.
+    NV_GPU_CONNECTOR_TYPE   connector;      // (IN) Specify connector type. For TV only.
+
+    // source mode information
+    NvU32                   width;          // (IN) width of the mode
+    NvU32                   height;         // (IN) height of the mode
+    NvU32                   depth;          // (IN) depth of the mode
+    NV_FORMAT               colorFormat;    //      color format if needs to specify. Not used now.
+
+    //rotation setting of the mode
+    NV_ROTATE               rotation;       // (IN) rotation setting.
+
+    // the scaling mode
+    NV_SCALING              scaling;        // (IN) scaling setting
+
+    // Timing info
+    NvU32                   refreshRate;    // (IN) refresh rate of the mode
+    NvU32                   interlaced:1;   // (IN) interlaced mode flag
+
+    NV_DISPLAY_TV_FORMAT    tvFormat;       // (IN) to choose the last TV format set this value to NV_DISPLAY_TV_FORMAT_NONE
+
+    // Windows desktop position
+    NvU32                   posx;           // (IN/OUT) x offset of this display on the Windows desktop
+    NvU32                   posy;           // (IN/OUT) y offset of this display on the Windows desktop
+    NvU32                   bGDIPrimary:1;  // (IN/OUT) Indicates if this is the desktop GDI primary.
+
+    NvU32                   bForceModeSet:1;// (IN) Used only on Win7 and higher during a call to NvAPI_SetViewEx. Turns off optimization & forces OS to set supplied mode.
+    NvU32                   bFocusDisplay:1;// (IN) If set, this display path should have the focus after the GPU topology change
+    NvU32                   gpuId:24;       // (IN) the physical display/target Gpu id which is the owner of the scan out (for SLI multimon, display from the slave Gpu)
+
+} NV_DISPLAY_PATH;
+
+typedef struct
+{
+    NvU32 version;     // (IN) structure version
+    NvU32 count;       // (IN) path count
+    NV_DISPLAY_PATH path[NVAPI_MAX_DISPLAY_PATH];
+} NV_DISPLAY_PATH_INFO;
+
+#define NV_DISPLAY_PATH_INFO_VER  NV_DISPLAY_PATH_INFO_VER3
+#define NV_DISPLAY_PATH_INFO_VER3 MAKE_NVAPI_VERSION(NV_DISPLAY_PATH_INFO,3)
+#define NV_DISPLAY_PATH_INFO_VER2 MAKE_NVAPI_VERSION(NV_DISPLAY_PATH_INFO,2)
+#define NV_DISPLAY_PATH_INFO_VER1 MAKE_NVAPI_VERSION(NV_DISPLAY_PATH_INFO,1)
+
+NVAPI_INTERFACE NvAPI_SetViewEx(NvDisplayHandle hNvDisplay, NV_DISPLAY_PATH_INFO *pPathInfo, NV_TARGET_VIEW_MODE displayView);
+
+///////////////////////////////////////////////////////////////////////////////
+// FUNCTION NAME:   NvAPI_GetViewEx
+//
+// DESCRIPTION:     This API lets caller retrieve the target display arrangement for selected source display handle.
+//                  Note: Display PATH with this API is limited to single GPU. DUALVIEW across GPUs will be returned as STANDARD VIEW.
+//                        Please use NvAPI_SYS_GetDisplayTopologies to query views across GPUs.
+//
+//  SUPPORTED OS: Windows Vista and higher
+//
+// PARAMETERS:      hNvDisplay(IN) - NVIDIA Display selection. NVAPI_DEFAULT_HANDLE not allowed, it has to be a handle enumerated with NvAPI_EnumNVidiaDisplayHandle().
+//                  pPathInfo(IN/OUT) - count field should be set to NVAPI_MAX_DISPLAY_PATH. Can be NULL to retrieve just the pathCount.
+//                  pPathCount(IN/OUT) - Number of elements in array pPathInfo->path.
+//                  pTargetViewMode(OUT)- Display view selected from NV_TARGET_VIEW_MODE.
+//
+// RETURN STATUS:
+//                  NVAPI_OK - completed request
+//                  NVAPI_API_NOT_INTIALIZED - NVAPI not initialized
+//                  NVAPI_ERROR - miscellaneous error occurred
+//                  NVAPI_INVALID_ARGUMENT - Invalid input parameter.
+//                  NVAPI_EXPECTED_DISPLAY_HANDLE - hNvDisplay is not a valid display handle.
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_GetViewEx(NvDisplayHandle hNvDisplay, NV_DISPLAY_PATH_INFO *pPathInfo, NvU32 *pPathCount, NV_TARGET_VIEW_MODE *pTargetViewMode);
+
+///////////////////////////////////////////////////////////////////////////////
+// FUNCTION NAME:   NvAPI_GetSupportedViews
+//
+// DESCRIPTION:     This API lets caller enumerate all the supported NVIDIA display views - nview and dualview modes.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+// PARAMETERS:      hNvDisplay(IN) - NVIDIA Display selection. It can be NVAPI_DEFAULT_HANDLE or a handle enumerated from NvAPI_EnumNVidiaDisplayHandle().
+//                  pTargetViews(OUT) - Array of supported views. Can be NULL to retrieve the pViewCount first.
+//                  pViewCount(IN/OUT) - Count of supported views.
+//
+// RETURN STATUS:
+//                  NVAPI_OK - completed request
+//                  NVAPI_ERROR - miscellaneous error occurred
+//                  NVAPI_INVALID_ARGUMENT: Invalid input parameter.
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_GetSupportedViews(NvDisplayHandle hNvDisplay, NV_TARGET_VIEW_MODE *pTargetViews, NvU32 *pViewCount);
+
+
+////////////////////////////////////////////////////////////////////////////////////////
+//
+// MOSAIC allows a multi display target output scanout on a single source.
+//
+// SAMPLE of MOSAIC 1x4 topo with 8 pixel horizontal overlap
+//
+//+-------------------------++-------------------------++-------------------------++-------------------------+
+//|                         ||                         ||                         ||                         |
+//|                         ||                         ||                         ||                         |
+//|                         ||                         ||                         ||                         |
+//|        DVI1             ||           DVI2          ||         DVI3            ||          DVI4           |
+//|                         ||                         ||                         ||                         |
+//|                         ||                         ||                         ||                         |
+//|                         ||                         ||                         ||                         |
+//|                         ||                         ||                         ||                         |
+//+-------------------------++-------------------------++-------------------------++-------------------------+
+
+#define NVAPI_MAX_MOSAIC_DISPLAY_ROWS       8
+#define NVAPI_MAX_MOSAIC_DISPLAY_COLUMNS    8
+
+#define NV_MOSAIC_MAX_DISPLAYS      (64)
+
+//
+// These bits are used to describe the validity of a topo.
+//
+#define NV_MOSAIC_TOPO_VALIDITY_VALID               0x00000000  // The topo is valid
+#define NV_MOSAIC_TOPO_VALIDITY_MISSING_GPU         0x00000001  // Not enough SLI GPUs were found to fill the entire
+                                                                // topo.  hPhysicalGPU will be 0 for these.
+#define NV_MOSAIC_TOPO_VALIDITY_MISSING_DISPLAY     0x00000002  // Not enough displays were found to fill the entire
+                                                                // topo.  displayOutputId will be 0 for these.
+#define NV_MOSAIC_TOPO_VALIDITY_MIXED_DISPLAY_TYPES 0x00000004  // Topo is only possible with displays of the same
+                                                                // NV_GPU_OUTPUT_TYPE.  Check displayOutputIds to make
+                                                                // sure they are all CRT, or all DFP.
+
+
+//
+// This structure defines the details of a topo.
+//
+typedef struct
+{
+    NvU32                version;              // version of this structure
+    NvLogicalGpuHandle   hLogicalGPU;          // logical gpu this topo is for
+    NvU32                validityMask;         // 0 means topo is valid with current hardware.
+                                               // If not 0, inspect bits against NV_MOSAIC_TOPO_VALIDITY_*.
+    NvU32                rowCount;             // number of displays in a row
+    NvU32                colCount;             // number of displays in a column
+
+    struct
+    {
+        NvPhysicalGpuHandle hPhysicalGPU;      // physical gpu to be used in the topo (0 if GPU missing)
+        NvU32               displayOutputId;   // connected display target (0 if no display connected)
+        NvS32               overlapX;          // pixels of overlap on left of target: (+overlap, -gap)
+        NvS32               overlapY;          // pixels of overlap on top of target: (+overlap, -gap)
+
+    } gpuLayout[NVAPI_MAX_MOSAIC_DISPLAY_ROWS][NVAPI_MAX_MOSAIC_DISPLAY_COLUMNS];
+
+} NV_MOSAIC_TOPO_DETAILS;
+
+#define NVAPI_MOSAIC_TOPO_DETAILS_VER         MAKE_NVAPI_VERSION(NV_MOSAIC_TOPO_DETAILS,1)
+
+
+//
+// These values refer to the different types of Mosaic topos that are possible.  When
+// getting the supported Mosaic topos, you can specify one of these types to narrow down
+// the returned list to only those that match the given type.
+//
+typedef enum
+{
+    NV_MOSAIC_TOPO_TYPE_ALL,                          // All mosaic topos
+    NV_MOSAIC_TOPO_TYPE_BASIC,                        // Basic Mosaic topos
+    NV_MOSAIC_TOPO_TYPE_PASSIVE_STEREO,               // Passive Stereo topos
+    NV_MOSAIC_TOPO_TYPE_SCALED_CLONE,                 // Not supported at this time
+    NV_MOSAIC_TOPO_TYPE_PASSIVE_STEREO_SCALED_CLONE,  // Not supported at this time
+    NV_MOSAIC_TOPO_TYPE_MAX,                          // Always leave this at end of enum
+} NV_MOSAIC_TOPO_TYPE;
+
+
+//
+// The complete list of supported Mosaic topos.
+//
+// NOTE: common\inc\nvEscDef.h shadows a couple PASSIVE_STEREO enums.  If this
+//       enum list changes and effects the value of NV_MOSAIC_TOPO_BEGIN_PASSIVE_STEREO
+//       please update the corresponding value in nvEscDef.h
+//
+typedef enum
+{
+    NV_MOSAIC_TOPO_NONE,
+
+    // 'BASIC' topos start here
+    //
+    // The result of using one of these Mosaic topos is that multiple monitors
+    // will combine to create a single desktop.
+    //
+    NV_MOSAIC_TOPO_BEGIN_BASIC,
+    NV_MOSAIC_TOPO_1x2_BASIC = NV_MOSAIC_TOPO_BEGIN_BASIC,
+    NV_MOSAIC_TOPO_2x1_BASIC,
+    NV_MOSAIC_TOPO_1x3_BASIC,
+    NV_MOSAIC_TOPO_3x1_BASIC,
+    NV_MOSAIC_TOPO_1x4_BASIC,
+    NV_MOSAIC_TOPO_4x1_BASIC,
+    NV_MOSAIC_TOPO_2x2_BASIC,
+    NV_MOSAIC_TOPO_2x3_BASIC,
+    NV_MOSAIC_TOPO_2x4_BASIC,
+    NV_MOSAIC_TOPO_3x2_BASIC,
+    NV_MOSAIC_TOPO_4x2_BASIC,
+    NV_MOSAIC_TOPO_1x5_BASIC,
+    NV_MOSAIC_TOPO_1x6_BASIC,
+    NV_MOSAIC_TOPO_7x1_BASIC,
+
+    // Add padding for 10 more entries. 6 will be enough room to specify every
+    // possible topology with 8 or fewer displays, so this gives us a little
+    // extra should we need it.
+    NV_MOSAIC_TOPO_END_BASIC = NV_MOSAIC_TOPO_7x1_BASIC + 9,
+
+    // 'PASSIVE_STEREO' topos start here
+    //
+    // The result of using one of these Mosaic topos is that multiple monitors
+    // will combine to create a single PASSIVE STEREO desktop.  What this means is
+    // that there will be two topos that combine to create the overall desktop.
+    // One topo will be used for the left eye, and the other topo (of the
+    // same rows x cols), will be used for the right eye.  The difference between
+    // the two topos is that different GPUs and displays will be used.
+    //
+    NV_MOSAIC_TOPO_BEGIN_PASSIVE_STEREO,    // value shadowed in nvEscDef.h
+    NV_MOSAIC_TOPO_1x2_PASSIVE_STEREO = NV_MOSAIC_TOPO_BEGIN_PASSIVE_STEREO,
+    NV_MOSAIC_TOPO_2x1_PASSIVE_STEREO,
+    NV_MOSAIC_TOPO_1x3_PASSIVE_STEREO,
+    NV_MOSAIC_TOPO_3x1_PASSIVE_STEREO,
+    NV_MOSAIC_TOPO_1x4_PASSIVE_STEREO,
+    NV_MOSAIC_TOPO_4x1_PASSIVE_STEREO,
+    NV_MOSAIC_TOPO_2x2_PASSIVE_STEREO,
+    NV_MOSAIC_TOPO_END_PASSIVE_STEREO = NV_MOSAIC_TOPO_2x2_PASSIVE_STEREO + 4,
+
+    //
+    // Total number of topos.  Always leave this at the end of the enumeration.
+    //
+    NV_MOSAIC_TOPO_MAX
+
+} NV_MOSAIC_TOPO;
+
+
+//
+// This is a topo brief structure.  It tells you what you need to know about
+// a topo at a high level.  A list of these is returned when you query for the
+// supported Mosaic information.
+//
+// If you need more detailed information about the topo, call
+// NvAPI_Mosaic_GetTopoGroup() with the topo value from this structure.
+//
+typedef struct
+{
+    NvU32                        version;            // version of this structure
+    NV_MOSAIC_TOPO               topo;               // the topo
+    NvU32                        enabled;            // 1 if topo is enabled, else 0
+    NvU32                        isPossible;         // 1 if topo *can* be enabled, else 0
+
+} NV_MOSAIC_TOPO_BRIEF;
+
+#define NVAPI_MOSAIC_TOPO_BRIEF_VER         MAKE_NVAPI_VERSION(NV_MOSAIC_TOPO_BRIEF,1)
+
+
+//
+// Basic per display settings that are used in setting/getting the Mosaic mode
+//
+typedef struct
+{
+    NvU32                        version;            // version of this structure
+    NvU32                        width;              // per display width
+    NvU32                        height;             // per display height
+    NvU32                        bpp;                // bits per pixel
+    NvU32                        freq;               // display frequency
+} NV_MOSAIC_DISPLAY_SETTING;
+
+#define NVAPI_MOSAIC_DISPLAY_SETTING_VER         MAKE_NVAPI_VERSION(NV_MOSAIC_DISPLAY_SETTING,1)
+
+
+//
+// Set a reasonable max number of display settings to support
+// so arrays are bound.
+//
+#define NV_MOSAIC_DISPLAY_SETTINGS_MAX 40
+
+//
+// This structure is used to contain a list of supported Mosaic topos
+// along with the display settings that can be used.
+//
+typedef struct
+{
+    NvU32                       version;                                         // version of this structure
+    NvU32                       topoBriefsCount;                                 // number of topos in below array
+    NV_MOSAIC_TOPO_BRIEF        topoBriefs[NV_MOSAIC_TOPO_MAX];                  // list of supported topos with only brief details
+    NvU32                       displaySettingsCount;                            // number of display settings in below array
+    NV_MOSAIC_DISPLAY_SETTING   displaySettings[NV_MOSAIC_DISPLAY_SETTINGS_MAX]; // list of per display settings possible
+
+} NV_MOSAIC_SUPPORTED_TOPO_INFO;
+
+#define NVAPI_MOSAIC_SUPPORTED_TOPO_INFO_VER         MAKE_NVAPI_VERSION(NV_MOSAIC_SUPPORTED_TOPO_INFO,1)
+
+
+//
+// Indexes to use to access the topos array within the mosaic topo
+//
+#define NV_MOSAIC_TOPO_IDX_DEFAULT       0
+
+#define NV_MOSAIC_TOPO_IDX_LEFT_EYE      0
+#define NV_MOSAIC_TOPO_IDX_RIGHT_EYE     1
+#define NV_MOSAIC_TOPO_NUM_EYES          2
+
+
+//
+// This defines the maximum number of topos that can be in a topo group.
+// At this time, it is set to 2 because our largest topo group (passive
+// stereo) only needs 2 topos (left eye and right eye).
+//
+// If a new topo group with more than 2 topos is added above, then this
+// number will also have to be incremented.
+//
+#define NV_MOSAIC_MAX_TOPO_PER_TOPO_GROUP 2
+
+
+//
+// This structure defines a group of topos that work together to create one
+// overall layout.  All of the supported topos are represented with this
+// structure.
+//
+// For example, a 'Passive Stereo' topo would be represented with this
+// structure, and would have separate topo details for the left and right eyes.
+// The count would be 2.  A 'Basic' topo is also represented by this structure,
+// with a count of 1.
+//
+// The structure is primarily used internally, but is exposed to applications in a
+// read only fashion because there are some details in it that might be useful
+// (like the number of rows/cols, or connected display information).  A user can
+// get the filled in structure by calling NvAPI_Mosaic_GetTopoGroup().
+//
+// You can then look at the detailed values within the structure.  There are no
+// entrypoints which take this structure as input (effectively making it read only).
+//
+typedef struct
+{
+    NvU32                      version;              // version of this structure
+    NV_MOSAIC_TOPO_BRIEF       brief;                // the brief details of this topo
+    NvU32                      count;                // number of topos in array below
+    NV_MOSAIC_TOPO_DETAILS     topos[NV_MOSAIC_MAX_TOPO_PER_TOPO_GROUP];
+
+} NV_MOSAIC_TOPO_GROUP;
+
+#define NVAPI_MOSAIC_TOPO_GROUP_VER         MAKE_NVAPI_VERSION(NV_MOSAIC_TOPO_GROUP,1)
+
+//  SUPPORTED OS: Windows XP and higher
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME:   NvAPI_Mosaic_GetSupportedTopoInfo
+//
+// DESCRIPTION:     This API returns information on the topos and display resolutions
+//                  supported by Mosaic.
+//
+//                  NOTE: Not all topos returned can be immediately set.
+//                        See 'OUT' Notes below.
+//
+//                  Once you get the list of supported topos, you can call
+//                  NvAPI_Mosaic_GetTopoGroup() with a Mosaic topo if you need
+//                  more information about that topo.
+//
+// PARAMETERS:      pSupportedTopoInfo(IN/OUT):  Information about what topos and display resolutions
+//                                               are supported for Mosaic.
+//                  type(IN):                    The type of topos the caller is interested in
+//                                               getting.  See NV_MOSAIC_TOPO_TYPE for possible
+//                                               values.
+//
+//     'IN' Notes:  pSupportedTopoInfo->version must be set before calling this function.
+//                  If the specified version is not supported by this implementation,
+//                  an error will be returned (NVAPI_INCOMPATIBLE_STRUCT_VERSION).
+//
+//     'OUT' Notes: Some of the topos returned might not be valid for one reason or
+//                  another.  It could be due to mismatched or missing displays.  It
+//                  could also be because the required number of GPUs is not found.
+//                  At a high level, you can see if the topo is valid and can be enabled
+//                  by looking at the pSupportedTopoInfo->topoBriefs[xxx].isPossible flag.
+//                  If this is true, the topo can be enabled.  Otherwise, if it
+//                  is false, you can find out why it cannot be enabled by getting the
+//                  details of the topo via NvAPI_Mosaic_GetTopoGroup().  From there,
+//                  look at the validityMask of the individual topos.  The bits can
+//                  be tested against the NV_MOSAIC_TOPO_VALIDITY_* bits.
+//
+//                  It is possible for this function to return NVAPI_OK with no topos
+//                  listed in the return structure.  If this is the case, it means that
+//                  the current hardware DOES support Mosaic, but with the given configuration
+//                  no valid topos were found.  This most likely means that SLI was not
+//                  enabled for the hardware.  Once enabled, you should see valid topos
+//                  returned from this function.
+//
+// RETURN STATUS    NVAPI_OK:                          No errors in returning supported topos
+//                  NVAPI_NOT_SUPPORTED:               Mosaic is not supported with the existing hardware
+//                  NVAPI_INVALID_ARGUMENT:            One or more args passed in are invalid
+//                  NVAPI_API_NOT_INTIALIZED:          The NvAPI API needs to be initialized first
+//                  NVAPI_NO_IMPLEMENTATION:           This entrypoint not available
+//                  NVAPI_INCOMPATIBLE_STRUCT_VERSION: The version of the structure passed in is not
+//                                                     compatible with this entrypoint
+//                  NVAPI_ERROR:                       Miscellaneous error occurred
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_Mosaic_GetSupportedTopoInfo(NV_MOSAIC_SUPPORTED_TOPO_INFO *pSupportedTopoInfo, NV_MOSAIC_TOPO_TYPE type);
+
+//  SUPPORTED OS: Windows XP and higher
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME:   NvAPI_Mosaic_GetTopoGroup
+//
+// DESCRIPTION:     This API returns a structure filled with the topo details
+//                  for the given Mosaic topo.
+//
+//                  If the pTopoBrief passed in matches the topo which is
+//                  current, then information in the brief and group structures
+//                  will reflect what is current.  Thus the brief would have
+//                  the current 'enable' status, and the group would have the
+//                  current overlap values.  If there is no match, then the
+//                  returned brief has an 'enable' status of FALSE (since it
+//                  is obviously not enabled), and the overlap values will be 0.
+//
+// PARAMETERS:      pTopoBrief(IN):         The topo to get details for.
+//                                          This must be one of the topo briefs
+//                                          returned from NvAPI_Mosaic_GetSupportedTopoInfo().
+//                  pTopoGroup(IN/OUT):     The topo details matching the brief.
+//
+//     'IN' Notes:  pTopoGroup->version must be set before calling this function.
+//                  If the specified version is not supported by this implementation,
+//                  an error will be returned (NVAPI_INCOMPATIBLE_STRUCT_VERSION).
+//
+// RETURN STATUS    NVAPI_OK:                          Details were retrieved successfully
+//                  NVAPI_NOT_SUPPORTED:               Mosaic is not supported with the existing hardware
+//                  NVAPI_INVALID_ARGUMENT:            One or more args passed in are invalid.
+//                  NVAPI_API_NOT_INTIALIZED:          The NvAPI API needs to be initialized first
+//                  NVAPI_NO_IMPLEMENTATION:           This entrypoint not available
+//                  NVAPI_INCOMPATIBLE_STRUCT_VERSION: The version of the structure passed in is not
+//                                                     compatible with this entrypoint
+//                  NVAPI_ERROR:                       Miscellaneous error occurred
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_Mosaic_GetTopoGroup(NV_MOSAIC_TOPO_BRIEF *pTopoBrief, NV_MOSAIC_TOPO_GROUP *pTopoGroup);
+
+//  SUPPORTED OS: Windows XP and higher
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME:   NvAPI_Mosaic_GetOverlapLimits
+//
+// DESCRIPTION:     This API returns the X and Y overlap limits required if
+//                  the given Mosaic topo and display settings are to be used.
+//
+// PARAMETERS:      pTopoBrief(IN):         The topo to get limits for.
+//                                          This must be one of the topo briefs
+//                                          returned from NvAPI_Mosaic_GetSupportedTopoInfo().
+//                  pDisplaySetting(IN):    The display settings to get limits for.
+//                                          This must be one of the settings
+//                                          returned from NvAPI_Mosaic_GetSupportedTopoInfo().
+//                  pMinOverlapX(OUT):      X overlap minimum
+//                  pMaxOverlapX(OUT):      X overlap maximum
+//                  pMinOverlapY(OUT):      Y overlap minimum
+//                  pMaxOverlapY(OUT):      Y overlap maximum
+//
+//
+//
+// RETURN STATUS    NVAPI_OK:                          Details were retrieved successfully
+//                  NVAPI_NOT_SUPPORTED:               Mosaic is not supported with the existing hardware
+//                  NVAPI_INVALID_ARGUMENT:            One or more args passed in are invalid.
+//                  NVAPI_API_NOT_INTIALIZED:          The NvAPI API needs to be initialized first
+//                  NVAPI_NO_IMPLEMENTATION:           This entrypoint not available
+//                  NVAPI_INCOMPATIBLE_STRUCT_VERSION: The version of the structure passed in is not
+//                                                     compatible with this entrypoint
+//                  NVAPI_ERROR:                       Miscellaneous error occurred
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_Mosaic_GetOverlapLimits(NV_MOSAIC_TOPO_BRIEF *pTopoBrief, NV_MOSAIC_DISPLAY_SETTING *pDisplaySetting, NvS32 *pMinOverlapX, NvS32 *pMaxOverlapX, NvS32 *pMinOverlapY, NvS32 *pMaxOverlapY);
+
+//  SUPPORTED OS: Windows XP and higher
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME:   NvAPI_Mosaic_SetCurrentTopo
+//
+// DESCRIPTION:     This API sets the Mosaic topo and does a mode change
+//                  using the given display settings.
+//
+//                  If NVAPI_OK is returned, the current Mosaic topo was set
+//                  correctly.  Any other status returned means the
+//                  topo was not set, and remains what it was before this
+//                  function was called.
+//
+//
+//
+// PARAMETERS:      pTopoBrief(IN):       The topo to set.
+//                                        This must be one of the topos
+//                                        returned from NvAPI_Mosaic_GetSupportedTopoInfo(),
+//                                        and it must have an isPossible value of 1.
+//                  pDisplaySetting(IN):  The per display settings to be used in the
+//                                        setting of Mosaic mode.
+//                                        This must be one of the settings
+//                                        returned from NvAPI_Mosaic_GetSupportedTopoInfo().
+//                  overlapX(IN):         The pixel overlap to use between horizontal
+//                                        displays (use positive a number for overlap,
+//                                        or a negative number to create a gap.)
+//                                        If the overlap is out of bounds for what is
+//                                        possible given the topo and display setting,
+//                                        the overlap will be clamped.
+//                  overlapY(IN):         The pixel overlap to use between vertical
+//                                        displays (use positive a number for overlap,
+//                                        or a negative number to create a gap.)
+//                                        If the overlap is out of bounds for what is
+//                                        possible given the topo and display setting,
+//                                        the overlap will be clamped.
+//                  enable(IN):           If 1, the topo being set will also be enabled,
+//                                        meaning that the mode set will occur.
+//                                        Passing a 0 means you don't want to be in
+//                                        Mosaic mode right now, but want to set the current
+//                                        Mosaic topo so you can enable it later with
+//                                        NvAPI_Mosaic_EnableCurrentTopo().
+//
+// RETURN STATUS    NVAPI_OK:                          Mosaic topo was set
+//                  NVAPI_NOT_SUPPORTED:               Mosaic is not supported with the existing hardware
+//                  NVAPI_INVALID_ARGUMENT:            One or more args passed in are invalid.
+//                  NVAPI_TOPO_NOT_POSSIBLE:           The topo passed in is not currently possible
+//                  NVAPI_API_NOT_INTIALIZED:          The NvAPI API needs to be initialized first
+//                  NVAPI_NO_IMPLEMENTATION:           This entrypoint not available
+//                  NVAPI_INCOMPATIBLE_STRUCT_VERSION: The version of the structure passed in is not
+//                                                     compatible with this entrypoint
+//                  NVAPI_MODE_CHANGE_FAILED:          There was an error changing the display mode
+//                  NVAPI_ERROR:                       Miscellaneous error occurred
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_Mosaic_SetCurrentTopo(NV_MOSAIC_TOPO_BRIEF *pTopoBrief, NV_MOSAIC_DISPLAY_SETTING *pDisplaySetting, NvS32 overlapX, NvS32 overlapY, NvU32 enable);
+
+//  SUPPORTED OS: Windows XP and higher
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME:   NvAPI_Mosaic_GetCurrentTopo
+//
+// DESCRIPTION:     This API returns information for the current Mosaic topo.
+//                  This includes topo, display settings, and overlap values.
+//
+//                  You can call NvAPI_Mosaic_GetTopoGroup() with the topo
+//                  if you require more information on the topo.
+//
+//                  If there isn't a current topo, then pTopoBrief->topo will
+//                  be NV_MOSAIC_TOPO_NONE.
+//
+// PARAMETERS:      pTopoBrief(OUT):      The current Mosaic topo
+//                  pDisplaySetting(OUT): The current per display settings
+//                  pOverlapX(OUT):       The pixel overlap between horizontal displays
+//                  pOverlapY(OUT):       The pixel overlap between vertical displays
+//
+//
+// RETURN STATUS    NVAPI_OK:                          Success getting current info
+//                  NVAPI_NOT_SUPPORTED:               Mosaic is not supported with the existing hardware
+//                  NVAPI_INVALID_ARGUMENT:            One or more args passed in are invalid
+//                  NVAPI_API_NOT_INTIALIZED:          The NvAPI API needs to be initialized first
+//                  NVAPI_NO_IMPLEMENTATION:           This entrypoint not available
+//                  NVAPI_ERROR:                       Miscellaneous error occurred
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_Mosaic_GetCurrentTopo(NV_MOSAIC_TOPO_BRIEF *pTopoBrief, NV_MOSAIC_DISPLAY_SETTING *pDisplaySetting, NvS32 *pOverlapX, NvS32 *pOverlapY);
+
+//  SUPPORTED OS: Windows XP and higher
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME:   NvAPI_Mosaic_EnableCurrentTopo
+//
+// DESCRIPTION:     This API enables or disables the current Mosaic topo
+//                  based on the setting of the incoming 'enable' parameter.
+//
+//                  When enabling, this will enable the current Mosaic topo
+//                  that was previously set.  Note that when the current Mosaic
+//                  topo is retrieved, it must have an isPossible value of 1 or
+//                  an error will occur.
+//
+//                  When disabling, the current Mosaic topo is disabled.
+//                  The topo information will persist, even across reboots.
+//                  To re-enable the Mosaic topo, simply call this function
+//                  again with the enable parameter set to 1.
+//
+// PARAMETERS:      enable(IN):               1 to enable the current Mosaic topo, 0 to disable it.
+//
+//
+// RETURN STATUS    NVAPI_OK:                 The Mosaic topo was enabled/disabled
+//                  NVAPI_NOT_SUPPORTED:      Mosaic is not supported with the existing hardware
+//                  NVAPI_INVALID_ARGUMENT:   One or more args passed in are invalid
+//                  NVAPI_TOPO_NOT_POSSIBLE:  The current topo is not currently possible
+//                  NVAPI_MODE_CHANGE_FAILED: There was an error changing the display mode
+//                  NVAPI_ERROR:              Miscellaneous error occurred
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_Mosaic_EnableCurrentTopo(NvU32 enable);
+
+
+//  SUPPORTED OS: Windows Vista and higher
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME:   NvAPI_Mosaic_GetDisplayViewportsByResolution
+//
+// DESCRIPTION:     This API returns the viewports which would be applied on
+//                  the requested display.
+//
+// PARAMETERS:      displayId(IN):    Display ID of a single display in the active
+//                                    mosaic topology to query.
+//                  srcWidth(IN):     Width of full display topology. If both
+//                                    width and height are 0, the current
+//                                    resolution is used.
+//                  srcHeight(IN):    Height of full display topology. If both
+//                                    width and height are 0, the current
+//                                    resolution is used.
+//                  viewports (OUT):  Array of NV_RECT viewports which represent
+//                                    the displays as identified in
+//                                    NvAPI_Mosaic_EnumGridTopologies. If the
+//                                    requested resolution is a single-wide
+//                                    resolution, only viewports[0] will
+//                                    contain the viewport details, regardless
+//                                    of which display is driving the display.
+//                  bezelCorrected(OUT):  Returns 1 if the requested resolution is
+//                                    bezel corrected. May be NULL.
+//
+// RETURN STATUS    NVAPI_OK:                          Capabilties have been returned.
+//                  NVAPI_INVALID_ARGUMENT:            One or more args passed in are invalid.
+//                  NVAPI_API_NOT_INTIALIZED:          The NvAPI API needs to be initialized first
+//                  NVAPI_MOSAIC_NOT_ACTIVE:           The display does not belong to an active Mosaic Topology
+//                  NVAPI_NO_IMPLEMENTATION:           This entrypoint not available
+//                  NVAPI_ERROR:                       Miscellaneous error occurred
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_Mosaic_GetDisplayViewportsByResolution(NvU32 displayId, NvU32 srcWidth, NvU32 srcHeight, NV_RECT viewports[NV_MOSAIC_MAX_DISPLAYS], NvU8* bezelCorrected);
+
+
+////////////////////////////////////////////////////////////////////////////////////////
+//
+// ###########################################################################
+// DELME_RUSS - DELME_RUSS - DELME_RUSS - DELME_RUSS - DELME_RUSS - DELME_RUSS
+//
+//   Below is the Phase 1 Mosaic stuff, the Phase 2 stuff above is what will remain
+//   once Phase 2 is complete.  For a small amount of time, the two will co-exist.  As
+//   soon as apps (nvapichk, NvAPITestMosaic, and CPL) are updated to use the Phase 2
+//   entrypoints, the code below will be deleted.
+//
+// DELME_RUSS - DELME_RUSS - DELME_RUSS - DELME_RUSS - DELME_RUSS - DELME_RUSS
+// ###########################################################################
+//
+//
+// Supported topos 1x4, 4x1 and 2x2 to start with.
+//
+// Selected scanout targets can be one per GPU or more than one on the same GPU.
+//
+// SAMPLE of MOSAIC 1x4 SCAN OUT TOPO with 8 pixel horizontal overlap
+//
+//+-------------------------++-------------------------++-------------------------++-------------------------+
+//|                         ||                         ||                         ||                         |
+//|                         ||                         ||                         ||                         |
+//|                         ||                         ||                         ||                         |
+//|        DVI1             ||           DVI2          ||         DVI3            ||          DVI4           |
+//|                         ||                         ||                         ||                         |
+//|                         ||                         ||                         ||                         |
+//|                         ||                         ||                         ||                         |
+//|                         ||                         ||                         ||                         |
+//+-------------------------++-------------------------++-------------------------++-------------------------+
+
+#define NVAPI_MAX_MOSAIC_DISPLAY_ROWS       8
+#define NVAPI_MAX_MOSAIC_DISPLAY_COLUMNS    8
+#define NVAPI_MAX_MOSAIC_TOPOS              16
+
+typedef struct
+{
+    NvU32 version;                             // version number of mosaic topology
+    NvU32 rowCount;                            // horizontal display count
+    NvU32 colCount;                            // vertical display count
+
+    struct
+    {
+        NvPhysicalGpuHandle hPhysicalGPU;      // physical gpu to be used in the topology
+        NvU32               displayOutputId;   // connected display target
+        NvS32               overlapX;          // pixels of overlap on left of target: (+overlap, -gap)
+        NvS32               overlapY;          // pixels of overlap on top of target: (+overlap, -gap)
+
+    } gpuLayout[NVAPI_MAX_MOSAIC_DISPLAY_ROWS][NVAPI_MAX_MOSAIC_DISPLAY_COLUMNS];
+
+} NV_MOSAIC_TOPOLOGY;
+
+#define NVAPI_MOSAIC_TOPOLOGY_VER         MAKE_NVAPI_VERSION(NV_MOSAIC_TOPOLOGY,1)
+
+typedef struct
+{
+    NvU32                   version;
+    NvU32                   totalCount;                     //count of valid topologies
+    NV_MOSAIC_TOPOLOGY      topos[NVAPI_MAX_MOSAIC_TOPOS];  //max topologies
+
+} NV_MOSAIC_SUPPORTED_TOPOLOGIES;
+
+#define NVAPI_MOSAIC_SUPPORTED_TOPOLOGIES_VER         MAKE_NVAPI_VERSION(NV_MOSAIC_SUPPORTED_TOPOLOGIES,1)
+
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME:   NvAPI_GetSupportedMosaicTopologies
+//
+// DESCRIPTION:     This API returns all valid Mosaic topologies
+//
+//  SUPPORTED OS: Windows XP
+//
+// PARAMETERS:      pMosaicTopos(OUT):  An array of valid Mosaic topologies.
+//
+// RETURN STATUS    NVAPI_OK:                      Call succeeded; 1 or more topologies were returned
+//                  NVAPI_INVALID_ARGUMENT:        one or more args are invalid
+//                  NVAPI_MIXED_TARGET_TYPES:      Mosaic topology is only possible with all targets of the same NV_GPU_OUTPUT_TYPE.
+//                  NVAPI_NVIDIA_DEVICE_NOT_FOUND: no NVIDIA GPU driving a display was found
+//                  NVAPI_NOT_SUPPORTED:           Mosaic is not supported with GPUs on this system.
+//                  NVAPI_NO_ACTIVE_SLI_TOPOLOGY:  SLI is not enabled, yet needs to be, in order for this function to succeed.
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_GetSupportedMosaicTopologies(NV_MOSAIC_SUPPORTED_TOPOLOGIES *pMosaicTopos);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME:   NvAPI_GetCurrentMosaicTopology
+//
+// DESCRIPTION:     This API gets the current Mosaic topology
+//
+//  SUPPORTED OS: Windows XP
+//
+// PARAMETERS:      pMosaicTopo(OUT):  The current Mosaic topology
+//                  pEnabled(OUT):     TRUE if returned topology is currently enabled, else FALSE
+//
+// RETURN STATUS    NVAPI_OK:                       Call succeeded.
+//                  NVAPI_INVALID_ARGUMENT:         one or more args are invalid
+//                  NVAPI_NVIDIA_DEVICE_NOT_FOUND:  no NVIDIA GPU driving a display was found
+//                  NVAPI_NOT_SUPPORTED:            Mosaic is not supported with GPUs on this system.
+//                  NVAPI_NO_ACTIVE_SLI_TOPOLOGY:   SLI is not enabled, yet needs to be, in order for this function to succeed.
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_GetCurrentMosaicTopology(NV_MOSAIC_TOPOLOGY *pMosaicTopo, NvU32 *pEnabled);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME:   NvAPI_SetCurrentMosaicTopology
+//
+// DESCRIPTION:     This API sets the Mosaic topology, and will enable it so the
+//                  Mosaic display settings will be enumerated upon request.
+//
+//  SUPPORTED OS: Windows XP
+//
+// PARAMETERS:      pMosaicTopo(IN):  A valid Mosaic topology
+//
+// RETURN STATUS    NVAPI_OK:                      Call succeeded
+//                  NVAPI_INVALID_ARGUMENT:        One or more args are invalid
+//                  NVAPI_NVIDIA_DEVICE_NOT_FOUND: No NVIDIA GPU driving a display was found
+//                  NVAPI_NOT_SUPPORTED:           Mosaic mode could not be set
+//                  NVAPI_NO_ACTIVE_SLI_TOPOLOGY:  SLI is not enabled, yet needs to be, in order for this function to succeed.
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_SetCurrentMosaicTopology(NV_MOSAIC_TOPOLOGY *pMosaicTopo);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME:   NvAPI_EnableCurrentMosaicTopology
+//
+// DESCRIPTION:     This API enables or disables the current Mosaic topology.
+//                  When enabling, this will use the last Mosaic topology that was set.
+//                  If enabled, enumeration of display settings will include valid
+//                  Mosaic resolutions.  If disabled, enumeration of display settings
+//                  will not include Mosaic resolutions.
+//
+//  SUPPORTED OS: Windows XP
+//
+// PARAMETERS:      enable(IN):  TRUE to enable the Mosaic Topology, FALSE to disable it.
+//
+// RETURN STATUS    NVAPI_OK:                      Call succeeded
+//                  NVAPI_INVALID_ARGUMENT:        One or more args are invalid
+//                  NVAPI_NVIDIA_DEVICE_NOT_FOUND: No NVIDIA GPU driving a display was found
+//                  NVAPI_NOT_SUPPORTED:           Mosaic mode could not be enabled/disabled
+//                  NVAPI_NO_ACTIVE_SLI_TOPOLOGY:  SLI is not enabled, yet needs to be, in order for this function to succeed.
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_EnableCurrentMosaicTopology(NvU32 enable);
+
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_GPU_GetHDCPSupportStatus
+//
+// DESCRIPTION: Returns information on a GPU's HDCP support status
+//
+//  SUPPORTED OS: Mac OS X, Windows XP and higher
+//
+// RETURN STATUS:
+//    NVAPI_OK - completed request
+//    NVAPI_ERROR - miscellaneous error occurred
+//    NVAPI_INVALID_ARGUMENT - pGetGpuHdcpSupportStatus is NULL
+//    NVAPI_HANDLE_INVALIDATED - handle passed has been invalidated (see user guide)
+//    NVAPI_EXPECTED_PHYSICAL_GPU_HANDLE - handle passed is not a physical GPU handle
+//    NVAPI_INCOMPATIBLE_STRUCT_VERSION - the version of the INFO struct is not supported
+//
+///////////////////////////////////////////////////////////////////////////////
+
+typedef enum _NV_GPU_HDCP_FUSE_STATE
+{
+    NV_GPU_HDCP_FUSE_STATE_UNKNOWN  = 0,
+    NV_GPU_HDCP_FUSE_STATE_DISABLED = 1,
+    NV_GPU_HDCP_FUSE_STATE_ENABLED  = 2,
+} NV_GPU_HDCP_FUSE_STATE;
+
+typedef enum _NV_GPU_HDCP_KEY_SOURCE
+{
+    NV_GPU_HDCP_KEY_SOURCE_UNKNOWN    = 0,
+    NV_GPU_HDCP_KEY_SOURCE_NONE       = 1,
+    NV_GPU_HDCP_KEY_SOURCE_CRYPTO_ROM = 2,
+    NV_GPU_HDCP_KEY_SOURCE_SBIOS      = 3,
+    NV_GPU_HDCP_KEY_SOURCE_I2C_ROM    = 4,
+    NV_GPU_HDCP_KEY_SOURCE_FUSES      = 5,
+} NV_GPU_HDCP_KEY_SOURCE;
+
+typedef enum _NV_GPU_HDCP_KEY_SOURCE_STATE
+{
+    NV_GPU_HDCP_KEY_SOURCE_STATE_UNKNOWN = 0,
+    NV_GPU_HDCP_KEY_SOURCE_STATE_ABSENT  = 1,
+    NV_GPU_HDCP_KEY_SOURCE_STATE_PRESENT = 2,
+} NV_GPU_HDCP_KEY_SOURCE_STATE;
+
+typedef struct
+{
+    NvU32                        version;               // Structure version
+    NV_GPU_HDCP_FUSE_STATE       hdcpFuseState;         // GPU's HDCP fuse state
+    NV_GPU_HDCP_KEY_SOURCE       hdcpKeySource;         // GPU's HDCP key source
+    NV_GPU_HDCP_KEY_SOURCE_STATE hdcpKeySourceState;    // GPU's HDCP key source state
+} NV_GPU_GET_HDCP_SUPPORT_STATUS;
+
+#define NV_GPU_GET_HDCP_SUPPORT_STATUS_VER MAKE_NVAPI_VERSION(NV_GPU_GET_HDCP_SUPPORT_STATUS,1)
+
+NVAPI_INTERFACE NvAPI_GPU_GetHDCPSupportStatus(NvPhysicalGpuHandle hPhysicalGpu, NV_GPU_GET_HDCP_SUPPORT_STATUS *pGetHDCPSupportStatus);
+
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_Stereo_CreateConfigurationProfileRegistryKey
+//
+//  SUPPORTED OS: Windows Vista and higher
+//
+// DESCRIPTION:   Creates new configuration registry key for current application.
+//
+//                If there was no configuration profile prior to the function call,
+//                tries to create brand new configuration profile registry key
+//                for a given application and fill it with default values.
+//                If an application already had a configuration profile registry key, does nothing.
+//                Name of the key is automatically determined as the name of the executable that calls this function.
+//                Because of this, application executable should have distinct and unique name.
+//                If the application is using only one version of DirectX, than the default profile type will be appropriate.
+//                If the application is using more than one version of DirectX from same executable,
+//                it should use appropriate profile type for each configuration profile.
+//
+// PARAMETERS:    registryProfileType(IN) - Type of profile that application wants to create.
+//                                          Should be one of the symbolic constants defined in NV_STEREO_REGISTRY_PROFILE_TYPE.
+//                                          Any other value will cause function to do nothing and return NV_STEREO_REGISTRY_PROFILE_TYPE_NOT_SUPPORTED.
+//
+// HOW TO USE:    When there is a need for an application to have default stereo parameter values,
+//                use this function to create a key where they will be stored.
+//
+// RETURN STATUS:
+//                NVAPI_OK - Key exists in the registry.
+//                NVAPI_STEREO_REGISTRY_PROFILE_TYPE_NOT_SUPPORTED - This profile type is not supported.
+//                NVAPI_STEREO_REGISTRY_ACCESS_FAILED - Access to registry failed.
+//                NVAPI_API_NOT_INTIALIZED - NVAPI not initialized.
+//                NVAPI_STEREO_NOT_INITIALIZED - Stereo part of NVAPI not initialized.
+//                NVAPI_ERROR - Something is wrong (generic error).
+//
+///////////////////////////////////////////////////////////////////////////////
+
+typedef enum _NV_StereoRegistryProfileType
+{
+    NVAPI_STEREO_DEFAULT_REGISTRY_PROFILE, // Default registry configuration profile.
+    NVAPI_STEREO_DX9_REGISTRY_PROFILE,     // Separate registry configuration profile for DX9 executable.
+    NVAPI_STEREO_DX10_REGISTRY_PROFILE     // Separate registry configuration profile for DX10 executable.
+} NV_STEREO_REGISTRY_PROFILE_TYPE;
+
+NVAPI_INTERFACE NvAPI_Stereo_CreateConfigurationProfileRegistryKey(NV_STEREO_REGISTRY_PROFILE_TYPE registryProfileType);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_Stereo_DeleteConfigurationProfileRegistryKey
+//
+//  SUPPORTED OS: Windows Vista and higher
+//
+// DESCRIPTION:   Removes configuration registry key for current application.
+//
+//                If an application already had a configuration profile prior to the function call,
+//                this function will try to remove application's configuration profile registry key from the registry.
+//                If there was no configuration profile registry key prior to the function call,
+//                the function will do nothing and will not report an error.
+//
+// PARAMETERS:    registryProfileType(IN) - Type of profile that application wants to delete.
+//                                          Should be one of the symbolic constants defined in NV_STEREO_REGISTRY_PROFILE_TYPE.
+//                                          Any other value will cause function to do nothing and return NV_STEREO_REGISTRY_PROFILE_TYPE_NOT_SUPPORTED.
+//
+// RETURN STATUS:
+//                NVAPI_OK - Key does not exist in the registry any more.
+//                NVAPI_STEREO_REGISTRY_PROFILE_TYPE_NOT_SUPPORTED - This profile type is not supported.
+//                NVAPI_STEREO_REGISTRY_ACCESS_FAILED - Access to registry failed.
+//                NVAPI_API_NOT_INTIALIZED - NVAPI not initialized.
+//                NVAPI_STEREO_NOT_INITIALIZED - Stereo part of NVAPI not initialized.
+//                NVAPI_ERROR - Something is wrong (generic error).
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_Stereo_DeleteConfigurationProfileRegistryKey(NV_STEREO_REGISTRY_PROFILE_TYPE registryProfileType);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_Stereo_SetConfigurationProfileValue
+//
+// PARAMETERS:    registryProfileType(IN) - Type of profile that application wants to access.
+//                                          Should be one of the symbolic constants defined in NV_STEREO_REGISTRY_PROFILE_TYPE.
+//                                          Any other value will cause function to do nothing and return NV_STEREO_REGISTRY_PROFILE_TYPE_NOT_SUPPORTED.
+//                valueRegistryID(IN)     - ID of the value that is being set.
+//                                          Should be one of the symbolic constants defined in NV_STEREO_REGISTRY_PROFILE_TYPE.
+//                                          Any other value will cause function to do nothing and return NVAPI_STEREO_REGISTRY_VALUE_NOT_SUPPORTED.
+//                pValue(IN)              - Address of the value that is being set.
+//                                          Should be either address of a DWORD or of a float,
+//                                          dependent on the type of the stereo parameter whose value is being set.
+//                                          The API will then cast that address to DWORD*
+//                                          and write whatever is in those 4 bytes as a DWORD to the registry.
+//
+//  SUPPORTED OS: Windows Vista and higher
+//
+// DESCRIPTION:   Sets given parameter value under the application's registry key.
+//
+//                If the value does not exist under the application's registry key,
+//                the value will be created under the key.
+//
+// RETURN STATUS:
+//                NVAPI_OK - Value is written to registry.
+//                NVAPI_STEREO_REGISTRY_PROFILE_TYPE_NOT_SUPPORTED - This profile type is not supported.
+//                NVAPI_STEREO_REGISTRY_VALUE_NOT_SUPPORTED - This value is not supported.
+//                NVAPI_STEREO_REGISTRY_ACCESS_FAILED - Access to registry failed.
+//                NVAPI_API_NOT_INTIALIZED - NVAPI not initialized.
+//                NVAPI_STEREO_NOT_INITIALIZED - Stereo part of NVAPI not initialized.
+//                NVAPI_ERROR - Something is wrong (generic error).
+//
+///////////////////////////////////////////////////////////////////////////////
+
+typedef enum _NV_StereoRegistryID
+{
+    NVAPI_CONVERGENCE_ID,         // Symbolic constant for convergence registry ID.
+    NVAPI_FRUSTUM_ADJUST_MODE_ID, // Symbolic constant for frustum adjust mode registry ID.
+} NV_STEREO_REGISTRY_ID;
+
+NVAPI_INTERFACE NvAPI_Stereo_SetConfigurationProfileValue(NV_STEREO_REGISTRY_PROFILE_TYPE registryProfileType, NV_STEREO_REGISTRY_ID valueRegistryID, void *pValue);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_Stereo_DeleteConfigurationProfileValue
+//
+// PARAMETERS:    registryProfileType(IN) - Type of profile that application wants to access.
+//                                          Should be one of the symbolic constants defined in NV_STEREO_REGISTRY_PROFILE_TYPE.
+//                                          Any other value will cause function to do nothing and return NV_STEREO_REGISTRY_PROFILE_TYPE_NOT_SUPPORTED.
+//                valueRegistryID(IN)     - ID of the value that is being deleted.
+//                                          Should be one of the symbolic constants defined in NV_STEREO_REGISTRY_PROFILE_TYPE.
+//                                          Any other value will cause function to do nothing and return NVAPI_STEREO_REGISTRY_VALUE_NOT_SUPPORTED.
+//
+//  SUPPORTED OS: Windows Vista and higher
+//
+// DESCRIPTION:   Removes given value from application's configuration profile registry key.
+//
+//                If there is no such value, the function will do nothing and will not report an error.
+//
+// RETURN STATUS:
+//                NVAPI_OK - Value does not exist in registry any more.
+//                NVAPI_STEREO_REGISTRY_PROFILE_TYPE_NOT_SUPPORTED - This profile type is not supported.
+//                NVAPI_STEREO_REGISTRY_VALUE_NOT_SUPPORTED - This value is not supported.
+//                NVAPI_STEREO_REGISTRY_ACCESS_FAILED - Access to registry failed.
+//                NVAPI_API_NOT_INTIALIZED - NVAPI not initialized.
+//                NVAPI_STEREO_NOT_INITIALIZED - Stereo part of NVAPI not initialized.
+//                NVAPI_ERROR - Something is wrong (generic error).
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_Stereo_DeleteConfigurationProfileValue(NV_STEREO_REGISTRY_PROFILE_TYPE registryProfileType, NV_STEREO_REGISTRY_ID valueRegistryID);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_Stereo_Enable
+//
+//  SUPPORTED OS: Windows Vista and higher
+//
+// DESCRIPTION:   Enables stereo mode in the registry.
+//                Call to this function affects entire system.
+//                Calls to functions that require stereo enabled with stereo disabled will have no effect,
+//                and will return apropriate error code.
+//
+// RETURN STATUS:
+//                NVAPI_OK - Stereo is now enabled.
+//                NVAPI_API_NOT_INTIALIZED - NVAPI not initialized.
+//                NVAPI_STEREO_NOT_INITIALIZED - Stereo part of NVAPI not initialized.
+//                NVAPI_ERROR - Something is wrong (generic error).
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_Stereo_Enable(void);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_Stereo_Disable
+//
+//  SUPPORTED OS: Windows Vista and higher
+//
+// DESCRIPTION:   Disables stereo mode in the registry.
+//                Call to this function affects entire system.
+//                Calls to functions that require stereo enabled with stereo disabled will have no effect,
+//                and will return apropriate error code.
+//
+// RETURN STATUS:
+//                NVAPI_OK - Stereo is now disabled.
+//                NVAPI_API_NOT_INTIALIZED - NVAPI not initialized.
+//                NVAPI_STEREO_NOT_INITIALIZED - Stereo part of NVAPI not initialized.
+//                NVAPI_ERROR - Something is wrong (generic error).
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_Stereo_Disable(void);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_Stereo_IsEnabled
+//
+// PARAMETERS:    pIsStereoEnabled(OUT)  - Address where result of the inquiry will be placed.
+//
+//  SUPPORTED OS: Windows Vista and higher
+//
+// DESCRIPTION:   Checks if stereo mode is enabled in the registry.
+//
+// RETURN STATUS:
+//                NVAPI_OK - Check was sucessfully completed and result reflects current state of stereo availability.
+//                NVAPI_API_NOT_INTIALIZED - NVAPI not initialized.
+//                NVAPI_STEREO_NOT_INITIALIZED - Stereo part of NVAPI not initialized.
+//                NVAPI_ERROR - Something is wrong (generic error).
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_Stereo_IsEnabled(NvU8 *pIsStereoEnabled);
+
+
+#if defined(_D3D9_H_) || defined(__d3d10_h__) || defined(__d3d11_h__)
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_Stereo_CreateHandleFromIUnknown
+//
+// PARAMETERS:    pDevice(IN) - Pointer to IUnknown interface that is IDirect3DDevice9*, ID3D10Device* or ID3D11Device.
+//                pStereoHandle(OUT) - Pointer to newly created stereo handle.
+//
+//  SUPPORTED OS: Windows Vista and higher
+//
+// DESCRIPTION:   Creates stereo handle, that is used in subsequent calls related to given device interface.
+//                This must be called before any other NvAPI_Stereo_ function for that handle.
+//                Multiple devices can be used at one time using multiple calls to this function (one per each device).
+//
+// HOW TO USE:    After the Direct3D device is created, create stereo handle.
+//                On call success:
+//                Use all other NvAPI_Stereo_ functions that have stereo handle as first parameter.
+//                After the device interface correspondent to the stereo handle is destroyed,
+//                application should call NvAPI_DestroyStereoHandle for that stereo handle.
+//
+// RETURN STATUS:
+//                NVAPI_OK - Stereo handle is created for given device interface.
+//                NVAPI_INVALID_ARGUMENT - Provided device interface is invalid.
+//                NVAPI_API_NOT_INTIALIZED - NVAPI not initialized.
+//                NVAPI_STEREO_NOT_INITIALIZED - Stereo part of NVAPI not initialized.
+//                NVAPI_ERROR - Something is wrong (generic error).
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_Stereo_CreateHandleFromIUnknown(IUnknown *pDevice, StereoHandle *pStereoHandle);
+#endif // defined(_D3D9_H_) || defined(__d3d10_h__)
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_Stereo_DestroyHandle
+//
+// PARAMETERS:    stereoHandle(IN) - Stereo handle that is to be destroyed.
+//
+//  SUPPORTED OS: Windows Vista and higher
+//
+// DESCRIPTION:   Destroys stereo handle created with one of NvAPI_Stereo_CreateHandleFrom functions.
+//                This should be called after device corresponding to the handle has been destroyed.
+//
+// RETURN STATUS:
+//                NVAPI_OK - Stereo handle is destroyed.
+//                NVAPI_API_NOT_INTIALIZED - NVAPI not initialized.
+//                NVAPI_STEREO_NOT_INITIALIZED - Stereo part of NVAPI not initialized.
+//                NVAPI_ERROR - Something is wrong (generic error).
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_Stereo_DestroyHandle(StereoHandle stereoHandle);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_Stereo_Activate
+//
+// PARAMETERS:    stereoHandle(IN) - Stereo handle correspondent to device interface.
+//
+//  SUPPORTED OS: Windows Vista and higher
+//
+// DESCRIPTION:   Activates stereo for device interface correspondent to given stereo handle.
+//                Activating stereo will be possible only if stereo was enabled previously in the registry.
+//                Calls to all functions that require stereo activated
+//                with stereo deactivated will have no effect and will return appropriate error code.
+//
+// HOW TO USE:    After the stereo handle for device interface is created via successfull call to appropriate NvAPI_Stereo_CreateHandleFrom function.
+//
+// RETURN STATUS:
+//                NVAPI_OK - Stereo is turned on.
+//                NVAPI_STEREO_INVALID_DEVICE_INTERFACE - Device interface is not valid. Create again, then attach again.
+//                NVAPI_API_NOT_INTIALIZED - NVAPI not initialized.
+//                NVAPI_STEREO_NOT_INITIALIZED - Stereo part of NVAPI not initialized.
+//                NVAPI_ERROR - Something is wrong (generic error).
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_Stereo_Activate(StereoHandle stereoHandle);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_Stereo_Deactivate
+//
+// PARAMETERS:    stereoHandle(IN) - Stereo handle correspondent to device interface.
+//
+//  SUPPORTED OS: Windows Vista and higher
+//
+// DESCRIPTION:   Deactivates stereo for given device interface.
+//                Calls to all functions that require stereo activated
+//                with stereo deactivated will have no effect and will return appropriate error code.
+//
+// HOW TO USE:    After the stereo handle for device interface is created via successfull call to appropriate NvAPI_Stereo_CreateHandleFrom function.
+//
+// RETURN STATUS:
+//                NVAPI_OK - Stereo is turned off.
+//                NVAPI_STEREO_INVALID_DEVICE_INTERFACE - Device interface is not valid. Create again, then attach again.
+//                NVAPI_API_NOT_INTIALIZED - NVAPI not initialized.
+//                NVAPI_STEREO_NOT_INITIALIZED - Stereo part of NVAPI not initialized.
+//                NVAPI_ERROR - Something is wrong (generic error).
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_Stereo_Deactivate(StereoHandle stereoHandle);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_Stereo_IsActivated
+//
+// PARAMETERS:    stereoHandle(IN) - Stereo handle correspondent to device interface.
+//                pIsStereoOn(IN)  - Address where result of the inquiry will be placed.
+//
+//  SUPPORTED OS: Windows Vista and higher
+//
+// DESCRIPTION:   Checks if stereo is activated for given device interface.
+//
+// HOW TO USE:    After the stereo handle for device interface is created via successfull call to appropriate NvAPI_Stereo_CreateHandleFrom function.
+//
+// RETURN STATUS:
+//                NVAPI_OK - Check was sucessfully completed and result reflects current state of stereo (on/off).
+//                NVAPI_STEREO_INVALID_DEVICE_INTERFACE - Device interface is not valid. Create again, then attach again.
+//                NVAPI_API_NOT_INTIALIZED - NVAPI not initialized.
+//                NVAPI_STEREO_NOT_INITIALIZED - Stereo part of NVAPI not initialized.
+//                NVAPI_ERROR - Something is wrong (generic error).
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_Stereo_IsActivated(StereoHandle stereoHandle, NvU8 *pIsStereoOn);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_Stereo_GetSeparation
+//
+// PARAMETERS:    stereoHandle(IN)           - Stereo handle correspondent to device interface.
+//                pSeparationPercentage(OUT) - Address of @c float type variable to store current separation percentage in.
+//
+//  SUPPORTED OS: Windows Vista and higher
+//
+// DESCRIPTION:   Gets current separation value (in percents).
+//
+// HOW TO USE:    After the stereo handle for device interface is created via successfull call to appropriate NvAPI_Stereo_CreateHandleFrom function.
+//
+// RETURN STATUS:
+//                NVAPI_OK - Retrieval of separation percentage was successfull.
+//                NVAPI_STEREO_INVALID_DEVICE_INTERFACE - Device interface is not valid. Create again, then attach again.
+//                NVAPI_API_NOT_INTIALIZED - NVAPI not initialized.
+//                NVAPI_STEREO_NOT_INITIALIZED - Stereo part of NVAPI not initialized.
+//                NVAPI_ERROR - Something is wrong (generic error).
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_Stereo_GetSeparation(StereoHandle stereoHandle, float *pSeparationPercentage);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_Stereo_SetSeparation
+//
+// PARAMETERS:    stereoHandle(IN)            - Stereo handle correspondent to device interface.
+//                newSeparationPercentage(IN) - New value for separation percentage.
+//
+//  SUPPORTED OS: Windows Vista and higher
+//
+// DESCRIPTION:   Sets separation to given percentage.
+//
+// HOW TO USE:    After the stereo handle for device interface is created via successfull call to appropriate NvAPI_Stereo_CreateHandleFrom function.
+//
+// RETURN STATUS:
+//                NVAPI_OK - Setting of separation percentage was successfull.
+//                NVAPI_STEREO_INVALID_DEVICE_INTERFACE - Device interface is not valid. Create again, then attach again.
+//                NVAPI_API_NOT_INTIALIZED - NVAPI not initialized.
+//                NVAPI_STEREO_NOT_INITIALIZED - Stereo part of NVAPI not initialized.
+//                NVAPI_STEREO_PARAMETER_OUT_OF_RANGE - Given separation percentage is out of [0..100] range.
+//                NVAPI_ERROR - Something is wrong (generic error).
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_Stereo_SetSeparation(StereoHandle stereoHandle, float newSeparationPercentage);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_Stereo_DecreaseSeparation
+//
+// PARAMETERS:    stereoHandle(IN) - Stereo handle correspondent to device interface.
+//
+//  SUPPORTED OS: Windows Vista and higher
+//
+// DESCRIPTION:   Decreases separation for given device interface (same like Ctrl+F3 hotkey).
+//
+// HOW TO USE:    After the stereo handle for device interface is created via successfull call to appropriate NvAPI_Stereo_CreateHandleFrom function.
+//
+// RETURN STATUS:
+//                NVAPI_OK - Decrease of separation percentage was successfull.
+//                NVAPI_STEREO_INVALID_DEVICE_INTERFACE - Device interface is not valid. Create again, then attach again.
+//                NVAPI_API_NOT_INTIALIZED - NVAPI not initialized.
+//                NVAPI_STEREO_NOT_INITIALIZED - Stereo part of NVAPI not initialized.
+//                NVAPI_ERROR - Something is wrong (generic error).
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_Stereo_DecreaseSeparation(StereoHandle stereoHandle);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_Stereo_IncreaseSeparation
+//
+// PARAMETERS:    stereoHandle(IN) - Stereo handle correspondent to device interface.
+//
+//  SUPPORTED OS: Windows Vista and higher
+//
+// DESCRIPTION:   Increases separation for given device interface (same like Ctrl+F4 hotkey).
+//
+// HOW TO USE:    After the stereo handle for device interface is created via successfull call to appropriate NvAPI_Stereo_CreateHandleFrom function.
+//
+// RETURN STATUS:
+//                NVAPI_OK - Increase of separation percentage was successfull.
+//                NVAPI_STEREO_INVALID_DEVICE_INTERFACE - Device interface is not valid. Create again, then attach again.
+//                NVAPI_API_NOT_INTIALIZED - NVAPI not initialized.
+//                NVAPI_STEREO_NOT_INITIALIZED - Stereo part of NVAPI not initialized.
+//                NVAPI_ERROR - Something is wrong (generic error).
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_Stereo_IncreaseSeparation(StereoHandle stereoHandle);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_Stereo_GetConvergence
+//
+// PARAMETERS:    stereoHandle(IN)  - Stereo handle correspondent to device interface.
+//                pConvergence(OUT) - Address of @c float type variable to store current convergence value in.
+//
+//  SUPPORTED OS: Windows Vista and higher
+//
+// DESCRIPTION:   Gets current convergence value.
+//
+// HOW TO USE:    After the stereo handle for device interface is created via successfull call to appropriate NvAPI_Stereo_CreateHandleFrom function.
+//
+// RETURN STATUS:
+//                NVAPI_OK - Retrieval of convergence value was successfull.
+//                NVAPI_STEREO_INVALID_DEVICE_INTERFACE - Device interface is not valid. Create again, then attach again.
+//                NVAPI_API_NOT_INTIALIZED - NVAPI not initialized.
+//                NVAPI_STEREO_NOT_INITIALIZED - Stereo part of NVAPI not initialized.
+//                NVAPI_ERROR - Something is wrong (generic error).
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_Stereo_GetConvergence(StereoHandle stereoHandle, float *pConvergence);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_Stereo_SetConvergence
+//
+// PARAMETERS:    stereoHandle(IN)             - Stereo handle correspondent to device interface.
+//                newConvergencePercentage(IN) - New value for convergence.
+//
+//  SUPPORTED OS: Windows Vista and higher
+//
+// DESCRIPTION:   Sets convergence to given value.
+//
+// HOW TO USE:    After the stereo handle for device interface is created via successfull call to appropriate NvAPI_Stereo_CreateHandleFrom function.
+//
+// RETURN STATUS:
+//                NVAPI_OK - Setting of convergence value was successfull.
+//                NVAPI_STEREO_INVALID_DEVICE_INTERFACE - Device interface is not valid. Create again, then attach again.
+//                NVAPI_API_NOT_INTIALIZED - NVAPI not initialized.
+//                NVAPI_STEREO_NOT_INITIALIZED - Stereo part of NVAPI not initialized.
+//                NVAPI_ERROR - Something is wrong (generic error).
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_Stereo_SetConvergence(StereoHandle stereoHandle, float newConvergencePercentage);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_Stereo_DecreaseConvergence
+//
+// PARAMETERS:    stereoHandle(IN) - Stereo handle correspondent to device interface.
+//
+//  SUPPORTED OS: Windows Vista and higher
+//
+// DESCRIPTION:   Decreases convergence for given device interface (same like Ctrl+F5 hotkey).
+//
+// HOW TO USE:    After the stereo handle for device interface is created via successfull call to appropriate NvAPI_Stereo_CreateHandleFrom function.
+//
+// RETURN STATUS:
+//                NVAPI_OK - Decrease of convergence was successfull.
+//                NVAPI_STEREO_INVALID_DEVICE_INTERFACE - Device interface is not valid. Create again, then attach again.
+//                NVAPI_API_NOT_INTIALIZED - NVAPI not initialized.
+//                NVAPI_STEREO_NOT_INITIALIZED - Stereo part of NVAPI not initialized.
+//                NVAPI_ERROR - Something is wrong (generic error).
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_Stereo_DecreaseConvergence(StereoHandle stereoHandle);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_Stereo_IncreaseConvergence
+//
+// PARAMETERS:    stereoHandle(IN) - Stereo handle correspondent to device interface.
+//
+//  SUPPORTED OS: Windows Vista and higher
+//
+// DESCRIPTION:   Increases convergence for given device interface (same like Ctrl+F5 hotkey).
+//
+// HOW TO USE:    After the stereo handle for device interface is created via successfull call to appropriate NvAPI_Stereo_CreateHandleFrom function.
+//
+// RETURN STATUS:
+//                NVAPI_OK - Increase of convergence was successfull.
+//                NVAPI_STEREO_INVALID_DEVICE_INTERFACE - Device interface is not valid. Create again, then attach again.
+//                NVAPI_API_NOT_INTIALIZED - NVAPI not initialized.
+//                NVAPI_STEREO_NOT_INITIALIZED - Stereo part of NVAPI not initialized.
+//                NVAPI_ERROR - Something is wrong (generic error).
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_Stereo_IncreaseConvergence(StereoHandle stereoHandle);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_Stereo_GetFrustumAdjustMode
+//
+// PARAMETERS:    stereoHandle(IN)        - Stereo handle correspondent to device interface.
+//                pFrustumAdjustMode(OUT) - Address of the NV_FRUSTUM_ADJUST_MODE type variable to store current frustum value in.
+//
+//  SUPPORTED OS: Windows Vista and higher
+//
+// DESCRIPTION:   Gets current frustum adjust mode value.
+//
+// HOW TO USE:    After the stereo handle for device interface is created via successfull call to appropriate NvAPI_Stereo_CreateHandleFrom function.
+//
+// RETURN STATUS:
+//                NVAPI_OK - Retrieval of frustum adjust mode was successfull.
+//                NVAPI_STEREO_INVALID_DEVICE_INTERFACE - Device interface is not valid. Create again, then attach again.
+//                NVAPI_API_NOT_INTIALIZED - NVAPI not initialized.
+//                NVAPI_STEREO_NOT_INITIALIZED - Stereo part of NVAPI not initialized.
+//                NVAPI_ERROR - Something is wrong (generic error).
+//
+///////////////////////////////////////////////////////////////////////////////
+
+typedef enum _NV_FrustumAdjustMode
+{
+    NVAPI_NO_FRUSTUM_ADJUST,    // Do not adjust frustum.
+    NVAPI_FRUSTUM_STRETCH,      // Stretch images in X.
+    NVAPI_FRUSTUM_CLEAR_EDGES   // Clear corresponding edges for each eye.
+} NV_FRUSTUM_ADJUST_MODE;
+
+NVAPI_INTERFACE NvAPI_Stereo_GetFrustumAdjustMode(StereoHandle stereoHandle, NV_FRUSTUM_ADJUST_MODE *pFrustumAdjustMode);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_Stereo_SetFrustumAdjustMode
+//
+// PARAMETERS:    stereoHandle(IN)               - Stereo handle correspondent to device interface.
+//                newFrustumAdjustModeValue (IN) - New value for frustum adjust mode.
+//                                                 Should be one of the symbolic constants defined in NV_FRUSTUM_ADJUST_MODE.
+//                                                 Any other value will cause function to do nothing and return NVAPI_STEREO_FRUSTUM_ADJUST_MODE_NOT_SUPPORTED.
+//
+//  SUPPORTED OS: Windows Vista and higher
+//
+// DESCRIPTION:   Sets current frustum adjust mode value.
+//
+// HOW TO USE:    After the stereo handle for device interface is created via successfull call to appropriate NvAPI_Stereo_CreateHandleFrom function.
+//
+// RETURN STATUS:
+//                NVAPI_OK - Retrieval of frustum adjust mode was successfull.
+//                NVAPI_STEREO_INVALID_DEVICE_INTERFACE - Device interface is not valid. Create again, then attach again.
+//                NVAPI_API_NOT_INTIALIZED - NVAPI not initialized.
+//                NVAPI_STEREO_NOT_INITIALIZED - Stereo part of NVAPI not initialized.
+//                NVAPI_STEREO_FRUSTUM_ADJUST_MODE_NOT_SUPPORTED - Given frustum adjust mode is not supported.
+//                NVAPI_ERROR - Something is wrong (generic error).
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_Stereo_SetFrustumAdjustMode(StereoHandle stereoHandle, NV_FRUSTUM_ADJUST_MODE newFrustumAdjustModeValue);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_Stereo_CaptureJpegImage
+//
+// PARAMETERS:    stereoHandle(IN) - Stereo handle correspondent to device interface.
+//                quality(IN)      - Quality of the JPEG image to be captured. Integer value betweeen 0 and 100.
+//
+//  SUPPORTED OS: Windows Vista and higher
+//
+// DESCRIPTION:   Captures current stereo image in JPEG stereo format with given quality.
+//                Only the last capture call per flip will be effective.
+//
+// HOW TO USE:    After the stereo handle for device interface is created via successfull call to appropriate NvAPI_Stereo_CreateHandleFrom function.
+//
+// RETURN STATUS:
+//                NVAPI_OK - Image captured.
+//                NVAPI_STEREO_INVALID_DEVICE_INTERFACE - Device interface is not valid. Create again, then attach again.
+//                NVAPI_API_NOT_INTIALIZED - NVAPI not initialized.
+//                NVAPI_STEREO_NOT_INITIALIZED - Stereo part of NVAPI not initialized.
+//                NVAPI_STEREO_PARAMETER_OUT_OF_RANGE - Given quality is out of [0..100] range.
+//                NVAPI_ERROR - Something is wrong (generic error).
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_Stereo_CaptureJpegImage(StereoHandle stereoHandle, NvU32 quality);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_Stereo_CapturePngImage
+//
+// PARAMETERS:    stereoHandle(IN) - Stereo handle correspondent to device interface.
+//
+//  SUPPORTED OS: Windows Vista and higher
+//
+// DESCRIPTION:   Captures current stereo image in PNG stereo format.
+//                Only the last capture call per flip will be effective.
+//
+// HOW TO USE:    After the stereo handle for device interface is created via successfull call to appropriate NvAPI_Stereo_CreateHandleFrom function.
+//
+// RETURN STATUS:
+//                NVAPI_OK - Image captured.
+//                NVAPI_STEREO_INVALID_DEVICE_INTERFACE - Device interface is not valid. Create again, then attach again.
+//                NVAPI_API_NOT_INTIALIZED - NVAPI not initialized.
+//                NVAPI_STEREO_NOT_INITIALIZED - Stereo part of NVAPI not initialized.
+//                NVAPI_ERROR - Something is wrong (generic error).
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_Stereo_CapturePngImage(StereoHandle stereoHandle);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_Stereo_ReverseStereoBlitControl
+//
+// PARAMETERS:    stereoHandle(IN) - Stereo handle correspondent to device interface.
+//                TurnOn(IN)       != 0  - turns on,
+//                                 == 0  - turns off
+//
+//  SUPPORTED OS: Windows Vista and higher
+//
+// DESCRIPTION:   Turns on/off reverse stereo blit
+//
+// HOW TO USE:    After the stereo handle for device interface is created via successfull call to appropriate
+//                NvAPI_Stereo_CreateHandleFrom function.
+//                After reversed stereo blit control turned on blit from stereo surface will
+//                produce right eye image in the left side of the destination surface and left
+//                eye image in the right side of the destination surface
+//                In DX9 Dst surface has to be created as render target and StretchRect has to be used.
+//                Conditions:
+//                1. DstWidth == 2*SrcWidth
+//                2. DstHeight == SrcHeight
+//                3. Src surface is actually stereo surface.
+//                4. SrcRect must be {0,0,SrcWidth,SrcHeight}
+//                5. DstRect must be {0,0,DstWidth,DstHeight}
+//
+//                In DX10 ResourceCopyRegion has to be used
+//                Conditions:
+//                1. DstWidth == 2*SrcWidth
+//                2. DstHeight == SrcHeight
+//                3. dstX == 0,
+//                4. dstY == 0,
+//                5. dstZ == 0,
+//                6  SrcBox: left=top=front==0;
+//                           right==SrcWidth; bottom==SrcHeight; back==1;
+//
+// RETURN STATUS:
+//                NVAPI_OK - Retrieval of frustum adjust mode was successfull.
+//                NVAPI_STEREO_INVALID_DEVICE_INTERFACE - Device interface is not valid. Create again, then attach again.
+//                NVAPI_API_NOT_INTIALIZED - NVAPI not initialized.
+//                NVAPI_STEREO_NOT_INITIALIZED - Stereo part of NVAPI not initialized.
+//                NVAPI_ERROR - Something is wrong (generic error).
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_Stereo_ReverseStereoBlitControl(StereoHandle hStereoHandle, NvU8 TurnOn);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_Stereo_SetNotificationMessage
+//
+// PARAMETERS:    stereoHandle(IN) - Stereo handle correspondent to device interface.
+//                hWnd(IN)         - Window HWND that will be notified when user changed stereo driver state.
+//                                   Actual HWND must be cast to an NvU64.
+//                messageID(IN)    - MessageID of the message that will be posted to hWnd
+//
+//  SUPPORTED OS: Windows Vista and higher
+//
+// DESCRIPTION:   Setup notification message that stereo driver will use to notify application
+//                when user changes stereo driver state.
+//                Call this API with NULL hWnd to prohibit notification.
+//
+//
+// HOW TO USE:    After the stereo handle for device interface is created via successfull call to appropriate
+//                NvAPI_Stereo_CreateHandleFrom function.
+//
+//                When user changes stereo state Activated or Deactivated, separation or conversion
+//                stereo driver will post defined message with the folloing parameters
+//
+//                wParam == MAKEWPARAM(l, h) where l == 0 if stereo is deactivated
+//                                                      1 if stereo is deactivated
+//                                                 h  - is current separation.
+//                                                      Actual separation is float(h*100.f/0xFFFF);
+//                lParam                           is current conversion.
+//                                                      Actual conversion is *(float*)&lParam
+//
+// RETURN STATUS:
+//                NVAPI_OK - Notification set.
+//                NVAPI_STEREO_INVALID_DEVICE_INTERFACE - Device interface is not valid. Create again, then attach again.
+//                NVAPI_API_NOT_INTIALIZED - NVAPI not initialized.
+//                NVAPI_STEREO_NOT_INITIALIZED - Stereo part of NVAPI not initialized.
+//                NVAPI_ERROR - Something is wrong (generic error).
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_Stereo_SetNotificationMessage(StereoHandle hStereoHandle, NvU64 hWnd,NvU64 messageID);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_Stereo_GetEyeSeparation
+//
+// PARAMETERS:    stereoHandle(IN) - Stereo handle correspondent to device interface.
+//                pSeparation(OUT) - Eye separation.
+//
+//  SUPPORTED OS: Windows Vista and higher
+//
+// DESCRIPTION:   Return eye separation as <between eye distance>/<phisical screen width> ratio
+//
+// HOW TO USE:    After the stereo handle for device interface is created via successfull call to appropriate
+//                Applyed only for DX9 and up.
+//
+// RETURN STATUS:
+//                NVAPI_OK - Active eye is set.
+//                NVAPI_STEREO_INVALID_DEVICE_INTERFACE - Device interface is not valid. Create again, then attach again.
+//                NVAPI_API_NOT_INTIALIZED - NVAPI not initialized.
+//                NVAPI_STEREO_NOT_INITIALIZED - Stereo part of NVAPI not initialized.
+//                NVAPI_ERROR - Something is wrong (generic error).
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_Stereo_GetEyeSeparation(StereoHandle hStereoHandle,  float *pSeparation );
+
+
+typedef NvU32   NVVIOOWNERID;                               // Unique identifier for VIO owner (process identifier or NVVIOOWNERID_NONE)
+#define NVVIOOWNERID_NONE                   0               // Unregistered ownerId
+
+typedef enum _NVVIOOWNERTYPE                                // Owner type for device
+{
+    NVVIOOWNERTYPE_NONE                             ,       //  No owner for device
+    NVVIOOWNERTYPE_APPLICATION                      ,       //  Application owns device
+    NVVIOOWNERTYPE_DESKTOP                          ,       //  Desktop transparent mode owns device (not applicable for video input)
+}NVVIOOWNERTYPE;
+
+// Access rights for NvAPI_VIO_Open()
+#define NVVIO_O_READ                        0x00000000      // Read access             (not applicable for video output)
+#define NVVIO_O_WRITE_EXCLUSIVE             0x00010001      // Write exclusive access  (not applicable for video input)
+
+#define NVVIO_VALID_ACCESSRIGHTS            (NVVIO_O_READ              | \
+                                             NVVIO_O_WRITE_EXCLUSIVE   )
+
+
+// VIO_DATA.ulOwnerID high-bit is set only if device has been initialized by VIOAPI
+// examined at NvAPI_GetCapabilities|NvAPI_VIO_Open to determine if settings need to be applied from registry or POR state read
+#define NVVIO_OWNERID_INITIALIZED  0x80000000
+
+// VIO_DATA.ulOwnerID next-bit is set only if device is currently in exclusive write access mode from NvAPI_VIO_Open()
+#define NVVIO_OWNERID_EXCLUSIVE    0x40000000
+
+// VIO_DATA.ulOwnerID lower bits are:
+//  NVGVOOWNERTYPE_xxx enumerations indicating use context
+#define NVVIO_OWNERID_TYPEMASK     0x0FFFFFFF // mask for NVVIOOWNERTYPE_xxx
+//---------------------------------------------------------------------
+// Enumerations
+//---------------------------------------------------------------------
+
+// Video signal format and resolution
+typedef enum _NVVIOSIGNALFORMAT
+{
+    NVVIOSIGNALFORMAT_NONE,                         // Invalid signal format
+    NVVIOSIGNALFORMAT_487I_59_94_SMPTE259_NTSC,     // 01  487i    59.94Hz  (SMPTE259) NTSC
+    NVVIOSIGNALFORMAT_576I_50_00_SMPTE259_PAL,      // 02  576i    50.00Hz  (SMPTE259) PAL
+    NVVIOSIGNALFORMAT_1035I_60_00_SMPTE260,         // 03  1035i   60.00Hz  (SMPTE260)
+    NVVIOSIGNALFORMAT_1035I_59_94_SMPTE260,         // 04  1035i   59.94Hz  (SMPTE260)
+    NVVIOSIGNALFORMAT_1080I_50_00_SMPTE295,         // 05  1080i   50.00Hz  (SMPTE295)
+    NVVIOSIGNALFORMAT_1080I_60_00_SMPTE274,         // 06  1080i   60.00Hz  (SMPTE274)
+    NVVIOSIGNALFORMAT_1080I_59_94_SMPTE274,         // 07  1080i   59.94Hz  (SMPTE274)
+    NVVIOSIGNALFORMAT_1080I_50_00_SMPTE274,         // 08  1080i   50.00Hz  (SMPTE274)
+    NVVIOSIGNALFORMAT_1080P_30_00_SMPTE274,         // 09  1080p   30.00Hz  (SMPTE274)
+    NVVIOSIGNALFORMAT_1080P_29_97_SMPTE274,         // 10  1080p   29.97Hz  (SMPTE274)
+    NVVIOSIGNALFORMAT_1080P_25_00_SMPTE274,         // 11  1080p   25.00Hz  (SMPTE274)
+    NVVIOSIGNALFORMAT_1080P_24_00_SMPTE274,         // 12  1080p   24.00Hz  (SMPTE274)
+    NVVIOSIGNALFORMAT_1080P_23_976_SMPTE274,        // 13  1080p   23.976Hz (SMPTE274)
+    NVVIOSIGNALFORMAT_720P_60_00_SMPTE296,          // 14  720p    60.00Hz  (SMPTE296)
+    NVVIOSIGNALFORMAT_720P_59_94_SMPTE296,          // 15  720p    59.94Hz  (SMPTE296)
+    NVVIOSIGNALFORMAT_720P_50_00_SMPTE296,          // 16  720p    50.00Hz  (SMPTE296)
+    NVVIOSIGNALFORMAT_1080I_48_00_SMPTE274,         // 17  1080I   48.00Hz  (SMPTE274)
+    NVVIOSIGNALFORMAT_1080I_47_96_SMPTE274,         // 18  1080I   47.96Hz  (SMPTE274)
+    NVVIOSIGNALFORMAT_720P_30_00_SMPTE296,          // 19  720p    30.00Hz  (SMPTE296)
+    NVVIOSIGNALFORMAT_720P_29_97_SMPTE296,          // 20  720p    29.97Hz  (SMPTE296)
+    NVVIOSIGNALFORMAT_720P_25_00_SMPTE296,          // 21  720p    25.00Hz  (SMPTE296)
+    NVVIOSIGNALFORMAT_720P_24_00_SMPTE296,          // 22  720p    24.00Hz  (SMPTE296)
+    NVVIOSIGNALFORMAT_720P_23_98_SMPTE296,          // 23  720p    23.98Hz  (SMPTE296)
+    NVVIOSIGNALFORMAT_2048P_30_00_SMPTE372,         // 24  2048p   30.00Hz  (SMPTE372)
+    NVVIOSIGNALFORMAT_2048P_29_97_SMPTE372,         // 25  2048p   29.97Hz  (SMPTE372)
+    NVVIOSIGNALFORMAT_2048I_60_00_SMPTE372,         // 26  2048i   60.00Hz  (SMPTE372)
+    NVVIOSIGNALFORMAT_2048I_59_94_SMPTE372,         // 27  2048i   59.94Hz  (SMPTE372)
+    NVVIOSIGNALFORMAT_2048P_25_00_SMPTE372,         // 28  2048p   25.00Hz  (SMPTE372)
+    NVVIOSIGNALFORMAT_2048I_50_00_SMPTE372,         // 29  2048i   50.00Hz  (SMPTE372)
+    NVVIOSIGNALFORMAT_2048P_24_00_SMPTE372,         // 30  2048p   24.00Hz  (SMPTE372)
+    NVVIOSIGNALFORMAT_2048P_23_98_SMPTE372,         // 31  2048p   23.98Hz  (SMPTE372)
+    NVVIOSIGNALFORMAT_2048I_48_00_SMPTE372,         // 32  2048i   48.00Hz  (SMPTE372)
+    NVVIOSIGNALFORMAT_2048I_47_96_SMPTE372,         // 33  2048i   47.96Hz  (SMPTE372)
+
+    NVVIOSIGNALFORMAT_1080PSF_25_00_SMPTE274,       // 34  1080PsF 25.00Hz  (SMPTE274)
+    NVVIOSIGNALFORMAT_1080PSF_29_97_SMPTE274,       // 35  1080PsF 29.97Hz  (SMPTE274)
+    NVVIOSIGNALFORMAT_1080PSF_30_00_SMPTE274,       // 36  1080PsF 30.00Hz  (SMPTE274)
+    NVVIOSIGNALFORMAT_1080PSF_24_00_SMPTE274,       // 37  1080PsF 24.00Hz  (SMPTE274)
+    NVVIOSIGNALFORMAT_1080PSF_23_98_SMPTE274,       // 38  1080PsF 23.98Hz  (SMPTE274)
+
+    NVVIOSIGNALFORMAT_1080P_50_00_SMPTE274_3G_LEVEL_A, // 39  1080P   50.00Hz  (SMPTE274) 3G Level A
+    NVVIOSIGNALFORMAT_1080P_59_94_SMPTE274_3G_LEVEL_A, // 40  1080P   59.94Hz  (SMPTE274) 3G Level A
+    NVVIOSIGNALFORMAT_1080P_60_00_SMPTE274_3G_LEVEL_A, // 41  1080P   60.00Hz  (SMPTE274) 3G Level A
+
+    NVVIOSIGNALFORMAT_1080P_60_00_SMPTE274_3G_LEVEL_B, // 42  1080p   60.00Hz  (SMPTE274) 3G Level B
+    NVVIOSIGNALFORMAT_1080I_60_00_SMPTE274_3G_LEVEL_B, // 43  1080i   60.00Hz  (SMPTE274) 3G Level B
+    NVVIOSIGNALFORMAT_2048I_60_00_SMPTE372_3G_LEVEL_B, // 44  2048i   60.00Hz  (SMPTE372) 3G Level B
+    NVVIOSIGNALFORMAT_1080P_50_00_SMPTE274_3G_LEVEL_B, // 45  1080p   50.00Hz  (SMPTE274) 3G Level B
+    NVVIOSIGNALFORMAT_1080I_50_00_SMPTE274_3G_LEVEL_B, // 46  1080i   50.00Hz  (SMPTE274) 3G Level B
+    NVVIOSIGNALFORMAT_2048I_50_00_SMPTE372_3G_LEVEL_B, // 47  2048i   50.00Hz  (SMPTE372) 3G Level B
+    NVVIOSIGNALFORMAT_1080P_30_00_SMPTE274_3G_LEVEL_B, // 48  1080p   30.00Hz  (SMPTE274) 3G Level B
+    NVVIOSIGNALFORMAT_2048P_30_00_SMPTE372_3G_LEVEL_B, // 49  2048p   30.00Hz  (SMPTE372) 3G Level B
+    NVVIOSIGNALFORMAT_1080P_25_00_SMPTE274_3G_LEVEL_B, // 50  1080p   25.00Hz  (SMPTE274) 3G Level B
+    NVVIOSIGNALFORMAT_2048P_25_00_SMPTE372_3G_LEVEL_B, // 51  2048p   25.00Hz  (SMPTE372) 3G Level B
+    NVVIOSIGNALFORMAT_1080P_24_00_SMPTE274_3G_LEVEL_B, // 52  1080p   24.00Hz  (SMPTE274) 3G Level B
+    NVVIOSIGNALFORMAT_2048P_24_00_SMPTE372_3G_LEVEL_B, // 53  2048p   24.00Hz  (SMPTE372) 3G Level B
+    NVVIOSIGNALFORMAT_1080I_48_00_SMPTE274_3G_LEVEL_B, // 54  1080i   48.00Hz  (SMPTE274) 3G Level B
+    NVVIOSIGNALFORMAT_2048I_48_00_SMPTE372_3G_LEVEL_B, // 55  2048i   48.00Hz  (SMPTE372) 3G Level B
+    NVVIOSIGNALFORMAT_1080P_59_94_SMPTE274_3G_LEVEL_B, // 56  1080p   59.94Hz  (SMPTE274) 3G Level B
+    NVVIOSIGNALFORMAT_1080I_59_94_SMPTE274_3G_LEVEL_B, // 57  1080i   59.94Hz  (SMPTE274) 3G Level B
+    NVVIOSIGNALFORMAT_2048I_59_94_SMPTE372_3G_LEVEL_B, // 58  2048i   59.94Hz  (SMPTE372) 3G Level B
+    NVVIOSIGNALFORMAT_1080P_29_97_SMPTE274_3G_LEVEL_B, // 59  1080p   29.97Hz  (SMPTE274) 3G Level B
+    NVVIOSIGNALFORMAT_2048P_29_97_SMPTE372_3G_LEVEL_B, // 60  2048p   29.97Hz  (SMPTE372) 3G Level B
+    NVVIOSIGNALFORMAT_1080P_23_98_SMPTE274_3G_LEVEL_B, // 61  1080p   29.98Hz  (SMPTE274) 3G Level B
+    NVVIOSIGNALFORMAT_2048P_23_98_SMPTE372_3G_LEVEL_B, // 62  2048p   29.98Hz  (SMPTE372) 3G Level B
+    NVVIOSIGNALFORMAT_1080I_47_96_SMPTE274_3G_LEVEL_B, // 63  1080i   47.96Hz  (SMPTE274) 3G Level B
+    NVVIOSIGNALFORMAT_2048I_47_96_SMPTE372_3G_LEVEL_B, // 64  2048i   47.96Hz  (SMPTE372) 3G Level B
+
+    NVVIOSIGNALFORMAT_END                              // 65  To indicate end of signal format list
+}NVVIOSIGNALFORMAT;
+
+// SMPTE standards format
+typedef enum _NVVIOVIDEOSTANDARD
+{
+    NVVIOVIDEOSTANDARD_SMPTE259                        ,       // SMPTE259
+    NVVIOVIDEOSTANDARD_SMPTE260                        ,       // SMPTE260
+    NVVIOVIDEOSTANDARD_SMPTE274                        ,       // SMPTE274
+    NVVIOVIDEOSTANDARD_SMPTE295                        ,       // SMPTE295
+    NVVIOVIDEOSTANDARD_SMPTE296                        ,       // SMPTE296
+    NVVIOVIDEOSTANDARD_SMPTE372                        ,       // SMPTE372
+}NVVIOVIDEOSTANDARD;
+
+// HD or SD video type
+typedef enum _NVVIOVIDEOTYPE
+{
+    NVVIOVIDEOTYPE_SD                                  ,       // Standard-definition (SD)
+    NVVIOVIDEOTYPE_HD                                  ,       // High-definition     (HD)
+}NVVIOVIDEOTYPE;
+
+// Interlace mode
+typedef enum _NVVIOINTERLACEMODE
+{
+    NVVIOINTERLACEMODE_PROGRESSIVE                     ,       // Progressive               (p)
+    NVVIOINTERLACEMODE_INTERLACE                       ,       // Interlace                 (i)
+    NVVIOINTERLACEMODE_PSF                             ,       // Progressive Segment Frame (psf)
+}NVVIOINTERLACEMODE;
+
+// Video data format
+typedef enum _NVVIODATAFORMAT
+{
+    NVVIODATAFORMAT_UNKNOWN   = -1                     ,       // Invalid DataFormat
+    NVVIODATAFORMAT_R8G8B8_TO_YCRCB444                 ,       // R8:G8:B8                => YCrCb  (4:4:4)
+    NVVIODATAFORMAT_R8G8B8A8_TO_YCRCBA4444             ,       // R8:G8:B8:A8             => YCrCbA (4:4:4:4)
+    NVVIODATAFORMAT_R8G8B8Z10_TO_YCRCBZ4444            ,       // R8:G8:B8:Z10            => YCrCbZ (4:4:4:4)
+    NVVIODATAFORMAT_R8G8B8_TO_YCRCB422                 ,       // R8:G8:B8                => YCrCb  (4:2:2)
+    NVVIODATAFORMAT_R8G8B8A8_TO_YCRCBA4224             ,       // R8:G8:B8:A8             => YCrCbA (4:2:2:4)
+    NVVIODATAFORMAT_R8G8B8Z10_TO_YCRCBZ4224            ,       // R8:G8:B8:Z10            => YCrCbZ (4:2:2:4)
+    NVVIODATAFORMAT_X8X8X8_444_PASSTHRU                ,       // R8:G8:B8                => RGB    (4:4:4)
+    NVVIODATAFORMAT_X8X8X8A8_4444_PASSTHRU             ,       // R8:G8:B8:A8             => RGBA   (4:4:4:4)
+    NVVIODATAFORMAT_X8X8X8Z10_4444_PASSTHRU            ,       // R8:G8:B8:Z10            => RGBZ   (4:4:4:4)
+    NVVIODATAFORMAT_X10X10X10_444_PASSTHRU             ,       // Y10:CR10:CB10           => YCrCb  (4:4:4)
+    NVVIODATAFORMAT_X10X8X8_444_PASSTHRU               ,       // Y10:CR8:CB8             => YCrCb  (4:4:4)
+    NVVIODATAFORMAT_X10X8X8A10_4444_PASSTHRU           ,       // Y10:CR8:CB8:A10         => YCrCbA (4:4:4:4)
+    NVVIODATAFORMAT_X10X8X8Z10_4444_PASSTHRU           ,       // Y10:CR8:CB8:Z10         => YCrCbZ (4:4:4:4)
+    NVVIODATAFORMAT_DUAL_R8G8B8_TO_DUAL_YCRCB422       ,       // R8:G8:B8 + R8:G8:B8     => YCrCb  (4:2:2 + 4:2:2)
+    NVVIODATAFORMAT_DUAL_X8X8X8_TO_DUAL_422_PASSTHRU   ,       // Y8:CR8:CB8 + Y8:CR8:CB8 => YCrCb  (4:2:2 + 4:2:2)
+    NVVIODATAFORMAT_R10G10B10_TO_YCRCB422              ,       // R10:G10:B10             => YCrCb  (4:2:2)
+    NVVIODATAFORMAT_R10G10B10_TO_YCRCB444              ,       // R10:G10:B10             => YCrCb  (4:4:4)
+    NVVIODATAFORMAT_X12X12X12_444_PASSTHRU             ,       // X12:X12:X12             => XXX    (4:4:4)
+    NVVIODATAFORMAT_X12X12X12_422_PASSTHRU             ,       // X12:X12:X12             => XXX    (4:2:2)
+    NVVIODATAFORMAT_Y10CR10CB10_TO_YCRCB422            ,       // Y10:CR10:CB10           => YCrCb  (4:2:2)
+    NVVIODATAFORMAT_Y8CR8CB8_TO_YCRCB422               ,       // Y8:CR8:CB8              => YCrCb  (4:2:2)
+    NVVIODATAFORMAT_Y10CR8CB8A10_TO_YCRCBA4224         ,       // Y10:CR8:CB8:A10         => YCrCbA (4:2:2:4)
+    NVVIODATAFORMAT_R10G10B10_TO_RGB444                ,       // R10:G10:B10             => RGB    (4:4:4)
+    NVVIODATAFORMAT_R12G12B12_TO_YCRCB444              ,       // R12:G12:B12             => YCrCb  (4:4:4)
+    NVVIODATAFORMAT_R12G12B12_TO_YCRCB422              ,       // R12:G12:B12             => YCrCb  (4:2:2)
+}NVVIODATAFORMAT;
+
+// Video output area
+typedef enum _NVVIOOUTPUTAREA
+{
+    NVVIOOUTPUTAREA_FULLSIZE                           ,       // Output to entire video resolution (full size)
+    NVVIOOUTPUTAREA_SAFEACTION                         ,       // Output to centered 90% of video resolution (safe action)
+    NVVIOOUTPUTAREA_SAFETITLE                          ,       // Output to centered 80% of video resolution (safe title)
+}NVVIOOUTPUTAREA;
+
+// Synchronization source
+typedef enum _NVVIOSYNCSOURCE
+{
+    NVVIOSYNCSOURCE_SDISYNC                            ,       // SDI Sync  (Digital input)
+    NVVIOSYNCSOURCE_COMPSYNC                           ,       // COMP Sync (Composite input)
+}NVVIOSYNCSOURCE;
+
+// Composite synchronization type
+typedef enum _NVVIOCOMPSYNCTYPE
+{
+    NVVIOCOMPSYNCTYPE_AUTO                             ,       // Auto-detect
+    NVVIOCOMPSYNCTYPE_BILEVEL                          ,       // Bi-level signal
+    NVVIOCOMPSYNCTYPE_TRILEVEL                         ,       // Tri-level signal
+}NVVIOCOMPSYNCTYPE;
+
+// Video input output status
+typedef enum _NVVIOINPUTOUTPUTSTATUS
+{
+    NVINPUTOUTPUTSTATUS_OFF                            ,       // Not in use
+    NVINPUTOUTPUTSTATUS_ERROR                          ,       // Error detected
+    NVINPUTOUTPUTSTATUS_SDI_SD                         ,       // SDI (standard-definition)
+    NVINPUTOUTPUTSTATUS_SDI_HD                         ,       // SDI (high-definition)
+}NVVIOINPUTOUTPUTSTATUS;
+
+// Synchronization input status
+typedef enum _NVVIOSYNCSTATUS
+{
+    NVVIOSYNCSTATUS_OFF                                ,       // Sync not detected
+    NVVIOSYNCSTATUS_ERROR                              ,       // Error detected
+    NVVIOSYNCSTATUS_SYNCLOSS                           ,       // Genlock in use, format mismatch with output
+    NVVIOSYNCSTATUS_COMPOSITE                          ,       // Composite sync
+    NVVIOSYNCSTATUS_SDI_SD                             ,       // SDI sync (standard-definition)
+    NVVIOSYNCSTATUS_SDI_HD                             ,       // SDI sync (high-definition)
+}NVVIOSYNCSTATUS;
+
+//Video Capture Status
+typedef enum _NVVIOCAPTURESTATUS
+{
+    NVVIOSTATUS_STOPPED                                ,       // Sync not detected
+    NVVIOSTATUS_RUNNING                                ,       // Error detected
+    NVVIOSTATUS_ERROR                                  ,       // Genlock in use, format mismatch with output
+}NVVIOCAPTURESTATUS;
+
+//Video Capture Status
+typedef enum _NVVIOSTATUSTYPE
+{
+    NVVIOSTATUSTYPE_IN                                 ,       // Input Status
+    NVVIOSTATUSTYPE_OUT                                ,       // Output Status
+}NVVIOSTATUSTYPE;
+
+#define NVAPI_MAX_VIO_DEVICES                 8   // Assumption, maximum 4 SDI input and 4 SDI output cards supported on a system
+#define NVAPI_MAX_VIO_JACKS                   4   // 4 physical jacks supported on each SDI input card.
+#define NVAPI_MAX_VIO_CHANNELS_PER_JACK       2   // Each physical jack an on SDI input card can have
+                                                  // two "channels" in the case of "3G" VideoFormats, as specified
+                                                  // by SMPTE 425; for non-3G VideoFormats, only the first channel within
+                                                  // a physical jack is valid
+#define NVAPI_MAX_VIO_STREAMS                 4   // 4 Streams, 1 per physical jack
+#define NVAPI_MIN_VIO_STREAMS                 1
+#define NVAPI_MAX_VIO_LINKS_PER_STREAM        2   // SDI input supports a max of 2 links per stream
+#define NVAPI_MAX_FRAMELOCK_MAPPING_MODES     20
+#define NVAPI_GVI_MIN_RAW_CAPTURE_IMAGES      1   // Min number of capture images
+#define NVAPI_GVI_MAX_RAW_CAPTURE_IMAGES      32  // Max number of capture images
+#define NVAPI_GVI_DEFAULT_RAW_CAPTURE_IMAGES  5   // Default number of capture images
+
+// Data Signal notification events. These need a event handler in RM.
+// Register/Unregister and PopEvent NVAPI's are already available.
+
+// Device configuration
+typedef enum _NVVIOCONFIGTYPE
+{
+    NVVIOCONFIGTYPE_IN                                 ,       // Input Status
+    NVVIOCONFIGTYPE_OUT                                ,       // Output Status
+}NVVIOCONFIGTYPE;
+
+typedef enum _NVVIOCOLORSPACE
+{
+    NVVIOCOLORSPACE_UNKNOWN,
+    NVVIOCOLORSPACE_YCBCR,
+    NVVIOCOLORSPACE_YCBCRA,
+    NVVIOCOLORSPACE_YCBCRD,
+    NVVIOCOLORSPACE_GBR,
+    NVVIOCOLORSPACE_GBRA,
+    NVVIOCOLORSPACE_GBRD,
+} NVVIOCOLORSPACE;
+
+// Component sampling
+typedef enum _NVVIOCOMPONENTSAMPLING
+{
+    NVVIOCOMPONENTSAMPLING_UNKNOWN,
+    NVVIOCOMPONENTSAMPLING_4444,
+    NVVIOCOMPONENTSAMPLING_4224,
+    NVVIOCOMPONENTSAMPLING_444,
+    NVVIOCOMPONENTSAMPLING_422
+} NVVIOCOMPONENTSAMPLING;
+
+typedef enum _NVVIOBITSPERCOMPONENT
+{
+    NVVIOBITSPERCOMPONENT_UNKNOWN,
+    NVVIOBITSPERCOMPONENT_8,
+    NVVIOBITSPERCOMPONENT_10,
+    NVVIOBITSPERCOMPONENT_12,
+} NVVIOBITSPERCOMPONENT;
+
+typedef enum _NVVIOLINKID
+{
+    NVVIOLINKID_UNKNOWN,
+    NVVIOLINKID_A,
+    NVVIOLINKID_B,
+    NVVIOLINKID_C,
+    NVVIOLINKID_D
+} NVVIOLINKID;
+
+typedef enum _NVVIOANCPARITYCOMPUTATION
+{
+    NVVIOANCPARITYCOMPUTATION_AUTO,
+    NVVIOANCPARITYCOMPUTATION_ON,
+    NVVIOANCPARITYCOMPUTATION_OFF
+} NVVIOANCPARITYCOMPUTATION;
+
+//---------------------------------------------------------------------
+// Structures
+//---------------------------------------------------------------------
+
+#define NVVIOCAPS_VIDOUT_SDI                0x00000001      // Supports Serial Digital Interface (SDI) output
+#define NVVIOCAPS_SYNC_INTERNAL             0x00000100      // Supports Internal timing source
+#define NVVIOCAPS_SYNC_GENLOCK              0x00000200      // Supports Genlock timing source
+#define NVVIOCAPS_SYNCSRC_SDI               0x00001000      // Supports Serial Digital Interface (SDI) synchronization input
+#define NVVIOCAPS_SYNCSRC_COMP              0x00002000      // Supports Composite synchronization input
+#define NVVIOCAPS_OUTPUTMODE_DESKTOP        0x00010000      // Supports Desktop transparent mode
+#define NVVIOCAPS_OUTPUTMODE_OPENGL         0x00020000      // Supports OpenGL application mode
+#define NVVIOCAPS_VIDIN_SDI                 0x00100000      // Supports Serial Digital Interface (SDI) input
+#define NVVIOCAPS_PACKED_ANC_SUPPORTED      0x00200000      // Supports Packed ANC
+
+#define NVVIOCLASS_SDI                      0x00000001      // SDI-class interface: SDI output with two genlock inputs
+
+// Device capabilities
+typedef struct _NVVIOCAPS
+{
+    NvU32             version;                              // Structure version
+    NvAPI_String      adapterName;                          // Graphics adapter name
+    NvU32             adapterClass;                         // Graphics adapter classes (NVVIOCLASS_SDI mask)
+    NvU32             adapterCaps;                          // Graphics adapter capabilities (NVVIOCAPS_* mask)
+    NvU32             dipSwitch;                            // On-board DIP switch settings bits
+    NvU32             dipSwitchReserved;                    // On-board DIP switch settings reserved bits
+    NvU32             boardID;                              // Board ID
+    struct                                                  //
+    {                                                       // Driver version
+        NvU32          majorVersion;                        // Major version
+        NvU32          minorVersion;                        // Minor version
+    } driver;                                               //
+    struct                                                  //
+    {                                                       // Firmware version
+        NvU32          majorVersion;                        // Major version
+        NvU32          minorVersion;                        // Minor version
+    } firmWare;                                             //
+    NVVIOOWNERID      ownerId;                              // Unique identifier for owner of video output (NVVIOOWNERID_INVALID if free running)
+    NVVIOOWNERTYPE    ownerType;                            // Owner type (OpenGL application or Desktop mode)
+} NVVIOCAPS;
+
+#define NVVIOCAPS_VER   MAKE_NVAPI_VERSION(NVVIOCAPS,1)
+
+// Input channel status
+typedef struct _NVVIOCHANNELSTATUS
+{
+    NvU32                  smpte352;                         // 4-byte SMPTE 352 video payload identifier
+    NVVIOSIGNALFORMAT      signalFormat;                     // Signal format
+    NVVIOBITSPERCOMPONENT  bitsPerComponent;                 // Bits per component
+    NVVIOCOMPONENTSAMPLING samplingFormat;                   // Sampling format
+    NVVIOCOLORSPACE        colorSpace;                       // Color space
+    NVVIOLINKID            linkID;                           // Link ID
+} NVVIOCHANNELSTATUS;
+
+// Input device status
+typedef struct _NVVIOINPUTSTATUS
+{
+    NVVIOCHANNELSTATUS     vidIn[NVAPI_MAX_VIO_JACKS][NVAPI_MAX_VIO_CHANNELS_PER_JACK];     // Video input status per channel within a jack
+    NVVIOCAPTURESTATUS     captureStatus;                  // status of video capture
+} NVVIOINPUTSTATUS;
+
+// Output device status
+typedef struct _NVVIOOUTPUTSTATUS
+{
+    NVVIOINPUTOUTPUTSTATUS  vid1Out;                        // Video 1 output status
+    NVVIOINPUTOUTPUTSTATUS  vid2Out;                        // Video 2 output status
+    NVVIOSYNCSTATUS         sdiSyncIn;                      // SDI sync input status
+    NVVIOSYNCSTATUS         compSyncIn;                     // Composite sync input status
+    NvU32                   syncEnable;                     // Sync enable (TRUE if using syncSource)
+    NVVIOSYNCSOURCE         syncSource;                     // Sync source
+    NVVIOSIGNALFORMAT       syncFormat;                     // Sync format
+    NvU32                   frameLockEnable;                // Framelock enable flag
+    NvU32                   outputVideoLocked;              // Output locked status
+    NvU32                   dataIntegrityCheckErrorCount;   // Data integrity check error count
+    NvU32                   dataIntegrityCheckEnabled;      // Data integrity check status enabled
+    NvU32                   dataIntegrityCheckFailed;       // Data integrity check status failed
+    NvU32                   uSyncSourceLocked;              // genlocked to framelocked to ref signal
+    NvU32                   uPowerOn;                       // TRUE: indicates there is sufficient power
+} NVVIOOUTPUTSTATUS;
+
+// Video device status.
+typedef struct _NVVIOSTATUS
+{
+    NvU32                 version;                        // Structure version
+    NVVIOSTATUSTYPE       nvvioStatusType;                // Input or Output status
+    union
+    {
+        NVVIOINPUTSTATUS  inStatus;                       //  Input device status
+        NVVIOOUTPUTSTATUS outStatus;                      //  Output device status
+    }vioStatus;
+} NVVIOSTATUS;
+
+#define NVVIOSTATUS_VER   MAKE_NVAPI_VERSION(NVVIOSTATUS,1)
+
+// Output region
+typedef struct _NVVIOOUTPUTREGION
+{
+    NvU32              x;                                    // Horizontal origin in pixels
+    NvU32              y;                                    // Vertical origin in pixels
+    NvU32              width;                                // Width of region in pixels
+    NvU32              height;                               // Height of region in pixels
+} NVVIOOUTPUTREGION;
+
+// Gamma ramp (8-bit index)
+typedef struct _NVVIOGAMMARAMP8
+{
+    NvU16              uRed[256];                            // Red channel gamma ramp (8-bit index, 16-bit values)
+    NvU16              uGreen[256];                          // Green channel gamma ramp (8-bit index, 16-bit values)
+    NvU16              uBlue[256];                           // Blue channel gamma ramp (8-bit index, 16-bit values)
+} NVVIOGAMMARAMP8;
+
+// Gamma ramp (10-bit index)
+typedef struct _NVVIOGAMMARAMP10
+{
+    NvU16              uRed[1024];                           // Red channel gamma ramp (10-bit index, 16-bit values)
+    NvU16              uGreen[1024];                         // Green channel gamma ramp (10-bit index, 16-bit values)
+    NvU16              uBlue[1024];                          // Blue channel gamma ramp (10-bit index, 16-bit values)
+} NVVIOGAMMARAMP10;
+
+// Sync delay
+typedef struct _NVVIOSYNCDELAY
+{
+    NvU32              version;                              // Structure version
+    NvU32              horizontalDelay;                      // Horizontal delay in pixels
+    NvU32              verticalDelay;                        // Vertical delay in lines
+} NVVIOSYNCDELAY;
+
+#define NVVIOSYNCDELAY_VER   MAKE_NVAPI_VERSION(NVVIOSYNCDELAY,1)
+
+
+// Video mode information
+typedef struct _NVVIOVIDEOMODE
+{
+    NvU32                horizontalPixels;                   // Horizontal resolution (in pixels)
+    NvU32                verticalLines;                      // Vertical resolution for frame (in lines)
+    float                fFrameRate;                         // Frame rate
+    NVVIOINTERLACEMODE   interlaceMode;                      // Interlace mode
+    NVVIOVIDEOSTANDARD   videoStandard;                      // SMPTE standards format
+    NVVIOVIDEOTYPE       videoType;                          // HD or SD signal classification
+} NVVIOVIDEOMODE;
+
+// Signal format details
+typedef struct _NVVIOSIGNALFORMATDETAIL
+{
+    NVVIOSIGNALFORMAT    signalFormat;                       // Signal format enumerated value
+    NVVIOVIDEOMODE       videoMode;                          // Video mode for signal format
+}NVVIOSIGNALFORMATDETAIL;
+
+// Buffer formats
+#define NVVIOBUFFERFORMAT_R8G8B8                  0x00000001   // R8:G8:B8
+#define NVVIOBUFFERFORMAT_R8G8B8Z24               0x00000002   // R8:G8:B8:Z24
+#define NVVIOBUFFERFORMAT_R8G8B8A8                0x00000004   // R8:G8:B8:A8
+#define NVVIOBUFFERFORMAT_R8G8B8A8Z24             0x00000008   // R8:G8:B8:A8:Z24
+#define NVVIOBUFFERFORMAT_R16FPG16FPB16FP         0x00000010   // R16FP:G16FP:B16FP
+#define NVVIOBUFFERFORMAT_R16FPG16FPB16FPZ24      0x00000020   // R16FP:G16FP:B16FP:Z24
+#define NVVIOBUFFERFORMAT_R16FPG16FPB16FPA16FP    0x00000040   // R16FP:G16FP:B16FP:A16FP
+#define NVVIOBUFFERFORMAT_R16FPG16FPB16FPA16FPZ24 0x00000080   // R16FP:G16FP:B16FP:A16FP:Z24
+
+// Data format details
+typedef struct _NVVIODATAFORMATDETAIL
+{
+    NVVIODATAFORMAT   dataFormat;                              // Data format enumerated value
+    NvU32             vioCaps;                                 // Data format capabilities (NVVIOCAPS_* mask)
+}NVVIODATAFORMATDETAIL;
+
+// Colorspace conversion
+typedef struct _NVVIOCOLORCONVERSION
+{
+    NvU32       version;                                    //  Structure version
+    float       colorMatrix[3][3];                          //  Output[n] =
+    float       colorOffset[3];                             //  Input[0] * colorMatrix[n][0] +
+    float       colorScale[3];                              //  Input[1] * colorMatrix[n][1] +
+                                                            //  Input[2] * colorMatrix[n][2] +
+                                                            //  OutputRange * colorOffset[n]
+                                                            //  where OutputRange is the standard magnitude of
+                                                            //  Output[n][n] and colorMatrix and colorOffset
+                                                            //  values are within the range -1.0 to +1.0
+    NvU32      compositeSafe;                               //  compositeSafe constrains luminance range when using composite output
+} NVVIOCOLORCONVERSION;
+
+#define NVVIOCOLORCONVERSION_VER   MAKE_NVAPI_VERSION(NVVIOCOLORCONVERSION,1)
+
+// Gamma correction
+typedef struct _NVVIOGAMMACORRECTION
+{
+    NvU32            version;                               // Structure version
+    NvU32            vioGammaCorrectionType;                // Gamma correction type (8-bit or 10-bit)
+    union                                                   // Gamma correction:
+    {
+        NVVIOGAMMARAMP8  gammaRamp8;                        // Gamma ramp (8-bit index, 16-bit values)
+        NVVIOGAMMARAMP10 gammaRamp10;                       // Gamma ramp (10-bit index, 16-bit values)
+    }gammaRamp;
+    float            fGammaValueR;                          // Red Gamma value within gamma ranges. 0.5 - 6.0
+    float            fGammaValueG;                          // Green Gamma value within gamma ranges. 0.5 - 6.0
+    float            fGammaValueB;                          // Blue Gamma value within gamma ranges. 0.5 - 6.0
+} NVVIOGAMMACORRECTION;
+
+#define NVVIOGAMMACORRECTION_VER   MAKE_NVAPI_VERSION(NVVIOGAMMACORRECTION,1)
+
+#define MAX_NUM_COMPOSITE_RANGE      2                      // maximum number of ranges per channel
+
+typedef struct _NVVIOCOMPOSITERANGE
+{
+    NvU32   uRange;
+    NvU32   uEnabled;
+    NvU32   uMin;
+    NvU32   uMax;
+} NVVIOCOMPOSITERANGE;
+
+
+// Device configuration (fields masks indicating NVVIOCONFIG fields to use for NvAPI_VIO_GetConfig/NvAPI_VIO_SetConfig() )
+#define NVVIOCONFIG_SIGNALFORMAT            0x00000001      // fields: signalFormat
+#define NVVIOCONFIG_DATAFORMAT              0x00000002      // fields: dataFormat
+#define NVVIOCONFIG_OUTPUTREGION            0x00000004      // fields: outputRegion
+#define NVVIOCONFIG_OUTPUTAREA              0x00000008      // fields: outputArea
+#define NVVIOCONFIG_COLORCONVERSION         0x00000010      // fields: colorConversion
+#define NVVIOCONFIG_GAMMACORRECTION         0x00000020      // fields: gammaCorrection
+#define NVVIOCONFIG_SYNCSOURCEENABLE        0x00000040      // fields: syncSource and syncEnable
+#define NVVIOCONFIG_SYNCDELAY               0x00000080      // fields: syncDelay
+#define NVVIOCONFIG_COMPOSITESYNCTYPE       0x00000100      // fields: compositeSyncType
+#define NVVIOCONFIG_FRAMELOCKENABLE         0x00000200      // fields: EnableFramelock
+#define NVVIOCONFIG_422FILTER               0x00000400      // fields: bEnable422Filter
+#define NVVIOCONFIG_COMPOSITETERMINATE      0x00000800      // fields: bCompositeTerminate        //Not Supported on Quadro FX 4000 SDI
+#define NVVIOCONFIG_DATAINTEGRITYCHECK      0x00001000      // fields: bEnableDataIntegrityCheck  //Not Supported on Quadro FX 4000 SDI
+#define NVVIOCONFIG_CSCOVERRIDE             0x00002000      // fields: colorConversion override
+#define NVVIOCONFIG_FLIPQUEUELENGTH         0x00004000      // fields: flipqueuelength control
+#define NVVIOCONFIG_ANCTIMECODEGENERATION   0x00008000      // fields: bEnableANCTimeCodeGeneration
+#define NVVIOCONFIG_COMPOSITE               0x00010000      // fields: bEnableComposite
+#define NVVIOCONFIG_ALPHAKEYCOMPOSITE       0x00020000      // fields: bEnableAlphaKeyComposite
+#define NVVIOCONFIG_COMPOSITE_Y             0x00040000      // fields: compRange
+#define NVVIOCONFIG_COMPOSITE_CR            0x00080000      // fields: compRange
+#define NVVIOCONFIG_COMPOSITE_CB            0x00100000      // fields: compRange
+#define NVVIOCONFIG_FULL_COLOR_RANGE        0x00200000      // fields: bEnableFullColorRange
+#define NVVIOCONFIG_RGB_DATA                0x00400000      // fields: bEnableRGBData
+#define NVVIOCONFIG_RESERVED_SDIOUTPUTENABLE         0x00800000      // fields: bEnableSDIOutput
+#define NVVIOCONFIG_STREAMS                 0x01000000      // fields: streams
+#define NVVIOCONFIG_ANC_PARITY_COMPUTATION  0x02000000      // fields: ancParityComputation
+
+// Don't forget to update NVVIOCONFIG_VALIDFIELDS in nvapi.spec when NVVIOCONFIG_ALLFIELDS changes.
+#define NVVIOCONFIG_ALLFIELDS   ( NVVIOCONFIG_SIGNALFORMAT          | \
+                                  NVVIOCONFIG_DATAFORMAT            | \
+                                  NVVIOCONFIG_OUTPUTREGION          | \
+                                  NVVIOCONFIG_OUTPUTAREA            | \
+                                  NVVIOCONFIG_COLORCONVERSION       | \
+                                  NVVIOCONFIG_GAMMACORRECTION       | \
+                                  NVVIOCONFIG_SYNCSOURCEENABLE      | \
+                                  NVVIOCONFIG_SYNCDELAY             | \
+                                  NVVIOCONFIG_COMPOSITESYNCTYPE     | \
+                                  NVVIOCONFIG_FRAMELOCKENABLE       | \
+                                  NVVIOCONFIG_422FILTER             | \
+                                  NVVIOCONFIG_COMPOSITETERMINATE    | \
+                                  NVVIOCONFIG_DATAINTEGRITYCHECK    | \
+                                  NVVIOCONFIG_CSCOVERRIDE           | \
+                                  NVVIOCONFIG_FLIPQUEUELENGTH       | \
+                                  NVVIOCONFIG_ANCTIMECODEGENERATION | \
+                                  NVVIOCONFIG_COMPOSITE             | \
+                                  NVVIOCONFIG_ALPHAKEYCOMPOSITE     | \
+                                  NVVIOCONFIG_COMPOSITE_Y           | \
+                                  NVVIOCONFIG_COMPOSITE_CR          | \
+                                  NVVIOCONFIG_COMPOSITE_CB          | \
+                                  NVVIOCONFIG_FULL_COLOR_RANGE      | \
+                                  NVVIOCONFIG_RGB_DATA              | \
+                                  NVVIOCONFIG_RESERVED_SDIOUTPUTENABLE | \
+                                  NVVIOCONFIG_STREAMS               | \
+                                  NVVIOCONFIG_ANC_PARITY_COMPUTATION)
+
+#define NVVIOCONFIG_VALIDFIELDS  ( NVVIOCONFIG_SIGNALFORMAT          | \
+                                   NVVIOCONFIG_DATAFORMAT            | \
+                                   NVVIOCONFIG_OUTPUTREGION          | \
+                                   NVVIOCONFIG_OUTPUTAREA            | \
+                                   NVVIOCONFIG_COLORCONVERSION       | \
+                                   NVVIOCONFIG_GAMMACORRECTION       | \
+                                   NVVIOCONFIG_SYNCSOURCEENABLE      | \
+                                   NVVIOCONFIG_SYNCDELAY             | \
+                                   NVVIOCONFIG_COMPOSITESYNCTYPE     | \
+                                   NVVIOCONFIG_FRAMELOCKENABLE       | \
+                                   NVVIOCONFIG_RESERVED_SDIOUTPUTENABLE | \
+                                   NVVIOCONFIG_422FILTER             | \
+                                   NVVIOCONFIG_COMPOSITETERMINATE    | \
+                                   NVVIOCONFIG_DATAINTEGRITYCHECK    | \
+                                   NVVIOCONFIG_CSCOVERRIDE           | \
+                                   NVVIOCONFIG_FLIPQUEUELENGTH       | \
+                                   NVVIOCONFIG_ANCTIMECODEGENERATION | \
+                                   NVVIOCONFIG_COMPOSITE             | \
+                                   NVVIOCONFIG_ALPHAKEYCOMPOSITE     | \
+                                   NVVIOCONFIG_COMPOSITE_Y           | \
+                                   NVVIOCONFIG_COMPOSITE_CR          | \
+                                   NVVIOCONFIG_COMPOSITE_CB          | \
+                                   NVVIOCONFIG_FULL_COLOR_RANGE      | \
+                                   NVVIOCONFIG_RGB_DATA              | \
+                                   NVVIOCONFIG_RESERVED_SDIOUTPUTENABLE | \
+                                   NVVIOCONFIG_STREAMS               | \
+                                   NVVIOCONFIG_ANC_PARITY_COMPUTATION)
+
+#define NVVIOCONFIG_DRIVERFIELDS ( NVVIOCONFIG_OUTPUTREGION          | \
+                                   NVVIOCONFIG_OUTPUTAREA            | \
+                                   NVVIOCONFIG_COLORCONVERSION       | \
+                                   NVVIOCONFIG_FLIPQUEUELENGTH)
+
+#define NVVIOCONFIG_GAMMAFIELDS  ( NVVIOCONFIG_GAMMACORRECTION       )
+
+#define NVVIOCONFIG_RMCTRLFIELDS ( NVVIOCONFIG_SIGNALFORMAT          | \
+                                   NVVIOCONFIG_DATAFORMAT            | \
+                                   NVVIOCONFIG_SYNCSOURCEENABLE      | \
+                                   NVVIOCONFIG_COMPOSITESYNCTYPE     | \
+                                   NVVIOCONFIG_FRAMELOCKENABLE       | \
+                                   NVVIOCONFIG_422FILTER             | \
+                                   NVVIOCONFIG_COMPOSITETERMINATE    | \
+                                   NVVIOCONFIG_DATAINTEGRITYCHECK    | \
+                                   NVVIOCONFIG_COMPOSITE             | \
+                                   NVVIOCONFIG_ALPHAKEYCOMPOSITE     | \
+                                   NVVIOCONFIG_COMPOSITE_Y           | \
+                                   NVVIOCONFIG_COMPOSITE_CR          | \
+                                   NVVIOCONFIG_COMPOSITE_CB)
+
+#define NVVIOCONFIG_RMSKEWFIELDS ( NVVIOCONFIG_SYNCDELAY             )
+
+#define NVVIOCONFIG_ALLOWSDIRUNNING_FIELDS ( NVVIOCONFIG_DATAINTEGRITYCHECK     | \
+                                             NVVIOCONFIG_SYNCDELAY              | \
+                                             NVVIOCONFIG_CSCOVERRIDE            | \
+                                             NVVIOCONFIG_ANCTIMECODEGENERATION  | \
+                                             NVVIOCONFIG_COMPOSITE              | \
+                                             NVVIOCONFIG_ALPHAKEYCOMPOSITE      | \
+                                             NVVIOCONFIG_COMPOSITE_Y            | \
+                                             NVVIOCONFIG_COMPOSITE_CR           | \
+                                             NVVIOCONFIG_COMPOSITE_CB           | \
+                                             NVVIOCONFIG_ANC_PARITY_COMPUTATION)
+
+ #define NVVIOCONFIG_RMMODESET_FIELDS ( NVVIOCONFIG_SIGNALFORMAT         | \
+                                        NVVIOCONFIG_DATAFORMAT           | \
+                                        NVVIOCONFIG_SYNCSOURCEENABLE     | \
+                                        NVVIOCONFIG_FRAMELOCKENABLE      | \
+                                        NVVIOCONFIG_COMPOSITESYNCTYPE )
+
+
+// Output device configuration
+// No members can be deleted from below structure. Only add new members at the
+// end of the structure
+typedef struct _NVVIOOUTPUTCONFIG_V1
+{
+    NVVIOSIGNALFORMAT    signalFormat;                         // Signal format for video output
+    NVVIODATAFORMAT      dataFormat;                           // Data format for video output
+    NVVIOOUTPUTREGION    outputRegion;                         // Region for video output (Desktop mode)
+    NVVIOOUTPUTAREA      outputArea;                           // Usable resolution for video output (safe area)
+    NVVIOCOLORCONVERSION colorConversion;                      // Color conversion.
+    NVVIOGAMMACORRECTION gammaCorrection;
+    NvU32                syncEnable;                           // Sync enable (TRUE to use syncSource)
+    NVVIOSYNCSOURCE      syncSource;                           // Sync source
+    NVVIOSYNCDELAY       syncDelay;                            // Sync delay
+    NVVIOCOMPSYNCTYPE    compositeSyncType;                    // Composite sync type
+    NvU32                frameLockEnable;                      // Flag indicating whether framelock was on/off
+    NvU32                psfSignalFormat;                      // Inidcates whether contained format is PSF Signal format
+    NvU32                enable422Filter;                      // Enables/Disables 4:2:2 filter
+    NvU32                compositeTerminate;                   // Composite termination
+    NvU32                enableDataIntegrityCheck;             // Enable data integrity check: true - enable, false - disable
+    NvU32                cscOverride;                          // Use provided CSC color matrix to overwrite
+    NvU32                flipQueueLength;                      // Number of buffers used for the internal flipqueue
+    NvU32                enableANCTimeCodeGeneration;          // Enable SDI ANC time code generation
+    NvU32                enableComposite;                      // Enable composite
+    NvU32                enableAlphaKeyComposite;              // Enable Alpha key composite
+    NVVIOCOMPOSITERANGE  compRange;                            // Composite ranges
+    NvU8                 reservedData[256];                    // Inicates last stored SDI output state TRUE-ON / FALSE-OFF
+    NvU32                enableFullColorRange;                 // Flag indicating Full Color Range
+    NvU32                enableRGBData;                        // Indicates data is in RGB format
+} NVVIOOUTPUTCONFIG_V1;
+
+typedef struct _NVVIOOUTPUTCONFIG_V2
+{
+    NVVIOSIGNALFORMAT    signalFormat;                         // Signal format for video output
+    NVVIODATAFORMAT      dataFormat;                           // Data format for video output
+    NVVIOOUTPUTREGION    outputRegion;                         // Region for video output (Desktop mode)
+    NVVIOOUTPUTAREA      outputArea;                           // Usable resolution for video output (safe area)
+    NVVIOCOLORCONVERSION colorConversion;                      // Color conversion.
+    NVVIOGAMMACORRECTION gammaCorrection;
+    NvU32                syncEnable;                           // Sync enable (TRUE to use syncSource)
+    NVVIOSYNCSOURCE      syncSource;                           // Sync source
+    NVVIOSYNCDELAY       syncDelay;                            // Sync delay
+    NVVIOCOMPSYNCTYPE    compositeSyncType;                    // Composite sync type
+    NvU32                frameLockEnable;                      // Flag indicating whether framelock was on/off
+    NvU32                psfSignalFormat;                      // Inidcates whether contained format is PSF Signal format
+    NvU32                enable422Filter;                      // Enables/Disables 4:2:2 filter
+    NvU32                compositeTerminate;                   // Composite termination
+    NvU32                enableDataIntegrityCheck;             // Enable data integrity check: true - enable, false - disable
+    NvU32                cscOverride;                          // Use provided CSC color matrix to overwrite
+    NvU32                flipQueueLength;                      // Number of buffers used for the internal flipqueue
+    NvU32                enableANCTimeCodeGeneration;          // Enable SDI ANC time code generation
+    NvU32                enableComposite;                      // Enable composite
+    NvU32                enableAlphaKeyComposite;              // Enable Alpha key composite
+    NVVIOCOMPOSITERANGE  compRange;                            // Composite ranges
+    NvU8                 reservedData[256];                    // Inicates last stored SDI output state TRUE-ON / FALSE-OFF
+    NvU32                enableFullColorRange;                 // Flag indicating Full Color Range
+    NvU32                enableRGBData;                        // Indicates data is in RGB format
+    NVVIOANCPARITYCOMPUTATION ancParityComputation;            // Enable HW ANC parity bit computation (auto/on/off)
+} NVVIOOUTPUTCONFIG_V2;
+
+// Stream configuration
+typedef struct _NVVIOSTREAM
+{
+    NvU32                   bitsPerComponent;                     // Bits per component
+    NVVIOCOMPONENTSAMPLING  sampling;                             // Sampling
+    NvU32                   expansionEnable;                      // Enable/disable 4:2:2->4:4:4 expansion
+    NvU32                   numLinks;                             // Number of active links
+    struct
+    {
+        NvU32               jack;                                 // This stream's link[i] will use the specified (0-based) channel within the
+        NvU32               channel;                              // specified (0-based) jack
+    } links[NVAPI_MAX_VIO_LINKS_PER_STREAM];
+} NVVIOSTREAM;
+
+// Input device configuration
+typedef struct _NVVIOINPUTCONFIG
+{
+    NvU32                numRawCaptureImages;                  // numRawCaptureImages is the number of frames to keep in the capture queue.
+                                                               // must be between NVAPI_GVI_MIN_RAW_CAPTURE_IMAGES and NVAPI_GVI_MAX_RAW_CAPTURE_IMAGES,
+    NVVIOSIGNALFORMAT    signalFormat;                         // Signal format.
+                                                               // Please note that both numRawCaptureImages and signalFormat should be set together.
+    NvU32                numStreams;                           // Number of active streams.
+    NVVIOSTREAM          streams[NVAPI_MAX_VIO_STREAMS];       // Stream configurations
+    NvU32                bTestMode;                            // This attribute controls the GVI test mode. Possible values 0/1.
+                                                               // When testmode enabled, the GVI device will generate fake data as quickly as possible.
+} NVVIOINPUTCONFIG;
+
+typedef struct _NVVIOCONFIG_V1
+{
+    NvU32                version;                              // Structure version
+    NvU32                fields;                               // Caller sets to NVVIOCONFIG_* mask for fields to use
+    NVVIOCONFIGTYPE      nvvioConfigType;                      // Input or Output configuration
+    union
+    {
+        NVVIOINPUTCONFIG     inConfig;                         //  Input device configuration
+        NVVIOOUTPUTCONFIG_V1 outConfig;                        //  Output device configuration
+    }vioConfig;
+} NVVIOCONFIG_V1;
+
+typedef struct _NVVIOCONFIG_V2
+{
+    NvU32                version;                              // Structure version
+    NvU32                fields;                               // Caller sets to NVVIOCONFIG_* mask for fields to use
+    NVVIOCONFIGTYPE      nvvioConfigType;                      // Input or Output configuration
+    union
+    {
+        NVVIOINPUTCONFIG     inConfig;                         //  Input device configuration
+        NVVIOOUTPUTCONFIG_V2 outConfig;                        //  Output device configuration
+    }vioConfig;
+} NVVIOCONFIG_V2;
+
+typedef NVVIOOUTPUTCONFIG_V2 NVVIOOUTPUTCONFIG;
+typedef NVVIOCONFIG_V2 NVVIOCONFIG;
+
+#define NVVIOCONFIG_VER1  MAKE_NVAPI_VERSION(NVVIOCONFIG_V1,1)
+#define NVVIOCONFIG_VER2  MAKE_NVAPI_VERSION(NVVIOCONFIG_V2,2)
+#define NVVIOCONFIG_VER   NVVIOCONFIG_VER2
+
+typedef struct
+{
+    NvPhysicalGpuHandle                 hPhysicalGpu;                   //handle to Physical GPU (This could be NULL for GVI device if its not binded)
+    NvVioHandle                         hVioHandle;                     //handle to SDI Input/Output device
+    NvU32                               vioId;                          //device Id of SDI Input/Output device
+    NvU32                               outputId;                       //deviceMask of the SDI display connected to GVO device.
+                                                                        //outputId will be 0 for GVI device.
+} NVVIOTOPOLOGYTARGET;
+
+typedef struct _NV_VIO_TOPOLOGY
+{
+    NvU32                       version;
+    NvU32                       vioTotalDeviceCount;                    //How many vio targets are valid
+    NVVIOTOPOLOGYTARGET         vioTarget[NVAPI_MAX_VIO_DEVICES];       //Array of vio targets
+}NV_VIO_TOPOLOGY, NVVIOTOPOLOGY;
+
+#define NV_VIO_TOPOLOGY_VER  MAKE_NVAPI_VERSION(NV_VIO_TOPOLOGY,1)
+#define NVVIOTOPOLOGY_VER    MAKE_NVAPI_VERSION(NVVIOTOPOLOGY,1)
+
+//---------------------------------------------------------------------
+// Function:    NvAPI_VIO_GetCapabilities
+//
+// Description: Determine graphics adapter video I/O capabilities.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+// Parameters:  NvVioHandle[IN] - The caller provides the SDI device handle as input.
+//              pAdapterCaps[OUT] - Pointer to receive capabilities
+//
+// Returns:     NVAPI_OK                          - Success
+//              NVAPI_API_NOT_INTIALIZED          - NVAPI Not Initialized
+//              NVAPI_INVALID_ARGUMENT            - Arguments passed to API are not valid
+//              NVAPI_INCOMPATIBLE_STRUCT_VERSION - NVVIOCAPS struct version used by the app is not compatible
+//              NVAPI_NOT_SUPPORTED                - Video I/O not supported
+//              NVAPI_ERROR                       - NVAPI Random errors
+//---------------------------------------------------------------------
+NVAPI_INTERFACE NvAPI_VIO_GetCapabilities(NvVioHandle     hVioHandle,
+                                          NVVIOCAPS       *pAdapterCaps);
+
+//---------------------------------------------------------------------
+// Function:    NvAPI_VIO_Open
+//
+// Description: Open graphics adapter for video I/O operations
+//              using the OpenGL application interface.  Read operations
+//              are permitted in this mode by multiple clients, but Write
+//              operations are application exclusive.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+// Parameters:  NvVioHandle[IN]     - The caller provides the SDI output device handle as input.
+//              vioClass[IN]        - Class interface (NVVIOCLASS_* value)
+//              ownerType[IN]       - user should specify the ownerType ( NVVIOOWNERTYPE_APPLICATION or NVVIOOWNERTYPE_DESKTOP)
+//
+// Returns:     NVAPI_OK                          - Success
+//              NVAPI_API_NOT_INTIALIZED          - NVAPI Not Initialized
+//              NVAPI_INVALID_ARGUMENT            - Arguments passed to API are not valid
+//              NVAPI_NOT_SUPPORTED                - Video I/O not supported
+//              NVAPI_ERROR                       - NVAPI Random errors
+//              NVAPI_DEVICE_BUSY                 - Access denied for requested access
+//---------------------------------------------------------------------
+NVAPI_INTERFACE NvAPI_VIO_Open(NvVioHandle       hVioHandle,
+                               NvU32             vioClass,
+                               NVVIOOWNERTYPE    ownerType);
+
+//---------------------------------------------------------------------
+// Function:    NvAPI_VIO_Close
+//
+// Description: Closes graphics adapter for Graphics to Video operations
+//              using the OpenGL application interface.  Closing an
+//              OpenGL handle releases the device.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+// Parameters:  NvVioHandle[IN]  - The caller provides the SDI output device handle as input.
+//              bRelease         - boolean value to decide on keeping or releasing ownership
+//
+// Returns:     NVAPI_OK                          - Success
+//              NVAPI_API_NOT_INTIALIZED          - NVAPI Not Initialized
+//              NVAPI_INVALID_ARGUMENT            - Arguments passed to API are not valid
+//              NVAPI_NOT_SUPPORTED                - Video I/O not supported
+//              NVAPI_ERROR                       - NVAPI Random errors
+//              NVAPI_DEVICE_BUSY                 - Access denied for requested access
+//---------------------------------------------------------------------
+NVAPI_INTERFACE NvAPI_VIO_Close(NvVioHandle       hVioHandle,
+                                NvU32             bRelease);
+
+//---------------------------------------------------------------------
+// Function:    NvAPI_VIO_Status
+//
+// Description: Get Video I/O LED status.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+// Parameters:  NvVioHandle[IN] - The caller provides the SDI device handle as input.
+//              pStatus(OUT)   - returns pointer to the NVVIOSTATUS
+//
+// Returns:     NVAPI_OK                          - Success
+//              NVAPI_API_NOT_INTIALIZED          - NVAPI Not Initialized
+//              NVAPI_INVALID_ARGUMENT            - Arguments passed to API are not valid
+//              NVAPI_INCOMPATIBLE_STRUCT_VERSION - Invalid structure version
+//              NVAPI_NOT_SUPPORTED               - Video I/O not supported
+//              NVAPI_ERROR                       - NVAPI Random errors
+//---------------------------------------------------------------------
+NVAPI_INTERFACE NvAPI_VIO_Status(NvVioHandle     hVioHandle,
+                                 NVVIOSTATUS     *pStatus);
+
+//---------------------------------------------------------------------
+// Function:    NvAPI_VIO_SyncFormatDetect
+//
+// Description: Detects Video I/O incoming sync video format.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+// Parameters:  NvVioHandle[IN] - The caller provides the SDI device handle as input.
+//              pWait(OUT)     - Pointer to receive milliseconds to wait
+//                               before VIOStatus will return detected
+//                               syncFormat.
+//
+// Returns:     NVAPI_OK                          - Success
+//              NVAPI_API_NOT_INTIALIZED          - NVAPI Not Initialized
+//              NVAPI_INVALID_ARGUMENT            - Arguments passed to API are not valid
+//              NVAPI_NOT_SUPPORTED               - Video I/O not supported
+//              NVAPI_ERROR                       - NVAPI Random errors
+//---------------------------------------------------------------------
+NVAPI_INTERFACE NvAPI_VIO_SyncFormatDetect(NvVioHandle hVioHandle,
+                                           NvU32       *pWait);
+
+//---------------------------------------------------------------------
+// Function:    NvAPI_VIO_GetConfig
+//
+// Description: Get Graphics to Video configuration.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+// Parameters:  NvVioHandle[IN] - The caller provides the SDI device handle as input.
+//              pConfig(OUT)    - Pointer to Graphics to Video configuration
+//
+// Returns:     NVAPI_OK                          - Success
+//              NVAPI_API_NOT_INTIALIZED          - NVAPI Not Initialized
+//              NVAPI_INVALID_ARGUMENT            - Arguments passed to API are not valid
+//              NVAPI_INCOMPATIBLE_STRUCT_VERSION - Invalid structure version
+//              NVAPI_NOT_SUPPORTED               - Video I/O not supported
+//              NVAPI_ERROR                       - NVAPI Random errors
+//---------------------------------------------------------------------
+NVAPI_INTERFACE NvAPI_VIO_GetConfig(NvVioHandle        hVioHandle,
+                                    NVVIOCONFIG        *pConfig);
+
+//---------------------------------------------------------------------
+// Function:    NvAPI_VIO_SetConfig
+//
+// Description: Set Graphics to Video configuration.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+// Parameters:  NvVioHandle[IN]     - The caller provides the SDI device handle as input.
+//              pConfig(IN)         - Pointer to Graphics to Video config
+//
+// Returns:     NVAPI_OK                          - Success
+//              NVAPI_API_NOT_INTIALIZED          - NVAPI Not Initialized
+//              NVAPI_INVALID_ARGUMENT            - Arguments passed to API are not valid
+//              NVAPI_INCOMPATIBLE_STRUCT_VERSION - Stucture version invalid
+//              NVAPI_NOT_SUPPORTED               - Video I/O not supported
+//              NVAPI_ERROR                       - NVAPI Random errors
+//              NVAPI_DEVICE_BUSY                 - Access denied for requested access
+//---------------------------------------------------------------------
+NVAPI_INTERFACE NvAPI_VIO_SetConfig(NvVioHandle            hVioHandle,
+                                    const NVVIOCONFIG      *pConfig);
+
+//---------------------------------------------------------------------
+// Function:    NvAPI_VIO_SetCSC
+//
+// Description: Set colorspace conversion parameters.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+// Parameters:  NvVioHandle[IN]     - The caller provides the SDI device handle as input.
+//              pCSC(IN)            - Pointer to CSC parameters
+//
+// Returns:     NVAPI_OK                          - Success
+//              NVAPI_API_NOT_INTIALIZED          - NVAPI Not Initialized
+//              NVAPI_INVALID_ARGUMENT            - Arguments passed to API are not valid
+//              NVAPI_INCOMPATIBLE_STRUCT_VERSION - Stucture version invalid
+//              NVAPI_NOT_SUPPORTED               - Video I/O not supported
+//              NVAPI_ERROR                       - NVAPI Random errors
+//              NVAPI_DEVICE_BUSY                 - Access denied for requested access
+//---------------------------------------------------------------------
+NVAPI_INTERFACE NvAPI_VIO_SetCSC(NvVioHandle           hVioHandle,
+                                 NVVIOCOLORCONVERSION  *pCSC);
+
+//---------------------------------------------------------------------
+// Function:    NvAPI_VIO_GetCSC
+//
+// Description: Get colorspace conversion parameters.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+// Parameters:  NvVioHandle[IN]     - The caller provides the SDI device handle as input.
+//              pCSC(OUT)           - Pointer to CSC parameters
+//
+// Returns:     NVAPI_OK                          - Success
+//              NVAPI_API_NOT_INTIALIZED          - NVAPI Not Initialized
+//              NVAPI_INVALID_ARGUMENT            - Arguments passed to API are not valid
+//              NVAPI_INCOMPATIBLE_STRUCT_VERSION - Stucture version invalid
+//              NVAPI_NOT_SUPPORTED               - Video I/O not supported
+//              NVAPI_ERROR                       - NVAPI Random errors
+//---------------------------------------------------------------------
+NVAPI_INTERFACE NvAPI_VIO_GetCSC(NvVioHandle           hVioHandle,
+                                 NVVIOCOLORCONVERSION  *pCSC);
+
+//---------------------------------------------------------------------
+// Function:    NvAPI_VIO_SetGamma
+//
+// Description: Set gamma conversion parameters.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+// Parameters:  NvVioHandle[IN]     - The caller provides the SDI device handle as input.
+//              pGamma(IN)          - Pointer to gamma parameters
+//
+// Returns:     NVAPI_OK                          - Success
+//              NVAPI_API_NOT_INTIALIZED          - NVAPI Not Initialized
+//              NVAPI_INVALID_ARGUMENT            - Arguments passed to API are not valid
+//              NVAPI_INCOMPATIBLE_STRUCT_VERSION - Stucture version invalid
+//              NVAPI_NOT_SUPPORTED               - Video I/O not supported
+//              NVAPI_ERROR                       - NVAPI Random errors
+//              NVAPI_DEVICE_BUSY                 - Access denied for requested access
+//---------------------------------------------------------------------
+NVAPI_INTERFACE NvAPI_VIO_SetGamma(NvVioHandle           hVioHandle,
+                                   NVVIOGAMMACORRECTION  *pGamma);
+
+//---------------------------------------------------------------------
+// Function:    NvAPI_VIO_GetGamma
+//
+// Description: Get gamma conversion parameters.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+// Parameters:  NvVioHandle[IN]     - The caller provides the SDI device handle as input.
+//              pGamma(OUT)         - Pointer to gamma parameters
+//
+// Returns:     NVAPI_OK                          - Success
+//              NVAPI_API_NOT_INTIALIZED          - NVAPI Not Initialized
+//              NVAPI_INVALID_ARGUMENT            - Arguments passed to API are not valid
+//              NVAPI_INCOMPATIBLE_STRUCT_VERSION - Stucture version invalid
+//              NVAPI_NOT_SUPPORTED               - Video I/O not supported
+//              NVAPI_ERROR                       - NVAPI Random errors
+//---------------------------------------------------------------------
+NVAPI_INTERFACE NvAPI_VIO_GetGamma(NvVioHandle           hVioHandle,
+                                   NVVIOGAMMACORRECTION* pGamma);
+
+//---------------------------------------------------------------------
+// Function:    NvAPI_VIO_SetSyncDelay
+//
+// Description: Set sync delay parameters.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+// Parameters:  NvVioHandle[IN] - The caller provides the SDI device handle as input.
+//              pSyncDelay(IN)  - const Pointer to sync delay parameters
+//
+// Returns:     NVAPI_OK                          - Success
+//              NVAPI_API_NOT_INTIALIZED          - NVAPI Not Initialized
+//              NVAPI_INVALID_ARGUMENT            - Arguments passed to API are not valid
+//              NVAPI_INCOMPATIBLE_STRUCT_VERSION - Stucture version invalid
+//              NVAPI_ERROR                       - NVAPI Random errors
+//              NVAPI_DEVICE_BUSY                 - Access denied for requested access
+//---------------------------------------------------------------------
+NVAPI_INTERFACE NvAPI_VIO_SetSyncDelay(NvVioHandle            hVioHandle,
+                                       const NVVIOSYNCDELAY   *pSyncDelay);
+
+//---------------------------------------------------------------------
+// Function:    NvAPI_VIO_GetSyncDelay
+//
+// Description: Get sync delay parameters.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+// Parameters:  NvVioHandle[IN]     - The caller provides the SDI device handle as input.
+//              pSyncDelay(OUT)     - Pointer to sync delay parameters
+//
+// Returns:     NVAPI_OK                          - Success
+//              NVAPI_API_NOT_INTIALIZED          - NVAPI Not Initialized
+//              NVAPI_INVALID_ARGUMENT            - Arguments passed to API are not valid
+//              NVAPI_INCOMPATIBLE_STRUCT_VERSION - Stucture version invalid
+//              NVAPI_ERROR                       - NVAPI Random errors
+//---------------------------------------------------------------------
+NVAPI_INTERFACE NvAPI_VIO_GetSyncDelay(NvVioHandle      hVioHandle,
+                                       NVVIOSYNCDELAY   *pSyncDelay);
+
+//---------------------------------------------------------------------
+// Function:    NvAPI_VIO_IsRunning
+//
+// Description: Determine if Video I/O is running.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+// Parameters:  NvVioHandle[IN]            - The caller provides the SDI device handle as input.
+//
+// Returns:     NVAPI_DRIVER_RUNNING       - Video I/O running
+//              NVAPI_DRIVER_NOTRUNNING    - Video I/O not running
+//---------------------------------------------------------------------
+NVAPI_INTERFACE NvAPI_VIO_IsRunning(NvVioHandle   hVioHandle);
+
+//---------------------------------------------------------------------
+// Function:    NvAPI_VIO_Start
+//
+// Description: Start Video I/O.
+//              This API should be called for NVVIOOWNERTYPE_DESKTOP only and will not work for OGL applications.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+// Parameters:  NvVioHandle[IN]    - The caller provides the SDI device handle as input.
+//
+// Returns:     NVAPI_OK                          - Success
+//              NVAPI_API_NOT_INTIALIZED          - NVAPI Not Initialized
+//              NVAPI_INVALID_ARGUMENT            - Arguments passed to API are not valid
+//              NVAPI_NOT_SUPPORTED               - Video I/O not supported
+//              NVAPI_ERROR                       - NVAPI Random errors
+//              NVAPI_DEVICE_BUSY                 - Access denied for requested access
+//---------------------------------------------------------------------
+NVAPI_INTERFACE NvAPI_VIO_Start(NvVioHandle     hVioHandle);
+
+//---------------------------------------------------------------------
+// Function:    NvAPI_VIO_Stop
+//
+// Description: Stop Video I/O.
+//              This API should be called for NVVIOOWNERTYPE_DESKTOP only and will not work for OGL applications.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+// Parameters:  NvVioHandle[IN]    - The caller provides the SDI device handle as input.
+//
+// Returns:     NVAPI_OK                          - Success
+//              NVAPI_API_NOT_INTIALIZED          - NVAPI Not Initialized
+//              NVAPI_INVALID_ARGUMENT            - Arguments passed to API are not valid
+//              NVAPI_NOT_SUPPORTED               - Video I/O not supported
+//              NVAPI_ERROR                       - NVAPI Random errors
+//              NVAPI_DEVICE_BUSY                 - Access denied for requested access
+//---------------------------------------------------------------------
+NVAPI_INTERFACE NvAPI_VIO_Stop(NvVioHandle     hVioHandle);
+
+
+//---------------------------------------------------------------------
+// Function:    NvAPI_VIO_IsFrameLockModeCompatible
+//
+// Description: Checkes whether modes are compatible in framelock mode
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+// Parameters:  NvVioHandle[IN]         - The caller provides the SDI device handle as input.
+//              srcEnumIndex(IN)        - Source Enumeration index
+//              destEnumIndex(IN)       - Destination Enumeration index
+//              pbCompatible(OUT)       - Pointer to receive compatability
+//
+// Returns:     NVAPI_OK                          - Success
+//              NVAPI_API_NOT_INTIALIZED          - NVAPI Not Initialized
+//              NVAPI_INVALID_ARGUMENT            - Arguments passed to API are not valid
+//              NVAPI_NOT_SUPPORTED               - Video I/O not supported
+//              NVAPI_ERROR                       - NVAPI Random errors
+//---------------------------------------------------------------------
+NVAPI_INTERFACE NvAPI_VIO_IsFrameLockModeCompatible(NvVioHandle              hVioHandle,
+                                                    NvU32                    srcEnumIndex,
+                                                    NvU32                    destEnumIndex,
+                                                    NvU32*                   pbCompatible);
+
+//---------------------------------------------------------------------
+// Function:    NvAPI_VIO_EnumDevices
+//
+// Description: Enumerate all VIO devices connected to the system.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+// Parameters:  NvVioHandle[OUT]                  - User passes the pointer of NvVioHandle[] array to get handles to all the connected vio devices.
+//              vioDeviceCount[OUT]               - User gets total number of VIO devices connected to the system.
+//
+// Returns:     NVAPI_OK                          - Success
+//              NVAPI_API_NOT_INTIALIZED          - NVAPI Not Initialized
+//              NVAPI_INVALID_ARGUMENT            - Arguments passed to API are not valid
+//              NVAPI_ERROR                       - NVAPI Random errors
+//              NVAPI_NVIDIA_DEVICE_NOT_FOUND     - No SDI Device found
+//---------------------------------------------------------------------
+NVAPI_INTERFACE NvAPI_VIO_EnumDevices(NvVioHandle       hVioHandle[NVAPI_MAX_VIO_DEVICES],
+                                      NvU32             *vioDeviceCount);
+
+
+//---------------------------------------------------------------------
+// Function:    NvAPI_VIO_QueryTopology
+//
+// Description: Enumerate all valid SDI topologies
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+// Parameters:  pNvVIOTopology[OUT]       - User passes the pointer to NVVIOTOPOLOGY to fetch all valid SDI Topologies.
+//
+// Returns:     NVAPI_OK                          - Success
+//              NVAPI_API_NOT_INTIALIZED          - NVAPI Not Initialized
+//              NVAPI_INVALID_ARGUMENT            - Arguments passed to API are not valid
+//              NVAPI_INCOMPATIBLE_STRUCT_VERSION - Invalid structure version
+//              NVAPI_ERROR                       - NVAPI Random errors
+//---------------------------------------------------------------------
+NVAPI_INTERFACE NvAPI_VIO_QueryTopology(NV_VIO_TOPOLOGY   *pNvVIOTopology);
+
+
+//---------------------------------------------------------------------
+// Function:    NvAPI_VIO_EnumSignalFormats
+//
+// Description: Enumerate signal formats supported by Video I/O.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+// Parameters:  NvVioHandle[IN]          - The caller provides the SDI device handle as input.
+//              enumIndex(IN)            - Enumeration index
+//              pSignalFormatDetail(OUT) - Pointer to receive detail or NULL
+//
+// Returns:     NVAPI_OK                 - Success
+//              NVAPI_API_NOT_INTIALIZED - NVAPI not initialized
+//              NVAPI_INVALID_ARGUMENT   - Invalid argument passed
+//              NVAPI_END_ENUMERATION    - No more signal formats to enumerate
+//---------------------------------------------------------------------
+NVAPI_INTERFACE NvAPI_VIO_EnumSignalFormats(NvVioHandle              hVioHandle,
+                                            NvU32                    enumIndex,
+                                            NVVIOSIGNALFORMATDETAIL  *pSignalFormatDetail);
+
+//---------------------------------------------------------------------
+// Function:    NvAPI_VIO_EnumDataFormats
+//
+// Description: Enumerate data formats supported by Video I/O.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+// Parameters:  NvVioHandle[IN]        - The caller provides the SDI device handle as input.
+//              enumIndex(IN)          - Enumeration index
+//              pDataFormatDetail(OUT) - Pointer to receive detail or NULL
+//
+// Returns:     NVAPI_OK               - Success
+//              NVAPI_END_ENUMERATION  - No more data formats to enumerate
+//              NVAPI_NOT_SUPPORTED    - Unsupported NVVIODATAFORMAT_ enumeration
+//---------------------------------------------------------------------
+NVAPI_INTERFACE NvAPI_VIO_EnumDataFormats(NvVioHandle            hVioHandle,
+                                          NvU32                  enumIndex,
+                                          NVVIODATAFORMATDETAIL  *pDataFormatDetail);
+
+
+//  SUPPORTED OS: Windows XP and higher
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_GPU_GetTachReading
+//
+//   DESCRIPTION: This retrieves the tachometer reading for fan speed for the specified physical GPU.
+//
+//   PARAMETERS:   hPhysicalGpu(IN) - GPU selection.
+//                 pValue(OUT)      - Pointer to a variable to get the tachometer reading
+//   HOW TO USE:   NvU32 Value = 0;
+//                 ret = NvAPI_GPU_GetTachReading(hPhysicalGpu, &Value);
+//                 On call success:
+//                 Value would contain the tachometer reading
+//
+// RETURN STATUS:
+//    NVAPI_OK - completed request
+//    NVAPI_ERROR - miscellaneous error occurred
+//    NVAPI_NOT_SUPPORTED - functionality not supported
+//    NVAPI_API_NOT_INTIALIZED - nvapi not initialized
+//    NVAPI_INVALID_ARGUMENT - invalid argument passed
+//    NVAPI_HANDLE_INVALIDATED - handle passed has been invalidated (see user guide)
+//    NVAPI_EXPECTED_PHYSICAL_GPU_HANDLE - handle passed is not a physical GPU handle
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_GPU_GetTachReading(NvPhysicalGpuHandle hPhysicalGPU, NvU32 *pValue);
+
+
+//
+// NV_GET_SCALING_CAPS
+//
+// Interface structure used in NvAPI_GetScalingCaps call.
+//
+// This NvAPI_GetScalingCaps returns scaling capability info for the specified display device
+//
+
+///////////////////////////////////////////////////////////////////////////////
+// FUNCTION NAME:   NvAPI_SYS_GetDisplayIdFromGpuAndOutputId
+//
+// DESCRIPTION:     Converts a Physical GPU handle and an output Id to a
+//                  displayId
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+// PARAMETERS:      hPhysicalGpu(IN)  - Handle to the physical GPU
+//                  outputId(IN)      - Connected display output Id on the
+//                                      target GPU, must only have one bit
+//                                      set.
+//                  displayId(OUT)    - Pointer to an NvU32 which will contain
+//                                      the display ID
+//
+// RETURN STATUS:
+//                  NVAPI_OK - completed request
+//                  NVAPI_API_NOT_INTIALIZED - NVAPI not initialized
+//                  NVAPI_ERROR - miscellaneous error occurred
+//                  NVAPI_INVALID_ARGUMENT - Invalid input parameter.
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_SYS_GetDisplayIdFromGpuAndOutputId(NvPhysicalGpuHandle hPhysicalGpu, NvU32 outputId, NvU32* displayId);
+
+///////////////////////////////////////////////////////////////////////////////
+// FUNCTION NAME:   NvAPI_SYS_GetGpuAndOutputIdFromDisplayId
+//
+// DESCRIPTION:     Converts a displayId to a Physical GPU handle and an outputId
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+// PARAMETERS:      displayId(IN)     - Display ID of display to retrieve
+//                                      GPU and outputId for
+//                  hPhysicalGpu(OUT) - Handle to the physical GPU
+//                  outputId(OUT)     - Connected display output Id on the
+//                                      target GPU, will only have one bit
+//                                      set.
+//
+// RETURN STATUS:
+//                  NVAPI_OK - completed request
+//                  NVAPI_API_NOT_INTIALIZED - NVAPI not initialized
+//                  NVAPI_ID_OUT_OF_RANGE - The DisplayId corresponds to a
+//                                          display which is not within the
+//                                          normal outputId range.
+//                  NVAPI_ERROR - miscellaneous error occurred
+//                  NVAPI_INVALID_ARGUMENT - Invalid input parameter.
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_SYS_GetGpuAndOutputIdFromDisplayId(NvU32 displayId, NvPhysicalGpuHandle *hPhysicalGpu, NvU32 *outputId);
+
+//  SUPPORTED OS: Windows XP and higher
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME:   NvAPI_DISP_GetDisplayIdByDisplayName
+//
+// DESCRIPTION:     This API retrieves the Display Id of a given display by
+//                  display name. The display must be active to retrieve the
+//                  displayId. In the case of clone mode or Surround gaming,
+//                  the primary or top-left display will be returned.
+//
+// PARAMETERS:      displayName(IN):  Name of display (Eg: "\\DISPLAY1" to
+//                                    retrieve the displayId for.
+//                  displayId(OUT):   Display ID of the requested display.
+//
+// RETURN STATUS    NVAPI_OK:                          Capabilties have been returned.
+//                  NVAPI_INVALID_ARGUMENT:            One or more args passed in are invalid.
+//                  NVAPI_API_NOT_INTIALIZED:          The NvAPI API needs to be initialized first
+//                  NVAPI_NO_IMPLEMENTATION:           This entrypoint not available
+//                  NVAPI_ERROR:                       Miscellaneous error occurred
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_DISP_GetDisplayIdByDisplayName(const char *displayName, NvU32* displayId);
+
+//  SUPPORTED OS: Windows XP and higher
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME:   NvAPI_DISP_GetGDIPrimaryDisplayId
+//
+// DESCRIPTION:     This API returns the Display ID of the GDI Primary.
+//
+// PARAMETERS:      displayId(OUT):   Display ID of the GDI Primary display.
+//
+// RETURN STATUS    NVAPI_OK:                          Capabilties have been returned.
+//                  NVAPI_NVIDIA_DEVICE_NOT_FOUND:     GDI Primary not on an NVIDIA GPU.
+//                  NVAPI_INVALID_ARGUMENT:            One or more args passed in are invalid.
+//                  NVAPI_API_NOT_INTIALIZED:          The NvAPI API needs to be initialized first
+//                  NVAPI_NO_IMPLEMENTATION:           This entrypoint not available
+//                  NVAPI_ERROR:                       Miscellaneous error occurred
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_DISP_GetGDIPrimaryDisplayId(NvU32* displayId);
+
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME:   NvAPI_GPU_GetECCStatusInfo
+//
+// PARAMETERS:      hPhysicalGpu (IN) - A handle identifying the physical GPU for
+//                                      which ECC status information is to be
+//                                      retrieved.
+//                  pECCStatusInfo (OUT) - A pointer to an ECC status structure.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+// DESCRIPTION:     This function returns ECC memory status information.
+//
+// RETURN STATUS:
+//    NVAPI_OK - The request was completed successfully.
+//    NVAPI_ERROR - An unknown error occurred.
+//    NVAPI_EXPECTED_PHYSICAL_GPU_HANDLE - The provided GPU handle is not a physical GPU handle.
+//    NVAPI_INVALID_HANDLE - The provided GPU handle is invalid.
+//    NVAPI_HANDLE_INVALIDATED - The provided GPU handle is no longer valid.
+//    NVAPI_INVALID_POINTER - An invalid argument pointer was provided.
+//    NVAPI_NOT_SUPPORTED - The request is not supported.
+//    NVAPI_API_NOT_INTIALIZED - NvAPI was not yet initialized.
+//
+///////////////////////////////////////////////////////////////////////////////
+
+typedef enum _NV_ECC_CONFIGURATION
+{
+    NV_ECC_CONFIGURATION_NOT_SUPPORTED = 0,
+    NV_ECC_CONFIGURATION_DEFERRED,           // Changes require a POST to take effect
+    NV_ECC_CONFIGURATION_IMMEDIATE,          // Changes can optionally be made to take effect immediately
+} NV_ECC_CONFIGURATION;
+
+typedef struct
+{
+    NvU32                 version;               // Structure version
+    NvU32                 isSupported : 1;       // ECC memory feature support
+    NV_ECC_CONFIGURATION  configurationOptions;  // Supported ECC memory feature configuration options
+    NvU32                 isEnabled : 1;         // Active ECC memory setting
+} NV_GPU_ECC_STATUS_INFO;
+
+#define NV_GPU_ECC_STATUS_INFO_VER MAKE_NVAPI_VERSION(NV_GPU_ECC_STATUS_INFO,1)
+
+NVAPI_INTERFACE NvAPI_GPU_GetECCStatusInfo(NvPhysicalGpuHandle hPhysicalGpu,
+                                           NV_GPU_ECC_STATUS_INFO *pECCStatusInfo);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME:   NvAPI_GPU_GetECCErrorInfo
+//
+// PARAMETERS:      hPhysicalGpu (IN) - A handle identifying the physical GPU for
+//                                      which ECC error information is to be
+//                                      retrieved.
+//                  pECCErrorInfo (OUT) - A pointer to an ECC error structure.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+// DESCRIPTION:     This function returns ECC memory error information.
+//
+// RETURN STATUS:
+//    NVAPI_OK - The request was completed successfully.
+//    NVAPI_ERROR - An unknown error occurred.
+//    NVAPI_EXPECTED_PHYSICAL_GPU_HANDLE - The provided GPU handle is not a physical GPU handle.
+//    NVAPI_INVALID_ARGUMENT - incorrect param value
+//    NVAPI_INVALID_POINTER - An invalid argument pointer was provided.
+//    NVAPI_INCOMPATIBLE_STRUCT_VERSION - structure version is not supported, initialize to NV_GPU_ECC_ERROR_INFO_VER.
+//    NVAPI_HANDLE_INVALIDATED - The provided GPU handle is no longer valid.
+//    NVAPI_NOT_SUPPORTED - The request is not supported.
+//    NVAPI_API_NOT_INTIALIZED - NvAPI was not yet initialized.
+//
+///////////////////////////////////////////////////////////////////////////////
+
+typedef struct
+{
+    NvU32   version;             // Structure version
+    struct {
+        NvU64  singleBitErrors;  // Number of single-bit ECC errors detected since last boot
+        NvU64  doubleBitErrors;  // Number of double-bit ECC errors detected since last boot
+    } current;
+    struct {
+        NvU64  singleBitErrors;  // Number of single-bit ECC errors detected since last counter reset
+        NvU64  doubleBitErrors;  // Number of double-bit ECC errors detected since last counter reset
+    } aggregate;
+} NV_GPU_ECC_ERROR_INFO;
+
+#define NV_GPU_ECC_ERROR_INFO_VER MAKE_NVAPI_VERSION(NV_GPU_ECC_ERROR_INFO,1)
+
+NVAPI_INTERFACE NvAPI_GPU_GetECCErrorInfo(NvPhysicalGpuHandle hPhysicalGpu,
+                                          NV_GPU_ECC_ERROR_INFO *pECCErrorInfo);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME:   NvAPI_GPU_ResetECCErrorInfo
+//
+// PARAMETERS:      hPhysicalGpu (IN) - A handle identifying the physical GPU for
+//                                      which ECC error information is to be
+//                                      cleared.
+//                  bResetCurrent (IN) - Reset the current ECC error counters.
+//                  bResetAggregate (IN) - Reset the aggregate ECC error counters.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+// DESCRIPTION:     This function resets ECC memory error counters.
+//
+// RETURN STATUS:
+//    NVAPI_OK - The request was completed successfully.
+//    NVAPI_ERROR - An unknown error occurred.
+//    NVAPI_EXPECTED_PHYSICAL_GPU_HANDLE - The provided GPU handle is not a physical GPU handle.
+//    NVAPI_INVALID_HANDLE - The provided GPU handle is invalid.
+//    NVAPI_HANDLE_INVALIDATED - The provided GPU handle is no longer valid.
+//    NVAPI_NOT_SUPPORTED - The request is not supported.
+//    NVAPI_API_NOT_INTIALIZED - NvAPI was not yet initialized.
+//
+///////////////////////////////////////////////////////////////////////////////
+
+NVAPI_INTERFACE NvAPI_GPU_ResetECCErrorInfo(NvPhysicalGpuHandle hPhysicalGpu, NvU8 bResetCurrent,
+                                            NvU8 bResetAggregate);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME:   NvAPI_GPU_GetECCConfigurationInfo
+//
+// PARAMETERS:      hPhysicalGpu (IN) - A handle identifying the physical GPU for
+//                                      which ECC configuration information
+//                                      is to be retrieved.
+//                  pECCConfigurationInfo (OUT) - A pointer to an ECC
+//                                                configuration structure.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+// DESCRIPTION:     This function returns ECC memory configuration information.
+//
+// RETURN STATUS:
+//    NVAPI_OK - The request was completed successfully.
+//    NVAPI_ERROR - An unknown error occurred.
+//    NVAPI_EXPECTED_PHYSICAL_GPU_HANDLE - The provided GPU handle is not a physical GPU handle.
+//    NVAPI_INVALID_HANDLE - The provided GPU handle is invalid.
+//    NVAPI_HANDLE_INVALIDATED - The provided GPU handle is no longer valid.
+//    NVAPI_INVALID_POINTER - An invalid argument pointer was provided.
+//    NVAPI_NOT_SUPPORTED - The request is not supported.
+//    NVAPI_API_NOT_INTIALIZED - NvAPI was not yet initialized.
+//
+///////////////////////////////////////////////////////////////////////////////
+
+typedef struct
+{
+    NvU32  version;                 // Structure version
+    NvU32  isEnabled : 1;           // Current ECC configuration stored in non-volatile memory
+    NvU32  isEnabledByDefault : 1;  // Factory default ECC configuration (static)
+} NV_GPU_ECC_CONFIGURATION_INFO;
+
+#define NV_GPU_ECC_CONFIGURATION_INFO_VER MAKE_NVAPI_VERSION(NV_GPU_ECC_CONFIGURATION_INFO,1)
+
+NVAPI_INTERFACE NvAPI_GPU_GetECCConfigurationInfo(NvPhysicalGpuHandle hPhysicalGpu,
+                                                  NV_GPU_ECC_CONFIGURATION_INFO *pECCConfigurationInfo);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME:   NvAPI_GPU_SetECCConfiguration
+//
+// PARAMETERS:      hPhysicalGpu (IN) - A handle identifying the physical GPU for
+//                                      which to update the ECC configuration
+//                                      setting.
+//                  bEnable (IN) - The new ECC configuration setting.
+//                  bEnableImmediately (IN) - Request that the new setting take effect immediately.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+// DESCRIPTION:     This function updates the ECC memory configuration setting.
+//
+// RETURN STATUS:
+//    NVAPI_OK - The request was completed successfully.
+//    NVAPI_ERROR - An unknown error occurred.
+//    NVAPI_EXPECTED_PHYSICAL_GPU_HANDLE - The provided GPU handle is not a physical GPU handle.
+//    NVAPI_INVALID_HANDLE - The provided GPU handle is invalid.
+//    NVAPI_HANDLE_INVALIDATED - The provided GPU handle is no longer valid.
+//    NVAPI_NOT_SUPPORTED - The request is not supported.
+//    NVAPI_API_NOT_INTIALIZED - NvAPI was not yet initialized.
+//
+///////////////////////////////////////////////////////////////////////////////
+
+NVAPI_INTERFACE NvAPI_GPU_SetECCConfiguration(NvPhysicalGpuHandle hPhysicalGpu, NvU8 bEnable,
+                                              NvU8 bEnableImmediately);
+
+#if defined(_D3D9_H_) || defined(__d3d10_h__) || defined(__d3d10_1_h__) || defined(__d3d11_h__)
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_D3D_SetFPSIndicatorState
+//
+//   DESCRIPTION: Display an overlay that tracks the number of times the app presents per second, or,
+//      the number of frames-per-second (FPS)
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+//   PARAMETERS: bool(IN)  - Whether or not to enable the fps indicator.
+//
+//   RETURN STATUS: NVAPI_OK: SUCCESS if the profile is found
+//                  NVAPI_ERROR: For miscellaneous errors.
+//
+///////////////////////////////////////////////////////////////////////////////
+
+NVAPI_INTERFACE NvAPI_D3D_SetFPSIndicatorState(IUnknown *pDev, NvU8 doEnable);
+
+#endif //if defined(_D3D9_H_) || defined(__d3d10_h__) || defined(__d3d10_1_h__) || defined(__d3d11_h__)
+
+// GPU Profile APIs
+
+#define NVAPI_UNICODE_STRING_MAX                             2048
+#define NVAPI_BINARY_DATA_MAX                                4096
+#define NVAPI_SETTING_MAX_VALUES                             100
+
+NV_DECLARE_HANDLE(NvDRSSessionHandle);
+NV_DECLARE_HANDLE(NvDRSProfileHandle);
+
+#define NVAPI_DRS_GLOBAL_PROFILE                             ((NvDRSProfileHandle) -1)
+
+typedef NvU16 NvAPI_UnicodeString[NVAPI_UNICODE_STRING_MAX];
+
+typedef enum _NVDRS_SETTING_TYPE
+{
+     NVDRS_DWORD_TYPE,
+     NVDRS_BINARY_TYPE,
+     NVDRS_STRING_TYPE,
+     NVDRS_WSTRING_TYPE
+} NVDRS_SETTING_TYPE;
+
+typedef enum _NVDRS_SETTING_LOCATION
+{
+     NVDRS_CURRENT_PROFILE_LOCATION,
+     NVDRS_GLOBAL_PROFILE_LOCATION,
+     NVDRS_BASE_PROFILE_LOCATION
+} NVDRS_SETTING_LOCATION;
+
+typedef struct _NVDRS_GPU_SUPPORT
+{
+    NvU32 geforce    :  1;
+    NvU32 quadro     :  1;
+    NvU32 nvs        :  1;
+    NvU32 reserved4  :  1;
+    NvU32 reserved5  :  1;
+    NvU32 reserved6  :  1;
+    NvU32 reserved7  :  1;
+    NvU32 reserved8  :  1;
+    NvU32 reserved9  :  1;
+    NvU32 reserved10 :  1;
+    NvU32 reserved11 :  1;
+    NvU32 reserved12 :  1;
+    NvU32 reserved13 :  1;
+    NvU32 reserved14 :  1;
+    NvU32 reserved15 :  1;
+    NvU32 reserved16 :  1;
+    NvU32 reserved17 :  1;
+    NvU32 reserved18 :  1;
+    NvU32 reserved19 :  1;
+    NvU32 reserved20 :  1;
+    NvU32 reserved21 :  1;
+    NvU32 reserved22 :  1;
+    NvU32 reserved23 :  1;
+    NvU32 reserved24 :  1;
+    NvU32 reserved25 :  1;
+    NvU32 reserved26 :  1;
+    NvU32 reserved27 :  1;
+    NvU32 reserved28 :  1;
+    NvU32 reserved29 :  1;
+    NvU32 reserved30 :  1;
+    NvU32 reserved31 :  1;
+    NvU32 reserved32 :  1;
+} NVDRS_GPU_SUPPORT;
+
+typedef struct _NVDRS_BINARY_SETTING // Enum to decide on the datatype of setting value.
+{
+     NvU32                valueLength;               // valueLength should always be in number of bytes.
+     NvU8                 valueData[NVAPI_BINARY_DATA_MAX];
+} NVDRS_BINARY_SETTING;
+
+typedef struct _NVDRS_SETTING_VALUES
+{
+     NvU32                      version;                // Structure Version
+     NvU32                      numSettingValues;       // Total number of values available in a setting.
+     NVDRS_SETTING_TYPE         settingType;            // Type of setting value.
+     union                                              // Setting can hold either DWORD or Binary value or string. Not mixed types.
+     {
+         NvU32                      u32DefaultValue;    // Accessing default DWORD value of this setting.
+         NVDRS_BINARY_SETTING       binaryDefaultValue; // Accessing default Binary value of this setting.
+                                                        // Must be allocated by caller with valueLength specifying buffer size, or only valueLength will be filled in.
+         NvAPI_UnicodeString        wszDefaultValue;    // Accessing default unicode string value of this setting.
+     };
+     union                                              // Setting values can be of either DWORD, Binary values or String type,
+     {                                                  // NOT mixed types.
+         NvU32                      u32Value;           // All possible DWORD values for a setting
+         NVDRS_BINARY_SETTING       binaryValue;        // All possible Binary values for a setting
+         NvAPI_UnicodeString        wszValue;           // Accessing current unicode string value of this setting.
+     }settingValues[NVAPI_SETTING_MAX_VALUES];
+} NVDRS_SETTING_VALUES;
+
+#define NVDRS_SETTING_VALUES_VER    MAKE_NVAPI_VERSION(NVDRS_SETTING_VALUES,1)
+
+typedef struct _NVDRS_SETTING
+{
+     NvU32                      version;                // Structure Version
+     NvAPI_UnicodeString        settingName;            // String name of setting
+     NvU32                      settingId;              // 32 bit setting Id
+     NVDRS_SETTING_TYPE         settingType;            // Type of setting value.
+     NVDRS_SETTING_LOCATION     settingLocation;        // Describes where the value in CurrentValue comes from.
+     NvU32                      isCurrentPredefined;    // It is different than 0 if the currentValue is a predefined Value,
+                                                        // 0 if the currentValue is a user value.
+     NvU32                      isPredefinedValid;      // It is different than 0 if the PredefinedValue union contains a valid value.
+     union                                              // Setting can hold either DWORD or Binary value or string. Not mixed types.
+     {
+         NvU32                      u32PredefinedValue;    // Accessing default DWORD value of this setting.
+         NVDRS_BINARY_SETTING       binaryPredefinedValue; // Accessing default Binary value of this setting.
+                                                           // Must be allocated by caller with valueLength specifying buffer size,
+                                                           // or only valueLength will be filled in.
+         NvAPI_UnicodeString        wszPredefinedValue;    // Accessing default unicode string value of this setting.
+     };
+     union                                              // Setting can hold either DWORD or Binary value or string. Not mixed types.
+     {
+         NvU32                      u32CurrentValue;    // Accessing current DWORD value of this setting.
+         NVDRS_BINARY_SETTING       binaryCurrentValue; // Accessing current Binary value of this setting.
+                                                        // Must be allocated by caller with valueLength specifying buffer size,
+                                                        // or only valueLength will be filled in.
+         NvAPI_UnicodeString        wszCurrentValue;    // Accessing current unicode string value of this setting.
+     };
+} NVDRS_SETTING;
+
+#define NVDRS_SETTING_VER        MAKE_NVAPI_VERSION(NVDRS_SETTING,1)
+
+typedef struct _NVDRS_APPLICATION
+{
+     NvU32                      version;            // Structure Version
+     NvU32                      isPredefined;       // Is the application userdefined/predefined
+     NvAPI_UnicodeString        appName;            // String name of the Application
+     NvAPI_UnicodeString        userFriendlyName;   // UserFriendly name of the Application
+     NvAPI_UnicodeString        launcher;
+} NVDRS_APPLICATION;
+
+#define NVDRS_APPLICATION_VER        MAKE_NVAPI_VERSION(NVDRS_APPLICATION,1)
+
+typedef struct _NVDRS_PROFILE
+{
+     NvU32                      version;            // Structure Version
+     NvAPI_UnicodeString        profileName;        // String name of the Profile
+     NVDRS_GPU_SUPPORT          gpuSupport;         // This flag indicates the profile support on either,
+                                                    // Quadro or Geforce or Both. Read Only.
+     NvU32                      isPredefined;       // Is the Profile userdefined/predefined
+     NvU32                      numOfApps;          // Total number of apps that belong to this profile. Read-only
+     NvU32                      numOfSettings;      // Total number of settings applied for this Profile. Read-only
+} NVDRS_PROFILE;
+
+#define NVDRS_PROFILE_VER        MAKE_NVAPI_VERSION(NVDRS_PROFILE,1)
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_DRS_CreateSession
+//
+//   DESCRIPTION: Allocate memory and initialization
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+//   PARAMETERS: NvDRSSessionHandle(OUT) - Returns pointer to session handle.
+//
+//   RETURN STATUS: NVAPI_OK: SUCCESS
+//                  NVAPI_ERROR: For miscellaneous errors.
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_DRS_CreateSession(NvDRSSessionHandle *phSession);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_DRS_DestroySession
+//
+//   DESCRIPTION: Free allocation and cleanup of NvDrsSession
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+//   PARAMETERS: NvDRSSessionHandle(IN) - Input to the session handle.
+//
+//   RETURN STATUS: NVAPI_OK: SUCCESS
+//                  NVAPI_ERROR: For miscellaneous errors.
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_DRS_DestroySession(NvDRSSessionHandle hSession);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_DRS_LoadSettings
+//
+//   DESCRIPTION: Load and parse settings data
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+//   PARAMETERS: NvDRSSessionHandle(IN) - Input to the session handle.
+//
+//   RETURN STATUS: NVAPI_OK: SUCCESS
+//                  NVAPI_ERROR: For miscellaneous errors.
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_DRS_LoadSettings(NvDRSSessionHandle hSession);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_DRS_SaveSettings
+//
+//   DESCRIPTION: Save settings data to the system
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+//   PARAMETERS: NvDRSSessionHandle(IN) - Input to the session handle.
+//
+//   RETURN STATUS: NVAPI_OK: SUCCESS
+//                  NVAPI_ERROR: For miscellaneous errors.
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_DRS_SaveSettings(NvDRSSessionHandle hSession);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_DRS_LoadSettingsFromFile
+//
+//   DESCRIPTION: Load settings from the given file path
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+//   PARAMETERS: NvDRSSessionHandle(IN) - Input to the session handle.
+//               NvAPI_UnicodeString(IN) - Binary File Name/Path
+//
+//   RETURN STATUS: NVAPI_OK: SUCCESS
+//                  NVAPI_ERROR: For miscellaneous errors.
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_DRS_LoadSettingsFromFile(NvDRSSessionHandle hSession, NvAPI_UnicodeString fileName);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_DRS_SaveSettingsToFile
+//
+//   DESCRIPTION: Save settings to the given file path
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+//   PARAMETERS: NvDRSSessionHandle(IN) - Input to the session handle.
+//               NvAPI_UnicodeString(IN) - Binary File Name/Path
+//
+//   RETURN STATUS: NVAPI_OK: SUCCESS
+//                  NVAPI_ERROR: For miscellaneous errors.
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_DRS_SaveSettingsToFile(NvDRSSessionHandle hSession, NvAPI_UnicodeString fileName);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_DRS_CreateProfile
+//
+//   DESCRIPTION: Create an empty profile.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+//   PARAMETERS: NvDRSSessionHandle(IN)   - Input to the session handle.
+//               NVDRS_PROFILE(IN)        - Input pointer to NVDRS_PROFILE.
+//               NvDRSProfileHandle(OUT)  - Returns pointer to profile handle.
+//
+//   RETURN STATUS: NVAPI_OK: SUCCESS
+//                  NVAPI_ERROR: For miscellaneous errors.
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_DRS_CreateProfile(NvDRSSessionHandle hSession, NVDRS_PROFILE *pProfileInfo, NvDRSProfileHandle *phProfile);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_DRS_DeleteProfile
+//
+//   DESCRIPTION: Delete a profile or sets it back to predefined value.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+//   PARAMETERS: NvDRSSessionHandle(IN)  - Input to the session handle.
+//               NvDRSProfileHandle (IN) - Input profile handle.
+//
+//   RETURN STATUS: NVAPI_OK: SUCCESS if the profile is found
+//                  NVAPI_ERROR: For miscellaneous errors.
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_DRS_DeleteProfile(NvDRSSessionHandle hSession, NvDRSProfileHandle hProfile);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_DRS_SetCurrentGlobalProfile
+//
+//   DESCRIPTION: Sets the current global profile in the driver.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+//   PARAMETERS: NvDRSSessionHandle(IN)  - Input to the session handle.
+//               NvAPI_UnicodeString(IN) - Input current Global profile name.
+//
+//   RETURN STATUS: NVAPI_OK: SUCCESS
+//                  NVAPI_ERROR: For miscellaneous errors.
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_DRS_SetCurrentGlobalProfile(NvDRSSessionHandle hSession, NvAPI_UnicodeString wszGlobalProfileName);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_DRS_GetCurrentGlobalProfile
+//
+//   DESCRIPTION: Returns the handle to the current global profile.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+//   PARAMETERS: NvDRSSessionHandle(IN)  - Input to the session handle.
+//               NvDRSProfileHandle(OUT) - Returns current Global profile handle.
+//
+//   RETURN STATUS: NVAPI_OK: SUCCESS
+//                  NVAPI_ERROR: For miscellaneous errors.
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_DRS_GetCurrentGlobalProfile(NvDRSSessionHandle hSession, NvDRSProfileHandle *phProfile);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_DRS_GetProfileInfo
+//
+//   DESCRIPTION: Get the information of the given profile. User needs to specify the name of the Profile.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+//   PARAMETERS: NvDRSSessionHandle(IN)  - Input to the session handle.
+//               NvDRSProfileHandle(IN)  - Input profile handle.
+//               NVDRS_PROFILE(OUT)      - Return the profile info.
+//
+//   RETURN STATUS: NVAPI_OK: SUCCESS
+//                  NVAPI_ERROR: For miscellaneous errors.
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_DRS_GetProfileInfo(NvDRSSessionHandle hSession, NvDRSProfileHandle hProfile, NVDRS_PROFILE *pProfileInfo);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_DRS_SetProfileInfo
+//
+//   DESCRIPTION: Specifies flags for a given profile. Currently only the NVDRS_GPU_SUPPORT is
+//                used to update the profile. Neither the name, number of settings or applications
+//                or other profile information can be changed with this function.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+//   PARAMETERS: NvDRSSessionHandle(IN)  - Input to the session handle.
+//               NvDRSProfileHandle(IN)  - Input profile handle.
+//               NVDRS_PROFILE(IN)       - Input the new profile info.
+//
+//   RETURN STATUS: NVAPI_OK: SUCCESS
+//                  NVAPI_ERROR: For miscellaneous errors.
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_DRS_SetProfileInfo(NvDRSSessionHandle hSession, NvDRSProfileHandle hProfile, NVDRS_PROFILE *pProfileInfo);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_DRS_FindProfileByName
+//
+//   DESCRIPTION: Find a profile in the current session.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+//   PARAMETERS: NvDRSSessionHandle(IN)  - Input to the session handle.
+//               NvAPI_UnicodeString(IN) - Input profileName.
+//               NvDRSProfileHandle(OUT) - Input profile handle.
+//
+//   RETURN STATUS: NVAPI_OK: SUCCESS if the profile is found
+//                  NVAPI_PROFILE_NOT_FOUND: if profile is not found
+//                  NVAPI_ERROR: For miscellaneous errors.
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_DRS_FindProfileByName(NvDRSSessionHandle hSession, NvAPI_UnicodeString profileName, NvDRSProfileHandle* phProfile);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_DRS_EnumProfiles
+//
+//   DESCRIPTION: Enumerate through all the profiles in the session.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+//   PARAMETERS: NvDRSSessionHandle(IN)   - Input to the session handle.
+//               index(IN)                - Input the index for enumeration.
+//               NvDRSProfileHandle(OUT)  - Returns profile handle.
+//
+//   RETURN STATUS: NVAPI_OK: SUCCESS if the profile is found
+//                  NVAPI_ERROR: For miscellaneous errors.
+//                  NVAPI_END_ENUMERATION: index exceeds the total number of available Profiles in DB.
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_DRS_EnumProfiles(NvDRSSessionHandle hSession, NvU32 index, NvDRSProfileHandle *phProfile);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_DRS_GetNumProfiles
+//
+//   DESCRIPTION: Obtain number of profiles in the current session object
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+//   PARAMETERS: NvDRSSessionHandle(IN)  - Input to the session handle.
+//               numProfiles(OUT) -  returns count of profiles in the current hSession.
+//
+//   RETURN STATUS: NVAPI_OK: SUCCESS
+//                  NVAPI_API_NOT_INTIALIZED: Failed to initialize.
+//                  NVAPI_INVALID_ARGUMENT: Invalid Arguments.
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_DRS_GetNumProfiles(NvDRSSessionHandle hSession, NvU32 *numProfiles);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_DRS_CreateApplication
+//
+//   DESCRIPTION: Add an executable name to a profile.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+//   PARAMETERS: NvDRSSessionHandle(IN)  - Input to the session handle.
+//               NvDRSProfileHandle(IN)  - Input profile handle.
+//               NVDRS_APPLICATION(IN)   - Input NVDRS_APPLICATION struct with the executable name to be added.
+//
+//   RETURN STATUS: NVAPI_OK: SUCCESS
+//                  NVAPI_ERROR: For miscellaneous errors.
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_DRS_CreateApplication(NvDRSSessionHandle hSession, NvDRSProfileHandle  hProfile, NVDRS_APPLICATION *pApplication);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_DRS_DeleteApplication
+//
+//   DESCRIPTION: Removes an executable from a profile.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+//   PARAMETERS: NvDRSSessionHandle(IN)  - Input to the session handle.
+//               NvDRSProfileHandle(IN)  - Input profile handle.
+//               NvAPI_UnicodeString(IN) - Input the executable name to be removed.
+//
+//   RETURN STATUS: NVAPI_OK: SUCCESS
+//                  NVAPI_ERROR: For miscellaneous errors.
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_DRS_DeleteApplication(NvDRSSessionHandle hSession, NvDRSProfileHandle hProfile, NvAPI_UnicodeString appName);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_DRS_GetApplicationInfo
+//
+//   DESCRIPTION: Get the information of the given application.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+//   PARAMETERS: NvDRSSessionHandle(IN)  - Input to the session handle.
+//               NvDRSProfileHandle(IN)  - Input profile handle.
+//               NvAPI_UnicodeString(IN) - Input application name.
+//               NVDRS_APPLICATION(OUT)  - Returns NVDRS_APPLICATION struct with all the attributes.
+//
+//   RETURN STATUS: NVAPI_OK: SUCCESS
+//                  NVAPI_ERROR: For miscellaneous errors.
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_DRS_GetApplicationInfo(NvDRSSessionHandle hSession, NvDRSProfileHandle hProfile, NvAPI_UnicodeString appName, NVDRS_APPLICATION *pApplication);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_DRS_EnumApplications
+//
+//   DESCRIPTION: Enumerate all the applications in a given profile from the starting index to the max length.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+//   PARAMETERS: NvDRSSessionHandle(IN)  - Input to the session handle.
+//               NvDRSProfileHandle(IN)  - Input profile handle.
+//               startIndex(IN)          - Indicates starting index for enumeration.
+//               appCount(IN OUT)        - Input max length of the passed in arrays, Returns the actual length.
+//               NVDRS_APPLICATION(OUT)  - Returns NVDRS_APPLICATION struct with all the attributes.
+//
+//   RETURN STATUS: NVAPI_OK: SUCCESS
+//                  NVAPI_ERROR: For miscellaneous errors.
+//                  NVAPI_END_ENUMERATION: startIndex exceeds the total appCount.
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_DRS_EnumApplications(NvDRSSessionHandle hSession, NvDRSProfileHandle hProfile, NvU32 startIndex, NvU32 *appCount, NVDRS_APPLICATION *pApplication);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_DRS_FindApplicationByName
+//
+//   DESCRIPTION: Search the Application and the associated Profile for given appName.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+//   PARAMETERS: NvDRSSessionHandle(IN)  - Input to the hSession handle.
+//               NvAPI_UnicodeString(IN) - Input appName.
+//               NvDRSProfileHandle(OUT) - Returns profile handle.
+//               NVDRS_APPLICATION(OUT)  - Returns NVDRS_APPLICATION struct pointer.
+//
+//   RETURN STATUS: NVAPI_OK: SUCCESS if the profile is found
+//                  NVAPI_APPLICATION_NOT_FOUND: if App not found
+//                  NVAPI_ERROR: For miscellaneous errors.
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_DRS_FindApplicationByName(NvDRSSessionHandle hSession, NvAPI_UnicodeString appName, NvDRSProfileHandle *phProfile, NVDRS_APPLICATION *pApplication);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_DRS_SetSetting
+//
+//   DESCRIPTION: Add/Modify a setting to a Profile.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+//   PARAMETERS: NvDRSSessionHandle(IN)  - Input to the session handle.
+//               NvDRSProfileHandle(IN)  - Input profile handle.
+//               NVDRS_SETTING(IN)       - Input NVDRS_SETTING struct pointer.
+//
+//   RETURN STATUS: NVAPI_OK: SUCCESS
+//                  NVAPI_ERROR: For miscellaneous errors.
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_DRS_SetSetting(NvDRSSessionHandle hSession, NvDRSProfileHandle hProfile, NVDRS_SETTING *pSetting);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_DRS_GetSetting
+//
+//   DESCRIPTION: Get the information of the given setting.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+//   PARAMETERS: NvDRSSessionHandle(IN)  - Input to the session handle.
+//               NvDRSProfileHandle(IN)  - Input profile handle.
+//               NvU32(IN)               - Input settingId.
+//               NVDRS_SETTING(OUT)      - Returns all the setting info
+//
+//   RETURN STATUS: NVAPI_OK: SUCCESS
+//                  NVAPI_ERROR: For miscellaneous errors.
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_DRS_GetSetting(NvDRSSessionHandle hSession, NvDRSProfileHandle hProfile, NvU32 settingId, NVDRS_SETTING *pSetting);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_DRS_EnumSettings
+//
+//   DESCRIPTION: Enumerate all the settings of a given profile from startIndex to the max length.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+//   PARAMETERS: NvDRSSessionHandle(IN)  - Input to the session handle.
+//               NvDRSProfileHandle(IN)  - Input profile handle.
+//               startIndex(IN)          - Indicates starting index for enumeration.
+//               settingsCount(IN OUT)   - Input max length of the passed in arrays, Returns the actual length.
+//               NVDRS_SETTING(OUT)      - Returns all the settings info.
+//
+//   RETURN STATUS: NVAPI_OK: SUCCESS
+//                  NVAPI_ERROR: For miscellaneous errors.
+//                  NVAPI_END_ENUMERATION: startIndex exceeds the total appCount.
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_DRS_EnumSettings(NvDRSSessionHandle hSession, NvDRSProfileHandle hProfile, NvU32 startIndex, NvU32 *settingsCount, NVDRS_SETTING *pSetting);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_DRS_EnumAvaliableSettingIds
+//
+//   DESCRIPTION: Enumerate all the Ids of all the settings recognized by NVAPI.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+//   PARAMETERS: pSettingIds(OUT)    - User-provided array of length *pMaxCount that NVAPI will fill with IDs.
+//               pMaxCount(IN OUT)   - Input max length of the passed in array, Returns the actual length.
+//
+//   RETURN STATUS: NVAPI_OK: SUCCESS
+//                  NVAPI_ERROR: For miscellaneous errors.
+//                  NVAPI_END_ENUMERATION: the provided pMaxCount is not enough to hold all settingIds.
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_DRS_EnumAvailableSettingIds(NvU32 *pSettingIds, NvU32 *pMaxCount);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_DRS_EnumAvailableSettingValues
+//
+//   DESCRIPTION: Enumerate all available setting values for a given setting.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+//   PARAMETERS: settingId(IN)               - Input settingId.
+//               maxNumCount(IN/OUT)         - Input max length of the passed in arrays, Returns the actual length.
+//               NVDRS_SETTING_VALUES(OUT)   - Returns all available setting values and its count.
+//
+//   RETURN STATUS: NVAPI_OK: SUCCESS
+//                  NVAPI_ERROR: For miscellaneous errors.
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_DRS_EnumAvailableSettingValues(NvU32 settingId, NvU32 *pMaxNumValues, NVDRS_SETTING_VALUES *pSettingValues);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_DRS_GetSettingIdFromName
+//
+//   DESCRIPTION: Get the binary ID of a setting given the setting name.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+//   PARAMETERS: NvAPI_UnicodeString(IN)  - Input Unicode settingName.
+//               NvU32(OUT)               - Returns corresponding settingId.
+//
+//   RETURN STATUS: NVAPI_OK: SUCCESS if the profile is found
+//                  NVAPI_PROFILE_NOT_FOUND: if profile is not found
+//                  NVAPI_SETTING_NOT_FOUND: if setting is not found
+//                  NVAPI_ERROR: For miscellaneous errors.
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_DRS_GetSettingIdFromName(NvAPI_UnicodeString settingName, NvU32 *pSettingId);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_DRS_GetSettingNameFromId
+//
+//   DESCRIPTION: Get the setting name given the binary ID.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+//   PARAMETERS: NvU32(IN)                - Input settingId.
+//               NvAPI_UnicodeString(OUT) - Returns corresponding Unicode settingName.
+//
+//   RETURN STATUS: NVAPI_OK: SUCCESS if the profile is found
+//                  NVAPI_PROFILE_NOT_FOUND: if profile is not found
+//                  NVAPI_SETTING_NOT_FOUND: if setting is not found
+//                  NVAPI_ERROR: For miscellaneous errors.
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_DRS_GetSettingNameFromId(NvU32 settingId, NvAPI_UnicodeString *pSettingName);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_DRS_DeleteProfileSetting
+//
+//   DESCRIPTION: Delete a setting or set it back to predefined value.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+//   PARAMETERS: NvDRSSessionHandle(IN)  - Input to the session handle.
+//               NvDRSProfileHandle(IN)  - Input profile handle.
+//               settingId(IN)           - Input settingId to be deleted.
+//
+//   RETURN STATUS: NVAPI_OK: SUCCESS if the profile is found
+//                  NVAPI_ERROR: For miscellaneous errors.
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_DRS_DeleteProfileSetting(NvDRSSessionHandle hSession, NvDRSProfileHandle hProfile, NvU32 settingId);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_DRS_RestoreAllDefaults
+//
+//   DESCRIPTION: Restore the whole system to predefined(default) values.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+//   PARAMETERS: NvDRSSessionHandle(IN)  - Input to the session handle.
+//
+//   RETURN STATUS: NVAPI_OK: SUCCESS if the profile is found
+//                  NVAPI_ERROR: For miscellaneous errors.
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_DRS_RestoreAllDefaults(NvDRSSessionHandle hSession);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_DRS_RestoreProfileDefaults
+//
+//   DESCRIPTION: Restore the given profile to predefined(default) values.
+//                Any and all user specified modifications will be removed.
+//                If the whole profile was set by the user, the profile will be removed.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+//   PARAMETERS: NvDRSSessionHandle(IN)  - Input to the session handle.
+//               NvDRSProfileHandle(IN)  - Input profile handle.
+//
+//   RETURN STATUS: NVAPI_OK: SUCCESS if the profile is found
+//                  NVAPI_PROFILE_REMOVED: SUCCESS, and the hProfile is no longer valid.
+//                  NVAPI_ERROR: For miscellaneous errors.
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_DRS_RestoreProfileDefault(NvDRSSessionHandle hSession, NvDRSProfileHandle hProfile);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_DRS_RestoreProfileDefaultSetting
+//
+//   DESCRIPTION: Restore the given profile setting to predefined(default) values.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+//   PARAMETERS: NvDRSSessionHandle(IN)  - Input to the session handle.
+//               NvDRSProfileHandle(IN)  - Input profile handle.
+//               NvU32(IN)               - Input settingId.
+//
+//   RETURN STATUS: NVAPI_OK: SUCCESS if the profile is found
+//                  NVAPI_ERROR: For miscellaneous errors.
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_DRS_RestoreProfileDefaultSetting(NvDRSSessionHandle hSession, NvDRSProfileHandle hProfile, NvU32 settingId);
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// FUNCTION NAME: NvAPI_DRS_GetBaseProfile
+//
+//   DESCRIPTION: Returns the handle to the current global profile.
+//
+//  SUPPORTED OS: Windows XP and higher
+//
+//   PARAMETERS: NvDRSSessionHandle(IN)  - Input to the session handle.
+//               NvDRSProfileHandle(OUT) - Returns Base profile handle.
+//
+//   RETURN STATUS: NVAPI_OK: SUCCESS
+//                  NVAPI_ERROR: For miscellaneous errors.
+//
+///////////////////////////////////////////////////////////////////////////////
+NVAPI_INTERFACE NvAPI_DRS_GetBaseProfile(NvDRSSessionHandle hSession, NvDRSProfileHandle *phProfile);
+
+
+#ifdef __nvapi_undef__ecount
+    #undef __ecount
+    #undef __nvapi_undef__ecount
+#endif
+#ifdef __nvapi_undef__bcount
+    #undef __bcount
+    #undef __nvapi_undef__bcount
+#endif
+#ifdef __nvapi_undef__in
+    #undef __in
+    #undef __nvapi_undef__in
+#endif
+#ifdef __nvapi_undef__in_ecount
+    #undef __in_ecount
+    #undef __nvapi_undef__in_ecount
+#endif
+#ifdef __nvapi_undef__in_bcount
+    #undef __in_bcount
+    #undef __nvapi_undef__in_bcount
+#endif
+#ifdef __nvapi_undef__in_z
+    #undef __in_z
+    #undef __nvapi_undef__in_z
+#endif
+#ifdef __nvapi_undef__in_ecount_z
+    #undef __in_ecount_z
+    #undef __nvapi_undef__in_ecount_z
+#endif
+#ifdef __nvapi_undef__in_bcount_z
+    #undef __in_bcount_z
+    #undef __nvapi_undef__in_bcount_z
+#endif
+#ifdef __nvapi_undef__in_nz
+    #undef __in_nz
+    #undef __nvapi_undef__in_nz
+#endif
+#ifdef __nvapi_undef__in_ecount_nz
+    #undef __in_ecount_nz
+    #undef __nvapi_undef__in_ecount_nz
+#endif
+#ifdef __nvapi_undef__in_bcount_nz
+    #undef __in_bcount_nz
+    #undef __nvapi_undef__in_bcount_nz
+#endif
+#ifdef __nvapi_undef__out
+    #undef __out
+    #undef __nvapi_undef__out
+#endif
+#ifdef __nvapi_undef__out_ecount
+    #undef __out_ecount
+    #undef __nvapi_undef__out_ecount
+#endif
+#ifdef __nvapi_undef__out_bcount
+    #undef __out_bcount
+    #undef __nvapi_undef__out_bcount
+#endif
+#ifdef __nvapi_undef__out_ecount_part
+    #undef __out_ecount_part
+    #undef __nvapi_undef__out_ecount_part
+#endif
+#ifdef __nvapi_undef__out_bcount_part
+    #undef __out_bcount_part
+    #undef __nvapi_undef__out_bcount_part
+#endif
+#ifdef __nvapi_undef__out_ecount_full
+    #undef __out_ecount_full
+    #undef __nvapi_undef__out_ecount_full
+#endif
+#ifdef __nvapi_undef__out_bcount_full
+    #undef __out_bcount_full
+    #undef __nvapi_undef__out_bcount_full
+#endif
+#ifdef __nvapi_undef__out_z
+    #undef __out_z
+    #undef __nvapi_undef__out_z
+#endif
+#ifdef __nvapi_undef__out_z_opt
+    #undef __out_z_opt
+    #undef __nvapi_undef__out_z_opt
+#endif
+#ifdef __nvapi_undef__out_ecount_z
+    #undef __out_ecount_z
+    #undef __nvapi_undef__out_ecount_z
+#endif
+#ifdef __nvapi_undef__out_bcount_z
+    #undef __out_bcount_z
+    #undef __nvapi_undef__out_bcount_z
+#endif
+#ifdef __nvapi_undef__out_ecount_part_z
+    #undef __out_ecount_part_z
+    #undef __nvapi_undef__out_ecount_part_z
+#endif
+#ifdef __nvapi_undef__out_bcount_part_z
+    #undef __out_bcount_part_z
+    #undef __nvapi_undef__out_bcount_part_z
+#endif
+#ifdef __nvapi_undef__out_ecount_full_z
+    #undef __out_ecount_full_z
+    #undef __nvapi_undef__out_ecount_full_z
+#endif
+#ifdef __nvapi_undef__out_bcount_full_z
+    #undef __out_bcount_full_z
+    #undef __nvapi_undef__out_bcount_full_z
+#endif
+#ifdef __nvapi_undef__out_nz
+    #undef __out_nz
+    #undef __nvapi_undef__out_nz
+#endif
+#ifdef __nvapi_undef__out_nz_opt
+    #undef __out_nz_opt
+    #undef __nvapi_undef__out_nz_opt
+#endif
+#ifdef __nvapi_undef__out_ecount_nz
+    #undef __out_ecount_nz
+    #undef __nvapi_undef__out_ecount_nz
+#endif
+#ifdef __nvapi_undef__out_bcount_nz
+    #undef __out_bcount_nz
+    #undef __nvapi_undef__out_bcount_nz
+#endif
+#ifdef __nvapi_undef__inout
+    #undef __inout
+    #undef __nvapi_undef__inout
+#endif
+#ifdef __nvapi_undef__inout_ecount
+    #undef __inout_ecount
+    #undef __nvapi_undef__inout_ecount
+#endif
+#ifdef __nvapi_undef__inout_bcount
+    #undef __inout_bcount
+    #undef __nvapi_undef__inout_bcount
+#endif
+#ifdef __nvapi_undef__inout_ecount_part
+    #undef __inout_ecount_part
+    #undef __nvapi_undef__inout_ecount_part
+#endif
+#ifdef __nvapi_undef__inout_bcount_part
+    #undef __inout_bcount_part
+    #undef __nvapi_undef__inout_bcount_part
+#endif
+#ifdef __nvapi_undef__inout_ecount_full
+    #undef __inout_ecount_full
+    #undef __nvapi_undef__inout_ecount_full
+#endif
+#ifdef __nvapi_undef__inout_bcount_full
+    #undef __inout_bcount_full
+    #undef __nvapi_undef__inout_bcount_full
+#endif
+#ifdef __nvapi_undef__inout_z
+    #undef __inout_z
+    #undef __nvapi_undef__inout_z
+#endif
+#ifdef __nvapi_undef__inout_ecount_z
+    #undef __inout_ecount_z
+    #undef __nvapi_undef__inout_ecount_z
+#endif
+#ifdef __nvapi_undef__inout_bcount_z
+    #undef __inout_bcount_z
+    #undef __nvapi_undef__inout_bcount_z
+#endif
+#ifdef __nvapi_undef__inout_nz
+    #undef __inout_nz
+    #undef __nvapi_undef__inout_nz
+#endif
+#ifdef __nvapi_undef__inout_ecount_nz
+    #undef __inout_ecount_nz
+    #undef __nvapi_undef__inout_ecount_nz
+#endif
+#ifdef __nvapi_undef__inout_bcount_nz
+    #undef __inout_bcount_nz
+    #undef __nvapi_undef__inout_bcount_nz
+#endif
+#ifdef __nvapi_undef__ecount_opt
+    #undef __ecount_opt
+    #undef __nvapi_undef__ecount_opt
+#endif
+#ifdef __nvapi_undef__bcount_opt
+    #undef __bcount_opt
+    #undef __nvapi_undef__bcount_opt
+#endif
+#ifdef __nvapi_undef__in_opt
+    #undef __in_opt
+    #undef __nvapi_undef__in_opt
+#endif
+#ifdef __nvapi_undef__in_ecount_opt
+    #undef __in_ecount_opt
+    #undef __nvapi_undef__in_ecount_opt
+#endif
+#ifdef __nvapi_undef__in_bcount_opt
+    #undef __in_bcount_opt
+    #undef __nvapi_undef__in_bcount_opt
+#endif
+#ifdef __nvapi_undef__in_z_opt
+    #undef __in_z_opt
+    #undef __nvapi_undef__in_z_opt
+#endif
+#ifdef __nvapi_undef__in_ecount_z_opt
+    #undef __in_ecount_z_opt
+    #undef __nvapi_undef__in_ecount_z_opt
+#endif
+#ifdef __nvapi_undef__in_bcount_z_opt
+    #undef __in_bcount_z_opt
+    #undef __nvapi_undef__in_bcount_z_opt
+#endif
+#ifdef __nvapi_undef__in_nz_opt
+    #undef __in_nz_opt
+    #undef __nvapi_undef__in_nz_opt
+#endif
+#ifdef __nvapi_undef__in_ecount_nz_opt
+    #undef __in_ecount_nz_opt
+    #undef __nvapi_undef__in_ecount_nz_opt
+#endif
+#ifdef __nvapi_undef__in_bcount_nz_opt
+    #undef __in_bcount_nz_opt
+    #undef __nvapi_undef__in_bcount_nz_opt
+#endif
+#ifdef __nvapi_undef__out_opt
+    #undef __out_opt
+    #undef __nvapi_undef__out_opt
+#endif
+#ifdef __nvapi_undef__out_ecount_opt
+    #undef __out_ecount_opt
+    #undef __nvapi_undef__out_ecount_opt
+#endif
+#ifdef __nvapi_undef__out_bcount_opt
+    #undef __out_bcount_opt
+    #undef __nvapi_undef__out_bcount_opt
+#endif
+#ifdef __nvapi_undef__out_ecount_part_opt
+    #undef __out_ecount_part_opt
+    #undef __nvapi_undef__out_ecount_part_opt
+#endif
+#ifdef __nvapi_undef__out_bcount_part_opt
+    #undef __out_bcount_part_opt
+    #undef __nvapi_undef__out_bcount_part_opt
+#endif
+#ifdef __nvapi_undef__out_ecount_full_opt
+    #undef __out_ecount_full_opt
+    #undef __nvapi_undef__out_ecount_full_opt
+#endif
+#ifdef __nvapi_undef__out_bcount_full_opt
+    #undef __out_bcount_full_opt
+    #undef __nvapi_undef__out_bcount_full_opt
+#endif
+#ifdef __nvapi_undef__out_ecount_z_opt
+    #undef __out_ecount_z_opt
+    #undef __nvapi_undef__out_ecount_z_opt
+#endif
+#ifdef __nvapi_undef__out_bcount_z_opt
+    #undef __out_bcount_z_opt
+    #undef __nvapi_undef__out_bcount_z_opt
+#endif
+#ifdef __nvapi_undef__out_ecount_part_z_opt
+    #undef __out_ecount_part_z_opt
+    #undef __nvapi_undef__out_ecount_part_z_opt
+#endif
+#ifdef __nvapi_undef__out_bcount_part_z_opt
+    #undef __out_bcount_part_z_opt
+    #undef __nvapi_undef__out_bcount_part_z_opt
+#endif
+#ifdef __nvapi_undef__out_ecount_full_z_opt
+    #undef __out_ecount_full_z_opt
+    #undef __nvapi_undef__out_ecount_full_z_opt
+#endif
+#ifdef __nvapi_undef__out_bcount_full_z_opt
+    #undef __out_bcount_full_z_opt
+    #undef __nvapi_undef__out_bcount_full_z_opt
+#endif
+#ifdef __nvapi_undef__out_ecount_nz_opt
+    #undef __out_ecount_nz_opt
+    #undef __nvapi_undef__out_ecount_nz_opt
+#endif
+#ifdef __nvapi_undef__out_bcount_nz_opt
+    #undef __out_bcount_nz_opt
+    #undef __nvapi_undef__out_bcount_nz_opt
+#endif
+#ifdef __nvapi_undef__inout_opt
+    #undef __inout_opt
+    #undef __nvapi_undef__inout_opt
+#endif
+#ifdef __nvapi_undef__inout_ecount_opt
+    #undef __inout_ecount_opt
+    #undef __nvapi_undef__inout_ecount_opt
+#endif
+#ifdef __nvapi_undef__inout_bcount_opt
+    #undef __inout_bcount_opt
+    #undef __nvapi_undef__inout_bcount_opt
+#endif
+#ifdef __nvapi_undef__inout_ecount_part_opt
+    #undef __inout_ecount_part_opt
+    #undef __nvapi_undef__inout_ecount_part_opt
+#endif
+#ifdef __nvapi_undef__inout_bcount_part_opt
+    #undef __inout_bcount_part_opt
+    #undef __nvapi_undef__inout_bcount_part_opt
+#endif
+#ifdef __nvapi_undef__inout_ecount_full_opt
+    #undef __inout_ecount_full_opt
+    #undef __nvapi_undef__inout_ecount_full_opt
+#endif
+#ifdef __nvapi_undef__inout_bcount_full_opt
+    #undef __inout_bcount_full_opt
+    #undef __nvapi_undef__inout_bcount_full_opt
+#endif
+#ifdef __nvapi_undef__inout_z_opt
+    #undef __inout_z_opt
+    #undef __nvapi_undef__inout_z_opt
+#endif
+#ifdef __nvapi_undef__inout_ecount_z_opt
+    #undef __inout_ecount_z_opt
+    #undef __nvapi_undef__inout_ecount_z_opt
+#endif
+#ifdef __nvapi_undef__inout_ecount_z_opt
+    #undef __inout_ecount_z_opt
+    #undef __nvapi_undef__inout_ecount_z_opt
+#endif
+#ifdef __nvapi_undef__inout_bcount_z_opt
+    #undef __inout_bcount_z_opt
+    #undef __nvapi_undef__inout_bcount_z_opt
+#endif
+#ifdef __nvapi_undef__inout_nz_opt
+    #undef __inout_nz_opt
+    #undef __nvapi_undef__inout_nz_opt
+#endif
+#ifdef __nvapi_undef__inout_ecount_nz_opt
+    #undef __inout_ecount_nz_opt
+    #undef __nvapi_undef__inout_ecount_nz_opt
+#endif
+#ifdef __nvapi_undef__inout_bcount_nz_opt
+    #undef __inout_bcount_nz_opt
+    #undef __nvapi_undef__inout_bcount_nz_opt
+#endif
+#ifdef __nvapi_undef__deref_ecount
+    #undef __deref_ecount
+    #undef __nvapi_undef__deref_ecount
+#endif
+#ifdef __nvapi_undef__deref_bcount
+    #undef __deref_bcount
+    #undef __nvapi_undef__deref_bcount
+#endif
+#ifdef __nvapi_undef__deref_out
+    #undef __deref_out
+    #undef __nvapi_undef__deref_out
+#endif
+#ifdef __nvapi_undef__deref_out_ecount
+    #undef __deref_out_ecount
+    #undef __nvapi_undef__deref_out_ecount
+#endif
+#ifdef __nvapi_undef__deref_out_bcount
+    #undef __deref_out_bcount
+    #undef __nvapi_undef__deref_out_bcount
+#endif
+#ifdef __nvapi_undef__deref_out_ecount_part
+    #undef __deref_out_ecount_part
+    #undef __nvapi_undef__deref_out_ecount_part
+#endif
+#ifdef __nvapi_undef__deref_out_bcount_part
+    #undef __deref_out_bcount_part
+    #undef __nvapi_undef__deref_out_bcount_part
+#endif
+#ifdef __nvapi_undef__deref_out_ecount_full
+    #undef __deref_out_ecount_full
+    #undef __nvapi_undef__deref_out_ecount_full
+#endif
+#ifdef __nvapi_undef__deref_out_bcount_full
+    #undef __deref_out_bcount_full
+    #undef __nvapi_undef__deref_out_bcount_full
+#endif
+#ifdef __nvapi_undef__deref_out_z
+    #undef __deref_out_z
+    #undef __nvapi_undef__deref_out_z
+#endif
+#ifdef __nvapi_undef__deref_out_ecount_z
+    #undef __deref_out_ecount_z
+    #undef __nvapi_undef__deref_out_ecount_z
+#endif
+#ifdef __nvapi_undef__deref_out_bcount_z
+    #undef __deref_out_bcount_z
+    #undef __nvapi_undef__deref_out_bcount_z
+#endif
+#ifdef __nvapi_undef__deref_out_nz
+    #undef __deref_out_nz
+    #undef __nvapi_undef__deref_out_nz
+#endif
+#ifdef __nvapi_undef__deref_out_ecount_nz
+    #undef __deref_out_ecount_nz
+    #undef __nvapi_undef__deref_out_ecount_nz
+#endif
+#ifdef __nvapi_undef__deref_out_bcount_nz
+    #undef __deref_out_bcount_nz
+    #undef __nvapi_undef__deref_out_bcount_nz
+#endif
+#ifdef __nvapi_undef__deref_inout
+    #undef __deref_inout
+    #undef __nvapi_undef__deref_inout
+#endif
+#ifdef __nvapi_undef__deref_inout_z
+    #undef __deref_inout_z
+    #undef __nvapi_undef__deref_inout_z
+#endif
+#ifdef __nvapi_undef__deref_inout_ecount
+    #undef __deref_inout_ecount
+    #undef __nvapi_undef__deref_inout_ecount
+#endif
+#ifdef __nvapi_undef__deref_inout_bcount
+    #undef __deref_inout_bcount
+    #undef __nvapi_undef__deref_inout_bcount
+#endif
+#ifdef __nvapi_undef__deref_inout_ecount_part
+    #undef __deref_inout_ecount_part
+    #undef __nvapi_undef__deref_inout_ecount_part
+#endif
+#ifdef __nvapi_undef__deref_inout_bcount_part
+    #undef __deref_inout_bcount_part
+    #undef __nvapi_undef__deref_inout_bcount_part
+#endif
+#ifdef __nvapi_undef__deref_inout_ecount_full
+    #undef __deref_inout_ecount_full
+    #undef __nvapi_undef__deref_inout_ecount_full
+#endif
+#ifdef __nvapi_undef__deref_inout_bcount_full
+    #undef __deref_inout_bcount_full
+    #undef __nvapi_undef__deref_inout_bcount_full
+#endif
+#ifdef __nvapi_undef__deref_inout_z
+    #undef __deref_inout_z
+    #undef __nvapi_undef__deref_inout_z
+#endif
+#ifdef __nvapi_undef__deref_inout_ecount_z
+    #undef __deref_inout_ecount_z
+    #undef __nvapi_undef__deref_inout_ecount_z
+#endif
+#ifdef __nvapi_undef__deref_inout_bcount_z
+    #undef __deref_inout_bcount_z
+    #undef __nvapi_undef__deref_inout_bcount_z
+#endif
+#ifdef __nvapi_undef__deref_inout_nz
+    #undef __deref_inout_nz
+    #undef __nvapi_undef__deref_inout_nz
+#endif
+#ifdef __nvapi_undef__deref_inout_ecount_nz
+    #undef __deref_inout_ecount_nz
+    #undef __nvapi_undef__deref_inout_ecount_nz
+#endif
+#ifdef __nvapi_undef__deref_inout_bcount_nz
+    #undef __deref_inout_bcount_nz
+    #undef __nvapi_undef__deref_inout_bcount_nz
+#endif
+#ifdef __nvapi_undef__deref_ecount_opt
+    #undef __deref_ecount_opt
+    #undef __nvapi_undef__deref_ecount_opt
+#endif
+#ifdef __nvapi_undef__deref_bcount_opt
+    #undef __deref_bcount_opt
+    #undef __nvapi_undef__deref_bcount_opt
+#endif
+#ifdef __nvapi_undef__deref_out_opt
+    #undef __deref_out_opt
+    #undef __nvapi_undef__deref_out_opt
+#endif
+#ifdef __nvapi_undef__deref_out_ecount_opt
+    #undef __deref_out_ecount_opt
+    #undef __nvapi_undef__deref_out_ecount_opt
+#endif
+#ifdef __nvapi_undef__deref_out_bcount_opt
+    #undef __deref_out_bcount_opt
+    #undef __nvapi_undef__deref_out_bcount_opt
+#endif
+#ifdef __nvapi_undef__deref_out_ecount_part_opt
+    #undef __deref_out_ecount_part_opt
+    #undef __nvapi_undef__deref_out_ecount_part_opt
+#endif
+#ifdef __nvapi_undef__deref_out_bcount_part_opt
+    #undef __deref_out_bcount_part_opt
+    #undef __nvapi_undef__deref_out_bcount_part_opt
+#endif
+#ifdef __nvapi_undef__deref_out_ecount_full_opt
+    #undef __deref_out_ecount_full_opt
+    #undef __nvapi_undef__deref_out_ecount_full_opt
+#endif
+#ifdef __nvapi_undef__deref_out_bcount_full_opt
+    #undef __deref_out_bcount_full_opt
+    #undef __nvapi_undef__deref_out_bcount_full_opt
+#endif
+#ifdef __nvapi_undef__deref_out_z_opt
+    #undef __deref_out_z_opt
+    #undef __nvapi_undef__deref_out_z_opt
+#endif
+#ifdef __nvapi_undef__deref_out_ecount_z_opt
+    #undef __deref_out_ecount_z_opt
+    #undef __nvapi_undef__deref_out_ecount_z_opt
+#endif
+#ifdef __nvapi_undef__deref_out_bcount_z_opt
+    #undef __deref_out_bcount_z_opt
+    #undef __nvapi_undef__deref_out_bcount_z_opt
+#endif
+#ifdef __nvapi_undef__deref_out_nz_opt
+    #undef __deref_out_nz_opt
+    #undef __nvapi_undef__deref_out_nz_opt
+#endif
+#ifdef __nvapi_undef__deref_out_ecount_nz_opt
+    #undef __deref_out_ecount_nz_opt
+    #undef __nvapi_undef__deref_out_ecount_nz_opt
+#endif
+#ifdef __nvapi_undef__deref_out_bcount_nz_opt
+    #undef __deref_out_bcount_nz_opt
+    #undef __nvapi_undef__deref_out_bcount_nz_opt
+#endif
+#ifdef __nvapi_undef__deref_inout_opt
+    #undef __deref_inout_opt
+    #undef __nvapi_undef__deref_inout_opt
+#endif
+#ifdef __nvapi_undef__deref_inout_ecount_opt
+    #undef __deref_inout_ecount_opt
+    #undef __nvapi_undef__deref_inout_ecount_opt
+#endif
+#ifdef __nvapi_undef__deref_inout_bcount_opt
+    #undef __deref_inout_bcount_opt
+    #undef __nvapi_undef__deref_inout_bcount_opt
+#endif
+#ifdef __nvapi_undef__deref_inout_ecount_part_opt
+    #undef __deref_inout_ecount_part_opt
+    #undef __nvapi_undef__deref_inout_ecount_part_opt
+#endif
+#ifdef __nvapi_undef__deref_inout_bcount_part_opt
+    #undef __deref_inout_bcount_part_opt
+    #undef __nvapi_undef__deref_inout_bcount_part_opt
+#endif
+#ifdef __nvapi_undef__deref_inout_ecount_full_opt
+    #undef __deref_inout_ecount_full_opt
+    #undef __nvapi_undef__deref_inout_ecount_full_opt
+#endif
+#ifdef __nvapi_undef__deref_inout_bcount_full_opt
+    #undef __deref_inout_bcount_full_opt
+    #undef __nvapi_undef__deref_inout_bcount_full_opt
+#endif
+#ifdef __nvapi_undef__deref_inout_z_opt
+    #undef __deref_inout_z_opt
+    #undef __nvapi_undef__deref_inout_z_opt
+#endif
+#ifdef __nvapi_undef__deref_inout_ecount_z_opt
+    #undef __deref_inout_ecount_z_opt
+    #undef __nvapi_undef__deref_inout_ecount_z_opt
+#endif
+#ifdef __nvapi_undef__deref_inout_bcount_z_opt
+    #undef __deref_inout_bcount_z_opt
+    #undef __nvapi_undef__deref_inout_bcount_z_opt
+#endif
+#ifdef __nvapi_undef__deref_inout_nz_opt
+    #undef __deref_inout_nz_opt
+    #undef __nvapi_undef__deref_inout_nz_opt
+#endif
+#ifdef __nvapi_undef__deref_inout_ecount_nz_opt
+    #undef __deref_inout_ecount_nz_opt
+    #undef __nvapi_undef__deref_inout_ecount_nz_opt
+#endif
+#ifdef __nvapi_undef__deref_inout_bcount_nz_opt
+    #undef __deref_inout_bcount_nz_opt
+    #undef __nvapi_undef__deref_inout_bcount_nz_opt
+#endif
+#ifdef __nvapi_undef__deref_opt_ecount
+    #undef __deref_opt_ecount
+    #undef __nvapi_undef__deref_opt_ecount
+#endif
+#ifdef __nvapi_undef__deref_opt_bcount
+    #undef __deref_opt_bcount
+    #undef __nvapi_undef__deref_opt_bcount
+#endif
+#ifdef __nvapi_undef__deref_opt_out
+    #undef __deref_opt_out
+    #undef __nvapi_undef__deref_opt_out
+#endif
+#ifdef __nvapi_undef__deref_opt_out_z
+    #undef __deref_opt_out_z
+    #undef __nvapi_undef__deref_opt_out_z
+#endif
+#ifdef __nvapi_undef__deref_opt_out_ecount
+    #undef __deref_opt_out_ecount
+    #undef __nvapi_undef__deref_opt_out_ecount
+#endif
+#ifdef __nvapi_undef__deref_opt_out_bcount
+    #undef __deref_opt_out_bcount
+    #undef __nvapi_undef__deref_opt_out_bcount
+#endif
+#ifdef __nvapi_undef__deref_opt_out_ecount_part
+    #undef __deref_opt_out_ecount_part
+    #undef __nvapi_undef__deref_opt_out_ecount_part
+#endif
+#ifdef __nvapi_undef__deref_opt_out_bcount_part
+    #undef __deref_opt_out_bcount_part
+    #undef __nvapi_undef__deref_opt_out_bcount_part
+#endif
+#ifdef __nvapi_undef__deref_opt_out_ecount_full
+    #undef __deref_opt_out_ecount_full
+    #undef __nvapi_undef__deref_opt_out_ecount_full
+#endif
+#ifdef __nvapi_undef__deref_opt_out_bcount_full
+    #undef __deref_opt_out_bcount_full
+    #undef __nvapi_undef__deref_opt_out_bcount_full
+#endif
+#ifdef __nvapi_undef__deref_opt_inout
+    #undef __deref_opt_inout
+    #undef __nvapi_undef__deref_opt_inout
+#endif
+#ifdef __nvapi_undef__deref_opt_inout_ecount
+    #undef __deref_opt_inout_ecount
+    #undef __nvapi_undef__deref_opt_inout_ecount
+#endif
+#ifdef __nvapi_undef__deref_opt_inout_bcount
+    #undef __deref_opt_inout_bcount
+    #undef __nvapi_undef__deref_opt_inout_bcount
+#endif
+#ifdef __nvapi_undef__deref_opt_inout_ecount_part
+    #undef __deref_opt_inout_ecount_part
+    #undef __nvapi_undef__deref_opt_inout_ecount_part
+#endif
+#ifdef __nvapi_undef__deref_opt_inout_bcount_part
+    #undef __deref_opt_inout_bcount_part
+    #undef __nvapi_undef__deref_opt_inout_bcount_part
+#endif
+#ifdef __nvapi_undef__deref_opt_inout_ecount_full
+    #undef __deref_opt_inout_ecount_full
+    #undef __nvapi_undef__deref_opt_inout_ecount_full
+#endif
+#ifdef __nvapi_undef__deref_opt_inout_bcount_full
+    #undef __deref_opt_inout_bcount_full
+    #undef __nvapi_undef__deref_opt_inout_bcount_full
+#endif
+#ifdef __nvapi_undef__deref_opt_inout_z
+    #undef __deref_opt_inout_z
+    #undef __nvapi_undef__deref_opt_inout_z
+#endif
+#ifdef __nvapi_undef__deref_opt_inout_ecount_z
+    #undef __deref_opt_inout_ecount_z
+    #undef __nvapi_undef__deref_opt_inout_ecount_z
+#endif
+#ifdef __nvapi_undef__deref_opt_inout_bcount_z
+    #undef __deref_opt_inout_bcount_z
+    #undef __nvapi_undef__deref_opt_inout_bcount_z
+#endif
+#ifdef __nvapi_undef__deref_opt_inout_nz
+    #undef __deref_opt_inout_nz
+    #undef __nvapi_undef__deref_opt_inout_nz
+#endif
+#ifdef __nvapi_undef__deref_opt_inout_ecount_nz
+    #undef __deref_opt_inout_ecount_nz
+    #undef __nvapi_undef__deref_opt_inout_ecount_nz
+#endif
+#ifdef __nvapi_undef__deref_opt_inout_bcount_nz
+    #undef __deref_opt_inout_bcount_nz
+    #undef __nvapi_undef__deref_opt_inout_bcount_nz
+#endif
+#ifdef __nvapi_undef__deref_opt_ecount_opt
+    #undef __deref_opt_ecount_opt
+    #undef __nvapi_undef__deref_opt_ecount_opt
+#endif
+#ifdef __nvapi_undef__deref_opt_bcount_opt
+    #undef __deref_opt_bcount_opt
+    #undef __nvapi_undef__deref_opt_bcount_opt
+#endif
+#ifdef __nvapi_undef__deref_opt_out_opt
+    #undef __deref_opt_out_opt
+    #undef __nvapi_undef__deref_opt_out_opt
+#endif
+#ifdef __nvapi_undef__deref_opt_out_ecount_opt
+    #undef __deref_opt_out_ecount_opt
+    #undef __nvapi_undef__deref_opt_out_ecount_opt
+#endif
+#ifdef __nvapi_undef__deref_opt_out_bcount_opt
+    #undef __deref_opt_out_bcount_opt
+    #undef __nvapi_undef__deref_opt_out_bcount_opt
+#endif
+#ifdef __nvapi_undef__deref_opt_out_ecount_part_opt
+    #undef __deref_opt_out_ecount_part_opt
+    #undef __nvapi_undef__deref_opt_out_ecount_part_opt
+#endif
+#ifdef __nvapi_undef__deref_opt_out_bcount_part_opt
+    #undef __deref_opt_out_bcount_part_opt
+    #undef __nvapi_undef__deref_opt_out_bcount_part_opt
+#endif
+#ifdef __nvapi_undef__deref_opt_out_ecount_full_opt
+    #undef __deref_opt_out_ecount_full_opt
+    #undef __nvapi_undef__deref_opt_out_ecount_full_opt
+#endif
+#ifdef __nvapi_undef__deref_opt_out_bcount_full_opt
+    #undef __deref_opt_out_bcount_full_opt
+    #undef __nvapi_undef__deref_opt_out_bcount_full_opt
+#endif
+#ifdef __nvapi_undef__deref_opt_out_z_opt
+    #undef __deref_opt_out_z_opt
+    #undef __nvapi_undef__deref_opt_out_z_opt
+#endif
+#ifdef __nvapi_undef__deref_opt_out_ecount_z_opt
+    #undef __deref_opt_out_ecount_z_opt
+    #undef __nvapi_undef__deref_opt_out_ecount_z_opt
+#endif
+#ifdef __nvapi_undef__deref_opt_out_bcount_z_opt
+    #undef __deref_opt_out_bcount_z_opt
+    #undef __nvapi_undef__deref_opt_out_bcount_z_opt
+#endif
+#ifdef __nvapi_undef__deref_opt_out_nz_opt
+    #undef __deref_opt_out_nz_opt
+    #undef __nvapi_undef__deref_opt_out_nz_opt
+#endif
+#ifdef __nvapi_undef__deref_opt_out_ecount_nz_opt
+    #undef __deref_opt_out_ecount_nz_opt
+    #undef __nvapi_undef__deref_opt_out_ecount_nz_opt
+#endif
+#ifdef __nvapi_undef__deref_opt_out_bcount_nz_opt
+    #undef __deref_opt_out_bcount_nz_opt
+    #undef __nvapi_undef__deref_opt_out_bcount_nz_opt
+#endif
+#ifdef __nvapi_undef__deref_opt_inout_opt
+    #undef __deref_opt_inout_opt
+    #undef __nvapi_undef__deref_opt_inout_opt
+#endif
+#ifdef __nvapi_undef__deref_opt_inout_ecount_opt
+    #undef __deref_opt_inout_ecount_opt
+    #undef __nvapi_undef__deref_opt_inout_ecount_opt
+#endif
+#ifdef __nvapi_undef__deref_opt_inout_bcount_opt
+    #undef __deref_opt_inout_bcount_opt
+    #undef __nvapi_undef__deref_opt_inout_bcount_opt
+#endif
+#ifdef __nvapi_undef__deref_opt_inout_ecount_part_opt
+    #undef __deref_opt_inout_ecount_part_opt
+    #undef __nvapi_undef__deref_opt_inout_ecount_part_opt
+#endif
+#ifdef __nvapi_undef__deref_opt_inout_bcount_part_opt
+    #undef __deref_opt_inout_bcount_part_opt
+    #undef __nvapi_undef__deref_opt_inout_bcount_part_opt
+#endif
+#ifdef __nvapi_undef__deref_opt_inout_ecount_full_opt
+    #undef __deref_opt_inout_ecount_full_opt
+    #undef __nvapi_undef__deref_opt_inout_ecount_full_opt
+#endif
+#ifdef __nvapi_undef__deref_opt_inout_bcount_full_opt
+    #undef __deref_opt_inout_bcount_full_opt
+    #undef __nvapi_undef__deref_opt_inout_bcount_full_opt
+#endif
+#ifdef __nvapi_undef__deref_opt_inout_z_opt
+    #undef __deref_opt_inout_z_opt
+    #undef __nvapi_undef__deref_opt_inout_z_opt
+#endif
+#ifdef __nvapi_undef__deref_opt_inout_ecount_z_opt
+    #undef __deref_opt_inout_ecount_z_opt
+    #undef __nvapi_undef__deref_opt_inout_ecount_z_opt
+#endif
+#ifdef __nvapi_undef__deref_opt_inout_bcount_z_opt
+    #undef __deref_opt_inout_bcount_z_opt
+    #undef __nvapi_undef__deref_opt_inout_bcount_z_opt
+#endif
+#ifdef __nvapi_undef__deref_opt_inout_nz_opt
+    #undef __deref_opt_inout_nz_opt
+    #undef __nvapi_undef__deref_opt_inout_nz_opt
+#endif
+#ifdef __nvapi_undef__deref_opt_inout_ecount_nz_opt
+    #undef __deref_opt_inout_ecount_nz_opt
+    #undef __nvapi_undef__deref_opt_inout_ecount_nz_opt
+#endif
+#ifdef __nvapi_undef__deref_opt_inout_bcount_nz_opt
+    #undef __deref_opt_inout_bcount_nz_opt
+    #undef __nvapi_undef__deref_opt_inout_bcount_nz_opt
+#endif
+
+#ifdef __cplusplus
+}; //extern "C" {
+
+#endif
+
+#pragma pack(pop)
+
+#endif // _NVAPI_H
+
diff --git a/modules/video_filter/stereoscopy.c b/modules/video_filter/stereoscopy.c
new file mode 100644
index 0000000..5e5114f
--- /dev/null
+++ b/modules/video_filter/stereoscopy.c
@@ -0,0 +1,2662 @@
+/*****************************************************************************
+ * stereoscopy.c : "steroscopy" video filter - splits one image into 2 eyes
+ *****************************************************************************
+ * Copyright (C) 2011 the VideoLAN team
+ *
+ * Authors: Andrew Price <andrewprice@andrewalexanderprice.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston MA 02110-1301, USA.
+ *****************************************************************************/
+
+/*****************************************************************************
+ * Preamble
+ *****************************************************************************/
+
+#ifdef HAVE_CONFIG_H
+# include "config.h"
+#endif
+
+#include <vlc_common.h>
+#include <vlc_plugin.h>
+#include <vlc_rand.h>
+
+#include <vlc_filter.h>
+#include "filter_picture.h"
+#include "stereoscopy.h"
+
+/*****************************************************************************
+ * Local prototypes
+ *****************************************************************************/
+static int  Create    ( vlc_object_t * );
+static picture_t *Filter( filter_t *, picture_t * );
+static void Destroy( vlc_object_t *p_this );
+
+/* based on those from extract.c */
+static void get_red_from_yuv420( picture_t *, picture_t *, int, int, int );
+static void get_red_from_yuv422( picture_t *, picture_t *, int, int, int );
+static void get_cyan_from_yuv420( picture_t *, picture_t *, int, int, int );
+static void get_cyan_from_yuv422( picture_t *, picture_t *, int, int, int );
+static void get_green_from_yuv420( picture_t *, picture_t *, int, int, int );
+static void get_green_from_yuv422( picture_t *, picture_t *, int, int, int );
+static void get_magenta_from_yuv420( picture_t *, picture_t *, int, int, int );
+static void get_magenta_from_yuv422( picture_t *, picture_t *, int, int, int );
+static void get_blue_from_yuv420( picture_t *, picture_t *, int, int, int );
+static void get_blue_from_yuv422( picture_t *, picture_t *, int, int, int );
+static void get_yellow_from_yuv420( picture_t *, picture_t *, int, int, int );
+static void get_yellow_from_yuv422( picture_t *, picture_t *, int, int, int );
+
+static void get_red_grayscale_from_yuv420( picture_t *, picture_t *, int, int,
+    int );
+static void get_red_grayscale_from_yuv422( picture_t *, picture_t *, int, int,
+    int );
+static void get_cyan_grayscale_from_yuv420( picture_t *, picture_t *, int, int,
+    int );
+static void get_cyan_grayscale_from_yuv422( picture_t *, picture_t *, int, int,
+    int );
+static void get_green_grayscale_from_yuv420( picture_t *, picture_t *, int, int,
+    int );
+static void get_green_grayscale_from_yuv422( picture_t *, picture_t *, int, int,
+    int );
+static void get_magenta_grayscale_from_yuv420( picture_t *, picture_t *, int,
+    int, int );
+static void get_magenta_grayscale_from_yuv422( picture_t *, picture_t *, int,
+    int, int );
+static void get_blue_grayscale_from_yuv420( picture_t *, picture_t *, int, int,
+    int );
+static void get_blue_grayscale_from_yuv422( picture_t *, picture_t *, int, int,
+    int );
+static void get_yellow_grayscale_from_yuv420( picture_t *, picture_t *, int,
+    int, int );
+static void get_yellow_grayscale_from_yuv422( picture_t *, picture_t *, int,
+    int, int );
+
+static void get_cyan_fill_from_yuv420( picture_t *, picture_t *, int, int,
+   int );
+static void get_cyan_fill_from_yuv422( picture_t *, picture_t *, int, int,
+   int );
+static void get_magenta_fill_from_yuv420( picture_t *, picture_t *, int, int,
+   int );
+static void get_magenta_fill_from_yuv422( picture_t *, picture_t *, int, int,
+   int );
+static void get_yellow_fill_from_yuv420( picture_t *, picture_t *, int, int,
+   int );
+static void get_yellow_fill_from_yuv422( picture_t *, picture_t *, int, int,
+  int );
+
+static void get_lefthalf_from_yuv420( picture_t *, picture_t *, int, int,
+  int );
+static void get_lefthalf_from_yuv422( picture_t *, picture_t *, int, int,
+  int );
+static void get_righthalf_from_yuv420( picture_t *, picture_t *, int, int,
+  int );
+static void get_righthalf_from_yuv422( picture_t *, picture_t *, int, int,
+  int );
+static void get_tophalf_from_yuv420( picture_t *, picture_t *, int, int,
+  int );
+static void get_tophalf_from_yuv422( picture_t *, picture_t *, int, int,
+  int );
+static void get_bottomhalf_from_yuv420( picture_t *, picture_t *, int, int,
+  int );
+static void get_bottomhalf_from_yuv422( picture_t *, picture_t *, int, int,
+  int );
+
+#define FILTER_PREFIX "stereoscopy-"
+
+#define LEFT_EYE_METHOD_TEXT N_("Left eye stereoscopy encoding")
+#define RIGHT_EYE_METHOD_TEXT N_("Right eye stereoscopy enconding")
+#define LEFT_EYE_METHOD_LONGTEXT N_("Represents the form of steroscopic "\
+                                    "encoding used for the image of the "\
+                                    "respective eye. " \
+                                    "0 - The image is intended to be 2D " \
+                                    "and should be displayed as such. " \
+                                    "1000 - The eye is encoded in the " \
+                                    "blue channel. " \
+                                    "1001 - The eye is encoded in the " \
+                                    "green and blue channels. " \
+                                    "1002 - The eye is encoded in the " \
+                                    "green channel. " \
+                                    "1003 - The eye is encoded in the " \
+                                    "red and blue channels. " \
+                                    "1004 - The eye is encoded in the " \
+                                    "red channel. " \
+                                    "1005 - The eye is encoded in the " \
+                                    "red and green channels. " \
+                                    "1010 - The eye is encoded in the " \
+                                    "blue channel as a gray scale image. " \
+                                    "1011 - The eye is encoded in the " \
+                                    "green and blue channels as a gray " \
+                                    "scale image. " \
+                                    "1012 - The eye is encoded in the " \
+                                    "green channel as a gray scale image. " \
+                                    "1013 - The eye is encoded in the " \
+                                    "red and blue channels as a gray " \
+                                    "scale image. " \
+                                    "1014 - The eye is encoded in the " \
+                                    "red channel as a gray scale image. " \
+                                    "1015 - The eye is encoded in the " \
+                                    "red and green channels as a gray " \
+                                    "scale image. " \
+                                    "1021 - The eye is encoded in the " \
+                                    "green and blue channels interpolating" \
+                                    "the red channel. " \
+                                    "1023 - The eye is encoded in the " \
+                                    "red and blue channels interpolating" \
+                                    "the green channel. " \
+                                    "1025 - The eye is encoded in the " \
+                                    "red and green channels interpolating" \
+                                    "the blue channel. " \
+                                    "2000 - The eye is encoded in the " \
+                                    "left half of the image. " \
+                                    "2001 - The eye is encoded in the " \
+                                    "right half of the image. " \
+                                    "2002 - The eye is encoded in the " \
+                                    "bottom half of the image. " \
+                                    "2003 - The eye is encoded in the " \
+                                    "top half of the image. ")
+#define RIGHT_EYE_METHOD_LONGTEXT LEFT_EYE_METHOD_LONGTEXT
+
+struct filter_sys_t
+{
+    int    i_leftEyeMethod;      /* stereoscopy encoding for left eye */
+    int    i_rightEyeMethod;     /* stereoscopy encoding for right eye */
+    bool   b_leftEyeLast;
+};
+
+/*****************************************************************************
+ * Module descriptor
+ *****************************************************************************/
+vlc_module_begin ()
+    set_description( N_("Stereoscopy video filter") )
+    set_shortname( N_( "Stereoscopy" ))
+    set_capability( "video filter2", 0 )
+    set_category( CAT_VIDEO )
+    set_subcategory( SUBCAT_VIDEO_VFILTER )
+
+    add_shortcut( "stereoscopy" )
+    set_callbacks( Create, Destroy )
+
+    add_integer( FILTER_PREFIX "left", STEREOSCOPY_ANAGLYPH_RED,
+                 LEFT_EYE_METHOD_TEXT, LEFT_EYE_METHOD_LONGTEXT, false )
+    add_integer( FILTER_PREFIX "right", STEREOSCOPY_ANAGLYPH_CYAN,
+                 RIGHT_EYE_METHOD_TEXT, RIGHT_EYE_METHOD_LONGTEXT, false )
+vlc_module_end ()
+
+/*****************************************************************************
+ * Create: initialises stereoscopy video filter
+ *****************************************************************************
+ * This function allocates and initializes a Distort vout method.
+ *****************************************************************************/
+static int Create( vlc_object_t *p_this )
+{
+    filter_t *p_filter;
+    filter_sys_t *p_sys;
+
+    p_filter = (filter_t *)p_this;
+    p_filter->pf_video_filter = Filter;
+    p_sys = p_filter->p_sys = malloc(sizeof(*p_sys));
+
+    if( !p_sys )
+        return VLC_ENOMEM;
+
+    p_sys->i_leftEyeMethod = var_InheritInteger( p_filter,
+        FILTER_PREFIX "left" );
+    p_sys->i_rightEyeMethod = var_InheritInteger( p_filter,
+        FILTER_PREFIX "right" );
+    p_sys->b_leftEyeLast = false;
+
+    return VLC_SUCCESS;
+}
+
+/*****************************************************************************
+ * Destroy: destroy Crop video thread output method
+ *****************************************************************************
+ * Terminate an output method created by CropCreateOutputMethod
+ *****************************************************************************/
+static void Destroy( vlc_object_t *p_this )
+{
+    filter_t *p_filter = (filter_t*)p_this;
+    free( p_filter->p_sys );
+}
+
+
+/*****************************************************************************
+ * DecodeImageYUV: extracts an image from a greater RGB image
+ *****************************************************************************
+ * Extracts the image for a single eye from a stereoscopic image containing
+ * both eyes in YUV420 or YUV422 format.
+ *****************************************************************************/
+static picture_t *DecodeImageYUV( filter_t *p_filter, picture_t *p_inpic,
+    int i_method, bool yuv422)
+{
+    picture_t *p_output = filter_NewPicture( p_filter );
+
+    if( !p_output )
+        return NULL;
+
+    switch( i_method) 
+    {
+        case STEREOSCOPY_ANAGLYPH_BLUE:
+            if(yuv422)
+                get_blue_from_yuv422(p_inpic, p_output,
+                    Y_PLANE, U_PLANE, V_PLANE);
+            else
+                get_blue_from_yuv420(p_inpic, p_output,
+                    Y_PLANE, U_PLANE, V_PLANE);
+            break;
+        case STEREOSCOPY_ANAGLYPH_CYAN:
+            if(yuv422)
+                get_cyan_from_yuv422(p_inpic, p_output,
+                    Y_PLANE, U_PLANE, V_PLANE);
+            else
+                get_cyan_from_yuv420(p_inpic, p_output,
+                    Y_PLANE, U_PLANE, V_PLANE);
+            break;
+        case STEREOSCOPY_ANAGLYPH_GREEN:
+            if(yuv422)
+                get_green_from_yuv422(p_inpic, p_output,
+                    Y_PLANE, U_PLANE, V_PLANE);
+            else
+                get_green_from_yuv420(p_inpic, p_output,
+                    Y_PLANE, U_PLANE, V_PLANE);
+            break;
+        case STEREOSCOPY_ANAGLYPH_MAGENTA:
+            if(yuv422)
+                get_magenta_from_yuv422(p_inpic, p_output,
+                    Y_PLANE, U_PLANE, V_PLANE);
+            else
+                get_magenta_from_yuv420(p_inpic, p_output,
+                    Y_PLANE, U_PLANE, V_PLANE);
+            break;
+        case STEREOSCOPY_ANAGLYPH_RED:
+            if(yuv422)
+                get_red_from_yuv422(p_inpic, p_output,
+                    Y_PLANE, U_PLANE, V_PLANE);
+            else
+                get_red_from_yuv420(p_inpic, p_output,
+                    Y_PLANE, U_PLANE, V_PLANE);
+            break;
+        case STEREOSCOPY_ANAGLYPH_YELLOW:
+            if(yuv422)
+                get_yellow_from_yuv422(p_inpic, p_output,
+                    Y_PLANE, U_PLANE, V_PLANE);
+            else
+                get_yellow_from_yuv420(p_inpic, p_output,
+                    Y_PLANE, U_PLANE, V_PLANE);
+            break;
+        case STEREOSCOPY_ANAGLYPH_BLUE_GRAY:
+            if(yuv422)
+                get_blue_grayscale_from_yuv422(p_inpic,
+                    p_output, Y_PLANE, U_PLANE, V_PLANE);
+            else
+                get_blue_grayscale_from_yuv420(p_inpic,
+                    p_output, Y_PLANE, U_PLANE, V_PLANE);
+            break;
+        case STEREOSCOPY_ANAGLYPH_CYAN_GRAY:
+            if(yuv422)
+                get_cyan_grayscale_from_yuv422(p_inpic,
+                    p_output, Y_PLANE, U_PLANE, V_PLANE);
+            else
+                get_cyan_grayscale_from_yuv420(p_inpic,
+                    p_output, Y_PLANE, U_PLANE, V_PLANE);
+            break;
+        case STEREOSCOPY_ANAGLYPH_GREEN_GRAY:
+            if(yuv422)
+                get_green_grayscale_from_yuv422(p_inpic,
+                    p_output, Y_PLANE, U_PLANE, V_PLANE);
+            else
+                get_green_grayscale_from_yuv420(p_inpic,
+                    p_output, Y_PLANE, U_PLANE, V_PLANE);
+            break;
+        case STEREOSCOPY_ANAGLYPH_MAGENTA_GRAY:
+            if(yuv422)
+                get_magenta_grayscale_from_yuv422(p_inpic,
+                    p_output, Y_PLANE, U_PLANE, V_PLANE);
+            else
+                get_magenta_grayscale_from_yuv420(p_inpic,
+                    p_output, Y_PLANE, U_PLANE, V_PLANE);
+            break;
+        case STEREOSCOPY_ANAGLYPH_RED_GRAY:
+            if(yuv422)
+                get_red_grayscale_from_yuv422(p_inpic, p_output,
+                    Y_PLANE, U_PLANE, V_PLANE);
+            else
+                get_red_grayscale_from_yuv420(p_inpic, p_output,
+                    Y_PLANE, U_PLANE, V_PLANE);
+            break;
+        case STEREOSCOPY_ANAGLYPH_YELLOW_GRAY:
+            if(yuv422)
+                get_yellow_grayscale_from_yuv422(p_inpic, p_output,
+                    Y_PLANE, U_PLANE, V_PLANE);
+            else
+                get_yellow_grayscale_from_yuv420(p_inpic, p_output,
+                    Y_PLANE, U_PLANE, V_PLANE);
+            break;
+        case STEREOSCOPY_ANAGLYPH_CYAN_FILL:
+            if(yuv422)
+                get_cyan_fill_from_yuv422(p_inpic, p_output,
+                    Y_PLANE, U_PLANE, V_PLANE);
+            else
+                get_cyan_fill_from_yuv420(p_inpic, p_output,
+                    Y_PLANE, U_PLANE, V_PLANE);
+            break;
+        case STEREOSCOPY_ANAGLYPH_MAGENTA_FILL:
+            if(yuv422)
+                get_magenta_fill_from_yuv422(p_inpic, p_output,
+                    Y_PLANE, U_PLANE, V_PLANE);
+            else
+                get_magenta_fill_from_yuv420(p_inpic, p_output,
+                    Y_PLANE, U_PLANE, V_PLANE);
+            break;
+        case STEREOSCOPY_ANAGLYPH_YELLOW_FILL:
+            if(yuv422)
+                get_yellow_fill_from_yuv422(p_inpic, p_output,
+                    Y_PLANE, U_PLANE, V_PLANE);
+            else
+                get_yellow_fill_from_yuv420(p_inpic, p_output,
+                    Y_PLANE, U_PLANE, V_PLANE);
+            break;
+        case STEREOSCOPY_SIDEBYSIDE_LEFT:
+            if(yuv422)
+                get_lefthalf_from_yuv422(p_inpic, p_output,
+                    Y_PLANE, U_PLANE, V_PLANE);
+            else
+                get_lefthalf_from_yuv420(p_inpic, p_output,
+                    Y_PLANE, U_PLANE, V_PLANE);
+            break;
+        case STEREOSCOPY_SIDEBYSIDE_RIGHT:
+            if(yuv422)
+                get_righthalf_from_yuv422(p_inpic, p_output,
+                    Y_PLANE, U_PLANE, V_PLANE);
+            else
+                get_righthalf_from_yuv420(p_inpic, p_output,
+                    Y_PLANE, U_PLANE, V_PLANE);
+            break;
+        case STEREOSCOPY_SIDEBYSIDE_BOTTOM:
+            if(yuv422)
+                get_bottomhalf_from_yuv422(p_inpic, p_output,
+                    Y_PLANE, U_PLANE, V_PLANE);
+            else
+                get_bottomhalf_from_yuv420(p_inpic, p_output,
+                    Y_PLANE, U_PLANE, V_PLANE);
+            break;
+        case STEREOSCOPY_SIDEBYSIDE_TOP:
+            if(yuv422)
+                get_tophalf_from_yuv422(p_inpic, p_output,
+                    Y_PLANE, U_PLANE, V_PLANE);
+            else
+                get_tophalf_from_yuv420(p_inpic, p_output,
+                    Y_PLANE, U_PLANE, V_PLANE);
+            break;
+    }
+
+    picture_CopyProperties( p_output, p_inpic );
+    return p_output;
+}
+
+/*****************************************************************************
+ * Render: displays previously rendered output
+ *****************************************************************************
+ * This function takes a single frame and divides the image up into seperate
+ * eyes, returning two frames.
+ *****************************************************************************/
+static picture_t *Filter( filter_t *p_filter, picture_t *p_inpic )
+{
+    filter_sys_t *p_sys;
+    bool yuv422;
+
+    if( !p_inpic ) return NULL;
+
+    if( (p_filter->fmt_in.video.i_height == 0) ||
+        (p_filter->fmt_in.video.i_width == 0) )
+        return NULL;
+
+    if( (p_filter->fmt_out.video.i_height == 0) ||
+        (p_filter->fmt_out.video.i_width == 0) )
+        return NULL;
+
+    p_sys = p_filter->p_sys;
+
+    /* already a 3d image so do nothing */
+    if( p_sys->i_leftEyeMethod == STEREOSCOPY_2D || p_inpic->i_eye > 0 ||
+        p_sys->i_rightEyeMethod == STEREOSCOPY_2D )
+        return p_inpic;
+    switch( p_inpic->format.i_chroma )
+    {
+        case VLC_CODEC_I420:
+        case VLC_CODEC_J420:
+        case VLC_CODEC_YV12:
+            yuv422 = false;
+            break;
+        case VLC_CODEC_I422:
+        case VLC_CODEC_J422:
+            yuv422 = true;
+            break;
+        default:
+            msg_Warn( p_filter, "Unsupported input chroma (%4.4s)",
+                      (char*)&(p_inpic->format.i_chroma) );
+            picture_Release( p_inpic );
+            return NULL;
+    }
+
+    /* CORRECT METHOD BUT COMMENTED OUT WHILE 'DROPPING PICTURES' ISSUE REMAINS
+
+    picture_t *p_leftOut;
+    picture_t *p_rightOut;
+    p_leftOut = DecodeImageYUV( p_filter, p_inpic, p_sys->i_leftEyeMethod, yuv422);
+    if( !p_leftOut )
+    {
+        msg_Warn( p_filter, "can't get left output picture" );
+        picture_Release( p_inpic );
+        return NULL;
+    }
+
+    p_leftOut->i_eye = 1;
+
+    p_leftOut->p_next = p_rightOut = DecodeImageYUV( p_filter, p_inpic,
+        p_sys->i_rightEyeMethod, yuv422);
+
+    if( !p_rightOut )
+    {
+        msg_Warn( p_filter, "can't get right output picture" );
+        picture_Release( p_leftOut );
+        picture_Release( p_inpic );
+        return NULL;
+    }
+
+    p_rightOut->i_eye = 2;
+
+    picture_Release(p_inpic);
+    return p_leftOut;
+    */
+
+    /* DECODES LEFT AND RIGHT FRAMES ALTERNATIVELY, DROPS A FRAME BUT IS A
+       WORKAROUND UNTIL DROPPING PICTURES IS FIXED */
+
+    if(p_sys->b_leftEyeLast)
+    {
+        p_sys->b_leftEyeLast = false;
+
+        /* do right eye */
+        picture_t *p_rightOut = DecodeImageYUV( p_filter, p_inpic,
+            p_sys->i_rightEyeMethod, yuv422);
+
+        if( !p_rightOut )
+        {
+            msg_Warn( p_filter, "can't get right output picture" );
+            picture_Release( p_inpic );
+            return NULL;
+        }
+
+        p_rightOut->i_eye = 1;
+        picture_Release( p_inpic );
+        return p_rightOut;
+    }
+    else
+    {
+        p_sys->b_leftEyeLast = true;
+
+        /* do left eye */
+        picture_t *p_leftOut = DecodeImageYUV( p_filter, p_inpic,
+            p_sys->i_leftEyeMethod, yuv422);
+
+        if( !p_leftOut )
+        {
+            msg_Warn( p_filter, "can't get left output picture" );
+            picture_Release( p_inpic );
+            return NULL;
+        }
+
+        p_leftOut->i_eye = 2;
+        picture_Release( p_inpic );
+        return p_leftOut;
+    }
+}
+
+/*****************************************************************************
+ * Colour conversion methods. These methods are based on those in extract.c.
+ *****************************************************************************/
+static void get_red_from_yuv420( picture_t *p_inpic, picture_t *p_outpic,
+                                 int yp, int up, int vp )
+{
+    uint8_t *y1in = p_inpic->p[yp].p_pixels;
+    uint8_t *y2in;
+    uint8_t *uin  = p_inpic->p[up].p_pixels;
+    uint8_t *vin  = p_inpic->p[vp].p_pixels;
+
+    uint8_t *y1out = p_outpic->p[yp].p_pixels;
+    uint8_t *y2out;
+    uint8_t *uout  = p_outpic->p[up].p_pixels;
+    uint8_t *vout  = p_outpic->p[vp].p_pixels;
+    int r, g, b;
+
+    const int i_in_pitch  = p_inpic->p[yp].i_pitch;
+    const int i_out_pitch = p_outpic->p[yp].i_pitch;
+
+    const int i_visible_pitch = p_inpic->p[yp].i_visible_pitch;
+    const int i_visible_lines = p_inpic->p[yp].i_visible_lines;
+    const int i_uv_visible_pitch = p_inpic->p[up].i_visible_pitch;
+
+    const uint8_t *yend = y1in + i_visible_lines * i_in_pitch;
+    while( y1in < yend )
+    {
+        const uint8_t *y1end = y1in + i_visible_pitch;
+        y2in  = y1in + i_in_pitch;
+        y2out = y1out + i_out_pitch;
+        while( y1in < y1end )
+        {
+            yuv_to_rgb(&r, &g, &b, *y1in, *uin, *vin);
+            rgb_to_yuv(y1out, uout, vout, r, 0, 0);
+
+            yuv_to_rgb(&r, &g, &b, *y2in, *uin, *vin);
+            rgb_to_yuv(y2out, uout, vout, r, 0, 0);
+            
+            y1in++;
+            y2in++;
+
+            y1out++;
+            y2out++;
+
+            yuv_to_rgb(&r, &g, &b, *y1in, *uin, *vin);
+            rgb_to_yuv(y1out, uout, vout, r, 0, 0);
+
+            yuv_to_rgb(&r, &g, &b, *y2in, *uin, *vin);
+            rgb_to_yuv(y2out, uout, vout, r, 0, 0);
+
+            y1in++;
+            y2in++;
+
+            y1out++;
+            y2out++;
+
+            uin++;
+            vin++;
+            uout++;
+            vout++;
+        }
+        y1in  += 2*i_in_pitch  - i_visible_pitch;
+        y1out += 2*i_out_pitch - i_visible_pitch;
+        uin   += p_inpic->p[up].i_pitch - i_uv_visible_pitch;
+        uout  += p_outpic->p[up].i_pitch - i_uv_visible_pitch;
+        vin   += p_inpic->p[vp].i_pitch  - i_uv_visible_pitch;
+        vout  += p_outpic->p[vp].i_pitch - i_uv_visible_pitch;
+    }
+}
+
+static void get_red_from_yuv422( picture_t *p_inpic, picture_t *p_outpic,
+                                 int yp, int up, int vp )
+{
+    uint8_t *y1in = p_inpic->p[yp].p_pixels;
+    uint8_t *uin  = p_inpic->p[up].p_pixels;
+    uint8_t *vin  = p_inpic->p[vp].p_pixels;
+
+    uint8_t *y1out = p_outpic->p[yp].p_pixels;
+    uint8_t *uout  = p_outpic->p[up].p_pixels;
+    uint8_t *vout  = p_outpic->p[vp].p_pixels;
+    int r, g, b;
+
+    const int i_in_pitch = p_inpic->p[yp].i_pitch;
+    const int i_out_pitch = p_inpic->p[yp].i_pitch;
+
+    const int i_visible_pitch = p_inpic->p[yp].i_visible_pitch;
+    const int i_visible_lines = p_inpic->p[yp].i_visible_lines;
+    const int i_uv_visible_pitch = p_inpic->p[up].i_visible_pitch;
+
+    const uint8_t *yend = y1in + i_visible_lines * i_in_pitch;
+    while( y1in < yend )
+    {
+        const uint8_t *y1end = y1in + i_visible_pitch;
+        while( y1in < y1end )
+        {
+            yuv_to_rgb(&r, &g, &b, *y1in, *uin, *vin);
+            rgb_to_yuv(y1out, uout, vout, r, 0, 0);
+
+            y1in++;
+            y1out++;
+
+            yuv_to_rgb(&r, &g, &b, *y1in, *uin, *vin);
+            rgb_to_yuv(y1out, uout, vout, r, 0, 0);
+
+            y1in++;
+            y1out++;
+
+            uin++;
+            vin++;
+
+            uout++;
+            vout++;
+        }
+        y1in  += i_in_pitch  - i_visible_pitch;
+        y1out += i_out_pitch - i_visible_pitch;
+        uin   += p_inpic->p[up].i_pitch - i_uv_visible_pitch;
+        uout  += p_outpic->p[up].i_pitch - i_uv_visible_pitch;
+        vin   += p_inpic->p[vp].i_pitch  - i_uv_visible_pitch;
+        vout  += p_outpic->p[vp].i_pitch - i_uv_visible_pitch;
+    }
+}
+
+static void get_cyan_from_yuv420( picture_t *p_inpic, picture_t *p_outpic,
+                                 int yp, int up, int vp )
+{
+    uint8_t *y1in = p_inpic->p[yp].p_pixels;
+    uint8_t *y2in;
+    uint8_t *uin  = p_inpic->p[up].p_pixels;
+    uint8_t *vin  = p_inpic->p[vp].p_pixels;
+
+    uint8_t *y1out = p_outpic->p[yp].p_pixels;
+    uint8_t *y2out;
+    uint8_t *uout  = p_outpic->p[up].p_pixels;
+    uint8_t *vout  = p_outpic->p[vp].p_pixels;
+    int r, g, b;
+
+    const int i_in_pitch  = p_inpic->p[yp].i_pitch;
+    const int i_out_pitch = p_outpic->p[yp].i_pitch;
+
+    const int i_visible_pitch = p_inpic->p[yp].i_visible_pitch;
+    const int i_visible_lines = p_inpic->p[yp].i_visible_lines;
+    const int i_uv_visible_pitch = p_inpic->p[up].i_visible_pitch;
+
+    const uint8_t *yend = y1in + i_visible_lines * i_in_pitch;
+    while( y1in < yend )
+    {
+        const uint8_t *y1end = y1in + i_visible_pitch;
+        y2in  = y1in + i_in_pitch;
+        y2out = y1out + i_out_pitch;
+        while( y1in < y1end )
+        {
+            yuv_to_rgb(&r, &g, &b, *y1in, *uin, *vin);
+            rgb_to_yuv(y1out, uout, vout, 0, g, b);
+
+            yuv_to_rgb(&r, &g, &b, *y2in, *uin, *vin);
+            rgb_to_yuv(y2out, uout, vout, 0, g, b);
+            
+            y1in++;
+            y2in++;
+
+            y1out++;
+            y2out++;
+
+            yuv_to_rgb(&r, &g, &b, *y1in, *uin, *vin);
+            rgb_to_yuv(y1out, uout, vout, 0, g, b);
+
+            yuv_to_rgb(&r, &g, &b, *y2in, *uin, *vin);
+            rgb_to_yuv(y2out, uout, vout, 0, g, b);
+
+            y1in++;
+            y2in++;
+
+            y1out++;
+            y2out++;
+
+            uin++;
+            vin++;
+            uout++;
+            vout++;
+        }
+        y1in  += 2*i_in_pitch  - i_visible_pitch;
+        y1out += 2*i_out_pitch - i_visible_pitch;
+        uin   += p_inpic->p[up].i_pitch - i_uv_visible_pitch;
+        uout  += p_outpic->p[up].i_pitch - i_uv_visible_pitch;
+        vin   += p_inpic->p[vp].i_pitch  - i_uv_visible_pitch;
+        vout  += p_outpic->p[vp].i_pitch - i_uv_visible_pitch;
+    }
+}
+
+static void get_cyan_from_yuv422( picture_t *p_inpic, picture_t *p_outpic,
+                                 int yp, int up, int vp )
+{
+    uint8_t *y1in = p_inpic->p[yp].p_pixels;
+    uint8_t *uin  = p_inpic->p[up].p_pixels;
+    uint8_t *vin  = p_inpic->p[vp].p_pixels;
+
+    uint8_t *y1out = p_outpic->p[yp].p_pixels;
+    uint8_t *uout  = p_outpic->p[up].p_pixels;
+    uint8_t *vout  = p_outpic->p[vp].p_pixels;
+    int r, g, b;
+
+    const int i_in_pitch = p_inpic->p[yp].i_pitch;
+    const int i_out_pitch = p_inpic->p[yp].i_pitch;
+
+    const int i_visible_pitch = p_inpic->p[yp].i_visible_pitch;
+    const int i_visible_lines = p_inpic->p[yp].i_visible_lines;
+    const int i_uv_visible_pitch = p_inpic->p[up].i_visible_pitch;
+
+    const uint8_t *yend = y1in + i_visible_lines * i_in_pitch;
+    while( y1in < yend )
+    {
+        const uint8_t *y1end = y1in + i_visible_pitch;
+        while( y1in < y1end )
+        {
+            yuv_to_rgb(&r, &g, &b, *y1in, *uin, *vin);
+            rgb_to_yuv(y1out, uout, vout, 0, g, b);
+
+            y1in++;
+            y1out++;
+
+            yuv_to_rgb(&r, &g, &b, *y1in, *uin, *vin);
+            rgb_to_yuv(y1out, uout, vout, 0, g, b);
+
+            y1in++;
+            y1out++;
+
+            uin++;
+            vin++;
+
+            uout++;
+            vout++;
+        }
+        y1in  += i_in_pitch  - i_visible_pitch;
+        y1out += i_out_pitch - i_visible_pitch;
+        uin   += p_inpic->p[up].i_pitch - i_uv_visible_pitch;
+        uout  += p_outpic->p[up].i_pitch - i_uv_visible_pitch;
+        vin   += p_inpic->p[vp].i_pitch  - i_uv_visible_pitch;
+        vout  += p_outpic->p[vp].i_pitch - i_uv_visible_pitch;
+    }
+}
+
+static void get_green_from_yuv420( picture_t *p_inpic, picture_t *p_outpic,
+                                 int yp, int up, int vp )
+{
+    uint8_t *y1in = p_inpic->p[yp].p_pixels;
+    uint8_t *y2in;
+    uint8_t *uin  = p_inpic->p[up].p_pixels;
+    uint8_t *vin  = p_inpic->p[vp].p_pixels;
+
+    uint8_t *y1out = p_outpic->p[yp].p_pixels;
+    uint8_t *y2out;
+    uint8_t *uout  = p_outpic->p[up].p_pixels;
+    uint8_t *vout  = p_outpic->p[vp].p_pixels;
+    int r, g, b;
+
+    const int i_in_pitch  = p_inpic->p[yp].i_pitch;
+    const int i_out_pitch = p_outpic->p[yp].i_pitch;
+
+    const int i_visible_pitch = p_inpic->p[yp].i_visible_pitch;
+    const int i_visible_lines = p_inpic->p[yp].i_visible_lines;
+    const int i_uv_visible_pitch = p_inpic->p[up].i_visible_pitch;
+
+    const uint8_t *yend = y1in + i_visible_lines * i_in_pitch;
+    while( y1in < yend )
+    {
+        const uint8_t *y1end = y1in + i_visible_pitch;
+        y2in  = y1in + i_in_pitch;
+        y2out = y1out + i_out_pitch;
+        while( y1in < y1end )
+        {
+            yuv_to_rgb(&r, &g, &b, *y1in, *uin, *vin);
+            rgb_to_yuv(y1out, uout, vout, 0, g, 0);
+
+            yuv_to_rgb(&r, &g, &b, *y2in, *uin, *vin);
+            rgb_to_yuv(y2out, uout, vout, 0, g, 0);
+            
+            y1in++;
+            y2in++;
+
+            y1out++;
+            y2out++;
+
+            yuv_to_rgb(&r, &g, &b, *y1in, *uin, *vin);
+            rgb_to_yuv(y1out, uout, vout, 0, g, 0);
+
+            yuv_to_rgb(&r, &g, &b, *y2in, *uin, *vin);
+            rgb_to_yuv(y2out, uout, vout, 0, g, 0);
+
+            y1in++;
+            y2in++;
+
+            y1out++;
+            y2out++;
+
+            uin++;
+            vin++;
+            uout++;
+            vout++;
+        }
+        y1in  += 2*i_in_pitch  - i_visible_pitch;
+        y1out += 2*i_out_pitch - i_visible_pitch;
+        uin   += p_inpic->p[up].i_pitch - i_uv_visible_pitch;
+        uout  += p_outpic->p[up].i_pitch - i_uv_visible_pitch;
+        vin   += p_inpic->p[vp].i_pitch  - i_uv_visible_pitch;
+        vout  += p_outpic->p[vp].i_pitch - i_uv_visible_pitch;
+    }
+}
+
+static void get_green_from_yuv422( picture_t *p_inpic, picture_t *p_outpic,
+                                   int yp, int up, int vp )
+{
+    uint8_t *y1in = p_inpic->p[yp].p_pixels;
+    uint8_t *uin  = p_inpic->p[up].p_pixels;
+    uint8_t *vin  = p_inpic->p[vp].p_pixels;
+
+    uint8_t *y1out = p_outpic->p[yp].p_pixels;
+    uint8_t *uout  = p_outpic->p[up].p_pixels;
+    uint8_t *vout  = p_outpic->p[vp].p_pixels;
+    int r, g, b;
+
+    const int i_in_pitch = p_inpic->p[yp].i_pitch;
+    const int i_out_pitch = p_inpic->p[yp].i_pitch;
+
+    const int i_visible_pitch = p_inpic->p[yp].i_visible_pitch;
+    const int i_visible_lines = p_inpic->p[yp].i_visible_lines;
+    const int i_uv_visible_pitch = p_inpic->p[up].i_visible_pitch;
+
+    const uint8_t *yend = y1in + i_visible_lines * i_in_pitch;
+    while( y1in < yend )
+    {
+        const uint8_t *y1end = y1in + i_visible_pitch;
+        while( y1in < y1end )
+        {
+            yuv_to_rgb(&r, &g, &b, *y1in, *uin, *vin);
+            rgb_to_yuv(y1out, uout, vout, 0, g, 0);
+
+            y1in++;
+            y1out++;
+
+            yuv_to_rgb(&r, &g, &b, *y1in, *uin, *vin);
+            rgb_to_yuv(y1out, uout, vout, 0, g, 0);
+
+            y1in++;
+            y1out++;
+
+            uin++;
+            vin++;
+
+            uout++;
+            vout++;
+        }
+        y1in  += i_in_pitch  - i_visible_pitch;
+        y1out += i_out_pitch - i_visible_pitch;
+        uin   += p_inpic->p[up].i_pitch - i_uv_visible_pitch;
+        uout  += p_outpic->p[up].i_pitch - i_uv_visible_pitch;
+        vin   += p_inpic->p[vp].i_pitch  - i_uv_visible_pitch;
+        vout  += p_outpic->p[vp].i_pitch - i_uv_visible_pitch;
+    }
+}
+
+static void get_magenta_from_yuv420( picture_t *p_inpic, picture_t *p_outpic,
+                                 int yp, int up, int vp )
+{
+    uint8_t *y1in = p_inpic->p[yp].p_pixels;
+    uint8_t *y2in;
+    uint8_t *uin  = p_inpic->p[up].p_pixels;
+    uint8_t *vin  = p_inpic->p[vp].p_pixels;
+
+    uint8_t *y1out = p_outpic->p[yp].p_pixels;
+    uint8_t *y2out;
+    uint8_t *uout  = p_outpic->p[up].p_pixels;
+    uint8_t *vout  = p_outpic->p[vp].p_pixels;
+    int r, g, b;
+
+    const int i_in_pitch  = p_inpic->p[yp].i_pitch;
+    const int i_out_pitch = p_outpic->p[yp].i_pitch;
+
+    const int i_visible_pitch = p_inpic->p[yp].i_visible_pitch;
+    const int i_visible_lines = p_inpic->p[yp].i_visible_lines;
+    const int i_uv_visible_pitch = p_inpic->p[up].i_visible_pitch;
+
+    const uint8_t *yend = y1in + i_visible_lines * i_in_pitch;
+    while( y1in < yend )
+    {
+        const uint8_t *y1end = y1in + i_visible_pitch;
+        y2in  = y1in + i_in_pitch;
+        y2out = y1out + i_out_pitch;
+        while( y1in < y1end )
+        {
+            yuv_to_rgb(&r, &g, &b, *y1in, *uin, *vin);
+            rgb_to_yuv(y1out, uout, vout, r, 0, b);
+
+            yuv_to_rgb(&r, &g, &b, *y2in, *uin, *vin);
+            rgb_to_yuv(y2out, uout, vout, r, 0, b);
+            
+            y1in++;
+            y2in++;
+
+            y1out++;
+            y2out++;
+
+            yuv_to_rgb(&r, &g, &b, *y1in, *uin, *vin);
+            rgb_to_yuv(y1out, uout, vout, r, 0, b);
+
+            yuv_to_rgb(&r, &g, &b, *y2in, *uin, *vin);
+            rgb_to_yuv(y2out, uout, vout, r, 0, b);
+
+            y1in++;
+            y2in++;
+
+            y1out++;
+            y2out++;
+
+            uin++;
+            vin++;
+            uout++;
+            vout++;
+        }
+        y1in  += 2*i_in_pitch  - i_visible_pitch;
+        y1out += 2*i_out_pitch - i_visible_pitch;
+        uin   += p_inpic->p[up].i_pitch - i_uv_visible_pitch;
+        uout  += p_outpic->p[up].i_pitch - i_uv_visible_pitch;
+        vin   += p_inpic->p[vp].i_pitch  - i_uv_visible_pitch;
+        vout  += p_outpic->p[vp].i_pitch - i_uv_visible_pitch;
+    }
+}
+
+static void get_magenta_from_yuv422( picture_t *p_inpic, picture_t *p_outpic,
+                                 int yp, int up, int vp )
+{
+    uint8_t *y1in = p_inpic->p[yp].p_pixels;
+    uint8_t *uin  = p_inpic->p[up].p_pixels;
+    uint8_t *vin  = p_inpic->p[vp].p_pixels;
+
+    uint8_t *y1out = p_outpic->p[yp].p_pixels;
+    uint8_t *uout  = p_outpic->p[up].p_pixels;
+    uint8_t *vout  = p_outpic->p[vp].p_pixels;
+    int r, g, b;
+
+    const int i_in_pitch = p_inpic->p[yp].i_pitch;
+    const int i_out_pitch = p_inpic->p[yp].i_pitch;
+
+    const int i_visible_pitch = p_inpic->p[yp].i_visible_pitch;
+    const int i_visible_lines = p_inpic->p[yp].i_visible_lines;
+    const int i_uv_visible_pitch = p_inpic->p[up].i_visible_pitch;
+
+    const uint8_t *yend = y1in + i_visible_lines * i_in_pitch;
+    while( y1in < yend )
+    {
+        const uint8_t *y1end = y1in + i_visible_pitch;
+        while( y1in < y1end )
+        {
+            yuv_to_rgb(&r, &g, &b, *y1in, *uin, *vin);
+            rgb_to_yuv(y1out, uout, vout, r, 0, b);
+
+            y1in++;
+            y1out++;
+
+            yuv_to_rgb(&r, &g, &b, *y1in, *uin, *vin);
+            rgb_to_yuv(y1out, uout, vout, r, 0, b);
+
+            y1in++;
+            y1out++;
+
+            uin++;
+            vin++;
+
+            uout++;
+            vout++;
+        }
+        y1in  += i_in_pitch  - i_visible_pitch;
+        y1out += i_out_pitch - i_visible_pitch;
+        uin   += p_inpic->p[up].i_pitch - i_uv_visible_pitch;
+        uout  += p_outpic->p[up].i_pitch - i_uv_visible_pitch;
+        vin   += p_inpic->p[vp].i_pitch  - i_uv_visible_pitch;
+        vout  += p_outpic->p[vp].i_pitch - i_uv_visible_pitch;
+    }
+}
+
+static void get_blue_from_yuv420( picture_t *p_inpic, picture_t *p_outpic,
+                                 int yp, int up, int vp )
+{
+    uint8_t *y1in = p_inpic->p[yp].p_pixels;
+    uint8_t *y2in;
+    uint8_t *uin  = p_inpic->p[up].p_pixels;
+    uint8_t *vin  = p_inpic->p[vp].p_pixels;
+
+    uint8_t *y1out = p_outpic->p[yp].p_pixels;
+    uint8_t *y2out;
+    uint8_t *uout  = p_outpic->p[up].p_pixels;
+    uint8_t *vout  = p_outpic->p[vp].p_pixels;
+    int r, g, b;
+
+    const int i_in_pitch  = p_inpic->p[yp].i_pitch;
+    const int i_out_pitch = p_outpic->p[yp].i_pitch;
+
+    const int i_visible_pitch = p_inpic->p[yp].i_visible_pitch;
+    const int i_visible_lines = p_inpic->p[yp].i_visible_lines;
+    const int i_uv_visible_pitch = p_inpic->p[up].i_visible_pitch;
+
+    const uint8_t *yend = y1in + i_visible_lines * i_in_pitch;
+    while( y1in < yend )
+    {
+        const uint8_t *y1end = y1in + i_visible_pitch;
+        y2in  = y1in + i_in_pitch;
+        y2out = y1out + i_out_pitch;
+        while( y1in < y1end )
+        {
+            yuv_to_rgb(&r, &g, &b, *y1in, *uin, *vin);
+            rgb_to_yuv(y1out, uout, vout, 0, 0, b);
+
+            yuv_to_rgb(&r, &g, &b, *y2in, *uin, *vin);
+            rgb_to_yuv(y2out, uout, vout, 0, 0, b);
+            
+            y1in++;
+            y2in++;
+
+            y1out++;
+            y2out++;
+
+            yuv_to_rgb(&r, &g, &b, *y1in, *uin, *vin);
+            rgb_to_yuv(y1out, uout, vout, 0, 0, b);
+
+            yuv_to_rgb(&r, &g, &b, *y2in, *uin, *vin);
+            rgb_to_yuv(y2out, uout, vout, 0, 0, b);
+
+            y1in++;
+            y2in++;
+
+            y1out++;
+            y2out++;
+
+            uin++;
+            vin++;
+            uout++;
+            vout++;
+        }
+        y1in  += 2*i_in_pitch  - i_visible_pitch;
+        y1out += 2*i_out_pitch - i_visible_pitch;
+        uin   += p_inpic->p[up].i_pitch - i_uv_visible_pitch;
+        uout  += p_outpic->p[up].i_pitch - i_uv_visible_pitch;
+        vin   += p_inpic->p[vp].i_pitch  - i_uv_visible_pitch;
+        vout  += p_outpic->p[vp].i_pitch - i_uv_visible_pitch;
+    }
+}
+
+static void get_blue_from_yuv422( picture_t *p_inpic, picture_t *p_outpic,
+                                 int yp, int up, int vp )
+{
+    uint8_t *y1in = p_inpic->p[yp].p_pixels;
+    uint8_t *uin  = p_inpic->p[up].p_pixels;
+    uint8_t *vin  = p_inpic->p[vp].p_pixels;
+
+    uint8_t *y1out = p_outpic->p[yp].p_pixels;
+    uint8_t *uout  = p_outpic->p[up].p_pixels;
+    uint8_t *vout  = p_outpic->p[vp].p_pixels;
+    int r, g, b;
+
+    const int i_in_pitch = p_inpic->p[yp].i_pitch;
+    const int i_out_pitch = p_inpic->p[yp].i_pitch;
+
+    const int i_visible_pitch = p_inpic->p[yp].i_visible_pitch;
+    const int i_visible_lines = p_inpic->p[yp].i_visible_lines;
+    const int i_uv_visible_pitch = p_inpic->p[up].i_visible_pitch;
+
+    const uint8_t *yend = y1in + i_visible_lines * i_in_pitch;
+    while( y1in < yend )
+    {
+        const uint8_t *y1end = y1in + i_visible_pitch;
+        while( y1in < y1end )
+        {
+            yuv_to_rgb(&r, &g, &b, *y1in, *uin, *vin);
+            rgb_to_yuv(y1out, uout, vout, 0, 0, b);
+
+            y1in++;
+            y1out++;
+
+            yuv_to_rgb(&r, &g, &b, *y1in, *uin, *vin);
+            rgb_to_yuv(y1out, uout, vout, 0, 0, b);
+
+            y1in++;
+            y1out++;
+
+            uin++;
+            vin++;
+
+            uout++;
+            vout++;
+        }
+        y1in  += i_in_pitch  - i_visible_pitch;
+        y1out += i_out_pitch - i_visible_pitch;
+        uin   += p_inpic->p[up].i_pitch - i_uv_visible_pitch;
+        uout  += p_outpic->p[up].i_pitch - i_uv_visible_pitch;
+        vin   += p_inpic->p[vp].i_pitch  - i_uv_visible_pitch;
+        vout  += p_outpic->p[vp].i_pitch - i_uv_visible_pitch;
+    }
+}
+
+static void get_yellow_from_yuv420( picture_t *p_inpic, picture_t *p_outpic,
+                                 int yp, int up, int vp )
+{
+    uint8_t *y1in = p_inpic->p[yp].p_pixels;
+    uint8_t *y2in;
+    uint8_t *uin  = p_inpic->p[up].p_pixels;
+    uint8_t *vin  = p_inpic->p[vp].p_pixels;
+
+    uint8_t *y1out = p_outpic->p[yp].p_pixels;
+    uint8_t *y2out;
+    uint8_t *uout  = p_outpic->p[up].p_pixels;
+    uint8_t *vout  = p_outpic->p[vp].p_pixels;
+    int r, g, b;
+
+    const int i_in_pitch  = p_inpic->p[yp].i_pitch;
+    const int i_out_pitch = p_outpic->p[yp].i_pitch;
+
+    const int i_visible_pitch = p_inpic->p[yp].i_visible_pitch;
+    const int i_visible_lines = p_inpic->p[yp].i_visible_lines;
+    const int i_uv_visible_pitch = p_inpic->p[up].i_visible_pitch;
+
+    const uint8_t *yend = y1in + i_visible_lines * i_in_pitch;
+    while( y1in < yend )
+    {
+        const uint8_t *y1end = y1in + i_visible_pitch;
+        y2in  = y1in + i_in_pitch;
+        y2out = y1out + i_out_pitch;
+        while( y1in < y1end )
+        {
+            yuv_to_rgb(&r, &g, &b, *y1in, *uin, *vin);
+            rgb_to_yuv(y1out, uout, vout, r, g, 0);
+
+            yuv_to_rgb(&r, &g, &b, *y2in, *uin, *vin);
+            rgb_to_yuv(y2out, uout, vout, r, g, 0);
+            
+            y1in++;
+            y2in++;
+
+            y1out++;
+            y2out++;
+
+            yuv_to_rgb(&r, &g, &b, *y1in, *uin, *vin);
+            rgb_to_yuv(y1out, uout, vout, r, g, 0);
+
+            yuv_to_rgb(&r, &g, &b, *y2in, *uin, *vin);
+            rgb_to_yuv(y2out, uout, vout, r, g, 0);
+
+            y1in++;
+            y2in++;
+
+            y1out++;
+            y2out++;
+
+            uin++;
+            vin++;
+            uout++;
+            vout++;
+        }
+        y1in  += 2*i_in_pitch  - i_visible_pitch;
+        y1out += 2*i_out_pitch - i_visible_pitch;
+        uin   += p_inpic->p[up].i_pitch - i_uv_visible_pitch;
+        uout  += p_outpic->p[up].i_pitch - i_uv_visible_pitch;
+        vin   += p_inpic->p[vp].i_pitch  - i_uv_visible_pitch;
+        vout  += p_outpic->p[vp].i_pitch - i_uv_visible_pitch;
+    }
+}
+
+static void get_yellow_from_yuv422( picture_t *p_inpic, picture_t *p_outpic,
+                                 int yp, int up, int vp )
+{
+    uint8_t *y1in = p_inpic->p[yp].p_pixels;
+    uint8_t *uin  = p_inpic->p[up].p_pixels;
+    uint8_t *vin  = p_inpic->p[vp].p_pixels;
+
+    uint8_t *y1out = p_outpic->p[yp].p_pixels;
+    uint8_t *uout  = p_outpic->p[up].p_pixels;
+    uint8_t *vout  = p_outpic->p[vp].p_pixels;
+    int r, g, b;
+
+    const int i_in_pitch = p_inpic->p[yp].i_pitch;
+    const int i_out_pitch = p_inpic->p[yp].i_pitch;
+
+    const int i_visible_pitch = p_inpic->p[yp].i_visible_pitch;
+    const int i_visible_lines = p_inpic->p[yp].i_visible_lines;
+    const int i_uv_visible_pitch = p_inpic->p[up].i_visible_pitch;
+
+    const uint8_t *yend = y1in + i_visible_lines * i_in_pitch;
+    while( y1in < yend )
+    {
+        const uint8_t *y1end = y1in + i_visible_pitch;
+        while( y1in < y1end )
+        {
+            yuv_to_rgb(&r, &g, &b, *y1in, *uin, *vin);
+            rgb_to_yuv(y1out, uout, vout, r, g, 0);
+
+            y1in++;
+            y1out++;
+
+            yuv_to_rgb(&r, &g, &b, *y1in, *uin, *vin);
+            rgb_to_yuv(y1out, uout, vout, r, g, 0);
+
+            y1in++;
+            y1out++;
+
+            uin++;
+            vin++;
+
+            uout++;
+            vout++;
+        }
+        y1in  += i_in_pitch  - i_visible_pitch;
+        y1out += i_out_pitch - i_visible_pitch;
+        uin   += p_inpic->p[up].i_pitch - i_uv_visible_pitch;
+        uout  += p_outpic->p[up].i_pitch - i_uv_visible_pitch;
+        vin   += p_inpic->p[vp].i_pitch  - i_uv_visible_pitch;
+        vout  += p_outpic->p[vp].i_pitch - i_uv_visible_pitch;
+    }
+}
+
+/****** grayscale variations ******/
+static void get_red_grayscale_from_yuv420( picture_t *p_inpic, picture_t *p_outpic,
+                                 int yp, int up, int vp )
+{
+    uint8_t *y1in = p_inpic->p[yp].p_pixels;
+    uint8_t *y2in;
+    uint8_t *uin  = p_inpic->p[up].p_pixels;
+    uint8_t *vin  = p_inpic->p[vp].p_pixels;
+
+    uint8_t *y1out = p_outpic->p[yp].p_pixels;
+    uint8_t *y2out;
+    uint8_t *uout  = p_outpic->p[up].p_pixels;
+    uint8_t *vout  = p_outpic->p[vp].p_pixels;
+    int r, g, b;
+
+    const int i_in_pitch  = p_inpic->p[yp].i_pitch;
+    const int i_out_pitch = p_outpic->p[yp].i_pitch;
+
+    const int i_visible_pitch = p_inpic->p[yp].i_visible_pitch;
+    const int i_visible_lines = p_inpic->p[yp].i_visible_lines;
+    const int i_uv_visible_pitch = p_inpic->p[up].i_visible_pitch;
+
+    const uint8_t *yend = y1in + i_visible_lines * i_in_pitch;
+    while( y1in < yend )
+    {
+        const uint8_t *y1end = y1in + i_visible_pitch;
+        y2in  = y1in + i_in_pitch;
+        y2out = y1out + i_out_pitch;
+        while( y1in < y1end )
+        {
+            yuv_to_rgb(&r, &g, &b, *y1in, *uin, *vin);
+            rgb_to_yuv(y1out, uout, vout, r, r, r);
+
+            yuv_to_rgb(&r, &g, &b, *y2in, *uin, *vin);
+            rgb_to_yuv(y2out, uout, vout, r, r, r);
+            
+            y1in++;
+            y2in++;
+
+            y1out++;
+            y2out++;
+
+            yuv_to_rgb(&r, &g, &b, *y1in, *uin, *vin);
+            rgb_to_yuv(y1out, uout, vout, r, r, r);
+
+            yuv_to_rgb(&r, &g, &b, *y2in, *uin, *vin);
+            rgb_to_yuv(y2out, uout, vout, r, r, r);
+
+            y1in++;
+            y2in++;
+
+            y1out++;
+            y2out++;
+
+            uin++;
+            vin++;
+            uout++;
+            vout++;
+        }
+        y1in  += 2*i_in_pitch  - i_visible_pitch;
+        y1out += 2*i_out_pitch - i_visible_pitch;
+        uin   += p_inpic->p[up].i_pitch - i_uv_visible_pitch;
+        uout  += p_outpic->p[up].i_pitch - i_uv_visible_pitch;
+        vin   += p_inpic->p[vp].i_pitch  - i_uv_visible_pitch;
+        vout  += p_outpic->p[vp].i_pitch - i_uv_visible_pitch;
+    }
+}
+
+static void get_red_grayscale_from_yuv422( picture_t *p_inpic, picture_t *p_outpic,
+                                 int yp, int up, int vp )
+{
+    uint8_t *y1in = p_inpic->p[yp].p_pixels;
+    uint8_t *uin  = p_inpic->p[up].p_pixels;
+    uint8_t *vin  = p_inpic->p[vp].p_pixels;
+
+    uint8_t *y1out = p_outpic->p[yp].p_pixels;
+    uint8_t *uout  = p_outpic->p[up].p_pixels;
+    uint8_t *vout  = p_outpic->p[vp].p_pixels;
+    int r, g, b;
+
+    const int i_in_pitch = p_inpic->p[yp].i_pitch;
+    const int i_out_pitch = p_inpic->p[yp].i_pitch;
+
+    const int i_visible_pitch = p_inpic->p[yp].i_visible_pitch;
+    const int i_visible_lines = p_inpic->p[yp].i_visible_lines;
+    const int i_uv_visible_pitch = p_inpic->p[up].i_visible_pitch;
+
+    const uint8_t *yend = y1in + i_visible_lines * i_in_pitch;
+    while( y1in < yend )
+    {
+        const uint8_t *y1end = y1in + i_visible_pitch;
+        while( y1in < y1end )
+        {
+            yuv_to_rgb(&r, &g, &b, *y1in, *uin, *vin);
+            rgb_to_yuv(y1out, uout, vout, r, r, r);
+
+            y1in++;
+            y1out++;
+
+            yuv_to_rgb(&r, &g, &b, *y1in, *uin, *vin);
+            rgb_to_yuv(y1out, uout, vout, r, r, r);
+
+            y1in++;
+            y1out++;
+
+            uin++;
+            vin++;
+
+            uout++;
+            vout++;
+        }
+        y1in  += i_in_pitch  - i_visible_pitch;
+        y1out += i_out_pitch - i_visible_pitch;
+        uin   += p_inpic->p[up].i_pitch - i_uv_visible_pitch;
+        uout  += p_outpic->p[up].i_pitch - i_uv_visible_pitch;
+        vin   += p_inpic->p[vp].i_pitch  - i_uv_visible_pitch;
+        vout  += p_outpic->p[vp].i_pitch - i_uv_visible_pitch;
+    }
+}
+
+static void get_cyan_grayscale_from_yuv420( picture_t *p_inpic, picture_t *p_outpic,
+                                 int yp, int up, int vp )
+{
+    uint8_t *y1in = p_inpic->p[yp].p_pixels;
+    uint8_t *y2in;
+    uint8_t *uin  = p_inpic->p[up].p_pixels;
+    uint8_t *vin  = p_inpic->p[vp].p_pixels;
+
+    uint8_t *y1out = p_outpic->p[yp].p_pixels;
+    uint8_t *y2out;
+    uint8_t *uout  = p_outpic->p[up].p_pixels;
+    uint8_t *vout  = p_outpic->p[vp].p_pixels;
+    int r, g, b;
+
+    const int i_in_pitch  = p_inpic->p[yp].i_pitch;
+    const int i_out_pitch = p_outpic->p[yp].i_pitch;
+
+    const int i_visible_pitch = p_inpic->p[yp].i_visible_pitch;
+    const int i_visible_lines = p_inpic->p[yp].i_visible_lines;
+    const int i_uv_visible_pitch = p_inpic->p[up].i_visible_pitch;
+
+    const uint8_t *yend = y1in + i_visible_lines * i_in_pitch;
+    int avg;
+    while( y1in < yend )
+    {
+        const uint8_t *y1end = y1in + i_visible_pitch;
+        y2in  = y1in + i_in_pitch;
+        y2out = y1out + i_out_pitch;
+        while( y1in < y1end )
+        {
+            yuv_to_rgb(&r, &g, &b, *y1in, *uin, *vin);
+            avg = (g + b) / 2;
+            rgb_to_yuv(y1out, uout, vout, avg, avg, avg);
+
+            yuv_to_rgb(&r, &g, &b, *y2in, *uin, *vin);
+            avg = (g + b) / 2;
+            rgb_to_yuv(y2out, uout, vout, avg, avg, avg);
+            
+            y1in++;
+            y2in++;
+
+            y1out++;
+            y2out++;
+
+            yuv_to_rgb(&r, &g, &b, *y1in, *uin, *vin);
+            avg = (g + b) / 2;
+            rgb_to_yuv(y1out, uout, vout, avg, avg, avg);
+
+            yuv_to_rgb(&r, &g, &b, *y2in, *uin, *vin);
+            avg = (g + b) / 2;
+            rgb_to_yuv(y2out, uout, vout, avg, avg, avg);
+
+            y1in++;
+            y2in++;
+
+            y1out++;
+            y2out++;
+
+            uin++;
+            vin++;
+            uout++;
+            vout++;
+        }
+        y1in  += 2*i_in_pitch  - i_visible_pitch;
+        y1out += 2*i_out_pitch - i_visible_pitch;
+        uin   += p_inpic->p[up].i_pitch - i_uv_visible_pitch;
+        uout  += p_outpic->p[up].i_pitch - i_uv_visible_pitch;
+        vin   += p_inpic->p[vp].i_pitch  - i_uv_visible_pitch;
+        vout  += p_outpic->p[vp].i_pitch - i_uv_visible_pitch;
+    }
+}
+
+static void get_cyan_grayscale_from_yuv422( picture_t *p_inpic, picture_t *p_outpic,
+                                 int yp, int up, int vp )
+{
+    uint8_t *y1in = p_inpic->p[yp].p_pixels;
+    uint8_t *uin  = p_inpic->p[up].p_pixels;
+    uint8_t *vin  = p_inpic->p[vp].p_pixels;
+
+    uint8_t *y1out = p_outpic->p[yp].p_pixels;
+    uint8_t *uout  = p_outpic->p[up].p_pixels;
+    uint8_t *vout  = p_outpic->p[vp].p_pixels;
+    int r, g, b;
+
+    const int i_in_pitch = p_inpic->p[yp].i_pitch;
+    const int i_out_pitch = p_inpic->p[yp].i_pitch;
+
+    const int i_visible_pitch = p_inpic->p[yp].i_visible_pitch;
+    const int i_visible_lines = p_inpic->p[yp].i_visible_lines;
+    const int i_uv_visible_pitch = p_inpic->p[up].i_visible_pitch;
+
+    const uint8_t *yend = y1in + i_visible_lines * i_in_pitch;
+    int avg;
+    while( y1in < yend )
+    {
+        const uint8_t *y1end = y1in + i_visible_pitch;
+        while( y1in < y1end )
+        {
+            yuv_to_rgb(&r, &g, &b, *y1in, *uin, *vin);
+            avg = (g + b) / 2;
+            rgb_to_yuv(y1out, uout, vout, avg, avg, avg);
+
+            y1in++;
+            y1out++;
+
+            yuv_to_rgb(&r, &g, &b, *y1in, *uin, *vin);
+            avg = (g + b) / 2;
+            rgb_to_yuv(y1out, uout, vout, avg, avg, avg);
+
+            y1in++;
+            y1out++;
+
+            uin++;
+            vin++;
+
+            uout++;
+            vout++;
+        }
+        y1in  += i_in_pitch  - i_visible_pitch;
+        y1out += i_out_pitch - i_visible_pitch;
+        uin   += p_inpic->p[up].i_pitch - i_uv_visible_pitch;
+        uout  += p_outpic->p[up].i_pitch - i_uv_visible_pitch;
+        vin   += p_inpic->p[vp].i_pitch  - i_uv_visible_pitch;
+        vout  += p_outpic->p[vp].i_pitch - i_uv_visible_pitch;
+    }
+}
+
+static void get_green_grayscale_from_yuv420( picture_t *p_inpic, picture_t *p_outpic,
+                                 int yp, int up, int vp )
+{
+    uint8_t *y1in = p_inpic->p[yp].p_pixels;
+    uint8_t *y2in;
+    uint8_t *uin  = p_inpic->p[up].p_pixels;
+    uint8_t *vin  = p_inpic->p[vp].p_pixels;
+
+    uint8_t *y1out = p_outpic->p[yp].p_pixels;
+    uint8_t *y2out;
+    uint8_t *uout  = p_outpic->p[up].p_pixels;
+    uint8_t *vout  = p_outpic->p[vp].p_pixels;
+    int r, g, b;
+
+    const int i_in_pitch  = p_inpic->p[yp].i_pitch;
+    const int i_out_pitch = p_outpic->p[yp].i_pitch;
+
+    const int i_visible_pitch = p_inpic->p[yp].i_visible_pitch;
+    const int i_visible_lines = p_inpic->p[yp].i_visible_lines;
+    const int i_uv_visible_pitch = p_inpic->p[up].i_visible_pitch;
+
+    const uint8_t *yend = y1in + i_visible_lines * i_in_pitch;
+    while( y1in < yend )
+    {
+        const uint8_t *y1end = y1in + i_visible_pitch;
+        y2in  = y1in + i_in_pitch;
+        y2out = y1out + i_out_pitch;
+        while( y1in < y1end )
+        {
+            yuv_to_rgb(&r, &g, &b, *y1in, *uin, *vin);
+            rgb_to_yuv(y1out, uout, vout, g, g, g);
+
+            yuv_to_rgb(&r, &g, &b, *y2in, *uin, *vin);
+            rgb_to_yuv(y2out, uout, vout, g, g, g);
+            
+            y1in++;
+            y2in++;
+
+            y1out++;
+            y2out++;
+
+            yuv_to_rgb(&r, &g, &b, *y1in, *uin, *vin);
+            rgb_to_yuv(y1out, uout, vout, g, g, g);
+
+            yuv_to_rgb(&r, &g, &b, *y2in, *uin, *vin);
+            rgb_to_yuv(y2out, uout, vout, g, g, g);
+
+            y1in++;
+            y2in++;
+
+            y1out++;
+            y2out++;
+
+            uin++;
+            vin++;
+            uout++;
+            vout++;
+        }
+        y1in  += 2*i_in_pitch  - i_visible_pitch;
+        y1out += 2*i_out_pitch - i_visible_pitch;
+        uin   += p_inpic->p[up].i_pitch - i_uv_visible_pitch;
+        uout  += p_outpic->p[up].i_pitch - i_uv_visible_pitch;
+        vin   += p_inpic->p[vp].i_pitch  - i_uv_visible_pitch;
+        vout  += p_outpic->p[vp].i_pitch - i_uv_visible_pitch;
+    }
+}
+
+static void get_green_grayscale_from_yuv422( picture_t *p_inpic, picture_t *p_outpic,
+                                   int yp, int up, int vp )
+{
+    uint8_t *y1in = p_inpic->p[yp].p_pixels;
+    uint8_t *uin  = p_inpic->p[up].p_pixels;
+    uint8_t *vin  = p_inpic->p[vp].p_pixels;
+
+    uint8_t *y1out = p_outpic->p[yp].p_pixels;
+    uint8_t *uout  = p_outpic->p[up].p_pixels;
+    uint8_t *vout  = p_outpic->p[vp].p_pixels;
+    int r, g, b;
+
+    const int i_in_pitch = p_inpic->p[yp].i_pitch;
+    const int i_out_pitch = p_inpic->p[yp].i_pitch;
+
+    const int i_visible_pitch = p_inpic->p[yp].i_visible_pitch;
+    const int i_visible_lines = p_inpic->p[yp].i_visible_lines;
+    const int i_uv_visible_pitch = p_inpic->p[up].i_visible_pitch;
+
+    const uint8_t *yend = y1in + i_visible_lines * i_in_pitch;
+    while( y1in < yend )
+    {
+        const uint8_t *y1end = y1in + i_visible_pitch;
+        while( y1in < y1end )
+        {
+            yuv_to_rgb(&r, &g, &b, *y1in, *uin, *vin);
+            rgb_to_yuv(y1out, uout, vout, g, g, g);
+
+            y1in++;
+            y1out++;
+
+            yuv_to_rgb(&r, &g, &b, *y1in, *uin, *vin);
+            rgb_to_yuv(y1out, uout, vout, g, g, g);
+
+            y1in++;
+            y1out++;
+
+            uin++;
+            vin++;
+
+            uout++;
+            vout++;
+        }
+        y1in  += i_in_pitch  - i_visible_pitch;
+        y1out += i_out_pitch - i_visible_pitch;
+        uin   += p_inpic->p[up].i_pitch - i_uv_visible_pitch;
+        uout  += p_outpic->p[up].i_pitch - i_uv_visible_pitch;
+        vin   += p_inpic->p[vp].i_pitch  - i_uv_visible_pitch;
+        vout  += p_outpic->p[vp].i_pitch - i_uv_visible_pitch;
+    }
+}
+
+static void get_magenta_grayscale_from_yuv420( picture_t *p_inpic, picture_t *p_outpic,
+                                 int yp, int up, int vp )
+{
+    uint8_t *y1in = p_inpic->p[yp].p_pixels;
+    uint8_t *y2in;
+    uint8_t *uin  = p_inpic->p[up].p_pixels;
+    uint8_t *vin  = p_inpic->p[vp].p_pixels;
+
+    uint8_t *y1out = p_outpic->p[yp].p_pixels;
+    uint8_t *y2out;
+    uint8_t *uout  = p_outpic->p[up].p_pixels;
+    uint8_t *vout  = p_outpic->p[vp].p_pixels;
+    int r, g, b;
+
+    const int i_in_pitch  = p_inpic->p[yp].i_pitch;
+    const int i_out_pitch = p_outpic->p[yp].i_pitch;
+
+    const int i_visible_pitch = p_inpic->p[yp].i_visible_pitch;
+    const int i_visible_lines = p_inpic->p[yp].i_visible_lines;
+    const int i_uv_visible_pitch = p_inpic->p[up].i_visible_pitch;
+
+    const uint8_t *yend = y1in + i_visible_lines * i_in_pitch;
+    int avg;
+    while( y1in < yend )
+    {
+        const uint8_t *y1end = y1in + i_visible_pitch;
+        y2in  = y1in + i_in_pitch;
+        y2out = y1out + i_out_pitch;
+        while( y1in < y1end )
+        {
+            yuv_to_rgb(&r, &g, &b, *y1in, *uin, *vin);
+            avg = (r + b) / 2;
+            rgb_to_yuv(y1out, uout, vout, avg, avg, avg);
+
+            yuv_to_rgb(&r, &g, &b, *y2in, *uin, *vin);
+            avg = (r + b) / 2;
+            rgb_to_yuv(y2out, uout, vout, avg, avg, avg);
+            
+            y1in++;
+            y2in++;
+
+            y1out++;
+            y2out++;
+
+            yuv_to_rgb(&r, &g, &b, *y1in, *uin, *vin);
+            avg = (r + b) / 2;
+            rgb_to_yuv(y1out, uout, vout, avg, avg, avg);
+
+            yuv_to_rgb(&r, &g, &b, *y2in, *uin, *vin);
+            avg = (r + b) / 2;
+            rgb_to_yuv(y2out, uout, vout, avg, avg, avg);
+
+            y1in++;
+            y2in++;
+
+            y1out++;
+            y2out++;
+
+            uin++;
+            vin++;
+            uout++;
+            vout++;
+        }
+        y1in  += 2*i_in_pitch  - i_visible_pitch;
+        y1out += 2*i_out_pitch - i_visible_pitch;
+        uin   += p_inpic->p[up].i_pitch - i_uv_visible_pitch;
+        uout  += p_outpic->p[up].i_pitch - i_uv_visible_pitch;
+        vin   += p_inpic->p[vp].i_pitch  - i_uv_visible_pitch;
+        vout  += p_outpic->p[vp].i_pitch - i_uv_visible_pitch;
+    }
+}
+
+static void get_magenta_grayscale_from_yuv422( picture_t *p_inpic, picture_t *p_outpic,
+                                 int yp, int up, int vp )
+{
+    uint8_t *y1in = p_inpic->p[yp].p_pixels;
+    uint8_t *uin  = p_inpic->p[up].p_pixels;
+    uint8_t *vin  = p_inpic->p[vp].p_pixels;
+
+    uint8_t *y1out = p_outpic->p[yp].p_pixels;
+    uint8_t *uout  = p_outpic->p[up].p_pixels;
+    uint8_t *vout  = p_outpic->p[vp].p_pixels;
+    int r, g, b;
+
+    const int i_in_pitch = p_inpic->p[yp].i_pitch;
+    const int i_out_pitch = p_inpic->p[yp].i_pitch;
+
+    const int i_visible_pitch = p_inpic->p[yp].i_visible_pitch;
+    const int i_visible_lines = p_inpic->p[yp].i_visible_lines;
+    const int i_uv_visible_pitch = p_inpic->p[up].i_visible_pitch;
+
+    const uint8_t *yend = y1in + i_visible_lines * i_in_pitch;
+    int avg;
+    while( y1in < yend )
+    {
+        const uint8_t *y1end = y1in + i_visible_pitch;
+        while( y1in < y1end )
+        {
+            yuv_to_rgb(&r, &g, &b, *y1in, *uin, *vin);
+            avg = (r + b) / 2;
+            rgb_to_yuv(y1out, uout, vout, avg, avg, avg);
+
+            y1in++;
+            y1out++;
+
+            yuv_to_rgb(&r, &g, &b, *y1in, *uin, *vin);
+            avg = (r + b) / 2;
+            rgb_to_yuv(y1out, uout, vout, avg, avg, avg);
+
+            y1in++;
+            y1out++;
+
+            uin++;
+            vin++;
+
+            uout++;
+            vout++;
+        }
+        y1in  += i_in_pitch  - i_visible_pitch;
+        y1out += i_out_pitch - i_visible_pitch;
+        uin   += p_inpic->p[up].i_pitch - i_uv_visible_pitch;
+        uout  += p_outpic->p[up].i_pitch - i_uv_visible_pitch;
+        vin   += p_inpic->p[vp].i_pitch  - i_uv_visible_pitch;
+        vout  += p_outpic->p[vp].i_pitch - i_uv_visible_pitch;
+    }
+}
+
+static void get_blue_grayscale_from_yuv420( picture_t *p_inpic, picture_t *p_outpic,
+                                 int yp, int up, int vp )
+{
+    uint8_t *y1in = p_inpic->p[yp].p_pixels;
+    uint8_t *y2in;
+    uint8_t *uin  = p_inpic->p[up].p_pixels;
+    uint8_t *vin  = p_inpic->p[vp].p_pixels;
+
+    uint8_t *y1out = p_outpic->p[yp].p_pixels;
+    uint8_t *y2out;
+    uint8_t *uout  = p_outpic->p[up].p_pixels;
+    uint8_t *vout  = p_outpic->p[vp].p_pixels;
+    int r, g, b;
+
+    const int i_in_pitch  = p_inpic->p[yp].i_pitch;
+    const int i_out_pitch = p_outpic->p[yp].i_pitch;
+
+    const int i_visible_pitch = p_inpic->p[yp].i_visible_pitch;
+    const int i_visible_lines = p_inpic->p[yp].i_visible_lines;
+    const int i_uv_visible_pitch = p_inpic->p[up].i_visible_pitch;
+
+    const uint8_t *yend = y1in + i_visible_lines * i_in_pitch;
+    while( y1in < yend )
+    {
+        const uint8_t *y1end = y1in + i_visible_pitch;
+        y2in  = y1in + i_in_pitch;
+        y2out = y1out + i_out_pitch;
+        while( y1in < y1end )
+        {
+            yuv_to_rgb(&r, &g, &b, *y1in, *uin, *vin);
+            rgb_to_yuv(y1out, uout, vout, b, b, b);
+
+            yuv_to_rgb(&r, &g, &b, *y2in, *uin, *vin);
+            rgb_to_yuv(y2out, uout, vout, b, b, b);
+            
+            y1in++;
+            y2in++;
+
+            y1out++;
+            y2out++;
+
+            yuv_to_rgb(&r, &g, &b, *y1in, *uin, *vin);
+            rgb_to_yuv(y1out, uout, vout, b, b, b);
+
+            yuv_to_rgb(&r, &g, &b, *y2in, *uin, *vin);
+            rgb_to_yuv(y2out, uout, vout, b, b, b);
+
+            y1in++;
+            y2in++;
+
+            y1out++;
+            y2out++;
+
+            uin++;
+            vin++;
+            uout++;
+            vout++;
+        }
+        y1in  += 2*i_in_pitch  - i_visible_pitch;
+        y1out += 2*i_out_pitch - i_visible_pitch;
+        uin   += p_inpic->p[up].i_pitch - i_uv_visible_pitch;
+        uout  += p_outpic->p[up].i_pitch - i_uv_visible_pitch;
+        vin   += p_inpic->p[vp].i_pitch  - i_uv_visible_pitch;
+        vout  += p_outpic->p[vp].i_pitch - i_uv_visible_pitch;
+    }
+}
+
+static void get_blue_grayscale_from_yuv422( picture_t *p_inpic, picture_t *p_outpic,
+                                 int yp, int up, int vp )
+{
+    uint8_t *y1in = p_inpic->p[yp].p_pixels;
+    uint8_t *uin  = p_inpic->p[up].p_pixels;
+    uint8_t *vin  = p_inpic->p[vp].p_pixels;
+
+    uint8_t *y1out = p_outpic->p[yp].p_pixels;
+    uint8_t *uout  = p_outpic->p[up].p_pixels;
+    uint8_t *vout  = p_outpic->p[vp].p_pixels;
+    int r, g, b;
+
+    const int i_in_pitch = p_inpic->p[yp].i_pitch;
+    const int i_out_pitch = p_inpic->p[yp].i_pitch;
+
+    const int i_visible_pitch = p_inpic->p[yp].i_visible_pitch;
+    const int i_visible_lines = p_inpic->p[yp].i_visible_lines;
+    const int i_uv_visible_pitch = p_inpic->p[up].i_visible_pitch;
+
+    const uint8_t *yend = y1in + i_visible_lines * i_in_pitch;
+    while( y1in < yend )
+    {
+        const uint8_t *y1end = y1in + i_visible_pitch;
+        while( y1in < y1end )
+        {
+            yuv_to_rgb(&r, &g, &b, *y1in, *uin, *vin);
+            rgb_to_yuv(y1out, uout, vout, b, b, b);
+
+            y1in++;
+            y1out++;
+
+            yuv_to_rgb(&r, &g, &b, *y1in, *uin, *vin);
+            rgb_to_yuv(y1out, uout, vout, b, b, b);
+
+            y1in++;
+            y1out++;
+
+            uin++;
+            vin++;
+
+            uout++;
+            vout++;
+        }
+        y1in  += i_in_pitch  - i_visible_pitch;
+        y1out += i_out_pitch - i_visible_pitch;
+        uin   += p_inpic->p[up].i_pitch - i_uv_visible_pitch;
+        uout  += p_outpic->p[up].i_pitch - i_uv_visible_pitch;
+        vin   += p_inpic->p[vp].i_pitch  - i_uv_visible_pitch;
+        vout  += p_outpic->p[vp].i_pitch - i_uv_visible_pitch;
+    }
+}
+
+static void get_yellow_grayscale_from_yuv420( picture_t *p_inpic, picture_t *p_outpic,
+                                 int yp, int up, int vp )
+{
+    uint8_t *y1in = p_inpic->p[yp].p_pixels;
+    uint8_t *y2in;
+    uint8_t *uin  = p_inpic->p[up].p_pixels;
+    uint8_t *vin  = p_inpic->p[vp].p_pixels;
+
+    uint8_t *y1out = p_outpic->p[yp].p_pixels;
+    uint8_t *y2out;
+    uint8_t *uout  = p_outpic->p[up].p_pixels;
+    uint8_t *vout  = p_outpic->p[vp].p_pixels;
+    int r, g, b;
+
+    const int i_in_pitch  = p_inpic->p[yp].i_pitch;
+    const int i_out_pitch = p_outpic->p[yp].i_pitch;
+
+    const int i_visible_pitch = p_inpic->p[yp].i_visible_pitch;
+    const int i_visible_lines = p_inpic->p[yp].i_visible_lines;
+    const int i_uv_visible_pitch = p_inpic->p[up].i_visible_pitch;
+
+    const uint8_t *yend = y1in + i_visible_lines * i_in_pitch;
+    int avg;
+    while( y1in < yend )
+    {
+        const uint8_t *y1end = y1in + i_visible_pitch;
+        y2in  = y1in + i_in_pitch;
+        y2out = y1out + i_out_pitch;
+        while( y1in < y1end )
+        {
+            yuv_to_rgb(&r, &g, &b, *y1in, *uin, *vin);
+            avg = (r + g) / 2;
+            rgb_to_yuv(y1out, uout, vout, avg, avg, avg);
+
+            yuv_to_rgb(&r, &g, &b, *y2in, *uin, *vin);
+            avg = (r + g) / 2;
+            rgb_to_yuv(y2out, uout, vout, avg, avg, avg);
+            
+            y1in++;
+            y2in++;
+
+            y1out++;
+            y2out++;
+
+            yuv_to_rgb(&r, &g, &b, *y1in, *uin, *vin);
+            avg = (r + g) / 2;
+            rgb_to_yuv(y1out, uout, vout, avg, avg, avg);
+
+            yuv_to_rgb(&r, &g, &b, *y2in, *uin, *vin);
+            avg = (r + g) / 2;
+            rgb_to_yuv(y2out, uout, vout, avg, avg, avg);
+
+            y1in++;
+            y2in++;
+
+            y1out++;
+            y2out++;
+
+            uin++;
+            vin++;
+            uout++;
+            vout++;
+        }
+        y1in  += 2*i_in_pitch  - i_visible_pitch;
+        y1out += 2*i_out_pitch - i_visible_pitch;
+        uin   += p_inpic->p[up].i_pitch - i_uv_visible_pitch;
+        uout  += p_outpic->p[up].i_pitch - i_uv_visible_pitch;
+        vin   += p_inpic->p[vp].i_pitch  - i_uv_visible_pitch;
+        vout  += p_outpic->p[vp].i_pitch - i_uv_visible_pitch;
+    }
+}
+
+static void get_yellow_grayscale_from_yuv422( picture_t *p_inpic, picture_t *p_outpic,
+                                 int yp, int up, int vp )
+{
+    uint8_t *y1in = p_inpic->p[yp].p_pixels;
+    uint8_t *uin  = p_inpic->p[up].p_pixels;
+    uint8_t *vin  = p_inpic->p[vp].p_pixels;
+
+    uint8_t *y1out = p_outpic->p[yp].p_pixels;
+    uint8_t *uout  = p_outpic->p[up].p_pixels;
+    uint8_t *vout  = p_outpic->p[vp].p_pixels;
+    int r, g, b;
+
+    const int i_in_pitch = p_inpic->p[yp].i_pitch;
+    const int i_out_pitch = p_inpic->p[yp].i_pitch;
+
+    const int i_visible_pitch = p_inpic->p[yp].i_visible_pitch;
+    const int i_visible_lines = p_inpic->p[yp].i_visible_lines;
+    const int i_uv_visible_pitch = p_inpic->p[up].i_visible_pitch;
+
+    const uint8_t *yend = y1in + i_visible_lines * i_in_pitch;
+    int avg;
+    while( y1in < yend )
+    {
+        const uint8_t *y1end = y1in + i_visible_pitch;
+        while( y1in < y1end )
+        {
+            yuv_to_rgb(&r, &g, &b, *y1in, *uin, *vin);
+            avg = (r + g) / 2;
+            rgb_to_yuv(y1out, uout, vout, avg, avg, avg);
+
+            y1in++;
+            y1out++;
+
+            yuv_to_rgb(&r, &g, &b, *y1in, *uin, *vin);
+            avg = (r + g) / 2;
+            rgb_to_yuv(y1out, uout, vout, avg, avg, avg);
+
+            y1in++;
+            y1out++;
+
+            uin++;
+            vin++;
+
+            uout++;
+            vout++;
+        }
+        y1in  += i_in_pitch  - i_visible_pitch;
+        y1out += i_out_pitch - i_visible_pitch;
+        uin   += p_inpic->p[up].i_pitch - i_uv_visible_pitch;
+        uout  += p_outpic->p[up].i_pitch - i_uv_visible_pitch;
+        vin   += p_inpic->p[vp].i_pitch  - i_uv_visible_pitch;
+        vout  += p_outpic->p[vp].i_pitch - i_uv_visible_pitch;
+    }
+}
+
+/****** fill in missing channel variations ******/
+static void get_cyan_fill_from_yuv420( picture_t *p_inpic, picture_t *p_outpic,
+                                 int yp, int up, int vp )
+{
+    uint8_t *y1in = p_inpic->p[yp].p_pixels;
+    uint8_t *y2in;
+    uint8_t *uin  = p_inpic->p[up].p_pixels;
+    uint8_t *vin  = p_inpic->p[vp].p_pixels;
+
+    uint8_t *y1out = p_outpic->p[yp].p_pixels;
+    uint8_t *y2out;
+    uint8_t *uout  = p_outpic->p[up].p_pixels;
+    uint8_t *vout  = p_outpic->p[vp].p_pixels;
+    int r, g, b;
+
+    const int i_in_pitch  = p_inpic->p[yp].i_pitch;
+    const int i_out_pitch = p_outpic->p[yp].i_pitch;
+
+    const int i_visible_pitch = p_inpic->p[yp].i_visible_pitch;
+    const int i_visible_lines = p_inpic->p[yp].i_visible_lines;
+    const int i_uv_visible_pitch = p_inpic->p[up].i_visible_pitch;
+
+    const uint8_t *yend = y1in + i_visible_lines * i_in_pitch;
+    int avg;
+    while( y1in < yend )
+    {
+        const uint8_t *y1end = y1in + i_visible_pitch;
+        y2in  = y1in + i_in_pitch;
+        y2out = y1out + i_out_pitch;
+        while( y1in < y1end )
+        {
+            yuv_to_rgb(&r, &g, &b, *y1in, *uin, *vin);
+            avg = (g + b) / 2;
+            rgb_to_yuv(y1out, uout, vout, avg, g, b);
+
+            yuv_to_rgb(&r, &g, &b, *y2in, *uin, *vin);
+            avg = (g + b) / 2;
+            rgb_to_yuv(y2out, uout, vout, avg, g, b);
+            
+            y1in++;
+            y2in++;
+
+            y1out++;
+            y2out++;
+
+            yuv_to_rgb(&r, &g, &b, *y1in, *uin, *vin);
+            avg = (g + b) / 2;
+            rgb_to_yuv(y1out, uout, vout, avg, g, b);
+
+            yuv_to_rgb(&r, &g, &b, *y2in, *uin, *vin);
+            avg = (g + b) / 2;
+            rgb_to_yuv(y2out, uout, vout, avg, g, b);
+
+            y1in++;
+            y2in++;
+
+            y1out++;
+            y2out++;
+
+            uin++;
+            vin++;
+            uout++;
+            vout++;
+        }
+        y1in  += 2*i_in_pitch  - i_visible_pitch;
+        y1out += 2*i_out_pitch - i_visible_pitch;
+        uin   += p_inpic->p[up].i_pitch - i_uv_visible_pitch;
+        uout  += p_outpic->p[up].i_pitch - i_uv_visible_pitch;
+        vin   += p_inpic->p[vp].i_pitch  - i_uv_visible_pitch;
+        vout  += p_outpic->p[vp].i_pitch - i_uv_visible_pitch;
+    }
+}
+
+static void get_cyan_fill_from_yuv422( picture_t *p_inpic, picture_t *p_outpic,
+                                 int yp, int up, int vp )
+{
+    uint8_t *y1in = p_inpic->p[yp].p_pixels;
+    uint8_t *uin  = p_inpic->p[up].p_pixels;
+    uint8_t *vin  = p_inpic->p[vp].p_pixels;
+
+    uint8_t *y1out = p_outpic->p[yp].p_pixels;
+    uint8_t *uout  = p_outpic->p[up].p_pixels;
+    uint8_t *vout  = p_outpic->p[vp].p_pixels;
+    int r, g, b;
+
+    const int i_in_pitch = p_inpic->p[yp].i_pitch;
+    const int i_out_pitch = p_inpic->p[yp].i_pitch;
+
+    const int i_visible_pitch = p_inpic->p[yp].i_visible_pitch;
+    const int i_visible_lines = p_inpic->p[yp].i_visible_lines;
+    const int i_uv_visible_pitch = p_inpic->p[up].i_visible_pitch;
+
+    const uint8_t *yend = y1in + i_visible_lines * i_in_pitch;
+    int avg;
+    while( y1in < yend )
+    {
+        const uint8_t *y1end = y1in + i_visible_pitch;
+        while( y1in < y1end )
+        {
+            yuv_to_rgb(&r, &g, &b, *y1in, *uin, *vin);
+            avg = (g + b) / 2;
+            rgb_to_yuv(y1out, uout, vout, avg, g, b);
+
+            y1in++;
+            y1out++;
+
+            yuv_to_rgb(&r, &g, &b, *y1in, *uin, *vin);
+            avg = (g + b) / 2;
+            rgb_to_yuv(y1out, uout, vout, avg, g, b);
+
+            y1in++;
+            y1out++;
+
+            uin++;
+            vin++;
+
+            uout++;
+            vout++;
+        }
+        y1in  += i_in_pitch  - i_visible_pitch;
+        y1out += i_out_pitch - i_visible_pitch;
+        uin   += p_inpic->p[up].i_pitch - i_uv_visible_pitch;
+        uout  += p_outpic->p[up].i_pitch - i_uv_visible_pitch;
+        vin   += p_inpic->p[vp].i_pitch  - i_uv_visible_pitch;
+        vout  += p_outpic->p[vp].i_pitch - i_uv_visible_pitch;
+    }
+}
+
+static void get_magenta_fill_from_yuv420( picture_t *p_inpic, picture_t *p_outpic,
+                                 int yp, int up, int vp )
+{
+    uint8_t *y1in = p_inpic->p[yp].p_pixels;
+    uint8_t *y2in;
+    uint8_t *uin  = p_inpic->p[up].p_pixels;
+    uint8_t *vin  = p_inpic->p[vp].p_pixels;
+
+    uint8_t *y1out = p_outpic->p[yp].p_pixels;
+    uint8_t *y2out;
+    uint8_t *uout  = p_outpic->p[up].p_pixels;
+    uint8_t *vout  = p_outpic->p[vp].p_pixels;
+    int r, g, b;
+
+    const int i_in_pitch  = p_inpic->p[yp].i_pitch;
+    const int i_out_pitch = p_outpic->p[yp].i_pitch;
+
+    const int i_visible_pitch = p_inpic->p[yp].i_visible_pitch;
+    const int i_visible_lines = p_inpic->p[yp].i_visible_lines;
+    const int i_uv_visible_pitch = p_inpic->p[up].i_visible_pitch;
+
+    const uint8_t *yend = y1in + i_visible_lines * i_in_pitch;
+    int avg;
+    while( y1in < yend )
+    {
+        const uint8_t *y1end = y1in + i_visible_pitch;
+        y2in  = y1in + i_in_pitch;
+        y2out = y1out + i_out_pitch;
+        while( y1in < y1end )
+        {
+            yuv_to_rgb(&r, &g, &b, *y1in, *uin, *vin);
+            avg = (r + b) / 2;
+            rgb_to_yuv(y1out, uout, vout, r, avg, b);
+
+            yuv_to_rgb(&r, &g, &b, *y2in, *uin, *vin);
+            avg = (r + b) / 2;
+            rgb_to_yuv(y2out, uout, vout, r, avg, b);
+            
+            y1in++;
+            y2in++;
+
+            y1out++;
+            y2out++;
+
+            yuv_to_rgb(&r, &g, &b, *y1in, *uin, *vin);
+            avg = (r + b) / 2;
+            rgb_to_yuv(y1out, uout, vout, r, avg, b);
+
+            yuv_to_rgb(&r, &g, &b, *y2in, *uin, *vin);
+            avg = (r + b) / 2;
+            rgb_to_yuv(y2out, uout, vout, r, avg, b);
+
+            y1in++;
+            y2in++;
+
+            y1out++;
+            y2out++;
+
+            uin++;
+            vin++;
+            uout++;
+            vout++;
+        }
+        y1in  += 2*i_in_pitch  - i_visible_pitch;
+        y1out += 2*i_out_pitch - i_visible_pitch;
+        uin   += p_inpic->p[up].i_pitch - i_uv_visible_pitch;
+        uout  += p_outpic->p[up].i_pitch - i_uv_visible_pitch;
+        vin   += p_inpic->p[vp].i_pitch  - i_uv_visible_pitch;
+        vout  += p_outpic->p[vp].i_pitch - i_uv_visible_pitch;
+    }
+}
+
+static void get_magenta_fill_from_yuv422( picture_t *p_inpic, picture_t *p_outpic,
+                                 int yp, int up, int vp )
+{
+    uint8_t *y1in = p_inpic->p[yp].p_pixels;
+    uint8_t *uin  = p_inpic->p[up].p_pixels;
+    uint8_t *vin  = p_inpic->p[vp].p_pixels;
+
+    uint8_t *y1out = p_outpic->p[yp].p_pixels;
+    uint8_t *uout  = p_outpic->p[up].p_pixels;
+    uint8_t *vout  = p_outpic->p[vp].p_pixels;
+    int r, g, b;
+
+    const int i_in_pitch = p_inpic->p[yp].i_pitch;
+    const int i_out_pitch = p_inpic->p[yp].i_pitch;
+
+    const int i_visible_pitch = p_inpic->p[yp].i_visible_pitch;
+    const int i_visible_lines = p_inpic->p[yp].i_visible_lines;
+    const int i_uv_visible_pitch = p_inpic->p[up].i_visible_pitch;
+
+    const uint8_t *yend = y1in + i_visible_lines * i_in_pitch;
+    int avg;
+    while( y1in < yend )
+    {
+        const uint8_t *y1end = y1in + i_visible_pitch;
+        while( y1in < y1end )
+        {
+            yuv_to_rgb(&r, &g, &b, *y1in, *uin, *vin);
+            avg = (r + b) / 2;
+            rgb_to_yuv(y1out, uout, vout, r, avg, b);
+
+            y1in++;
+            y1out++;
+
+            yuv_to_rgb(&r, &g, &b, *y1in, *uin, *vin);
+            avg = (r + b) / 2;
+            rgb_to_yuv(y1out, uout, vout, r, avg, b);
+
+            y1in++;
+            y1out++;
+
+            uin++;
+            vin++;
+
+            uout++;
+            vout++;
+        }
+        y1in  += i_in_pitch  - i_visible_pitch;
+        y1out += i_out_pitch - i_visible_pitch;
+        uin   += p_inpic->p[up].i_pitch - i_uv_visible_pitch;
+        uout  += p_outpic->p[up].i_pitch - i_uv_visible_pitch;
+        vin   += p_inpic->p[vp].i_pitch  - i_uv_visible_pitch;
+        vout  += p_outpic->p[vp].i_pitch - i_uv_visible_pitch;
+    }
+}
+
+static void get_yellow_fill_from_yuv420( picture_t *p_inpic, picture_t *p_outpic,
+                                 int yp, int up, int vp )
+{
+    uint8_t *y1in = p_inpic->p[yp].p_pixels;
+    uint8_t *y2in;
+    uint8_t *uin  = p_inpic->p[up].p_pixels;
+    uint8_t *vin  = p_inpic->p[vp].p_pixels;
+
+    uint8_t *y1out = p_outpic->p[yp].p_pixels;
+    uint8_t *y2out;
+    uint8_t *uout  = p_outpic->p[up].p_pixels;
+    uint8_t *vout  = p_outpic->p[vp].p_pixels;
+    int r, g, b;
+
+    const int i_in_pitch  = p_inpic->p[yp].i_pitch;
+    const int i_out_pitch = p_outpic->p[yp].i_pitch;
+
+    const int i_visible_pitch = p_inpic->p[yp].i_visible_pitch;
+    const int i_visible_lines = p_inpic->p[yp].i_visible_lines;
+    const int i_uv_visible_pitch = p_inpic->p[up].i_visible_pitch;
+
+    const uint8_t *yend = y1in + i_visible_lines * i_in_pitch;
+    int avg;
+    while( y1in < yend )
+    {
+        const uint8_t *y1end = y1in + i_visible_pitch;
+        y2in  = y1in + i_in_pitch;
+        y2out = y1out + i_out_pitch;
+        while( y1in < y1end )
+        {
+            yuv_to_rgb(&r, &g, &b, *y1in, *uin, *vin);
+            avg = (r + g) / 2;
+            rgb_to_yuv(y1out, uout, vout, r, g, avg);
+
+            yuv_to_rgb(&r, &g, &b, *y2in, *uin, *vin);
+            avg = (r + g) / 2;
+            rgb_to_yuv(y2out, uout, vout, r, g, avg);
+            
+            y1in++;
+            y2in++;
+
+            y1out++;
+            y2out++;
+
+            yuv_to_rgb(&r, &g, &b, *y1in, *uin, *vin);
+            avg = (r + g) / 2;
+            rgb_to_yuv(y1out, uout, vout, r, g, avg);
+
+            yuv_to_rgb(&r, &g, &b, *y2in, *uin, *vin);
+            avg = (r + g) / 2;
+            rgb_to_yuv(y2out, uout, vout, r, g, avg);
+
+            y1in++;
+            y2in++;
+
+            y1out++;
+            y2out++;
+
+            uin++;
+            vin++;
+            uout++;
+            vout++;
+        }
+        y1in  += 2*i_in_pitch  - i_visible_pitch;
+        y1out += 2*i_out_pitch - i_visible_pitch;
+        uin   += p_inpic->p[up].i_pitch - i_uv_visible_pitch;
+        uout  += p_outpic->p[up].i_pitch - i_uv_visible_pitch;
+        vin   += p_inpic->p[vp].i_pitch  - i_uv_visible_pitch;
+        vout  += p_outpic->p[vp].i_pitch - i_uv_visible_pitch;
+    }
+}
+
+static void get_yellow_fill_from_yuv422( picture_t *p_inpic, picture_t *p_outpic,
+                                 int yp, int up, int vp )
+{
+    uint8_t *y1in = p_inpic->p[yp].p_pixels;
+    uint8_t *uin  = p_inpic->p[up].p_pixels;
+    uint8_t *vin  = p_inpic->p[vp].p_pixels;
+
+    uint8_t *y1out = p_outpic->p[yp].p_pixels;
+    uint8_t *uout  = p_outpic->p[up].p_pixels;
+    uint8_t *vout  = p_outpic->p[vp].p_pixels;
+    int r, g, b;
+
+    const int i_in_pitch = p_inpic->p[yp].i_pitch;
+    const int i_out_pitch = p_inpic->p[yp].i_pitch;
+
+    const int i_visible_pitch = p_inpic->p[yp].i_visible_pitch;
+    const int i_visible_lines = p_inpic->p[yp].i_visible_lines;
+    const int i_uv_visible_pitch = p_inpic->p[up].i_visible_pitch;
+
+    const uint8_t *yend = y1in + i_visible_lines * i_in_pitch;
+    int avg;
+    while( y1in < yend )
+    {
+        const uint8_t *y1end = y1in + i_visible_pitch;
+        while( y1in < y1end )
+        {
+            yuv_to_rgb(&r, &g, &b, *y1in, *uin, *vin);
+            avg = (r + g) / 2;
+            rgb_to_yuv(y1out, uout, vout, r, g, avg);
+
+            y1in++;
+            y1out++;
+
+            yuv_to_rgb(&r, &g, &b, *y1in, *uin, *vin);
+            avg = (r + g) / 2;
+            rgb_to_yuv(y1out, uout, vout, r, g, avg);
+
+            y1in++;
+            y1out++;
+
+            uin++;
+            vin++;
+
+            uout++;
+            vout++;
+        }
+        y1in  += i_in_pitch  - i_visible_pitch;
+        y1out += i_out_pitch - i_visible_pitch;
+        uin   += p_inpic->p[up].i_pitch - i_uv_visible_pitch;
+        uout  += p_outpic->p[up].i_pitch - i_uv_visible_pitch;
+        vin   += p_inpic->p[vp].i_pitch  - i_uv_visible_pitch;
+        vout  += p_outpic->p[vp].i_pitch - i_uv_visible_pitch;
+    }
+}
+
+static void get_lefthalf_from_yuv420( picture_t *p_inpic, picture_t *p_outpic,
+    int yp, int up, int vp )
+{
+    uint8_t *y1in = p_inpic->p[yp].p_pixels;
+    uint8_t *y2in;
+    uint8_t *uin  = p_inpic->p[up].p_pixels;
+    uint8_t *vin  = p_inpic->p[vp].p_pixels;
+
+    uint8_t *y1out = p_outpic->p[yp].p_pixels;
+    uint8_t *y2out;
+    uint8_t *uout  = p_outpic->p[up].p_pixels;
+    uint8_t *vout  = p_outpic->p[vp].p_pixels;
+
+    const int i_in_pitch  = p_inpic->p[yp].i_pitch;
+    const int i_out_pitch = p_outpic->p[yp].i_pitch;
+
+    const int i_visible_pitch = p_inpic->p[yp].i_visible_pitch;
+    const int i_visible_lines = p_inpic->p[yp].i_visible_lines;
+    const int i_uv_visible_pitch = p_inpic->p[up].i_visible_pitch;
+
+    const uint8_t *yend = y1in + i_visible_lines * i_in_pitch;
+    int avg;
+    while( y1in < yend )
+    {
+        /* only go up to half way */
+        const uint8_t *y1end = y1in + (i_visible_pitch / 2);
+        y2in  = y1in + i_in_pitch;
+        y2out = y1out + i_out_pitch;
+        while( y1in < y1end )
+        {
+            *uout = *uin;
+            uout++;
+            *uout = *uin;
+            uout++;
+            uin++;
+
+            *vout = *vin;
+            vout++;
+            *vout = *vin;
+            vout++;
+            vin++;
+
+            *y1out = *y1in;
+            y1out++;
+            *y1out = *y1in;
+            y1out++;
+            y1in++;
+
+            *y1out = *y1in;
+            y1out++;
+            *y1out = *y1in;
+            y1out++;
+            y1in++;
+
+            *y2out = *y2in;
+            y2out++;
+            *y2out = *y2in;
+            y2out++;
+            y2in++;
+
+            *y2out = *y2in;
+            y2out++;
+            *y2out = *y2in;
+            y2out++;
+            y2in++;
+
+        }
+        y1in  += (i_in_pitch / 2) + 2*i_in_pitch  - i_visible_pitch;
+        y1out += 2*i_out_pitch - i_visible_pitch;
+        uin   += (p_inpic->p[up].i_pitch / 2) + p_inpic->p[up].i_pitch - i_uv_visible_pitch;
+        uout  += p_outpic->p[up].i_pitch - i_uv_visible_pitch;
+        vin   += (p_inpic->p[vp].i_pitch / 2) + p_inpic->p[vp].i_pitch - i_uv_visible_pitch;
+        vout  += p_outpic->p[vp].i_pitch - i_uv_visible_pitch;
+    }
+}
+
+static void get_lefthalf_from_yuv422( picture_t *p_inpic, picture_t *p_outpic,
+    int yp, int up, int vp )
+{
+    uint8_t *y1in = p_inpic->p[yp].p_pixels;
+    uint8_t *uin  = p_inpic->p[up].p_pixels;
+    uint8_t *vin  = p_inpic->p[vp].p_pixels;
+
+    uint8_t *y1out = p_outpic->p[yp].p_pixels;
+    uint8_t *uout  = p_outpic->p[up].p_pixels;
+    uint8_t *vout  = p_outpic->p[vp].p_pixels;
+
+    const int i_in_pitch = p_inpic->p[yp].i_pitch;
+    const int i_out_pitch = p_inpic->p[yp].i_pitch;
+
+    const int i_visible_pitch = p_inpic->p[yp].i_visible_pitch;
+    const int i_visible_lines = p_inpic->p[yp].i_visible_lines;
+    const int i_uv_visible_pitch = p_inpic->p[up].i_visible_pitch;
+
+    const uint8_t *yend = y1in + i_visible_lines * i_in_pitch;
+    int avg;
+    while( y1in < yend )
+    {
+        /* only go up to half way */
+        const uint8_t *y1end = y1in + (i_visible_pitch / 2);
+        while( y1in < y1end )
+        {
+            *uout = *uin;
+            uout++;
+            *uout = *uin;
+            uout++;
+            uin++;
+
+            *vout = *vin;
+            vout++;
+            *vout = *vin;
+            vout++;
+            vin++;
+
+            *y1out = *y1in;
+            y1out++;
+            *y1out = *y1in;
+            y1out++;
+            y1in++;
+
+            *y1out = *y1in;
+            y1out++;
+            *y1out = *y1in;
+            y1out++;
+            y1in++;
+        }
+        y1in  += (i_in_pitch / 2) + i_in_pitch  - i_visible_pitch;
+        y1out += i_out_pitch - i_visible_pitch;
+        uin   += (p_inpic->p[up].i_pitch / 2) + p_inpic->p[up].i_pitch - i_uv_visible_pitch;
+        uout  += p_outpic->p[up].i_pitch - i_uv_visible_pitch;
+        vin   += (p_inpic->p[vp].i_pitch / 2) + p_inpic->p[vp].i_pitch - i_uv_visible_pitch;
+        vout  += p_outpic->p[vp].i_pitch - i_uv_visible_pitch;
+    }
+}
+
+static void get_righthalf_from_yuv420( picture_t *p_inpic,
+    picture_t *p_outpic, int yp, int up, int vp )
+{
+    uint8_t *y1in = p_inpic->p[yp].p_pixels;
+    uint8_t *y2in;
+    uint8_t *uin  = p_inpic->p[up].p_pixels;
+    uint8_t *vin  = p_inpic->p[vp].p_pixels;
+
+    uint8_t *y1out = p_outpic->p[yp].p_pixels;
+    uint8_t *y2out;
+    uint8_t *uout  = p_outpic->p[up].p_pixels;
+    uint8_t *vout  = p_outpic->p[vp].p_pixels;
+
+    const int i_in_pitch  = p_inpic->p[yp].i_pitch;
+    const int i_out_pitch = p_outpic->p[yp].i_pitch;
+
+    const int i_visible_pitch = p_inpic->p[yp].i_visible_pitch;
+    const int i_visible_lines = p_inpic->p[yp].i_visible_lines;
+    const int i_uv_visible_pitch = p_inpic->p[up].i_visible_pitch;
+
+    const uint8_t *yend = y1in + i_visible_lines * i_in_pitch;
+    int avg;
+    while( y1in < yend )
+    {
+        const uint8_t *y1end = y1in + i_visible_pitch;
+        /* start at half way */
+        y1in += i_visible_pitch / 2;
+        y2in  = y1in + i_in_pitch;
+        y2out = y1out + i_out_pitch;
+
+        uin   += p_inpic->p[up].i_pitch / 2;
+        vin   += p_inpic->p[vp].i_pitch  / 2;
+        while( y1in < y1end )
+        {
+            *uout = *uin;
+            uout++;
+            *uout = *uin;
+            uout++;
+            uin++;
+
+            *vout = *vin;
+            vout++;
+            *vout = *vin;
+            vout++;
+            vin++;
+
+            *y1out = *y1in;
+            y1out++;
+            *y1out = *y1in;
+            y1out++;
+            y1in++;
+
+            *y1out = *y1in;
+            y1out++;
+            *y1out = *y1in;
+            y1out++;
+            y1in++;
+
+            *y2out = *y2in;
+            y2out++;
+            *y2out = *y2in;
+            y2out++;
+            y2in++;
+
+            *y2out = *y2in;
+            y2out++;
+            *y2out = *y2in;
+            y2out++;
+            y2in++;
+
+        }
+        y1in  += 2*i_in_pitch  - i_visible_pitch;
+        y1out += 2*i_out_pitch - i_visible_pitch;
+        uin   += p_inpic->p[up].i_pitch - i_uv_visible_pitch;
+        uout  += p_outpic->p[up].i_pitch - i_uv_visible_pitch;
+        vin   += p_inpic->p[vp].i_pitch  - i_uv_visible_pitch;
+        vout  += p_outpic->p[vp].i_pitch - i_uv_visible_pitch;
+    }
+}
+
+static void get_righthalf_from_yuv422( picture_t *p_inpic,
+    picture_t *p_outpic, int yp, int up, int vp )
+{
+    uint8_t *y1in = p_inpic->p[yp].p_pixels;
+    uint8_t *uin  = p_inpic->p[up].p_pixels;
+    uint8_t *vin  = p_inpic->p[vp].p_pixels;
+
+    uint8_t *y1out = p_outpic->p[yp].p_pixels;
+    uint8_t *uout  = p_outpic->p[up].p_pixels;
+    uint8_t *vout  = p_outpic->p[vp].p_pixels;
+
+    const int i_in_pitch = p_inpic->p[yp].i_pitch;
+    const int i_out_pitch = p_inpic->p[yp].i_pitch;
+
+    const int i_visible_pitch = p_inpic->p[yp].i_visible_pitch;
+    const int i_visible_lines = p_inpic->p[yp].i_visible_lines;
+    const int i_uv_visible_pitch = p_inpic->p[up].i_visible_pitch;
+
+    const uint8_t *yend = y1in + i_visible_lines * i_in_pitch;
+    int avg;
+    while( y1in < yend )
+    {
+        const uint8_t *y1end = y1in + i_visible_pitch;
+        /* start at half way */
+        y1in += i_visible_pitch / 2;
+
+        uin   += p_inpic->p[up].i_pitch / 2;
+        vin   += p_inpic->p[vp].i_pitch  / 2;
+        while( y1in < y1end )
+        {
+            *uout = *uin;
+            uout++;
+            *uout = *uin;
+            uout++;
+            uin++;
+
+            *vout = *vin;
+            vout++;
+            *vout = *vin;
+            vout++;
+            vin++;
+
+            *y1out = *y1in;
+            y1out++;
+            *y1out = *y1in;
+            y1out++;
+            y1in++;
+
+            *y1out = *y1in;
+            y1out++;
+            *y1out = *y1in;
+            y1out++;
+            y1in++;
+        }
+        y1in  += i_in_pitch  - i_visible_pitch;
+        y1out += i_out_pitch - i_visible_pitch;
+        uin   += p_inpic->p[up].i_pitch - i_uv_visible_pitch;
+        uout  += p_outpic->p[up].i_pitch - i_uv_visible_pitch;
+        vin   += p_inpic->p[vp].i_pitch - i_uv_visible_pitch;
+        vout  += p_outpic->p[vp].i_pitch - i_uv_visible_pitch;
+    }
+}
+
+static void get_tophalf_from_yuv420( picture_t *p_inpic, picture_t *p_outpic,
+    int yp, int up, int vp )
+{
+}
+
+static void get_tophalf_from_yuv422( picture_t *p_inpic, picture_t *p_outpic,
+    int yp, int up, int vp )
+{
+}
+
+static void get_bottomhalf_from_yuv420( picture_t *p_inpic,
+    picture_t *p_outpic, int yp, int up, int vp )
+{
+}
+
+static void get_bottomhalf_from_yuv422( picture_t *p_inpic,
+    picture_t *p_outpic, int yp, int up, int vp )
+{
+}
+
diff --git a/modules/video_filter/stereoscopy.h b/modules/video_filter/stereoscopy.h
new file mode 100644
index 0000000..5b15d12
--- /dev/null
+++ b/modules/video_filter/stereoscopy.h
@@ -0,0 +1,52 @@
+/*****************************************************************************
+ * sterescopy.h : sterescopy plugin for vlc
+ *****************************************************************************
+ * Copyright (C) 2011 the VideoLAN team
+ *
+ * Author: Andrew Price <andrewprice@andrewalexanderprice.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston MA 02110-1301, USA.
+ *****************************************************************************/
+
+#ifndef VLC_STEREOSCOPY_H
+#define VLC_STEREOSCOPY_H 1
+
+/* do nothing, comes in as 2d, goes out as 2d */
+#define STEREOSCOPY_2D                          0
+
+#define STEREOSCOPY_ANAGLYPH_BLUE               1000
+#define STEREOSCOPY_ANAGLYPH_CYAN               1001
+#define STEREOSCOPY_ANAGLYPH_GREEN              1002
+#define STEREOSCOPY_ANAGLYPH_MAGENTA            1003
+#define STEREOSCOPY_ANAGLYPH_RED                1004
+#define STEREOSCOPY_ANAGLYPH_YELLOW             1005
+
+#define STEREOSCOPY_ANAGLYPH_BLUE_GRAY          1010
+#define STEREOSCOPY_ANAGLYPH_CYAN_GRAY          1011
+#define STEREOSCOPY_ANAGLYPH_GREEN_GRAY         1012
+#define STEREOSCOPY_ANAGLYPH_MAGENTA_GRAY       1013
+#define STEREOSCOPY_ANAGLYPH_RED_GRAY           1014
+#define STEREOSCOPY_ANAGLYPH_YELLOW_GRAY        1015
+
+#define STEREOSCOPY_ANAGLYPH_CYAN_FILL          1021
+#define STEREOSCOPY_ANAGLYPH_MAGENTA_FILL       1023
+#define STEREOSCOPY_ANAGLYPH_YELLOW_FILL        1025
+
+#define STEREOSCOPY_SIDEBYSIDE_LEFT             2000
+#define STEREOSCOPY_SIDEBYSIDE_RIGHT            2001
+#define STEREOSCOPY_SIDEBYSIDE_BOTTOM           2002
+#define STEREOSCOPY_SIDEBYSIDE_TOP              2003
+
+#endif /* VLC_STEREOSCOPY_H */
diff --git a/nvapiwrapper/README b/nvapiwrapper/README
new file mode 100644
index 0000000..e75e751
--- /dev/null
+++ b/nvapiwrapper/README
@@ -0,0 +1,7 @@
+'nvapiwrapper' is a wrapper around NvAPI, the proprietary-licensed nVidia
+wrapper. nvapiwrapper wraps the nvapi.lib static library (which is a MSVC
+binary) into a dynamically loadable library (nvapiwrapper.dll) that can
+be used via MinGW. Compile nvapiwrapper.c with the MSVC++ compiler to
+output the .dll.
+
+This is only a temporary solution and will not remain here permanently.
\ No newline at end of file
diff --git a/nvapiwrapper/nvapi.lib b/nvapiwrapper/nvapi.lib
new file mode 100644
index 0000000000000000000000000000000000000000..c8e9617a3c6e218b6666cbab05d12d856632d183
GIT binary patch
literal 81968
zcmeIbeSDPFng1V<Py}2lBIZkJL27MUEs01mKD3Z0AUwtdVoGVlBpH~|VJ1!{7|_at
zEk$vw_3N?}-D0s1sdWqW*Y%aPR)ls(THV#!mSw41E!+CdT3V><_Lr@0`F*bYI_GoF
zWCreG|M~s#C9OB_b6wZDuFtv8{WSN?J#*;|k#tAw<D)C4=KfuEb>++%SIxTS>dIWZ
zZO)o;%}3R<YII3S$@fZ1DmR_`@7y~0zhN7gy{0X>F47fm>xd*0P0>tGIyq;~)s3^N
zTNk!1ylH0Jl6BRM4Q<VtNT#QI&YU?bs!MWuz>&__4vp1q3v(i3i&LFFiKzIim(Ool
z(!8vCNo{>w+nhOGnnah@xUnaiUf+<+MANGy9YLR2)s2u5WK@momPOiax+N_ltYulv
zBFScS)~2J8OtdcE-Ia)}pPNptU7oDYWFj50Xs0pS$hxcRu5GJM#3S9!Jwd_h?q$(l
z3_qF^(G*=1?}ntNXm_e7-I42T&ZMK6j#yK)BU9g-(`|V&efo}V^P-vBo^(2z%rq}*
zkX7raZEKEZ<~BArBs=3BkxVL`>u+dol<w8t-KmZ^I(E7NE?F1vj7Q8c=SPyA376J%
zGtP$2n)L>kMAqg-&8ur@Ovl$o(l)4}lY=vf7N?SNXseBMMcU(ucqSh0W=K<Wn@&S@
zS64#D5KkrZosH?#>bR$ny_%!l-9viRMHA6X^fc+zSs-1G11mKXPp<KG)J3~9>D2lH
z_3D#7YrSeYLkoQCBJqT5i6(19XJ|-EB+-+*jwF#$o!8ss&9TpoCp$e+HS2Sx4y#WB
zOu~GpY%^{;8j`D1{;GhtCej@(uoB&-IxmrGk0c6*EGaw`bT;t?3Kp0V#B+_x&O3C3
z&MzK`@U~2>fkmlEXQ5T++ojjsAsZfcZfwla>O`V0x;oO6$mFbe<255O5&qgM7*Jq%
z&5?C>i^(bA+n1$=ibEoEusH1uAmlXb8J?j+;@z_4&c6vsyHjb71BcAE+EfDjbSjD6
zB9Y^e>6@FzIv?V!Pf9K$Z*i(S67N`+>Oz(^>urAx8Cp&@{za)ZI65TeH7@7c5c3%h
zW6tf4dIgVn!M+t+-#s)xY6VBnd5zUw(X@ZCx1Nqnd|h;DPo}HKZ3NbrNECL|q$24~
ze+xGqYI?fe_UUZRiBzVLecAdh9*RvgR(BF7muP3<!b9CR#WS%*@y?tx#?VYS<Afx0
z5ogM$=dbE{jZNO^%NA2-V{JoyUFx<Z4ztn7+MD8?nV8)wOkmymWMpl;qp@4gf!(qS
z-Fei6)YsNxn5*M!deXs}q`-PcNPRk;N*8v?+Q3A3M?9OkuAy#-p1D1Vgn!U6k@%;;
z<jm{psl`#FHr12N49PRUuC}qcr>iTK&S?1|{)VO-hgft@3RJ;LZ0N+5LVR^Rn&ysT
zgf*INJlHpDdRDKFrkmp%hHgd8>v09Mwm|M>xG-vpMmoI{qe;9h7EP~>B+Rj6XxWzb
zc&dA8{o<zRy10L?Hk||anS3o62~P32e9Euf632cSNt|IsINU}vr<-#q9=gT&Yg*hx
zrX6SIcqcYLoq^ia+V*%d=b8m)9e2594mTR??Ztk~8IE8%xpLxiHai~j3m;RF#ptL@
z<8YNW>yrbeyAc~;&X$ki%bv0r*I1D?Zaax)=GQH5Fk9@94!j~SJZsU6JC4h_)d=&n
z<ofL<i*3b=@vM?0@9<tYw7YOYFIf=b1bAu8V56NmtJu4am5UACg`=G<@#t-CCx~X8
zzPv4C$UL^xBqGUMf@4IKCtIYJjGh{4x<g;Xj9S?(tsl*s(sB19p#j(4acs42N7pg5
z<(!V?L~Jt{KkAxubz!HOI}sy?uI`%k*w<2t9{&p7rCN$DFA?cl6ki*6=St`1%9C3D
zHswOZGcTR$=^COFduaikOXn?WtM8TbHeOXm?UfqFWP2A5K(fLCr|s$WX#PZV@M<j<
z?}F7Ih4GkG*3c=NBF+faNpr4t#|9f2?5gnBq$A0W*pPkJ1m$M%Ht)Q2IL{+jU8>`j
z993L%x|U@PC%mgM48kauLxWu}ur@_kr=#65Iho76rsJJFI>761t)}U=)@Hmsj;7kG
z<<iN!7BFVKM3n2S1zpiK4Qst)POiH#S=bxAoX<J`n+siiU7lXQFv=@Un=$C4uYY9)
zHY`uxlEhUA2di@HqLIRa>!KaV&@Gp`SP^TYN%x}PRIm}v(XNPIl;q`>*Q;kITVJgf
z>Jz+l%&QQ*cFld2Z{_I~{*WGeY#3sc1Hx&C31|I!ykI%aAmN^y?&;3prE=%Z_*Zty
z{Pd^o-jEDi%{JonDZ1@8$3vxA1r6Og+@W?{l;F}Ms!=t#Z-LSKFLq3KY~saEgod7G
zLxD4F6(M9vN-pm7KFN?1v(uBm5|$?uc)4rWcuT|5w%SChn^PbLc^Om}$wcO+a53kO
z(RAVRt;5}vu;%9Ynj|j3^83iv(p>9T6ib0yK$1yZ!FBtP_<51FYa>H!&FhmL*#0Bj
zl_fy~&fR#$xd=x%*|czB)`iP5yxjCVH*`1kB$M7%r1V_c73JP8?cm1Z&?BKZWb$$c
zq|=F48-5WO^HjrDP&F?1-ElRj5xo4!Nta3Sgcn3$^t!g|aMb9?l$`bZ7azU0@>=`;
z#W1{qv8gh66Qg9<x&QtDum*DOkDt4ve(sJs4j<?4sGqx|j(4l-aFbe2jCz0UwD)rn
za_){gZms3sa>prm=vz4copXDNm38df&)reaxzCjQlHuGPb@Rrtxpj$4)|?yeXSxG!
zL*4yyy9o|W<|59N@7x{rb9dCwbl3b$zLs-$)N$*nGv`P*<WB4v-=)ME*W4F7cSpUz
zE&OwL)aAoEatpy8;@wT`0(YvN^V}Wv;JzR(-Rz1xcSjwcraN~>ou4ZV-a9yVM_t}Q
z!AU6Wb}>To?*!YM-skS9%UZ<Fb?%OO!F$vHH{Veo@<>3~69F@4*e3;6jc!ZzWGZgL
zhbvRJbysxa9i&7GZ$ek}R?VtNu1my|x3u9+!s)5@n@cL}0|lnDtun*howqr!s;rzf
zYu41Mv#y<a?Nxzs)#ydTMwWc(hfgp5`!`BTeu{he@;ALRjrRlAMYV-CV1(S@_y0zZ
zLtM1IXU%2J*8FY2j3IGzO2*Yp$LCxkHVFTAjVdX5EiZ1)v(wYLftMn-QJ#$O{^pca
z&Y9lc-R+r5#`z7yn@TF5ou0ubt3BU!_mq^}ihSRCP>l~k$JCO>RTXvhbE}sxTDGX6
z=DKM;J@L-ziFo_8si!dyN9Sb8`9X>`wb!leT-Uv_Yv#)Ko_L~jW%q3>)6vArHC;Vz
zo#}Ne(=)EA3>Iybl`A`gcjCKO2A?Tk+1+`|N}1x7W{OvGidSNa5#&#CRmnx;hN1At
zk_$>kmz0jx<)w?`9qCkeYISC6dDDlcF73+TGZ7o`uGCa{*9sptO_!A1JK`e=y9&NG
zyOeAFCttnszpVXlAG`cRmM{3(_jg%d^}sKuTAuR2<G-=|i8ubA`Ibli)rpywBfl$a
zwEX4u|J7mn#jcBfZ}}%94*#v?8Gm|IHksgW<`)ls)bbPOm43r=>Gp3-vwZ(QZ)4rR
zoX}Bj?SEZ4@mrRc|Kjh~Sf26t19(SD|L*+XfAuex*ZjxQtmPH2U-T!-KS=)SX3Mkp
zu32UIf+PR+faPV|yB1o0=lh+HSbpr1EAae|{#AebpSZ3bJMWj&|M{DTKWAgUuypxn
zEdOYK<t3KS|K+BUmapA=?~9h7yJ5r*%P;JI>?zBshX(%5a(wzvud&?H`LO}Zzb^gS
z9LqmD_#@8O?l1iQpR7Ik<f|XC{GD%K{{zdHef~S|vHY9<*T@%sbo7U<{gP$3{@U{B
zqd$1u@>OrwGUsRhJMuMafAE7Nl9nI&Km*swcYZMcC2K$Lw{Oq2T=(RN6_(#$|8uU-
z-@W|HRo31zx|8eSAIAT(!rI^U+woivKmOiP9;@zI{FQ&SF&j>lR#~3-SHENaJEI%E
zYwhEwJiu-BSI?DRZ|zV1^G$jvfZ^`H`TN7x9{X}X=kcx4PyfQ&pWXQOYRj8%c=Eq3
zzqjh{=PjT7+>V`=uPR^mkmV&0&Nyy4@%2e<mVbI^?JJf)uyRbb<?lC*`lIE$?_T(G
z%Rjo|T^Y;&`TM(1T0Z{3x@RoU?7!p>mgn!DbD8BAfB$rY<@)-E-*5SfvHvjL@~;N(
z<2LrzHFt7*n0eL3*V&lZ-+qPKcKkBN?WFSQeN$}A%uA=#TYhx+$d#5`>qZ>4eEfLd
zk1WqTf8PSj3;*u$$1Gp+Z=YXe`I*N)^A*dr58d^;<vkmZ-EMi#cdq>3mjCWccW$?Q
z_kBOV!Sa{qJamiY4_+1JestbNKYFjVSI_@_o#ks@eh;_pKm0oJ7uNph{J(s+<%fC~
z{M7QhjxS+M<}Z&^^P}ktsI%#<g*+yV{MgTLw0(cl_t%$O{^o>fb1nbHi0?E0(O(U4
z`#=1(Jsiv8Z=PiSo0i|f?eo~ozuIc^{JP?w->^K;H--Dl#dodZHu>GB-W+9PzV?+X
zIL7;Lt^c;QUv<ylywCD~9DVPPEr0!UQ+Q06dVKn`*8U$mzHyu7f4TOLlP&*ZVBI$?
zPyhLYBP|cU_%GZ}Zu$PFcx;?-=hN@ln7apl$8|pVsbg1Idu-JuFIXNq<9r^UU;T%>
zS$FrT+aosSaOxk)-~8#fCR+QLT?_8C{M!4jdD`;ROTW$S<d@%^S8MIrh4Cvb$M2o;
zJImKyvS*{^CszOF_m+ph{F$39SKYP0+w#$CE4iK*M5b~dzkl}+rrVf*Jiq&S%gJXZ
zAGX}yv4_X=2lsvO6V^U6()K6I@2fi5Z26JZpXGWEE^elGCK7P!!*jXM*Oe^ae*DJg
z>Vx%vm+qlG?~h5QQy0tfQCV2W=>9*SI(6#bM-MA02||Lsps_&Ul<gNtzZ=!{T&XnV
z@2*3q{#~XqRzA=;Or3ZAaKzp9@7(p7cS?Fb<N~(`#hVKCzZd;aEq~{8&t^X0;(aB~
zigLeQ6}$JN&t1)0!FXbITR;AZT$34M=6nm|Exgx`eu7Kv=;~*;|K?Lac)|T)ecp9^
z>~r;l!FY9zGHcK1{&!>zepS}No&S2p%M@{U{oq}n87x7-e@nn!!5{}Q$Wj@^ZLT2Z
zN=|~$)xRYLetZ7*`nT?ScG%tZZ*5=v*7b|u`OK8<%ip@?<+0Cg86kfBA>fv0$7VML
zyZ>)rI?c>@1vp!IW0O$^<C|bt&h)!J7S!qaz=cniN`=oo+cPO97r7kSqY{t}oWpGN
zyMj^vHopA=ao)Z7o#*O<J;IF2W*`5T%TG4tWE-`;er)6R#iMS-7I4=ON8Me2+{RAY
zzWjI-#tQGr8*}=M+g^X%O;VozaZpea=$`-x^vi|0(=P$pQgK4RMjQRn?H5QpM8BU6
z`bRYe+OgGp+7}<c5%UK9CmUmae6IF_>pwXB1^TB#OQ2s~OgQ}#kS!G_^lP+R|I!Z8
z?`JD^{ri1#$B?)F%b`HmzZ_@-{qh3H>6d_PsW_ouqn&<fhv@gS6|3Lx6QX}66sUf=
zXbtqsi#DfU0<yssE%a-&(=Y81{eHG$_4|E7^v{6;)n5k)^verPr(XiHrQ(EsX_WLh
z{n8H6?`JDkzuzZB|Dr&V9Df=?fqr>$?DR`OHgH0}Mmzn|4$<#tD^|bXCq#cM^{=%0
z<psUdF9F$7aYDaFJN?oQ(eGy~R=?jTM1Lm~==Ku>1nXaJLOA^rkS!G_^lP-yzjpft
z(hkw@XM_H6IKq#`(Q;H%a2y?*a~!Qd4)0s=;=JMab7ROm{&Ycs>dycI{c_{P>6d_P
zsW_ouquu(Kc8GpITe0ik@8h%=JpSJS1*(4&AkZ&2dz^j=$d-x|`Ze0=mv)GLKU=Z-
z{XQZ3w?TpGzZVebmm5@0zXW7U#R>fy?et4KM8BV{Sp9yV5d9BAf$HB02=vQMHK$(!
zvZdmLevNker5&Q*&sMB{zfXw%N1#CUe-#kumm7gjzXW7U#R>h=;PD^(ue3w-``Mts
z=>6C4=f;q?|2`fllH>nAP@rFKUON2}kPV#BuhDM(OFKlrpRL&S@Aq-q3+})D)c>^A
zFE?DBehJ8yiWB-Z+Ub{eh<-m?vHJZ!A^Lv^1-ktl0tD+{ZW25F5|AwwC-iHy(=Y81
z{eHG$_4|E7^uGiJs{dzzK)>ABcKRhCTPjZI*J!6-+9CS=Y{lyL`-JF!1qxLEYk)w%
z+>CenB_LZWPUzQYqaUwdq#dH)&j$UWuV4K5T<rz7{{bja{l@`;et84I>6d_PsW_ou
zqn&<fhv@gS6{FveFGBxYP@wt;0fByb)5GbPfNZHap<koj_9N{O{eHG$w;#Vx?ilip
zpLjIJ=$H2t1O4(wjngjy*-~*rzeXGVx8i03%pv;yY|uXeS7_sKg*FzicFndlF6SD~
ze=Y3y%^inqOY)aDp0QA*^Dzz-j7Q#Va^sPJY^gXg9*uVMA?=Xy_}Pk`55G_DIP&zD
zL4oR@3<~ti8)Qzu1Y}Fa3H=&v^y7Ri?GXKbHs~+<eC+pgW60Bg85F4ga!{aO-qdsY
zB_LZWPUzQYr(fD3`u%KYqu=j$2K|*#p!#Qm0{!wvq|+|}*-~*rzeYR#(hkw@XFD7H
ze!ny5zX1wV{~S=DU*0@*`XwM+Do*IvXt(`KJ4C;qt=R3~@8h%=+<)gof$Cob3iQhx
zzD~acWJ|>f{Tl7`OFKlrpRHK^exDHi%b-B@w}Jxw@+P&@F9F$7aYDaFJN?oQ(eGy~
zR=?jTME@!%Q2m{tK)<}P?(|DQwp5(ZuhB+7t|z1&qTkO3{h`+retfR>g4<653RHg=
zD9|q-25|Z%AX_R<=+|hcU)mx1{cOeP_v4Gu-wOq*{|-=~Up~O#^h-dtRGiSS(MCVc
z$I=eb?`MPlvpOI9ee=gsa6Uc@MLM2sAe|3<2*Zs>0<xvz#CSB?jA#A!3#1(~9{EUz
z&4%$z#`Q%Rt}iCw`eMkrtt{s{!@pPL=g1vb-udl*DAMsf2nxm{A0)8~Mm#D3*-~+0
zJQ{7rgZDe69Wow28^%-A`yGCt5d9BBf$Dz*6zG=^zc~F8kS!G_^lP-!FYOThezs!u
z`+Y+6_d$W`e;gF(mk;bX{SuHZ6({s-w9_x`5dD6(V)grdLiB$Z3RHhTD9|q-GIIJQ
zAX_R<=+|hcU)mx1{cOeR_xptCe-;W<{|`Zde)(XO(=P$pQgK4RMmzn|4$<#tD^|bX
zCq(}XP@wu>0tNcz!(2|k1Y}Fa3H=)F^h-NLzn`sG{eGVi{YRic^}hlN^veg(oPG(&
zmWmVlHQMQyc8GpITe156J|X&l4F#%y02Jt#56wCK5|AwwC-iHy(=Y81{eHG$_4|E7
z^q+(R)&CYK&@UhKbNVG9TPjZI*Jz_3ug|0%qTkO3{X@=Sr+>f0@8`ylcm8?@3RHi|
zaHC&7oappRK(<tz(67->zqCX2``OM$zu)f+`bR;S>K|+M%Lgi*ehJ8yiWB-Z+Ub{e
zh<-oY+35HCok9NuC{X=npkVuv4}m)U5|AwwC-iHy+y12;qTkO}?Dp^XaoP)B&rO8_
z)qfc%&@Ufcb^0YBTPjZI*J!6-+9CS=Y{lyL`-JGf5(-p*B`DA@AGUS+B_LZWPUzQY
zqrYeS1=0@D?`MPlGF*>N!1d@jT#tI!auaf{Mg7mN`2BOoQgA-1ph(Aa11K1ed|=p(
zM*^~?;>36~+RcZwL&oE0D|SBoKDlGaJ08_Rf$E<R3iQi|oSl9N$d-x|`Ze0=mv)GL
zKU=Z-{XQZ38=*k;F9QYo<%8KyzXW7U#R>fy?et4KM8BV{Sp9yV5dABmK=rQz1^VT~
z<W9c?WJ|>f{Tl7`OFKlrpRHK^exDHiF(^>|2~eP4J^=6ZOF*_%oY1e)PQSE6^!wS0
z)$jKS(Vu|=)!z#W^vj3#oqh?(mWmVlHQMQyc8GpITe156J|X%yL4oT3EGW<~4;ncA
z5|AwwC-iHy(=Y81{eHG$_4|E7^xq2ws{ejapkE%2aQY=6TPjZI*J!6-+9CS=Y{lyL
z`-JG<2?eVEVNjr79_VoTB_LZWPUzQYr(fD3`u%Lh>i7GE=>IAdsQx}spkE$Barz}7
zTPjZI*J!6-+9CS=Y{lyL`-JG<2L-DCyP!b7JUHX@OF*_%oY1e)PQSE6^!wS0)$jKS
z(f>3QsQza`fqr?|$LW`VY^gY*U!$FVX@}_dvlXk~?-Qc`5EQ8X7eIl2c|ghOmw;@k
zIH6yooqlPD==ZY~tKaVvqW@=5p!$!10{!w(mD4W)*-~*rzeYR#(hkw@XDe2}-zP->
zYfzy2e+>%s%Y$G}zXW7U#R>fy?et4KM8BV{Sp9yV5dFuYK=q#l1^VUTHK$(!vZdmL
zevLNz@p@j`A^QDn&|mcHdB2|<L*DiCAQY(ncR+!DdEn0Jmw;@kIH6yo-TIeyh<-m?
zvFqRO<Fpri{W9V_tA7+I&@T@OI{gxW=LfKaevNker5&Q*&sMB{zfXw%aZsS^e*!4b
zFAp|4{StuZ2e5>GjW+t_`2m<i^!wSMKlJ@FKR#D`!Sz2G3RM48P@rEP#&r560M8F#
z3H=)F^h-NLzn`rb{eFBA`pcm}^<N1J^veUJPQL`;`2j4UU!#qFyk92m5dD5O=s&CX
z%ly9iV<|WvGoeVwQw0jfBM-s4@kjukC%_Wp(P%dwX@`u*&vv%s@%t7zo;gsY<EaA$
z<B<n>-FPGb&lg~c@o2Oe500<W4jGT14dW^L`0Dp_W63+dE`kEp-v|oy%frV`zXag<
z0xY3lqn&<fhv@gSosE9K-x>6`LV@aE2@3Sf1Jh2w1mO7sETLbcjefjeDeVybem3a$
z?s1*|`7FPW(_V0Y=!62*9|HyY<somUUjp!a0hZ9O(Qf@qJ4C;q?QGV+-_MO9Z~N(j
z0@a@Z1^VT|bf;ee@O%N5(67-(KaNk*4$<#tgZ{HRKKXs!7-SyoU*34`fFd2wCQvXQ
zdAQz<M*{G?0hSn#M!WftcF1`AY-ckcem^&sJpJ3CK=t1X3iQht0yzB=faeXcgno^7
z^C9gJ{eHHyoe#gS8-tw-`8RJo4?>ZSXD28ak9?_t8;=Cw`2#F59*uVMA?=Xy_}R{8
zKKy=eEP47LfdbY4RZyT`zKFr;mjFC}fF<;6w9${_le9zh``MtssN<90$7wIP{vU?|
z)xQrE=$9{#aQY<x&mUk3{Tl7`OFKlrpRHK^exDHi{ZOF#p9Tf`<qI#IehI+y2UtSC
zMjQS3e2%n3^!wSM|9|xP96v|Mczy^)I-WzIU_A1r9d0}lfaejg#CSB?j0f-UNIPUa
zem0Eftl!`9`{$0O;P&+r6zO<=1`5U_Up(T*BLR3m0ZWWWqs@45{*ZRac>HV_&sm*6
z{J!~PDL9^2ph(B_8Ymc#e0ho+j|AX(1uQWhjW*+v=M`WM8IPY0;|YDe<j3caA@6uK
z00pZ5I4IEnQ+(lz(=P#dUI9z!*J!tWNjpTppY4CLefj;17|&Z!q~jR`1>=z~t#RX#
z06f2dCB~!CZa$<PG9Eu$G4tWa7oopogw;O+6zG>P+Hv|N0M9RA3H=&v^yB;??GXKb
zHs~+v{NeY>9YfysG!_bU{f`3$`sK@koPG(w^9oo(zec<DFYOThezs!PzaO8gz2N>_
z1_i2rGAPh5Uufj?O8}l%z!Lg3+Ub{eh<-m?G5Y=ZBJ^Jd1**Rs6zG>PVRHH<0M9F6
z3H=)FwjXJS==ZY~yZ!ima>tOj{ZvAM>YoV;^vf4VIsFoV=M}JoevNkPU)mx1{cOdo
ze?LA~d%^AJ1}ISdb3lQ9`LZjgUjp#F0+!IP(N4d#L-hOEiqY@K7omSX6sZ11pg_NT
zL6_4n0eD^kOX$~VqaXJ-q#dH)&j$TP-{0{2xpCxeKg*y%^|yio{qm(^PQL`;c?B$?
zU!&djFYOThezsz_f4`5@UU2(a1qG_V6BOu|FG6$rB>>MWU<v&iZS;Q{&nv(jqTkOp
z3g0=9^T8eeL*#xSMdz*W1S+cDE>NIXzO2pZl>j`SfF<;5w9_l?5WRl3GwSsNPp`KZ
z6;<yYpg^yDp`6nz0eBt(OX$^TqZij}(hkw<XDep^^y4X8HjUsfZ+(9j3RM3#P@rGF
z1kdT006c$yCG=~w+rFh8qTkO}?Dp;V$sI$U{`;Xo^*;y-^vf6bIsFoV=MAugevNkP
zU)mx1{cOdoe?LA~yG%fy{)eGJ^*;g%^vjnGI{gxW=MAugevNker5&Q*&sL0nKfVb4
zeNdqK9|r~c<qHy>ehI+y23SJBMmzn|4$<#tD@MN`UxfbeLV@b<2L<}&OC6nl3BdCP
zSVF%>yX{}vA^QDn#cuz8pWHFzZ9mUKf$IMuNVk7{5v9{F0eId3OX$~Vr(fD3`sHga
zZMI_d`+Y+6zW@cQ|0PhMU%oukRvhuD1mJlCETLbcoqlPD==ZY~tKaVvqW=gKsQy<#
zfqwbIPp4l3@Vo(*(67;M`<Hfzem`3=+rJ;5tG(dy=hsl6`UgOPe)*D8r(Xi_yaATb
zuhCAwv_tg!*^1Hc#}}dhBowIrw?Ml6<BL_DehI+y23SJBM!W4t+9CSoYg%o#Vz(c^
zPwp7<_TP7)K=qg4n*{^?@@25L;)q8j0M8r13H=)F^h-NLzn`sG{eGVi{iEdj5QFd6
z8*BB;7uY)e5`gCoRKG^M?MK=n`u%LhY(IW{uJ(f4{{$#d{bitF{mYl`I{gxW=MAvL
z`qyZuU)mx1{cOeP_v4GuKNSj8|7D;+zkE@!(=P#d-T+JJ*J!u>NIOKopRL&K$M2In
zhP>_nN+?kMm7qYse7UjHF9CSo088lCXs2J=A^QDn#p?I_gy^q=0@Z&5D9|ro$n5k>
z0G=<v68bgT>6dnhem`5W`u#p3`s<)T_0I<d`sGWcoqh?x^95K!zec<5U)mx1{cOc-
z|9*U~_JaFwBNV9qWuQR6eDSr@F9CSI088lCXt(~Q9irdQHtL?@?r-{ia>tOj{jY=q
z)xQc9=$9|+cKRg%&lg|`{Tglb<NX+Ehv@gSVf~-=`!Rn1+_4m#j~Eo`coLvsJo1I(
zZaflz=MAvLcr@D0hqOb+<7X>&fAIU{jv;S8GEkuUdqIJI`I2;}Ujp#F0hZ9O(N4d#
zL-hOEiq-G;3DLg^3RM4RL4khxVt1!s0`R;6me8-!MnCSiNjpTppAGtpzTf8eb7RO`
z|Mx<H>c1Zp=$9{}clsp&&l_L~{Tl7ozqCX2``L<J|9&5*z2Nr06AD!S!=OOFe1X2x
zF9CSo088lCXs2J=A^QDn#p?I_gy{b&6sZ0_P@rGF^xx^106cGiCG=~w(=Y81{eHG$
z_4|E7^zVZL)&E^kpkIEd!0DF&Ja2#{^lP-!FYOThezs!u`+Y+6KMe({|5;F=Uw&M{
z>6ZXJZ-6EAYqZlZ?GXKbwqo`BeM0mff&$h50w~ZgKM3LUO8}lXz!Lg3+Ub{eh<-m?
zvHJZ!A^Lv?1*-oDNVk9dh=tQH0eId3OX$~Vr(fD3`sF7vY_?+c`+Y+6zXk=W|JR^E
zzx?oqtvKRQ3BdCPSVF%>JN?oQ(eGy~R=?jTME`LpQ2i%Cfqwb15T{=P@Vo(*(67->
zzqCX2``L=s@AnDOKL`b?{~b`EUw+`k>6ZXJZ-6EAYqZlZ?GXKbwqo`BeM0n)kl!QG
z-zxwG`sGJioPG(w^9EQ#zeYR#(hkw@XDe2}-zP->I4Ds46F`A}`5_snUjp#F0hZ9O
z(MG>KZvb<Mem@)Zhkky>kI&U!@cLmg6sZ2Gpg_O;_>I#q0eId3OX$~Vr(fD3`u%Lh
z==bA`&|eM(s{cw*pkIEl$LW^<Ja2#{^lP-!FYOThezs!t`|(BSp9ux3zX}xSmme8&
z`XvC*7hnnf8g2CB^JLNv(eG!2{<Hc#ncp{mECsixIZ&kIsRIS$ksnHO<B<S7Uw|dX
zqtRwO`23HwL&oE0!+47N{Ey!!cN}@I2Npqr>Td)E`sK%+oPG(w^95K!zec<5N!lU$
z{cOc-Pkwx^_JZrb6$(`UN>HF*evr!PmjFCpfF<;6w9${(W6}=M?`MPlqF;~s{oFY6
z)_*4ysQwrz&@Vrt<@8Gco-e=>`Ze0=mv)GLKik>p_xqhee-{*}{tPJ4FF*X{^h*Gq
zFTfJ|HQH_e(hkw@XDfF5_xm{Q1-G9&pg{F+0tNcz$I6_33BdCNSVF%>yY(;a5dD6(
zvswRsKR1TF?PnVlsQ!CFfqwacHK$(!@H_#Q(67->zqCX2``OM$zu)f+`X7V>)xQ%I
z=$9XbbNVF!&ktY;{Tl7IA8Ci^_p=qd{rG*H_JZ5bBT%6FzX}TU%MaN({StuZ2e5>G
zjW+smJtXZA{eCv+54|4p<8!qa)c-gXsQ!JRK)?L>p3^S@czys&=+|hs{-qtF-_KU;
z`uF?fjv;UR?}q}_|1>DjFFzRQ^h*GqAHWj&HQMQyc8GpITe156J|X&l2nDMD5Gc?u
zKXT~wO8}l1z!Lg3+UUpmOWGm&{cO0uKCbbe;(ouz@8`ylxBg#(0@eRBkZwQtVMeE4
z0`PnQme8-!Zv9I;M8EvZqs><A`uF=d?FG00SD--kzXl5Q%a2LgiX$GC06Y(XCG=~w
zTmRAy(eGzFoAvMab7RO`{{v8<`j3MG{qh5tPQL`;c>pY-U!&dnmv)GLKU=Zy&-i_u
z_JZsGEhtd^gP=ga{Aj1sF9G=cKbFw1(MCUxpVAJ|?`JFK`02;zYA>k2<Xu+(2vDG3
zerVL`mjHbJA4}-hXs2J=A^QDn#pw6ri_kw73UvLC0|ol!$5EYr3Bc$7v4nn&cKW3q
zqTkO}jDA192>oSHp!z3+0{!xXu1>!M;Pd}jLcc~k{n8H6?`JDUzaL+O{>z|1^_PPJ
z{qiHUPQL`;^Z!^vzeXGVc>O5t5dD5O=r8K^qu(cY40*?&N+?kMGeNrj<A-ydehI+m
z|FMLAjduE_9im@;hSz2*R=?jTME?y?p!(;40{!x1zqaCtM<oEC|Hl&gHQMOM`B&N@
z`u%LsU-auozn>dJ-uj;p1*(4$D9|rIQ0(+e06zbZCG=~wTmRAy(eGy~cK!Q(oc4mp
z&t*`c`ddMPe)&;lr(Xi_`F|{-U!$FVX@}_dvlXk~?-Qbb6%?rcPEep<ehAv>mjHbJ
zA4}-hXs2J=A^QDn#p?I_gy>H|f$Hx91^VU3tDSxc!1DlDLcd14?O)m<`u%KYv;F)1
z+!*q<|6V9i{da%@{qlp`PQL`;`2Z}TU!$FVX@}_dvz?88zuy`3e-;W<|29ydUw$Oq
z>6ZXJAAlwFYqZlZ?GXKbwzJXi_dA3B`=LPfKL`r+%MY77{StuZ1F(dCjduE_9irdQ
zb~gI`erM4CFchf%M?iso`7w5<UjnkF;)H&UHu`b?m3D}JKO6KHb^i7HIPC?GpM6lE
z`X2`c`sD}Yoqh?x^8r{wzec<DFYOThezvn&|9(F=hP?gvyHKF|`$2(z`O$l)Ujp!a
z0G80N(N4d#L-hOE&PKoA?+p5%g#y+8Lr|bUe(#juIsFoV=L4{WevLNz@qUK1L-hOE
zp#QAi&+z-YG01jg|MKSJ1t`+-yaWoybKNC-HoEah0G=1X664WmGah_iPTC>k@v~t(
zXZ?9OzkmLi^2T!nigY}$fP(QnvHCZ^cjJ)&JU@UX#-q`0exw~T9zWaJ&X3<We=IUb
zdE@yt6zO;dK*4y1zx<h-+;}7a&l6yY@o2Q$U!)x}9zWaJ>@R*lH<mp8C!s*~zXb~P
zSKYP0+v%48JWqfn^lP-64{3+!_p_bteE5Cc80@}Ma6aCFA{|f3C^Md;*H(J>uO$G_
z7r=?}Xtdj3q#ZIIKimIgfARb0k120{MnR~KXRIC1g2+_wd2|WD^9DK|jW*-K`B2&+
z<MFd$JVl)k{XV&4$kRUo3RHg?DA>O4-~EH>Zu^n|Ja2#{=0l_1{vquU{eHHy*+2Y#
zZVY+)r$T}1zYG-U|Ht#YpLhBt0M8p>3H=)F*1xnv^!wS0UH^U`r@i3*a3vI|{z_1w
zKl#k$!%n{h;CTZqp<kn&erbp3_p=qN-|rKmzX}Re{|%r(e|yIs@B7>(0M8p>3H=)F
zwjXJS==Zao&GzH>b7RQce(In=_0I<d`XAi)!B4pLF9CSo088lCXrmwZQ>7iE-_Hj9
zq3=ie@lLlrrsnBygaXyS3>4^}8EN~I(=P#d-T+JJ*J!u>NIOKopRL&K$M2InhCKZ%
zp+NPo0tNctS9P-4>6ZXJZ-6EAYqZ;bq#dH)&vrK3kKfOYAy0n{3RHgr6zG3s^=G~N
z*%E-~3$TQKjdtr_+9CS=Y{jmBzmL^^0d!8pe<MpS#&TRh@4<3%KvS_)@8zT_(1rMK
zWXZ>9s{=`|ktGdSN~Vz|OG&LD&C&*%6nLYw-2u`bUm)$IcQ;6Te2une8221)|HQbT
z(Kf)ilb{LsZ)C~aw4H|^LAofgoexs)c-r1W+hw$UgtlvFYXj-nVjvyICX)P6o!b5d
zG&ZRA@1!?D+V{UeI?7YDosTbdR#g{)RB07R^Hqa1-$K#~dfRD>ky50Mq#Yow(MLK6
z(rT}e<O`;??l62+l-3<XngmksG}_8Z6{Oju7LeABk?sU(-JK-)Vmi%y0Hk%FCmp5t
z7;W;^TpD+Rbc!?)529+_a#9UQ>#ijAg0${tkmlP?+C}dk+T<$&G;S|xKj|<?>&g?#
zO2hFXTCF>oR0Yzy)gaBckhFr{cG_a36lo)A2S}^+kq&~){F3AYy;^q|-U`&ZV@Q)g
z>YYYgIjMp)o74i*x-rrgkk);eBp)2m%m+YP_j%G$dXLd2Z?$UN3DPOjM7$8ty5*!A
zkeOdnFG%Zd25G+Sq+Rsxp-pb_Xxv`Xe$ru()|FR`O2cswH}gx93mdIl4bprINh|1W
zr%g@;8kZt%B<%ocwLVf7q;+2-4T7}pu=8!cF{DW#^-iO$oK!)YO=<yY-56;L$jmRP
zAEcQNfOH(slaA7RjJ5&N3DPOj#L>2HIjII@=9kn9(z=^LT6a5X7rlFE>m%(Y?I#@u
znfWCRA7krICRKs7ZZ*ivFKGq6?X<;6DbhyL4v?8&(m{}p_Z8A0Nb3$mQLQ_MGzp~M
zX|$D-DoC?QEg&<$q^%&W`v|EYq?r$Z@PC|PpC=uq_ZV#hq!Xl5q=~p3(YocN8jzV^
zQZGpBZU&({>f&nv4eg?L4{d#<y`=r5!yq%iq~U*I>rN(BfwXQlNb4>nt)RD^wiqcz
z+DO^~GV@D12r~0a8U$(GVYu|tx?@O_K<b@FTREwMG@H}{GV@E?0@At<llnoL`2a}k
zK2JJI?=jj2NGC|ANE2~^Y37&oagf$+CG~=|?q-mgU(zmm_t4fy+DqC`It()NOZqcN
z>z2LSQWZ$+R)fs^l2*{$PFswWB5fq?0GatE9R!*AB@KeK?y&K;?ikV}kb0-lR!*uQ
z%_g;g%>0t>0cqW@k`941^G`rJ-d~X3p!ZGM21%z#7b30py&R-<t4K{C{2zO0g0u~!
zb-xJGz7LTeqxT8g`bqmqFOpsdY2886L>SOO-AdAYkk-8sq;)?@x|!ZIZM~$8r29x;
z2jTyy(N8)I(z+)}qfk`qz8n8&-S?0_Oz#ZZsz|d*OG&FiTDO<91Eh8Lkq&|If9U%O
z{?WR>AiY8Fo3ss*<h8c;xDYQ=lr9Hp-6~QONb4p@+d$}!x?coo--k$#(fb5#{iOY*
z7fG*!wC*5j{3W*Tm8AI~t$QO#>wc1SGreirdPy5e_mRF1(z^Ymmq9w-<D^k#w(h$@
zTK7Gq57Rq?wkpzW(o)iDkeOf77eHFKk8}v6<NXOp>;8iD2EA|6Hb^=}y6}J5zL$f{
z{F0V{v~G;F4P@pQWagLj7`;!>)=%0`dXe-x$jmQk5?&B%-I=6Tkk*ZWwC*jW4fJlI
zZ5!!6(r(g|Agz0d^d?B_j>RnvrE-wgy$YmtuO}^_w~4k^QX45n+6vOTJ4sJ~wAu@#
z0g%@H14!$>O&X1xH0m7>Qg0b)3aNrL7o>GtNokPQy_eJn(#+ohY3A>deoXJnv>hS6
zN;*Lr`CePMj5GtJbr+FhAgy~VNbBBCx`*BeXxmBJP1;M!f^@t`NN<9)?%4NPDhFxZ
zt3X=!deQ=Vn`mn#wUJV!tspbMq$faTen|r$t@{U%)_t2adW!Xq2dTG=G=)?_nhP@X
zOG<;x{F3@WW`04M`Fo@v)B7@QM@X-dPLM`UwROu#GeBB*5h(^T^9$0tx0CLn_W{~=
zl6I5!lCmH(zoa)oT6gTFmdZh9enDFIdeQ=Vn`mn#wUJV!tspbMq$fdI_a)K*$jmQD
z>%L7IJ<WQ@gVb9_nnJ1|%>|kHC9MN#-TO&>ATz%p&HO#mkLi7xwj-ohNhe4n-*4-d
zk!FFkZX+oMGV=@4y0??=q4xpWc9M3J_L8z7Gry!aL1un0vs4Z;^9$0t*OL~|+eBL{
zsg0B(Z3UV6B|QPsx-XChKxTeHTK8?z=nq)$c#wL_NK;4^q`4q7zoa`sT6ZU@AEb2;
zfHd>-q@(m6qiuk6f^>>B@p4<YoKyqSx+_V&Ag#L@q;<EGcG0_swm#Bc(tgrmkdAkN
zH2j0M?qpIGNb6REwC+OE3VPdVi;+^KjienQt=mUB2-5MsLK*~V-C^an?ikV}kb0-l
zR!*uQ%_g;gv~G;F1*CN!CiR0f^8t{VU(!)}kI^<jIzc)`n)o4Gx13Z1GV@F71!>*Q
zATz(DUG(mut&g;qw4ZbsWagJN{KK~HWKtDK>sEuz{E}AC+fG}Ilp<{;?EsniB^?Br
z`6Ug4wC=DgY~3-WNg(x3qph4&L7Gi!0h#$FZ2_72CG~?e^8t{VU(!)}kI^<jIzc)`
zns}wHTTZG0nfWF4g0${t(AW}rg|?lvi{3r7^^x|H_LB~S%>0suf5g_EOsWED-D=R-
zpzcD_3VPdVi;+^KjienQGry#RATz(DL6FuRHr>`8Lz)Cq?=;%VNfo5oq!y5wU(yzk
znO{;rNHZS*>3E+f9i{geZ3Cneq*J7c6}E0UsRm@`m(&Z=x|=~-cROhpy?bcuBkd*a
zCmjZv`6Ugnv~?$wsz6$|8f4~|w1VDt+G3;>X(MR|$jmS4Ajr%wX%M7!hh1gsjv-9~
zsdpM}<)jMIY*Guz%r9vxNb5dA>IZ4&10XZMq@(m6qiuk6f^>>BafYp1PO1T!`6cy&
zwC-k*nP1W_diT)QN7_r;PdW@T^Gh0jwXHjuR0Yzy)gUv!q!skG(-tG8NE=BzKxTeP
z&wwrpjtoaggCMOtY^JR{hBOJJ-f6UzlPXBFNiCoWL5&#cPLS5!N$Lk_<^v!zzoet|
z9;0o5bb@q>H1VUhZaHZINb7czwt+4V^nDSebsr)<M(-1}^^^9KUL?H^nh@k0Bu$!S
z>&_&#f-Vl?A|S1M3uyzrTWH%xx{tJ*^dv~@9wNOC((#sDW2p?JbuR^J-784f(OW~?
ze9}@<8)+R#>uw``9i(-iB^?22-Cu#U?r%wdqIY<e^^PK4NSZ>L1=70nN$nu5dk1MJ
zNb7zDq;<bVdWznIv>hV7NP3m@N08PXb*-h#L0WeXsTE}A7i8v_w1M6&v~45ZN7_w#
z5@hC=^ae=lj=0WJIY{eX1=70LlNQk1L|ZGVjg%s71!>)#q$fdI_a)K*NbCLqq;=mW
zjlSM`$Ai>cMw&vZAk777-B!{Dkk);W)DP0S2SA$ndD2mOkI^<jIzc)`ns|e)TTYq_
z(z>fiy&$c-8KiZ$lXlU&hqgY_UebQjVUUh@fHeGLw(ew76-et=gS75K(h7RpX^W9k
zq>ZE<Ag$X+ItbG7zCs!VY29HTw{^#mCV|vDjka=91!*>^1*COjqz6D+_i@r8kY@e~
zNXPpN(i`-?N!uXl6zRg*w(sR2ty@L<G)U|Al6Hc$?pHus_gkc==sif=A<~PaS4n>a
zY28tCEPWWHb?Znmkk-8wq;+p6-9zsKwCyDACha9<L0b0+>GvS5JF41JIY{eX1=70L
zlNQk1L|ZGVjg%s71!>)#q-Q`{_Xueaq;-eY*t%m#lR)a7Mq4?lf;5}d0@AuM(w!i!
zyOY!p(#!`yI^O3=N9jFA+W_eV=@e;Vt*u*5ssU-;m84#f*4+%!y4y*+=-oqGA89XX
zKj|<?$2&m!Gf3-})mf?nY29j&)?G+iL2o;4F;a@Ok+cJ(b^A!qfXw`o20>bPSiP+~
zhBOJJ-f6UzlPXBFNi85Vzoac7t@|*kAEcQNfXw`oj?#OKwgJ)!(kar!xwdXO>Ej@+
z+e+#MY2D2rGry!=^zNapkF=MxpL7^x=9lzmkeT0kma0Hnw;E*Tm$ZW3cG_a36lo)A
z2guAXDGSoNuaO2pT6frdTXzg;5=gz%Xe%dGkY<xwKxTePTR>)hN&O(rd;nzTmvofg
zW3&yBPLNKKCN|i*<)mvsTK7g$45W2$1!>*eN%zqE0Bt)-yGeUVS&)wR2<iWTwC=D4
zmdZd{_fnA7y@GTdy*0GWCoLtlk=B8<?l#hwL0Y$;bOfYze+AOIza{;N-r)<acNFPD
z(iGAxkk*|~Y6ofEJ4ic0TK6j;t@|y~Q}iCB?GWij(yOFDg0$|aMV8(N(z;coR*=?>
zfX0@{{kmI78|d9a+cwgDq}`+^L0b0^>6aj_J4h;9Z0lYM8XMHTf^;3dHMGqqEhV*)
z)`86YlD-Tw^GiAcGV=@4y1ym;iQeH$talXYLedn{ERdOBQai}ZFKH*p%r8jmev9-J
zy$5MKM0%0*D(R0PGrvnMO#^A&8%V7nGru6Mdkbj;y<2G8M!Ju*oAe~e%rEH}Nb9~s
zDr>ZLF9n(TC0$2v4Q=yDOG#~{bs#gpq%VWa{F07<%>07P{F44e@9-O~cNFPD(iGAx
zkeOf7r$Jh`m$VaP<`-n<m-H092WdM*dXe-h>5m{YzfG2=fz14pT0v%hL1unQ8|d9a
z+cwgDq}`+^L1unQ$3SL&NoCEp?xi3zzohHvt)Xo`X(_3Vv<_tEm-J=OMZuAwpL7Id
z<`-n<m-HukhcC0<QKSn=Q%JKw6M`D^NuLH?6xe!6J3(fCL1unQPtkjjwnL;BNw1Rr
z2$~So7`5EeG?3Q4fz%4RIEagY%>0rz(7T1UZKV51yGc)iwC*9&F_6}Mhg8;L>s|^n
z^Gmvp-WuBGla`X&Nb5jacN=LBNb5dLIs&>l81Jt@W`0S3qIdXB);o%HA!!O}7D(&P
zCw&@Z=9jb+q;<anGV@D%ir#~?9U{F*dX@A?keT0BOVdDReo3t$ts4QE`6X?jcMEOX
zNcWL;lb!^b`6c}xq;*Gq!csX%>s|%Yy4RBy(Az{?E2)i?B5eg}-JPT-Kw9?&(f~;7
z{sE+Q-zJS-VZGx)>MbKpAyts(g0yZcDGk!P_mcWRTK793&HO#mkLi7xwj-ohNhe4n
zKWXchk!FFkZX+oM(z>^TwC?Ssd+2?Dww<Kiq`jmpNXL7G^d?B_j$LV~9AxGfq;;<+
zEugoFwpLObDMi`}GV@D%0%YcwGypR53(~r8lSY5addGv*TSl5fsvyk;nfWE9L1unQ
zeIPTxAkF+e(vRtVnYJUOS4k&GBR_5HmXT(FwC*BO3}ogPq;+p6-9zsKwCyDACha9<
zL1unQZ-UJHwpl6%nfV22-RnsU=xw5{mDEN`k+y=&{F0sknfWCRfXw`YwC>xa(W|U?
zJV?D|q$#8d(p-?4Us4)m=9kn5GV=@4%-<vZnBJFZJ3@Mubb>T8V(XTXW`NB6l42k;
zzaXu9JLw*JAE0d~X*X#vDGM_5OL`Mz=C|EaImpZ}Nb6otT0n0TZLOp>Qi`+{WagLj
z1jx)UX#iyA7o>IHCXMc}-ti#ymXW5ADoArdW`0R&keOdnAIQuvNHc$r^kaHortJvn
zRniI4$WB|gj5Hmjb?1{}ATz%pt$RD^9(o_3Z6|3rX)h@YGV@FNJxJ@0idrfMnfV22
z-RnsU=xw5{mDEN`k+y=&{F1&6(z=I810XZMAg%j0Y4mFA9S>4(8EFcsf;1Oo=9jbq
zq;(%8^@FtT0gz^Xo^+JnW3&yBPLNKKCa$q{%SkmLt-F%c3(~rqL0We^X&1eFXzL^G
zCG9622I+VQNPh-t-LjaaDv;K#25H@eq!skG(-tG8NE=BzKw7ttlm%(s*GPjPtvf7k
z>y9B!0;zWzZRMm2(ri)-NbAN(TR~d)5mG-$Gamq%`6V5t_ZV#hq!Xl5q=`4%y5*!A
zkeOdnFG%Zd2ATOK?V@)NZGEJ@r2VABATz(Dk+;~oQ%O}Ity>K;^GjMmZ#!)<Qi`;Z
zv;$=3my`vW`6Ug4wC=EktviM^38da>w3U-8NV7>TATz(DEg-G?FsUD;nGb-*mdJg=
z=SfHDJx1FA=>+K%Y2sR2x198Gkk)M_^@6nSX3*H6?sn2HdiT)QN7_r;PdW@T^Gh0@
zv~?$wsz6$|8l-g>l2*{$PFswWB5fq?0GatE9R%rkUm*>GwC=E!tviM^38da>w3U-8
zNV7>TATz(Dtst%Y2&o^WnGb+;yw8)4(tC`y0n!Q5DbmC)TeqB41Jb%HNxdMgyBTEW
zm$ZxCJ+$?a_LBCK4uj16l1AQY>rN$AfwXQl$jmQk1-<RG#YidAM$!(DnP1XDkeOf7
zAV}*DOWV3*NRvS7okm+Zse&|{)B-Z|OS%)Jb$62bL7Mph$jmS4D80vM8z7w^ogz)_
zwsp%%9|vjOR#GoW>uv^_`6cb5cMolSq`jp5q{ARHzob8dE((qeWf@CVAgx;sGV@DX
zL2o;4F;a@Ok+cIeA*j(udIqF*kB|mIT6b8FtviM^38da>w3U-8NV7>Tpb0_U7-<Vg
z>po2C2VES*9RQj6B^{;r7;OWj6Qon5iR*0La#9UQ>#ijAf-Vl~ZU&k8CGDbj4{d#<
zy`=r5!yp~+0BPiHw(e9?6-et=gUtMrR?yo{Ta1(<Z6xggY27~3L6DC371AI`>kjL+
zb;pn<fz&&VwsKMhX*Q_^WagK&1!U%z)DP0k2S8?iNk{2DM%w`C1nCrM;(A-RoKyoc
z^GoUlY2D2rGry!=^zNapkF=MxpL7^x=9e^bgRMK2R0Yzy)gUv!q!skG(-tG8NE=Bz
zKxTePS&)wRHPRqR>khl!)*VBd1XAxb+R8~4q}ikvkeOf7R*=?xgwzkx%m+Ybeo05^
zJx1FA=>+K%Y2qEWZaHZ#Nb9a5^@6nSW{{a*(k^=U(AG!VOWIF53^Mae8vYqucQUC8
zq;;!7W`0R4=xwJhMoN)3l6HX1{F1UDGry!kkk%b`r>#4NGzp~MX|$D-DoC?QEg&<$
zq^%$`zodSUW<CHi^GiBP?=jj2NGC|ANE0{Oy5*z=Ag$X;+6L0PUj%90he(gn`vh(M
zr2V89Nw0%+yo03oZL)Q%NUb2P8v$wETSyz|-9p<o(tV`eq$fdI_Ymm~kdAl6W=rKD
zt$P(n>t0V<KyMRmt)w<minJA^b$61U1ZmxuNCP0P`v;KLeVa6Ti}j8Nske+Yg;YVB
z3(~r+qzxdg`yi<wq;(H~H1qSMqx2r5ZGd!wbc!_bE?c*pv;?GeW29{$t@}lg)_sWd
z7`;!>)=%0`dXe-x$ZS`n@t?JIuO!U}Y26z^TKAKro9Ru{)=Sz*x{vgAkk;)d9R}%m
zPm)G`&enZ5NbA0b^kI5u&{jp7O<GD?4br;3qz6D+_i@r8kdF5!Ag%ig(i`-?N!uXl
z6zRgPw(sR2ty@KE0%_d@X&cDQFUZU<=`nhrpsk;@pY$T>b&#1~(!|f(x|O8)ATz%p
zGry#p=}pttOWH`fkMwnrnP1XBfpokBq*2>!-FJh`{E|LQ?+n_iNV7>xNvlC-en}62
z%>0rLfz14Z%>0txp!ZGM21%z#7v63AUJf$zOKJgW-7eBLkeOeQnP1Xl^gcmbKWRVd
zMbhgaGry$q_t?5ulBTbYC!!_#_vce3C2P)WOZ8+bZi**6Q@3?jbVk=j6RECfx}vvg
zRz-4MBA&dZZA~;ey`u{+=e@r<9jUcl)8n0`V^@`&LZ0(V=B$oJGSe$7hapNW(>v4A
zj?B8CoLJ8rHr>mhIK4C4-m~ViW@!z_f9DPRwmQ7!^v*~oV%p~gF<qmydFO3^bEyj)
z;l&IunVxpt#B<&-8~Tk6n_?PzS@XP)R?V0>Q`UbFQ(`PviC-<#+q=6px}>BOaNe+S
zwwd$q2hfr{5+friDY*&%iBM<3C3le3S-uX7{HbMnCfb`(1Mcrht?Mvz4<X5~ez^TX
z<G?@9GiIu(^{>upEN|vnM$06aKUFvtmPY(Hvc%?@j#ed{&QcG{$sEgSSoUEeT+HWS
z>B8!Amd7Ly2IVY2k~}#U`F7lW7^aIEjXGWL@-3IbQi<`qm|9p)=2()j>^t9&*(rHO
z`<8ymGsd^PB6)Hw^3AvVFomwxhhXWtz_+Y|rSdO)%T`!U=2&Fi?7Ps9$x0q<HZJqO
zN}hN7mj9GIIhKoL0}TG`?7SD2XUF@!s$toLgNw`jNm%CKP~a@LN*)|+oMpS@$+5_{
z+isfZ#~hG6m-v=fB~O`ec}Mc(Sl)vf-t@oxn2*8IILWu%1k2R-_?9#*ujN>_!}7>v
zKjtx5R=wA^ydZhr=Ue_?$&+LG0Jg73ruZ=*hh^1N-?9Rhsh9eewXnRFW7#Bmrui{n
zl05JCEzd}v%Y4hvB~Om!O<4AQz>gV)?Y--A-|{|KDnIC3X25bX$FcyHedT`4N?5u+
z<XhxBa4SFTTmBlBlR1`t$#aDt^Rnc*(zl$DJRk8bW!V2t=2$)s%RU_5-8R+%OIL+&
zxgD0uO5gHj$&+JwTJqrN>+(D=d1m;QUr3&-eanAJo*c_~91r%*^kc4oWz$D}OC2nY
zvwTYwmT}kkmaVY7lw<iOEcaLWG4dU_jo12?=U|z7oo_h;%WFB7e}`q?^?uB79I?7?
z@GT#JrSfCGWezMSb1ZGJJo|A!<_=iypY2<|1k0*9zUA*>nOf~z{tqlCb1Y+Ublg|t
z$6NtRSFLYZ2uo$1Z%M*(GRN`-$y4vg$T!?}&GjvRlsxl%%cVFHpUkl=g=OD-Kc*9w
zRSmvn11#ef_?8D?c`3*8_psc*(2w~!ERBnN%W+u7E%q&?I1jv(W0?ZW{Y(6q>tShJ
z>RWDtWn80gk#DwrDaZ09$#bJ0^Q7cy@-07=Jk7r4KP69&<r18Q?qBA|Tn9_za^LbP
zSjM&ZmOEg1DaW!)^5Ejd?Sls-PpfZv9hRw|@GYe{<Gq$+nF`AzEBu&BSXO<~w^YM2
zb)|1<mOMF@l;ru8AM;ts^J(AmCCSs~TfQZEaxCAMJgfYepGcmFZ~2YnY4<JvEqQV*
z7mq`p4nO9@u&nCzE!V>`HR@Xy!tz><MXm_;t@dL+4@=h?-|`47l`-G)eOONBSdK`Z
zxF7ST<hj|mOvaT(<t@HtE-WW=ED2clCH$ECVCh=xTfQZElD;J?d2%fOCV5hR%t&0b
z$O{O!MSTF4%3FO)JuD}4ET4vDU)qo9g{7<8x7-g)WyZJk!E!RkBHw|#ug8yhUGl8+
zE%IHrmACnpvWt)>$8tR^`+EJDPs7r+-naC^Qn|smJRo^;EPEx-?S9O2lIITJ@+-;n
z8Q=0}$&+Jw&jjST(~r3pmQ5Rd%W_y6H~E%zuuR?TTkeJBwH(VHSoUr4W1fO#(_Oyh
zUtyW^S>JLVt|&`B=Ud(n%d<I_T39x1^<z3<ne%zyvRU$M^DTQMPmblslILz4^J}zb
zC)Y)~;%)1eMcNb5IdiUVtX{sPrMj`9tz}uwqB(P_OJ=WW(~yoxBGDAh^rVv#HmkaI
zVcWu+X0|O^C(+HBNT#QI&YU?bhV+0Vov|GntJ@alL?pVj`;9%(^!kQmCYoLy=?G-Z
zs%}JuoZ#5vRA-MBIlo~^^RntCwe@XnqSDA{NX9eqNFu%=TGG}QU)$BzHa8uOE{eCO
zBkA>XW?JLCXr?ip>ZtC-OYQFNIaSuaC>7~6!POG2;+7{9u-g{;)~C~{^kVdktU(<O
zf|>eTqUr8<D%qS#$CGQkfVy~hS0b{$E*)PNO`9O=ZvI4b8*-?xI@wv1jwCx`LxSp)
zJ!_Y&i+9E&Ce{2%vJ*EZj0Wdko~+JfA|0`4=V=2QW9z%)nA3TU%e(yqi&ATbnq_r)
z(R0(OwI;3Ym>VGhc?xW3Z5lT`qNe{DBazgJDO@zy?}@b4a)otE7T3oMs_yPib;Kd8
z^9<{^uA#Y6Cdmc6QJ$e&PLG_pC6Tq9JVd!{u7X)neq?=8_SN|})%K*jQ)xR01Qs$Q
zZA(oelDwrh)g$|t4R4NSnxd<*`Nx_t>ZRBq)A3H(YgQ+)BS-zsJx|Qio=jIyrooRf
zG8<EA>;|h-UKP({t<W^TZgE3%PgmEFcnNNk1as3^HMOZ^CY?&yZh^Bll}M$BI<Bsh
zX~FtPN0XW6MGbN^;)<=iy6)Pxrs$e@H-_I7?N0TiJ93@Nlj$?Ls}u1^cXLm0XsYgB
zhI>st>D&a^)1#S=SQGBs)%RMt*s(;_ysn<wR2pN!>L22&P9$_yatAbhFuo*mMLR>>
z7-~p_ao-fr#1_RnbJokyS}xfcqMO%aEv{X*zKbisq^a)6;HXwuO?_QMoj-JJdqYiF
zQQCKC>J}W$aYxc*u1&3Nk0&D;99{i{=smY5k??mCBdf8tp`jBSMSOJ}2jwAs5HqwK
zGS&2S7q)sEyiP45n-eL2M^Jl1(~UzawY0}m-A&PTaXBv(@-3}jd?vR!4-7e@XtnBj
zjn%mI>~EBIYITP|fb8Q#%9_0eE2zFMbz8C<n{Z_9P4Ui5Y)GIzss_7cP0#Ap(R6cg
zf;A^TRnZcMf=J@bK{csJy3;>C7@>9RlaaOYj>c};Z@VQRZ#P;Ni>B8`64-PyIH__b
z8)notMcv66&70D3H&%02t&PRI(9^GMJlH94vaL&X+~PZz&Rf)0-zzH>mmE>_w5uf7
zfsLiGqb|BS(v!$^pSGtB@G{tw%i<KSVQ`3xbVb_Z30%%ZIas7?iAQg<HPP8`8n3tJ
z)SqK8$J}VA^km}2sqRR;LylJTFH3c${8i#Y#4|6Q>glpNoJ&q4iAdL?_}X}8XmZFi
zo17%b?|XWup6^cYhir3_kwM8RrMqUm9Ox50IR^@FbShbdByhRo)-Y0;Iyn*Rtz0*V
z!u}kog+t6HKfkWF(X4DaD)(@8HRCK5O||J|5>5oG<7;}-!4VIatnxOLp32he7e<{d
z?Nb*`L^E>MJc~Xuq5>Uo*zMsF!$>-P`a;pVD!Af|LcK^CVr}TwU|vw<tOLEql`FS~
z<;h!;I93hmUKho|E44oNTG*rrPD|dwk3)&b`6}Ph&~1AR6(c)Gv@4=hF+>4Y;%R+#
z(GDD0yKxjbP3MMWNPujVsU&tSyrbx@T+B#x{!ZhxwNKyO7C(Iis?SaLbZ2_jR(IZv
zf8~gnKm4!|9M0qfwV*4yreUr3vdPZ0x*L-Py*M-C<Q>)68XOa$*1s@xt71t?&h#C@
z?lR;BnhC;i>em;TjFyI_!8K%o!>+iNc15|_NxL?Y>gH+?L+(x-Sk@;y=B9Ac%G6=6
z?BJ<Fd^)ArP3@WtI@n!tsIj@$w@BYy3$}rIk+o|hL!$C*vYA2@_TvZ-9Y#$-dqa0q
zPcrGfh7DB83wpm&b0)=8fdn+*RTeJZ7vY>L+X^n(x-cJj#o~98m#THR9_nz%Ug;a$
z2QY`_9ElR&9AA^f6-Ka1dAO8bK{CAAJ;Y^>w9D{1SgsMgao88z`g**fQw}b;PREsi
zUWB?UJrkMh^j?d)NPGS^r=o_=n)L?#%TgOPudbmn9bb#P5{$R2$H=a)t<`PHKMOlw
za1Uar3nx8n-nF#_owDWE)?(LjXNRHvv4IQ?v8wPYstxYBjm-_oPT9j!X_3cCt!rvF
z=d5Pj81b%h#bJ)n1w3-c1!;4x>7++<WSv}h<=OpsnTEOYxeRmrV`#r+si9syshabs
z-%U?#1su>|E(qo&QtgpMfe_gr^+NkhA*Q3h#sj^<ohUi25B1E&XG=_{n)NxG5LS<D
z@y5wLLDE6XlENMxdUaP<!W<s+hkqI;a(bSjGDV5!&QT*n@O=5hz}hvF?5jb+0@mON
zP+*G)1gwk16LR;%^lRwM(NQQQxMazRa%J^^Fm#<ezj%V{5ndz6y3g5$3Jd@{Cw7`B
eUi90me}B-%YbMo1ga#BS1DQ3r+%SnsM*n|(z&kzw

literal 0
HcmV?d00001

diff --git a/nvapiwrapper/nvapiwrapper.c b/nvapiwrapper/nvapiwrapper.c
new file mode 100644
index 0000000..e705c4a
--- /dev/null
+++ b/nvapiwrapper/nvapiwrapper.c
@@ -0,0 +1,41 @@
+#include <d3d9.h>
+#include <nvapi.h>
+
+__declspec(dllexport) NvAPI_Status WINAPI NvAPIWrapper_Initialize()
+{
+	return NvAPI_Initialize();
+}
+
+__declspec(dllexport) NvAPI_Status WINAPI NvAPIWrapper_Unload()
+{
+	return NvAPI_Unload();
+}
+
+__declspec(dllexport) NvAPI_Status WINAPI NvAPIWrapper_Stereo_IsEnabled(
+	NvU8 *pIsStereoEnabled)
+{
+	return NvAPI_Stereo_IsEnabled(pIsStereoEnabled);
+}
+
+__declspec(dllexport) NvAPI_Status WINAPI NvAPIWrapper_Stereo_Enable(void)
+{
+	return NvAPI_Stereo_Enable();
+}
+
+__declspec(dllexport) NvAPI_Status WINAPI NvAPIWrapper_Stereo_CreateHandleFromIUnknown(
+	IUnknown *pDevice, StereoHandle *pStereoHandle)
+{
+	return NvAPI_Stereo_CreateHandleFromIUnknown(pDevice, pStereoHandle);
+}
+
+__declspec(dllexport) NvAPI_Status WINAPI NvAPIWrapper_Stereo_IsActivated(
+	StereoHandle stereoHandle, NvU8 *pIsStereoOn)
+{
+	return NvAPI_Stereo_IsActivated(stereoHandle, pIsStereoOn);
+}
+
+__declspec(dllexport) NvAPI_Status WINAPI NvAPIWrapper_Stereo_DestroyHandle(
+	StereoHandle stereoHandle)
+{
+    return NvAPI_Stereo_DestroyHandle(stereoHandle);
+}
\ No newline at end of file
diff --git a/nvapiwrapper/nvapiwrapper.dll b/nvapiwrapper/nvapiwrapper.dll
new file mode 100644
index 0000000000000000000000000000000000000000..b33032408cb433eca5a4d0dc71319ef1d3956985
GIT binary patch
literal 49152
zcmeI5dwf*Yx%W3Ag8_qy6l&grO{D0_@d9(dUxE@EZW68rMMEHi!!3baC@KmXwS-_n
zYAscd+^kK3%B7a3f+YeS5YvLx(o{VHmfBHLxyVbSQ0M(U>zO@k%nWDmIhW6Q|LA-^
zd(E@<`mJZaYwc&Rz4y#sd&b<oO6jgBN+y<QR8d;+POl=7{>Motim%Ck?Hc9Pp1-}J
zrQ7J=-Y_vVtF~Z%P4)dX74r&aR8&<}*A+|;7Sz;N70jwC7&dl7!My6q;Naf9dku=Y
z&N21*+NjdSMd~u>rV~XYkRNo@hq3o#Mc)?rKZ^YAg=dONg#O{8*?7Nm>VTq=qWoy=
z{jah2lj42+tQjHl-L)m9#fmbzn?d<3C;v{h?1YkW!`0n-DatcgQ^;%Ye-ZDwShk6L
zuCOx{#h`Q(E7W&|^611NFLqNhlp<tMiR#7QIlJ^1iV{NUtveLOOT|YN<yCe?Ir%!F
zD9wEoWgR|ufLxnooke+3;#%ZaB<8!=gX@Be>agyS?<2{@LT#mupYSSBlxc%&Dl6(L
z6eZFF1@Nh4VOfJE;Z=l>9?UYO{c04nVnO#Q>#!ueicm7RrnY7V)`_+rfq_0$HepG4
z6_LN1;M{5mKSA4-6Il9U*@7kERir4lCuIL={ug@S<ISktCSM<)Mli~3+oYzBrsAy9
z$TK4qrD1>Oy?ZkgOWWE$?mr?~pWQSjt8`qXU=-EKx_57utRwuz$`$N+Da-MBFNwOz
zpNIP64isOe7B~2o9z+P&e=D?mo01#tmxXjAtx^kmwR{<kMnCR_7KIL?a6J{4M*C%w
z@NpreRH@Hz>P<!CqWuu+xd#lwFMYzn=*Mk%4;4mAyG8qnD*H1Vi!V1kd|9dg*8>Jo
z9fGEQRAqds`m{4fCtZG`weCi#S4omS?)0?K3floo{IfPLgWu4wC;e08suft(;G+Vi
zu4jXfvPxYab<Op$HT8WD7=#9&f50F_uq>@jf4O(xSGR9NNA`hY8q3ulC9m8uy;?3)
z559!5&?EnT%h5PQV{vE0!<|Zfua<w1paFvDq)s%_fId6@9obTBt5;EYp!fn(<#f-c
z;tLI}-5QH8G>y678FTsJ{H944<{ZsF@K|Omnt>Mtb6T^*OS33{`p6ZwjIOp(GZ8Nh
z9erc%sT<tj6Q5ImW6n+keZmv1_1_4s$h>WCyk#3n5Eg~qRP|M&m8WMl^`^qcF_#Y%
zpC#5<tJJRV^VFoX<73{a>k->c#o49U8O9+3kZUaNP`B4NnkIFOM_W;Pc3iBE*s%L^
zn~FQ+MoQw(rG63oeO3M+2MjVgH<BQ1phEDoI>sMt>P>kKe)bmU&ngw{i24NfF&*Qu
z-N1jgG{pK;>?!+y00@}B0G8<gw_h6fx$J)ugbh>(epbu=r@RI~dyDhy>VK}2strl~
zUkC!`zZI6?|JkOS{#EjmAZ(yQ@UvR-Q(l9gy`{&`b#(DtLBRY@Sc1RzJFh<{`AHBq
zP$BqPE%_<0!Oz~(<L5fM_=`Zm{KH@g{%NZ}D3JUl2pgyn{H&Jzl-J;AZ|U)K9bNpR
zLBRZ_umpep>Mehf{3Hk)s1W?Dmi(00;Ad~?@pBzr{AD0u{;9A8|CCRDULyHP5H?UD
z_*pIaDX+oL-qPdeI=c8PLBRYWSc1RD56)O6KMBGHDg-~PWBl`)dQ)D5pS{KTb1}ka
zW3<c~FUHaAuZ*L`9VoqkQXDt9Ue`7xjX(22!2ETv1b@Zf@^DrYJ3HA(g0O)K!Ov>h
z|CHC@XK!(SUE?R$>B^pR{9g<L=3fd+@W1%L=QAWf3Bm>{1V5`KKjk&}*;{)2Tt^rG
zG7vET3Rr^w@cgfRD)~teHc%n>SuOb~uffmW(&Ohky7->~0rRhcCHUXYJoYomPlB+4
z3c=56$xnF=e)g6gKiAR4zYYY<{}L?0Z~kKAE0UiCVFML{pVcvb?7x)P;Ad}fe%<>o
z*X!Dbr2Tgb2$+8xEWvMmdaq6LlOSxMLh!R%_CMt{_}N>WU)TQ2b-J>r+<#j@!2G*m
z3H}}34L_0mBnTU*5d5r`{FK+=XK(58a~)m$`$53`2Vn_*L(@+NN`4ZA4O9qzR!e@$
zYw)wT^!T}sF8(7RVE%Vt3I0`oT$XVBB|+Fgh2Uqk<fps_KYL4$pX=!2e;)+Qe*%`^
zf2!|{LfQW$2pgyn{H%`g<NAg28vN`n&aZj>!unL~DdRr^0_N|4CHQ}6{Q73ePlB+4
z3c=56$xnF=e)guHpY^)=FMxpgJ7Ed_N$>sQe#uXQuz?D}&uSSzl-J;AZ*hKI;}6$K
z)rO?;Q+Y$>&x9rT&0AI*B|izm1}X$Ut7H5NntD@SgP*;{`TODwEf;5K*|^$`#ZvB9
z&fyZTg}H93c2F$QE2%x%AmZ(j3rn=;k?;TDPqIBE2pgyn?P0at9+cN;4||KZN7we?
zI;q-`#GeNO<{tn{@ZbO0*s$a$LD)cr;AeG=AID?LYw)wTIKS@WG1u$bh9v$$AYlGN
zSc3oVkG}SW<R?McK!xCEwdAL~20wdCpP%b#@*6?G{8m_ke_z$f*^-|GVFML{pVg9|
z@*4c?Eq#8jr^)XH0rMBZ68wR!_fM1jBnTU*5d5r`@lSaTe)bmU*A@R<rz?BP{kH@J
z%s(2I;P2i3`D)2eg0O)K!Ov>RPk9Y~_Ld$$*U`m45d_R%221cyY??nx@{=HJphEDo
zTJlp~gP*;n$Io?i@lOK*^H;(W{Fh&^TqpTS5H?UD_*os}$N2>1HTc<EoL}>Ng7vA`
zQ^wC+5HSCISb~4kb+_!2{3Hk)s1W?Dmi(00;Ae08`B|@<e-Q|ne=#h<KlGK~C48Sn
zg0O)K!O!X#KaR(g*WhPwasIT9$6WVHZArO39tRP(XBjNs9^F4kxIQ33*g%D7536JC
zd7!B`<u%%~NqCF5X8_JG@^F697v~pUj%|5gInPM^u84i4YFE<nZ54>PJ<q@r?fLHP
zi~};hNDwwqA=<<0SbOk$2jw-|!`|ZU(KWtu9bNn{fPnee!4mx68$0P?$xni?feOLT
zYROM|4Sx2P9zWO7#or79=HCKK@V~joc%9@YLD)cr;Ageur@RI~drOa>>*(Tt6$H%R
z0!#4s{9tJh$xni?feOLTYROM|4Sx2P9zWO7#or17=HCxX@VmCII4t=|5H?UD_*pIa
zDX+oL-qPdeI=cAVK*0P*U<v*M-ppquKMBGHDg-~PB|qgg_}N=}{9H#De>(`6|9x13
zzirQ^*Cam)!Uie?KdU7_<u&-(TYCIlM;HGo5HNoPmf){`KJsVDPlB+43c=56$xnF=
ze)g6gKiAR4e-;GHe*u=@pEdaR4#`h~uz?D}&*~UIuFoj1!Oz~}{9TS=SN^?&>ve5I
z((&su2$)~l8{?l`>5E8y5`+y@2!2*ee#&d`v$yp5xt=C}7QmQ4Tjf7x_;HcsCqdXi
zh2Uqk<fps_KYL4`pX+Jz_XPp-=fM*3^UmHk6MiovLD)cr;Agdrf68m{v$r_EuJZ@3
z)0I8t`CI`An12u~!N2x<pZ-qvKMBGHDg-~PB|qgg_}N=}{9H#D|E(Zkej_ZwU$yi2
zZIYh^VFML{pVcw``ljBL*WhPwasE7<kM_m+XfDo26ShU)ubhh}-n+u}Q?(`K_HcrT
z+v9~L+Oz!?&pz265`+y@i1x5rZV$?9w1>UL+mq0SE8l;^byBq<X*?PR0_HD)CHMz@
zcYA-yPlB+43c=56$xnF=e)g6gKiAR4UkU=|p9o9v|E1+b0zV1D1}X$Ut0h0>HTc<E
zdi-2R7ynccF#j}If<MRB>t@;iBnTU*5d5r`{FK+=XK(58a~)m$ArLVCTv&qtx`_);
zNq!Q94O9qzR!e@$Yw)wT^!T}sF8(?YF#jT0g1^_h`?g4a5`+y@2!2*ee#&d`v$yp4
zxsERWr66Gb$6*P6)1^BS##0i64O9qzR!e@$Yw)wT^!T}sF8&oDVE$FG1pmYTsQ9t$
ze-eZZR0w`nOMc30@Uyq{__>ZQ{xu+A{uf{g{%8Irvr6)lAZ(yQ@UvR-Q(l9gy`{&`
zb#(E+1On!7h9&sd-8drQ`xFv{4O9qzR!e@$Yw)wT^!T}sF8*yGVE$KO3I6T-N{-0>
zCqdXih2Uqk<fps_KYL4$pX=!2-wguhZ-piJyPv)^T=J73Y@kB$vs&^~UW1>#rN_^8
zbnzbq0rR)P68yt<X5KCNNf0(rA^2G>`6;i#&)(AG=Q_Ih-vI&hx5E<r-zxq?!uO*j
z2pgyn{H&Jzl-J;AZ|U)K9bNn<K*0Q`U<v-e9sMBT_a+jA4O9qzR!e@$Yw)wT^!T}s
zF8&S>F#lOtf`4+a%7pJDNDwwqA^2Gx<Hz+p<u&-(Tby6_^*q<>+J>a_=S~nX|7BQ$
z|2KU;7$W1J1YrXef}hp0|0%D*&)(wvy3YT(PFMDn*Dsm-RQ@bjg8!=1eG<NpAOYqN
zAO%0GB|qgg_}N=}{9H#De=Z2P|NFuc{D*eEJ3;n82{3;EDfn3(<EQxpSgpa&-s1e4
zzn8H-6?@A59{>X8FMuWZmycQhTgguX%pX7sepX9<%4_hmH~svq*UeuD0_MLJmf(Nz
zjKL}SNr3qSNWstQ7(ae5qr3(`dyDg@^?MoDy;56JZVxMnxIIo-qCH>#!QT>&2PD9J
z0;FgUt7UsAuhAa%_MdAH*G;QEMIhq#41*=w^GNW)SLOC00p=GVMSEBsYY)a(%4@WT
zy~W$3dwk`3UE7j0zK#X~^OwRB{C)CQC)^)P0?aQ!3Vv2ge#&d`v$yp5xt=C}83>qv
zDlEZ&@_@l3`=11uUw{<+td8;H_e#oZ@Uyo#zpmp0*Xhcha(}1<0rQ7o3I3gbysM|=
zCjsUcAO%0GW&cxNgP*;{`E|z+*X!Dbr1+T+0_LxSCHNcv?N`SnKM63u04exc9plIN
zM0pK<_7>+)YkcCmUE4t0L475)XEBJlJxgJU_Jm$+N%;Me1YrXeqCKpZ+k^5N?O|{6
z_UPUoT(4_elK7W_fcaOz68sl>?S4;g4-#O$0aEa@T5b=@Yw)wTIDcB(gX?x}gSsu~
zJ*hp<fQZ|(29{_~>yk?|WqU|~`3FeR9#+fkL3xe#u(x=7bZ-x?*R?H4{Odr#{4c>0
z{EvEf{zLMU0P_!!f}hnfevD6)*WhPwaeiIn6W8g=p0fY9fPne8!4mw}I~(7U{3O8q
z1Ek<*wdAL~20wdCkDu%4;%@-~^Y4Zw_|HD^>>9~W0?a=^3Vv3{_;G&@<u&-(Tb%zt
zb$<@~(AA#(Ama8MgeBTzDxCPdY!3-A9|0-a!|GUj@cRzsHQK}8;_XTM_Z_aEsx2ww
z>j;RrJ@3F0?YZ+AbBAmX2{1naDcZy8SbK2%pu9$V*jv0kX^mH0_eyO^*`D`7#O*l&
zOSEV1%ik!M?IA(fK!s=zt7Gk<`3hLA(H`~|Z;$5n66>$jhNST-0s`jmfF<~Ue{kOW
zlAi>auYeT%td{Xbc@2K{7UxepzPP^b_FMoFx2F@9XwQvPuO2GfLjufSK#KOTT5b=@
zYqW>G#oME~Jy@@sU)itnXTlQvuaD2VDEUc%`3p$F&*~UIjvtiQ;Ad}feqF~8u9K<_
zN%52o0`C7@Sc1Q?anv6qKM62j0V()dE&HGH8vN`n&ac`3tWU+Ba(~VP0rL-lCHUX;
zUR5XgNr3qZNWsr)$xnF=e)guHpY^)=2Z4b33t<WV|NCj<S;<cV%vV4Pepbu)p}Yn^
zdyDhyiXX0%strl;V*~;7TVV<Qj@1i)E%`}+`3gwE&uZEKl-J;AZ*hLj_+fo2_LTAC
z1p)IH!4mw|mg~+*eiC550#fj^TJlp~gP*<W=V!fc{t^%{|7ci(zhrIEAjwYx%vV4P
zepbi$@%;wnHTc<EoL~3(H`nXhj->dR2m<CWgC+P6f4X~w<R<~<D<B0wt7ZICUW1>#
z#rbu`KiBEXo-%%>fq?ldVF~`?;upRp`ALBJ3P{1v>KOlhn6H4<8vN`n#*b$XeC5WS
z#GA-j*abSNzvto;nRh-c!Fx;gZw5<V5@3D;Qt+}`@={)dm%ZuWWuX@DB77qAE`}v|
zPj;?MxL=I~n2&%IysVD#;(U$r8ocZ+9v_<H3+uaJQ)q}+Qhz@V0_I-^OYmQCJd$vK
z1qm?!04excE#sT=8vN`n&aW%JxlXD!B=N5T0rNitOYmDw{oFEMNPzhUNWsr)+5eQ+
z;Ad}fe$D=8eJXa^07?8WfPnee!4mwTpRG?gKO+I=8z2Qgt0h0>HTc<^ety>L=5Gc8
z^KXGA_@DhClyH9w2{7LPDfn3}`6;i#&))R&vtBp<s~}+h7FdGcxO-c^j2{wUz5!D3
zvs%VK<u&-(Tby54{BxaDZAglrRuC}%epnp;H{=&feiC550aEa@TJlp~gWoE=rN_^8
zbn&-=fccNW68sz2_LwU9Nr3qVNWsr)$xnF=e)g6gKiAR4-wp!ie;=0MFB_KmuH+{H
z<{KadKdWW@Q(l9gy~X)8#~;?GVoy2#oB{#!M_>v5j*jLxB|ix;-vBB2SuOb~uffmW
z^z*Y`H~(1>F#iQu9REGHjg<T(z<dLw;AgdrAIfX+TZOkczpnk4>!fN!(*AoH1kA7e
zCdNPN7sq^(p9Gk1fI{%ITJlp~gP*;n$Io?i@n->y`Lk92>;C-R(UPA8m~X)Rtd{XZ
zc@2K{7U$QDf7YjBPZ|GxLBRZZutfa)deg(}B|ix;-vBB4pVg9|@*4c?O+P>Db@La1
zfcXc(68v{O-|&&-CjsUgAO%0GW&BWHgP*;{`E|uV*Gbier1-xT1k7)QCHOZi`S2mh
zPXf$0Kni|VOMc30@Uyq{__>ZQekTZ+-wR9d7j3`w`;wmom|uVt{H&Jzl-J;AZ|U)K
z9bNpxK*0PZumt}ve)LF_<R<~<7a#>ct7ZICUW1>##rZY&U)HB$Pr3h=f`Iua!V>(A
zEC1k?{3O8q0;J$)wd{Y&Yw)wT82|FbIVxA4-@$cKwIM0~r-Fd_r@<2ZFBUyNNAi;Z
z^9zuIpVcvb{2oJj4Sx0(@Bg&FFX#HH+LCg6gh0gYnF~v_=U+_0g!xY-z<dLwXb-F9
z_Mp5*d)QmNJ-Wstu9K<_N!z0i1kAq(mf-LHwKuPq+k*s{Z-5m1td{(g*WhPw>G5+N
zUHnTy!2FNH68u9;J{>0cNr3qVNWstQ7(c#mqr3(`dyDhy{=SXtb!|gZ|E~Z6^RI#>
z_#H?4C)_Vi0?ao+3Vv40{-?YKKYNSw>xv())0I7C{I3B4^S=N~@Si(1_Zr#%B*1(F
zq~K?@<fps_KYL4$pX=!2e+dN4-waFeZ!CH0TFFlW%r`&^epX9<%4_hmxAgeAjxPRf
zAYlGiVF~`{7mfVA<R<~<8z2Qgt0h0>HTc<Edi-2R7yoV$Fn=p7!GBf9oeA+ng0O)K
z!Ov>RPk9Y~_Ld$$*U`m)5CqKM221eQJ=KwLK1~A5H$V!0R!e@$Yw)wT^!T}sF8+5w
z!2Ip7IR0yTC!CLx0P_uyf}horpYj^~8-=&@__>ZQ{u3Zz{!_37|M&}|5}w~c0?ao+
z3Vv2ge#&d`v$yp4xsERW4iGT^Sy+O<hwl&gs|59V!z93b1Ek<*wdAL~20wdCkDu%4
z;_n0j^IwJ~_}^~+;Z2gC1ekAt6#T4~{FK+=XK(58a~)m$nPHVb3zp#jY2SgvB|ix;
z-vBB2SuOb~uffmW(&Ohky7+TJ!2RDBmf*i8^Yw)ICjsUgAO%0GWBfGV0IN0l*;|}n
z^LmE$sn}DVKMVi?^B2Gp{2Nb366YIWb=W|K;Ageur@RI~d(+R)dfohmAYlGmVF~_Y
zKi-gVJwpP_H$V!0R!e@$Yw)u-{rs%g&2I$(^E+V){xLs2n=t;90P_owf}hnfe%wz+
zc@2K{7Uxgvelo6mrM9Gury>w>dxpUh?YV2x;)MH0Nr3qUNYNfv$J&GYe<-if9`+V*
zkFN7+u9K=AN!J6TLBRZ_umt~y)*n16$0HJ8egRVOvs%Uz<u&-(Tby5We`b9u_LTi!
z1_I`v3QO>x8uG_aBtHo-zW^!tSsmlY^%&(f_}N>WU-$JG*X!Djr2el20rQ7o3I0fP
ze!_ek5@3D-Qt-1{@>5=epS`8e&-FC<=YxRx>tG4~eht$S?x!RH<`*CZKdWW@Q(l9g
zy~X);#Xr~S%APWQ7K4EKm%<YKufBFZOU4fgFrNS^_*pIcpYj^~>@Ci(JASxc*ES@@
z&oU4&{|Z=w|HtcZNw}UQ0p=4R1wX4LKjk&}*<1SjTu+n#84xi48d!pV)q>(zWdD-@
z^9PWEpVcycD6hfK-s1ea;)m;WWltGD>p;N#FToQ0rse<kP03FJ%pX7sepbi$aXv(O
z4Sx0(=hqxRS)YnMCI1!>F#k4Kg8#F3uRkRDNf0(rA^2G>`=9a}{Om2xudDyLPO3H}
z#eWM3n144c!T<6T`3cW&AOYqNAO%0GB|qgg_}N=}{9H#D|9%iK|3O%Szo27qtL%Rg
zV7>rS@UuF`kK-5RHTc<EjDI<vNxEF$|JQK6u5C!_|05t^{&!$;{5<=U??`?UV158n
z@UvR>Kjk&}KNH^4>wm7(l|5zrzYhZDKLJbd|H*Z6faE6u<^v!FKdWW`Q(l9gy`|s(
zT(4^zlKMXa0_N|4CHUWqEc}V&CjsUIAO%0GW&cxNgP*;{`E~8TT&F90%KpCq0_N|8
zCHM#b;h7$ip9Hx7A1U}*9plINNqG%^_7;yH&GD1<sn}EUD+g5mOjv@y^YEV%?oS~B
z?*B&$epX9<%4_hmH~svq*Ug^|0`C7@Sb~4f>-Q!+Pm%<<{~sy%SuOb~uffmW^z*Y`
zH-8=on128)!Qc0h-IrzjkO24pBLzRJB|qgg_}QC&e%9;e9|QvCFN7ud8zX;9_&%Kk
zxc?t1_*os}$MqxSHTc<EoL|@e%XLz<A!+<Ef`Iw0usHtj{qPpq|0KZu|46~lYROM|
z4gOByEj@m&ql@1Q0_HD*CHO<ru4|M0BnTU*5d5r;@#FYQc@2K{7U$P}{?GNgwjrti
zOF+Q<qhSgD9_F42&!Z**?*B&$epbu=r@RI~dyDhyiXX1il|AM7IS~ZRUj|F?AOB5b
z!ts{`xc?t1_*pIaDX+oL-qPdeI=c9$fq?ldVF~`V(T6Hz{Ez_m|04xIt0h0>HTc<E
zdi-2R7yn!kF#mj5g8x|cZxi@QfcXGO!Ov<L|CHC@XK!(S-SN-$y0#%H{uhCO`4__y
z{6GEu=C8~CCjsUMAO%0GB|qgg_}N?f{9I3y|8Wp7|1wyD|LW&PJ|g)^fcXJP!Ov>R
zPk9Y~_Le?B*VE)*1p?-O2A1GI@lD5W$xi~z4?qfjR!e@$Yw)wT^!d4-CjSc{VE%Qm
z1pn@_uO!@$LITVWKni|V$M|vlrMw0|dyDhy8b7&CSN4?SXEO+xe+w+Z|G`hceTVFS
z5@3D+Qt-1{_CMt{_}N>WU-$mY^}4npY5#o{1kB$8OYnzB&AL_clK}Grkb<AplArP#
z{Om1#ey*p<-wFce-w#Xh&svfHH_1-|%nv{cepbi$@p}g4HTc<EoIkDKGq`ToHc%X?
zucYnK1|n|H5m=%<?&~%zk?kP?<_jQ2dsrQ75AK(vyheN2Tf9AK-!I4Yuhgcb_OyeD
z+w(pw(ViVM|MID94+$`T04dtTYPo$VuhAa%7H>~l+lT93sV%gPlG<|$MBJVTEYY5f
zqYvLD+d~4(CqRn!uv+dfl-FnvdyBV6_x{fHy0#^W|11cY{{k$*?`+spEBQ%)`2<M8
z&uY0nD6hfK-s1deZ4a*7wGHaNl5%@o1`)SMIT&ltyDnqG_tzu{8>kTNVYS>}D6i2T
z_7-nX+WQOFzfzl$woev7xjorxdq!3iB+N%A0p=TUdsrQ74~~bF*JuxWTLxjn{;aP&
zlm5#0`*NLBZAjwp3&+f#2TR1)s<rzD%lIMz<{Kcz_F%Q#KPa!k&)(wvy7v#R*R>5v
z`~@Ij{z0$=|8INNz9sodfcXYU!Ov>h|CHC@XK!(SUFRcQrz?BP{oz&+FuxI&;II1i
zfMb%M1ekAt6#T4~{FK+=XK(58bDb4%-mpKnsko!*FZb@_y*jD?oe(j<7nb0kK4U||
z^V~^*`36YA&uSSzl-J;AZ*hLz@x%4Hwjqgs7zmiZ1eV}`X4}6^k^N5s%r`&^epbi$
z@qH@gHTc<EoL}?%RMvOpR>#yN{!$Py|3p}V-&#@rh2$pz<{KadKdWW@P+o(dy~X);
z#Xr|c)rKVgsUTqfX|M$UH=SoENPZH84O9qzR?GOIyaqpei}UM_AFkK64N3eV5HSB-
zSb~4u%*PYH&n5xp7a#>ct7ZRFUW1>#ErU@1_|J8|%I@hsA3o|cKHK;454$T$Q*?4@
zsiG*+eoMD0xl@|XPLB2~fwl3-TS(fFJaMt!U}-J7Z(qYrN@R#ZQ9_TdQ*tBMz&emQ
z=-IWfGhk1#wBEO`DT<C6H*SKZb@E-V;_P~}%diTc_Q<y?*XPlP^rl=>S!P4<veIO;
z;&b*K#7BJm2?{N(AGdZ>l!k}1yX8Fbb6A!5UtFwjnv%)VMoe-M^3&IP_SIb%iU2>_
z&j}~9l?iu6kD=55ditsZ#o4H<tltm6vor2{qP4E)?EJ`}9*T0>6?y^U&@)I57^s|t
zk?ts(GUbWZoF^WPMx&usBw2wZa*A5jXd|KJy(zAHv+J|)G5x$Kb6x)q*47OO(OV>%
z2_ZhHceFlta<m>dLD1@`X!^$=<1_w4+{<y?hR%$--hllMeelQIP%&zw&Cp~UhR=*1
zLk9r!@di;qn<jd!sU4>Rjm5c*_hvPm&h*@yU2|uHN2&WP+HVnIcCY(5YN3jqyrQvt
zbW$ffjUJ2I$On}jYZ}w(8k1XZa203O{jzZkVi8WWn%Ylqiq>aG`z?kq429%UgoFqV
zOY27J8dve<`mEAezaUP^@4M&Cz1hm_+|a@8=$k*IZ<;=DI^T3}7781SPg&kXpf}nU
zArKmiFMH0_=ek5x)Mqu0IrZ@`skhG785+LKs2{xk1U}I7MqSojlP5%vpl-v%r<9z>
zzYh)8L{|PI8pTTLlBKa#Bk*aY`?6d8AcRA~U8NHuHmth~5fUkfUbw`j>OpIwN1nJy
zAJx774)Pa3IVyF(fj_8@KOf>7)z3fOpALdqO+6dOoG2X^`2zxQ%9MRg!AL{!ltM9m
zp!o8a2%<<&@H7>lirkFP-gm%2jm7FH?;jN5^@hl|QHEf_-)iGuwIgk)H|1V*9FOo~
zM|!lQ5TCGd-J9sD-Y-zvZw;l_KSQZ)6{WrvNN29-*CO6}ZxL_TFB5Nu$Hm)?OU2u5
zi}CitO2an1H5DrxUlQ+`8=LX|RB_hES1JF*iObRG0mE4UcT>74>#1<#OUNBCtU=l{
zQ)xY5ctMn6AES|^@ria+Szjm2_hCl+6;PZ+uwr(%$Umr$W@A4cgq5LFNTU4;k>WR1
z2$cFPX#PZ+5c!VwyA@@n(SAm}y}2*68vzz+rQ&^Uv-^h5QbawSk-T4=YUrdurCqNS
zHK&}eoShYUj_T1?Q3D>4!7)#J#EGYhPn14Ye5#bTfsKZ|=&{nsG}LL>kKlhlT7N2f
zOaywg{sb)ASH8M=-;ay}%07J3AVDa$8N5ZtqZ9t#-oN$l?Ndtb#WtVZ(gN^bQ*u{R
zrzc#S({vTWDkFNN;XtP6%bIiLG;&UEX(bgUS5&Eo|2FYiO=GfJ#@wwaGhN;4GA*t6
zsG;8OZ#?QOEmoBJGnS*jx*9{vOjk)>&NF+P_Nu3D!UxyKE?(m8elX{kL;Fscob$^C
zJuFA>dTLl!9(IfVO%G=`m1KK9uj$!Tmeu`Fo=Y{oZf|HU^c<^+SX!}@f5jd1%>FWz
zy8~PKM;nyf%JtX<l+uQdtO=9v5`khW?zH>{J$|-wBNa6UBj`@DLRfMmH>1-U_GhAB
zCgLCFZ=-dkTv94ZvQXk~DjM`gB>(S68cuYJZHuNcXDb_flbb1kq7ziHi&~C8>cS}6
zDq2o^XiRQtO|B5Vv5vO>jq^o1SEM1NqL0MR+6OZdutKTtDMD-jYz$^{Z*6PiHb-p)
z(ll&PZsXiRxldua<%DehWi%hHj@EZJ6<?0=VDydm$i750Zp=6yF{1T-acJQP4}J0+
zx|sI7$R2!H!~Q%9F>yYUEBd)1*eS-M33u(e^P{3&yRf%JJqPM~Ke4Z_=iiTPq#gBi
zaPm{do!HHasG0SbE%i7)WK*kf!I~R;?<?Lx2VEZNiZ57-&sxrU{$798ugAjk>D(ti
ztIuu<_rCVqit@&Z+^f$v+KB7##~N+)DfgA%^X9&`=#7=A9KCUxNT-UlOr#S<`Z!YR
zwg27Mg&m5L@pDD#i)HjL6vd9^CM?-l&c3QB?_>EjmJL|Ghvh*mQ?X3M;>R)_y1{t=
zCKh^iz|Scx$FQ_vX~wb|%Tg>gSSqoUVJX2<gvE>{Ggg;9aQZnmwwnJeC;v{eG3Y1@
zusFA4`H`YjEv%S7YjEY<xmYLc@^SUSng>Qy)dg#2R?G-uwRq70P6In-N_f?ODy40_
z4WksDw~U`KY{Hjq|9E!7>iRK1svSSP|8<`?)B5S|sr9wNn%b!qRh2ct?@X<%o>4z9
zSXEa$b>Xbq`ii*)wRQECv#JZsMw4-BX-)O);0%-r`WY2-=T03ToExmD4f2}r)Ktu$
zAFLTXzjC??j3FlFi;lija3uDw=BK{M?JmT-7mK>St&7fsQ(LO9mbWLAzqMY;{Qye{
zv7){PVY?~Y6s09$-9@a!Q7Gl>|ED;c-fehIFgSYF^qPvA2bAKBZwKqJC1wn*#1^Zq
zRTOXc(bW}|vGSpcGOBp|oyDUqW)3xL_wsqzQq?ocXVlawO@^89r6~U=qdZtOqq;I!
zSzc9-h}@P@KC5b09U^g_vR&HcLFG5y$}8s8-d`SEG^<WgOx?=M@0dToY{vY$;j`vK
zu3YLyj>{{9)9dfQKUh;9s;-`+C=;NYfzYTbuX|vA5WZ(tmseHH3)aF!t*Q#_1W#p_
z*H-~-j&cvw*e|N9#D{#Vd%0NqX7}>gnlTe5-!a}~G;)h>0Q;gD!TELNAw=!mV2!nW
zM)kaT)m6$TO0j5EX|?zi<&ZKgNR3qU9T{S0Bk#e=;zcu1|Nfw|BXh#sU~s<jaboEm
z)$`_8)CA)qr8RRRI%if@MO~13U-W!yH*AYL>T7DS$EYiRpE;?Dx#$x>Ijg!V)>X=n
zGbaS=u3X%GMD4IxH<n`4!m09sGHh0D#q_zsiJ_Wcd?Vk14O*-Gq`MeDN-=s=*UYP^
zni0ICx}JJh`98(S#91@uh!qO9q2y#oBPwwyNLU-A$La^D?t}+w>w@zp&YBk-S_}9f
zS@Hcu9p661SW08aRk5WR`TbZ<V4=OU6w4|sMOfxzDZrA8C5rNI>{OJISgNr+g=HI-
zx3Q4N45ho0sTh<VJW8sg3Jsj)cP<=SI^r%KXUaz)VrNy%o%LX_$k?T50=gksU492T
ztu9z1!en?&^}G?2s^(Nxf2XR*nOZ+ASX)<9{Qy@evZfXlSJ4K!(npS{9Xg|K)<S%2
z<&{2VL@m3hO!|aL*dHn?;rgGi)IG2w^ENtsir0?=1`0p%di$kupR4xIHr@2Es@?mY
z*Pm1EX{$ddQ0@HHTmGWjQ$G25{4m?&2WPD6`ij5hm8$lO4}3mDwGYq#+NY}hcIL64
zskZrxjjyP-_36Df)!xzF@DtTGH2q|tYOng^viRpd)ptgry8eg8uWwfEN$>sQe$_T_
zSsf3IN521qKdI~Q|7>hnweSAuYhS4LzN(Y6RXect{%NY+yZ!Uksy(r3{wUSH{Ced&
z)!ua7EjS_N*U(pf7w@Z0-9L!)e|L7q0af$8v6CKF?Kk%ruT$-wA1uY!HvFQ0kymZ{
zM|Rbwe>Ycc`loQ!rhnX4ZTk0W)joy)qgHMDXJyr<e<@aN`j=nTrhm&-ZTja~)uw-O
zRc-o5RMn<`7gcTgr%u(Tf4x*~`UgqXrhj8pZTe?J)uw+5RBiglJ=LavuTyRMCpgun
ze^pa$`gbzbrhofVZTjad)uw-<Qf>NIC)K8ZMN)10M<Lawf8<eZ`ga@Erhki3ZTi<0
z)uw+hQEmG757nlB(NJyr7Yfy;e|1o8`iBJ7rhgYuZF)MtYSYv0Rhym?uiEs4b=9V)
zm8&*A^;@;+DcY({Po!3Dda|=>)02`_o1QwX+VtdJ)ut!msy01fR<-Hjt*T8=L{)8i
zvZ!j)lR8zKo_eX;^aM%OrYA9~Ha*o)wdo0gs!dPaQ*C;Boodrl;8dHQsHWQVgfi8p
zr+uk5JvB?U=?PS-O;2-DZF)MAYSUAORGXgCquTVe8`Y*K$EY?vfkn0Hi6*K|PX|$L
zdeVk!(^D%{o1Orn+VnI9)utyCs5Z^=S8bXxui7;GT(xN?w`$YOXw{}!#;Q#-c2%2Z
zys9?M8dYtYg{j&!lTo#4R-kJ4!#qFLrrBz$O*6k#n`Tm}HqA^@ZJObu+B926wQ1Ig
zYSSzZ)u!1Hs!g*CRGaSBS8clUUA5^ha@D3gvQ?YzY*uZ$OIWq(Zd=u+yH{14?gUkB
zx~o#P>Fz|;raS#qo9>!ZZMp+Zwdsy7)uub6RGaQHQf<0hN44oL7uBY_L{yvZvQTZh
zTS2wySANwViQns0n|^gxZTb~gwdog8)uvw-RhxdTQ*HXyOSS3OBh{u~V^o{Inc4n-
z_6)=2rFg09|M~vE+XI>6<GU&J!xNUJDvi2611pRv*5k`-@tsN;Mz6cO;kzHMpm-~4
zYlHKq&wZd^(Y(1;wZ4J%HC67~8KL03irU-e&6-hDU0Xe~?lxR!x+`ku4PIy(Sb!_8
zSu=6HFd1K;;2O_2&@|XM(BHdPL4mifroOgr1g?2?db4mn)T|B8sIQq-_ki$IfS0!>
zxS$@N609t(nY9p?V)qAY<AsUE#fwmtE;dI87Y64R%%#*fu%dQE)xzpI!J2^u^|OY~
zpvzX@z?l_uYl8#*-XU?{U#%SXpP)$kbnlR_uzH8Y8;$DTA!>j6ONW*Y9X4#lo!>4i
ziy8lwJY832VdK7T{EhJ~;}PRAW5oD3;|1gA#;7sNlw;~=y4B=2m6*nwCYh>C-!VO6
zdfc?ew9d5I^mEg%OnXglncgw|yXmi{9CM!8Xf881ntx>8VE(CjtNB;veddVyocWTu
zm!*#-&ysH$Vi|5Jv(#8tSeh-{ExRm-EJrQvmgAN)mLAqT>tJh%HDq02eaO1py4t$N
zy4JeY8n(7u&s(!?g*KDTV;gB3Z!5Ev+p29(+Sb^1*xGCn+d11MTQ7Sbd!9YtKEyuU
zUS_Ycudp}Ux7&Bw5802}+wI5gXY4&3c@DE<v?JtL;CRTf+_BoR#<AA1)e&~IJI*_@
zorO-5)8icJ9Pcc1mOHDRPde8)cR1Ue5$8GQC1)>JA6K3$-!;TF+*RgU=vw7!c5Qd<
zavgFVb+x;WyUw_Jxbxg*_h@&>y}<pDd%1hHdyRXod#gL_Zg-z|XL|}gCXdH6(lg#u
z<|+47d!F>H@$B%lc_N;3o=cuy-ag(uZ@zbkceuCATjO2fZT4>W?(!b;9`&|+k9*H}
zd-(Evc3-J4<Xhl-$hX|L+PB8H*0<Fc_O<)Y`?CFoev{whAL$?OFY}lCtNl;<*Z6n%
z+x!v#IsYYpuRxzbULZd(BrrTs7N`lV2s8(_2X+Mx1&#*V1IGhr0@%3=@I5TzpocNf
zXf}>EhKvi04;hymR~y$D*BZAP!^U>wr-+C`lgZ>UjWmrnm6^&-)utyA4X>CEnj)ri
zrc0(?=01pneDe_VaKu85d4;*zyxqLZe8_y%+-^Q@K4b2INN`&wS{7LzwKQ3tvur>t
zY_;sM9J53$8P)+-r*)`xl=W`wbi_inb&2&^YcrzYgtgP!&33iz8@7Rng(0?pZL%$d
zC|GA}vAtn?%l5AAL&U-vTh#V-dm*A=nthS|QG1j9Ir|30!dCkp`!RdOp5Ykaa5{!M
zMmg?wOh+tKJC-<}bu>HnI^K75I=VTpc7DS-5V0`C8E{T^hMbQ%UvRcK-*CR=eAoFQ
zV&RN4>ioK^(B(%IEOI^SYH~g2+JIQt>e}Nv=8Cw!bmh67?xF5c?z`R75ewDsCGKb4
z&F(|)Q|>I!wVwW-n>}Wa(-ZKF_004v@@(+z_OyFWdQN-3@ML(iyg7&gySKzU-MiSk
z#=G9T+54JzulJz$Fk;}MH_JEB=k=BODtvQ%5BeVSE%U8J4D9qB^nK{N?921t;J?N1
z_TTO=@sC9eEc7q)Z}9K-xBE}}Py4^{X9ThWIfwy!pd>IousE<Lus*Ok@LFJR;9%e|
zV&Edh00wx9fh^-dqt{qwtT4_oK4^T*xXic`F|gBk(D<S8vN6wegXtEN+jP4a70OKu
zP0LIhOuJ3(rjw@ArY}qx<}7m#V!&=LG0!wFHLo$RH*Yq-X5MQ)Xg-V>xM<F@++-=j
zNKj#!V|mc>m}Qw|rDd&Ur{$pKBa4EO;0Eh0R=4$bj0a<_<<^DPW!4SW-53c@T2EWQ
zux8k@Y&o`ko84Aon{Hc-kzl=Tv+Xt8UfV(2VcT)rMO&7Au)V|{vM;bdWM6JyZC_(w
zix>!FEI4n^b`&~H4v%A`W4xoxQH~gR5@W#*N1G$!IOn+J=;iF=%yZ@=28LrSsBx}v
zHaoXFcR3F^k2>3(#}NZPFcz3yqg^4_0@p*X<*wDPHLkUYfiT8`^R8@nq1)v4xJSCj
zyUX0=h=C_D7VL1hxg+j#?n~}oo<5#DPrhe}XE?@!8qW$(vuC?!m*<e@C}QEb=ZvQZ
z#saf<v^V5k;C;xu+`AgFu-3cP8^&00-ka?!^qG7f-$>th#6r2R+V>>Jf*rm#U&MFL
zcgfew-^ZWl&-V}U564(g<6q%#_HXy^@*naaMJycmpYiv=SYQr}4uk>=0uKe22Ua5%
z)&{l)!WawA2b3bj0b(HAScqRJJjRj6@rZ<SW3}-~j08K3Z8$!hGhQ<GGW9X#net6T
zOv5n})R<P7noZkHyG(~nM-d6fO=nC!FcR3!rRI=%f%zfxa`S3L!de^`!Waq8o3ky2
z7L&ze8EF}hNGP{dTb{J6vFxz4VH`MTxn${O?Sn|jw+^umx0YF}5ChHD?bcn^L)N2+
zgyYsT)*iMz+hD{%$hN@tkZrkbH6mfHZL2M8Yqx!2>uYz~huTNk@3v1zBvjj%*q_Bn
zaL9hjp5?gK(cf`1jt5Rhz%kY_)3FGnz&6K0$J>tg9G~EL(CLUea-26gofrk?JC`}1
zc0TXigyTVrbC2_|^CM@cvybamSBYz!>mJu^R}IF3C9ajOmt8Fw1<ty%+}FDMyKlzv
z!08US$GT^_7rCEvzltNlN%v{@7w!yCmL~@hVE2?@6j+KQ!FtbT&ugB&o`aslh=7Zp
zEbq<UVJWx&MQ`qZ%l5xLFg36!@MxeZ@LXU6js{x;djiJ-5gG$Zc?`G)+rPv(&UlY;
zwz0;z$hZV!z{|!K<GVOFNHqeyXlhA00#uoor91`<wv<>xmIaoFEXyscvE|p|C=kZk
zz<Eoywa{v^daNU@<FVz-aTItGX9KTT4_YJEbJk1NUba5i^7%Ll49D3(m2H`=*|y!b
z%XY|i6kGl{jsiV!Hej}oPB{X6itV3j1b7A8Kh+4Z(77tD5#X<`Za5dX!F`L{?Y`Yz
zg6&`KUg%!t{-Jxj`=I-6_j~S7a7NJSj=FO^H{n=trzhlD=6Txlyk`^62wFUQ5Cb21
zIz4^7x8g`J&U=q{HqHnZd6#%sdSCXocz@@O;7D+-ufOkRpV{a11$<+DGkuGE-}5!&
zNbt7rJ>MrdBk1%+eL4P{{7(O!{t%7?Py3(uZ^9Wti+_**u>T`}r@v3&RvZb&1?~yV
z#u>q)z>>hqz{`OaoDp;clxciUm}R`y*xz_F&Ig>vfN`vGCgNbVaSM(EZyVn;equat
z?8I4Oj_D?o({!gPgyX=|rsqwYOgj(@drXH-ADKE$*O&`&92jT5$2=S71B=W{%qz_=
zn_F-`(1GK?wU+*tn=NLG(-N?Zwamm>!D`DE90%UEyl43YvCwIWT5_y6;jG|JoDVFs
zK5c#8y2-l3+G5>fJ#765X9d^be4xZO&UTM&wynmt$hO3`()KdW3Xa-3a2&YS-rs&R
zV!>$-*vHyu;;dk`eT)5|{cZbu_D^s$=(I=eIgXn!5{!4ubu4o{?Reg?2}gq##~#OF
z$43|muEF_0iF2Iu9_MTv4Hh|<I9EDf#z=6~+2PD`UF+)ax*10Urz_wZ>zav?;6;oA
z?XHuq)2=UE8SX51jyvCNM;uIdFUE0Ty?e9!HTPab!eRGu_eGo)4D@($9H{Wj@jU2x
z43V(Xv(~c{Bf&==1;>FKytjDW-rErgW4-0xh2CY}4c^^24xIF!_I}~b@MZaOeEB#t
zEb&eEEyi(Ry>GMcHQ!!D!eQTW-$h@RA6F$f4pjK(_#gB?hDccHU+drLKj{C^f7zcG
zxFK*$z#X_9kuWw;9#|MyhS6X*jsqtHrvqOEl=&P78OAJQjxpb8$A~c9xERNQ^~TM{
z*Nl4+35SixjTdoVIMC$9aiGF9$Mm4-F+{>j(^}I`oELs*x@^ib-(bGQ>^9$yNEmA_
zH!sAPu)(|=$AOdP)8;SC8I~+d4z3UE7!#&j7GpG6Z`o{l&9WDfa2VGI7cE)VfmSa@
zg9_^$>x0(E5D6=BeXtW_!Uu?fJlhSnTWoII?TCc2xIS2jG2unTK)dav?KF-B8TKrD
z4z3UEI4ighF|fwI-oDxXntd-K;V`ZbE@Di$*)c4wtAkgZ2h+Mbu)9msx;ohDIg;|~
zV4-(a%BusjZ*<D5gHI6y|K+QLr5p!6aBW~WmZrQmIB(2Od2O)MbR?~7gDV{uK1B@t
zPaYSpbY{5IaU|t&;lJz5aHso7$}_`-o>eK&4DH_1|CTd@h5l73&kXH>(v)Y07!B~_
zGsi(+91n&XM;Y(NXb{4g;S%Gs#%AO1aAufgy4KX+bhF8fBSHY*8O$^-GCgN{HRYMX
zm97nLwhT*oX7HsYFXh$YUhDg5T^-(TpPJUyVc2mZ<<;RM_>Q0@#ns{MuBj=n4tux@
zQeGYIb-(ZKaCi6g#+AW!p4&Vw&)qmDsK@bOo#&@GFFfk`tEa<r9^Vq=c>CjcVDdU~
zG??U_<$cuqBU~Bmz_$c{_I`>h#Bcg;#96@*91rgBO~f|^kNBSTeeC<X|33c<xE5^o
zzv6$@|C;{|jQ)rH$Nc~9KZPs9&+z>~cU&3f1+EW#D{vdG4~GWE1jgeU@&3TPKy9Eg
zuqyCFoEdBn{1V?691na#aj*{ef8kBRcrXyx29?Gq@J&I9X$-y*co^pZKQw)5$~5;f
z=VIKy%{<h6AFltlnGcvhG5_7%-Ey_%YZ&WGETxvI80|xrDoY)%0_k3&0=QgbJcT&A
b)nqiCz_`(2$}$ha83cXUKVSb7J@EeklpQ6=

literal 0
HcmV?d00001

-- 
1.7.4.msysgit.0

